/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@tensorflow/tfjs-core")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{},e.tf)}(this,(function(e,t){"use strict";function n(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var o=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,o.get?o:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,t}var o=n(t);const i=t.env();var r;i.registerFlag("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE",(()=>15)),i.registerFlag("WEBGPU_CPU_FORWARD",(()=>!0)),i.registerFlag("WEBGPU_MATMUL_WORK_PER_THREAD",(()=>4)),i.registerFlag("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE",(()=>!1)),i.registerFlag("WEBGPU_USE_LOW_POWER_GPU",(()=>!1)),i.registerFlag("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD",(()=>1e3)),i.registerFlag("WEBGPU_USE_PROFILE_TOOL",(()=>!1)),i.registerFlag("WEBGPU_USE_IMPORT",(()=>!1)),function(e){e[e.MUL=0]="MUL",e[e.ADD=1]="ADD",e[e.SUB=2]="SUB",e[e.DIV=3]="DIV",e[e.EQUAL=4]="EQUAL",e[e.GREATER=5]="GREATER",e[e.GREATER_EQUAL=6]="GREATER_EQUAL",e[e.LESS=7]="LESS",e[e.LESS_EQUAL=8]="LESS_EQUAL",e[e.LOGICAL_AND=9]="LOGICAL_AND",e[e.NOT_EQUAL=10]="NOT_EQUAL",e[e.SQUARED_DIFFERENCE=11]="SQUARED_DIFFERENCE",e[e.INT_DIV=12]="INT_DIV",e[e.POW=13]="POW",e[e.PRELU=14]="PRELU",e[e.MAX=15]="MAX",e[e.MIN=16]="MIN",e[e.COMPLEX_MULTIPLY_REAL=17]="COMPLEX_MULTIPLY_REAL",e[e.COMPLEX_MULTIPLY_IMAG=18]="COMPLEX_MULTIPLY_IMAG"}(r||(r={}));const a="\n  if (isNaN.r) {\n    resultTemp.r = uniforms.NAN;\n  }\n  if (isNaN.g) {\n    resultTemp.g = uniforms.NAN;\n  }\n  if (isNaN.b) {\n    resultTemp.b = uniforms.NAN;\n  }\n  if (isNaN.a) {\n    resultTemp.a = uniforms.NAN;\n  }\n  ",s=`\n  let isModRound1Bool = vec4<i32>(round(abs(b) % vec4<f32>(2.0))) == vec4<i32>(1);\n  let isModRound1 = vec4<f32>(isModRound1Bool);\n  let multiplier = sign(a) * isModRound1 + (vec4<f32>(1.0) - isModRound1);\n  var resultTemp = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  let isExpZero = b == vec4<f32>(0.0);\n  if (isExpZero.r) {\n    resultTemp.r = 1.0;\n  }\n  if (isExpZero.g) {\n    resultTemp.g = 1.0;\n  }\n  if (isExpZero.b) {\n    resultTemp.b = 1.0;\n  }\n  if (isExpZero.a) {\n    resultTemp.a = 1.0;\n  }\n  let isNaN = a < vec4<f32>(0.0) & floor(b) < b;\n  ${a}\n  return resultTemp;\n  `;function u(e,t){const n=t?a:"\n  if (isnan(a)) { return a; }\n  if (isnan(b)) { return b; }\n  ";return t?`\n    var resultTemp = vec4<f32>(${e}(a, b));\n    let isNaN = isnanVec4(a) | isnanVec4(b);\n    `+n+"\n    return resultTemp;\n  ":n+`\n    return ${e}(a, b);\n  `}function l(e,t){switch(e){case r.MUL:return"return a * b;";case r.ADD:return"return a + b;";case r.SUB:return"return a - b;";case r.DIV:return"return a / b;";case r.EQUAL:return t?"return vec4<f32>(a == b);":"return f32(a == b);";case r.GREATER:return t?"return vec4<f32>(a > b);":"return f32(a > b);";case r.GREATER_EQUAL:return t?"return vec4<f32>(a >= b);":"return f32(a >= b);";case r.LESS:return t?"return vec4<f32>(a < b);":"return f32(a < b);";case r.LESS_EQUAL:return t?"return vec4<f32>(a <= b);":"return f32(a <= b);";case r.LOGICAL_AND:return t?"return (vec4<f32>(a >= vec4<f32>(1.0)) *\n  vec4<f32>(b >= vec4<f32>(1.0)));":"return f32(f32(a) >= 1.0 && f32(b) >= 1.0);";case r.NOT_EQUAL:return t?"return vec4<f32>(a != b);":"return f32(a != b);";case r.SQUARED_DIFFERENCE:return"return (a - b) * (a - b);";case r.INT_DIV:return t?"\n  let ia = vec4<i32>(round(a));\n  let ib = vec4<i32>(round(b));\n  let cond = ib != vec4<i32>(0);\n  var resultTemp = vec4<i32>(0);\n  let s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    resultTemp[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    resultTemp[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    resultTemp[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    resultTemp[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4<f32>(resultTemp);\n  ":"\n  let s = sign(a) * sign(b);\n  let ia = i32(round(a));\n  let ib = i32(round(b));\n  return f32(idiv(ia, ib, s));\n  ";case r.PRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (b * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n  ":"if (a < 0.0) { return b * a; }  return a;";case r.MAX:return u("max",t);case r.MIN:return u("min",t);case r.POW:return t?s:"\n  if(a < 0.0 && floor(b) < b) {\n    return uniforms.NAN;\n  }\n  if (b == 0.0) {\n    return 1.0;\n  }\n  if (round(abs(b) % 2.0) != 1.0) {\n    return pow(abs(a), b);\n  }\n  return sign(a) * pow(abs(a), b);\n  ";case r.COMPLEX_MULTIPLY_REAL:return"return areal * breal - aimag * bimag;";case r.COMPLEX_MULTIPLY_IMAG:return"return areal * bimag + aimag * breal;";default:throw new Error(`BinaryType ${e} is not implemented!`)}}var d;!function(e){e[e.ABS=0]="ABS",e[e.CEIL=1]="CEIL",e[e.COS=2]="COS",e[e.COSH=3]="COSH",e[e.ELU=4]="ELU",e[e.EXP=5]="EXP",e[e.EXPM1=6]="EXPM1",e[e.FLOOR=7]="FLOOR",e[e.LINEAR=8]="LINEAR",e[e.LOG=9]="LOG",e[e.LOGICAL_NOT=10]="LOGICAL_NOT",e[e.NEG=11]="NEG",e[e.RELU=12]="RELU",e[e.RELU6=13]="RELU6",e[e.LEAKYRELU=14]="LEAKYRELU",e[e.RSQRT=15]="RSQRT",e[e.SIN=16]="SIN",e[e.SINH=17]="SINH",e[e.SIGMOID=18]="SIGMOID",e[e.SQRT=19]="SQRT",e[e.SQUARE=20]="SQUARE",e[e.TANH=21]="TANH",e[e.TO_INT=22]="TO_INT"}(d||(d={}));function c(e,t){switch(e){case d.ABS:return"return abs(a);";case d.COS:return"return cos(a);";case d.COSH:return"\n  let e2x = exp(-a);\n  return (e2x + 1.0 / e2x) / 2.0;\n";case d.CEIL:return"return ceil(a);";case d.ELU:return t?"\n  var resFloat = exp(a) - vec4<f32>(1.0);\n  if (a.r >= 0.0) {\n    resFloat.r = a.r;\n  }\n  if (a.g >= 0.0) {\n    resFloat.g = a.g;\n  }\n  if (a.b >= 0.0) {\n    resFloat.b = a.b;\n  }\n  if (a.a >= 0.0) {\n    resFloat.a = a.a;\n  }\n  return resFloat;\n":"if (a >= 0.0) { return a; }  return (exp(a) - 1.0);";case d.EXP:return"return exp(a);";case d.EXPM1:return"return exp(a) - 1.0;";case d.FLOOR:return"return floor(a);";case d.LINEAR:return"return a;";case d.LOG:return"if (a < 0.0) { return 1.0/0.0; }\n  return log(a);";case d.LOGICAL_NOT:return"return f32(!(a >= 1.0));";case d.NEG:return"return -a;";case d.LEAKYRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (uniforms.alpha * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return uniforms.alpha * a; } return a;";case d.RELU:return t?"\n  return select(a, vec4<f32>(0.0), a < vec4<f32>(0.0));\n":"return select(a, 0.0, a < 0.0);";case d.RELU6:return t?"return clamp(a, vec4<f32>(0.0, 0.0, 0.0, 0.0), vec4<f32>(6.0, 6.0, 6.0, 6.0));":"return clamp(a, 0.0, 6.0);";case d.RSQRT:return"return 1.0/sqrt(a);";case d.SIGMOID:return"return 1.0 / (1.0 + exp(-1.0 * a));";case d.SIN:return"return sin(a);";case d.SINH:return"\n  let e2x = exp(a);\n  return (e2x - 1.0 / e2x) / 2.0;\n";case d.SQRT:return"return sqrt(a);";case d.SQUARE:return"return a * a;";case d.TANH:return"\n  let e2x = exp(-2.0 * abs(a));\n  return sign(a) * (1.0 - e2x) / (1.0 + e2x);\n";case d.TO_INT:return"return f32(i32((a)));";default:throw new Error(`BinaryType ${e} is not implemented!`)}}function p(e,t=!1){if(null===e)return null;if("linear"===e)return c(d.LINEAR);if("relu"===e)return c(d.RELU,t);if("elu"===e)return c(d.ELU,t);if("relu6"===e)return c(d.RELU6,t);if("prelu"===e)return l(r.PRELU,t);if("sigmoid"===e)return c(d.SIGMOID,t);if("leakyrelu"===e)return c(d.LEAKYRELU,t);throw new Error(`Activation ${e} has not been implemented for the WebGPU backend.`)}function h(e,t){if(Math.max(...e)>3)throw new Error("Cannot symbolically compute strides for rank > 4 tensor.");const n=e.length,o=e.map((e=>`${t}[${e}]`)),i=new Array(n-1);i[n-2]=o[n-1];for(let e=n-3;e>=0;--e)i[e]=`(${i[e+1]} * ${o[e+1]})`;return i}function f(e){if(e<=1)return"i32";if(2===e)return"vec2<i32>";if(3===e)return"vec3<i32>";if(4===e)return"vec4<i32>";if(5===e)return"vec5";if(6===e)return"vec6";throw Error(`GPU for rank ${e} is not yet supported`)}function m(e){if(0===e)return"x";if(1===e)return"y";if(2===e)return"z";if(3===e)return"w";if(4===e)return"u";if(5===e)return"v";throw Error(`Index ${e} is not yet supported`)}function g(e,t){return"float32"===e?t?"vec4<f32>":"f32":"int32"===e||"bool"===e?t?"vec4<i32>":"i32":e}function b(e,n,o,i=!1){const r=[];if(r.push(`\n    let workGroupSizeX = ${o.workGroupSize[0]}u;\n    let workGroupSizeY = ${o.workGroupSize[1]}u;\n    let workGroupSizeZ = ${o.workGroupSize[2]}u;\n\n    var<private> localId: vec3<u32>;\n    var<private> globalId: vec3<u32>;\n    var<private> numWorkgroups: vec3<u32>;\n\n    // Only used when the y/z dimension of workgroup size is 1.\n    fn getGlobalIndex() -> i32 {\n      if (numWorkgroups.y == 1u && numWorkgroups.z == 1u) {\n        return i32(globalId.x);\n      }\n\n      let localInvocationIndex = localId.z * workGroupSizeX * workGroupSizeY +\n          localId.y * workGroupSizeX + localId.x;\n      let workGroupID = (globalId - localId)/vec3<u32>(\n          workGroupSizeX, workGroupSizeY, workGroupSizeZ);\n\n      return i32((workGroupID.z * numWorkgroups.x * numWorkgroups.y +\n        workGroupID.y * numWorkgroups.x + workGroupID.x) *\n        (workGroupSizeX * workGroupSizeY * workGroupSizeZ) +\n        localInvocationIndex);\n    }\n  `),!0===i)return r.push(`\n      struct Uniform {\n        size            : i32,\n        numChannels     : i32,\n        outShapeStrides : vec2<i32>,\n        dispatchSize    : vec3<u32>,\n      };\n\n      @group(0) @binding(0) var<storage, write> result: array<${g(n.dtype,o.isVec4)}>;\n      @group(0) @binding(2) var<uniform> uniforms: Uniform;\n    `),[I,r.join("\n"),w(n.shape),o.getUserCode()].join("\n");let a=!1,s=!1,u="struct Uniforms { NAN : f32, ";o.variableNames.forEach(((t,n)=>{const o=f(e[n].shape.length);"vec5"!==o&&"vec6"!==o||(s=!0),(a||s)&&(u+="@align(16) "),a=s,u+=`${t.charAt(0).toLowerCase()+t.slice(1)}Shape : ${o}, `}));const l=f(n.shape.length);s="vec5"===l||"vec6"===l,(a||s)&&(u+="@align(16) "),a=s,u+=`outShape : ${l}, `;const d=f(n.shape.length-1);s="vec5"===d||"vec6"===d,(a||s)&&(u+="@align(16) "),a=s,u+=`\n       outShapeStrides: ${d}, `,o.size&&(a&&(u+="@align(16) "),a=!1,u+="size : i32, "),o.uniforms&&(a&&(u+="@align(16) "),u+=o.uniforms),u+="};",r.push(u),o.atomic?r.push("\n    @group(0) @binding(0) var<storage, read_write> result: array<atomic<i32>>;\n  "):r.push(`\n    @group(0) @binding(0) var<storage, write> result: array<${g(n.dtype,o.isVec4)}>;\n  `),o.variableNames.forEach(((t,n)=>{r.push(`\n    @group(0) @binding(${1+n}) var<storage, read> ${t}: array<${g(e[n].dtype,o.isVec4)}>;\n    `)})),""!==u&&r.push(`\n    @group(0) @binding(${1+o.variableNames.length}) var<uniform> uniforms: Uniforms;\n    `);const[c,p]=function(e,t){const{x:n,y:o=[],z:i=[]}=t,r=e.length;if(n.length===r){return[`fn getOutputCoords() -> ${f(r)}{\n      let globalIndex = getGlobalIndex();\n      return getCoordsFromIndex(globalIndex);\n    }\n    `,r]}let a="";const s=[n,o,i];let u=0;for(let e=0;e<s.length;e++){const t=s[e];if(0!==t.length)if(u+=t.length,1===t.length)a+=`let d${t[0]} = i32(globalId[${e}]);`;else{const n=h(t,"uniforms.outShape");a+=`var index${e} = i32(globalId[${e}]);`;for(let o=0;o<n.length;o++)a+=`let d${t[o]} = index${e} / ${n[o]};`,o===n.length-1?a+=`let d${t[o+1]} = index${e} - d${t[o]} * ${n[o]};`:a+=`index${e} = index${e} - d${t[o]} * ${n[o]};`}}const l=[];for(let e=0;e<u;e++)l.push(`d${e}`);const d=f(u);let c=`fn getOutputCoords() -> ${d} {\n    ${a}\n  `;0===l.length?c+=`return ${d}(0); }`:c+=`return ${d}(${l.join(",")}); }`;return[c,u]}(n.shape,o.dispatchLayout),b=[I,r.join("\n"),w(n.shape),c,k(n.shape.length)];if(o.atomic||b.push(function(e,t,n){const o=e.length,i=g(t,n);let r;r=n?`fn setOutputAtIndex(flatIndex : i32, value : vec4<f32>) {\n      result[flatIndex] = ${i}(value);\n    }\n    fn setOutputAtIndexI32(flatIndex : i32, value : vec4<i32>) {\n      result[flatIndex] = ${i}(value);\n    }`:`fn setOutputAtIndex(flatIndex : i32, value : f32) {\n      result[flatIndex] = ${i}(value);\n    }\n    fn setOutputAtIndexI32(flatIndex : i32, value : i32) {\n      result[flatIndex] = ${i}(value);\n    }`;if(o>=2){const e=["d0","d1","d2","d3","d4","d5"].slice(0,o),t=f(o);r+=n?`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : vec4<f32>) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex / 4, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : vec4<i32>) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex / 4, value);\n      }\n    `:`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : f32) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : i32) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex, value);\n      }\n    `}return r}(n.shape,n.dtype,o.isVec4)),p===n.shape.length){const i=e.map((e=>function(e,n,o,i){let r=function(e,t){const n=e.name,o=e.shape.length,i=f(o),r="get"+n.charAt(0).toUpperCase()+n.slice(1),a=["d0","d1","d2","d3","d4","d5"].slice(0,o),s=a.map((e=>`${e} : i32`)).join(", ");if(o<1)return t?`\n        fn ${r}() -> vec4<f32> {\n          return vec4<f32>(${n}[0]);\n        }\n      `:`\n      fn ${r}() ->f32 {\n        return f32(${n}[0]);\n      }\n    `;const u=`uniforms.${n.charAt(0).toLowerCase()+n.slice(1)}Shape`;let l=`${o}D`;0===o&&(l="1D");if(t)return`\n      fn ${r}(${s}) -> vec4<f32> {\n        return vec4<f32>(${n}[getIndexFromCoords${l}(${i}(${a.join(",")}),\n          ${u}) / 4]);\n      }\n      `;return`\n    fn ${r}(${s}) -> f32 {\n      return f32(${n}[getIndexFromCoords${l}(${i}(${a.join(",")}),\n        ${u})]);\n    }\n   `}(e,o);e.shape.length<=n.length&&(r+=function(e,n,o,i){const r=e.name,a=r.charAt(0).toUpperCase()+r.slice(1),s="get"+a+"ByOutput",u=e.shape.length,l=n.length,d=f(l);if(t.util.arraysEqual(e.shape,n)&&i)return o?`\n        fn ${s}Index(globalIndex : i32) -> vec4<f32> {\n          return vec4<f32>(${r}[globalIndex]);\n        }\n\n        fn ${s}Coords(coords : ${d}) -> vec4<f32> {\n          return vec4<f32>(${r}[${l>1?"getOutputIndexFromCoords(coords)":"coords"} / 4]);\n        }\n        `:`\n      fn ${s}Index(globalIndex : i32) -> f32 {\n        return f32(${r}[globalIndex]);\n      }\n\n      fn ${s}Coords(coords : ${d}) -> f32 {\n        return f32(${r}[${l>1?"getOutputIndexFromCoords(coords)":"coords"}]);\n      }\n      `;const c=t.backend_util.getBroadcastDims(e.shape,n),p=l-u;let h="";if(0===u)return o?`\n      fn ${s}Index(globalIndex : i32) -> vec4<f32> {\n        return get${a}();\n      }\n\n      fn ${s}Coords(coords : ${d}) -> vec4<f32> {\n        return get${a}();\n      }\n    `:`\n      fn ${s}Index(globalIndex : i32) -> f32{\n        return get${a}();\n      }\n\n      fn ${s}Coords(coords : ${d}) -> f32{\n        return get${a}();\n      }\n    `;h=l<2&&c.length>=1?"coords = 0;":c.map((e=>`coords.${m(e+p)} = 0;`)).join("\n");let g="";if(l<2&&u>0)g="coords";else if(l>1){g=`${f(u)}(${e.shape.map(((e,t)=>`coords.${m(t+p)}`)).join(", ")})`}else g="coords";const b=`uniforms.${r.charAt(0).toLowerCase()+r.slice(1)}Shape`,I=`${u}D`;if(o)return`\n      fn ${s}Index(globalIndex : i32) -> vec4<f32> {\n        var coords = getCoordsFromIndex(globalIndex);\n        ${h}\n        return ${r}[getIndexFromCoords${I}(${g}, ${b}) / 4];\n      }\n\n      fn ${s}Coords(coordsIn : ${d}) -> vec4<f32> {\n        var coords = coordsIn;\n        ${h}\n        return ${r}[getIndexFromCoords${I}(${g}, ${b}) / 4];\n      }\n    `;return`\n    fn ${s}Index(globalIndex : i32) -> f32 {\n      var coords = getCoordsFromIndex(globalIndex);\n      ${h}\n      return f32(${r}[getIndexFromCoords${I}(${g}, ${b})]);\n    }\n\n    fn ${s}Coords(coordsIn : ${d}) -> f32 {\n      var coords = coordsIn;\n      ${h}\n      return f32(${r}[getIndexFromCoords${I}(${g}, ${b})]);\n    }\n  `}(e,n,o,i));return r}(e,n.shape,o.isVec4,o.dispatchLayout.x.length===n.shape.length))).join("\n");b.push(i)}b.push(o.getUserCode());return b.join("\n")}const I="\n  struct vec5 {x: i32, y: i32, z: i32, w: i32, u: i32};\n  struct vec6 {x: i32, y: i32, z: i32, w: i32, u: i32, v: i32};\n\n  // Checks whether coordinates lie within the bounds of the shape.\n  fn coordsInBounds2D(coord : vec2<i32>, shape : vec2<i32>) -> bool {\n    return all(coord >= vec2<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds3D(coord : vec3<i32>, shape : vec3<i32>) -> bool {\n    return all(coord >= vec3<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds4D(coord : vec4<i32>, shape : vec4<i32>) -> bool {\n    return all(coord >= vec4<i32>(0)) && all(coord < shape);\n  }\n\n  fn getIndexFromCoords1D(coord : i32, shape : i32) -> i32 {\n    return coord;\n  }\n  fn getIndexFromCoords2D(coords : vec2<i32>, shape : vec2<i32>) -> i32 {\n    return dot(coords, vec2<i32>(shape.y, 1));\n  }\n  fn getIndexFromCoords3D(coords : vec3<i32>, shape : vec3<i32>) -> i32 {\n    return dot(coords, vec3<i32>(shape.y * shape.z, shape.z, 1));\n  }\n  fn getIndexFromCoords4D(coords : vec4<i32>, shape : vec4<i32>) -> i32 {\n    return dot(coords, vec4<i32>(\n        shape.y * shape.z * shape.w, shape.z * shape.w, shape.w, 1));\n  }\n  fn getIndexFromCoords5D(coords : vec5, shape : vec5) -> i32 {\n    let shapeStrides: vec5 = vec5(shape.y * shape.z * shape.w * shape.u, shape.z * shape.w * shape.u, shape.w * shape.u, shape.u, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u;\n  }\n  fn getIndexFromCoords6D(coords : vec6, shape : vec6) -> i32 {\n    let shapeStrides: vec6 = vec6(shape.y * shape.z * shape.w * shape.u * shape.v, shape.z * shape.w * shape.u * shape.v, shape.w * shape.u * shape.v, shape.u * shape.v, shape.v, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u + coords.v*shapeStrides.v;\n  }\n\n  fn idiv(a: i32, b: i32, sign: f32) -> i32 {\n    var res: i32 = a / b;\n    let mod: i32 = a % b;\n    if (sign < 0. && mod != 0) {\n      res = res - 1;\n    }\n    return res;\n  }\n\n  // NaN defination in IEEE 754-1985 is :\n  //   - sign = either 0 or 1.\n  //   - biased exponent = all 1 bits.\n  //   - fraction = anything except all 0 bits (since all 0 bits represents infinity).\n  // https://en.wikipedia.org/wiki/IEEE_754-1985#Representation_of_non-numbers\n  fn isnan(val: f32) -> bool {\n    let floatToUint: u32 = bitcast<u32>(val);\n    return (floatToUint & 0x7fffffffu) > 0x7f800000u;\n  }\n  fn isnanVec4(val : vec4<f32>) -> vec4<bool> {\n    return vec4<bool>(isnan(val[0]), isnan(val[1]), isnan(val[2]), isnan(val[3]));\n  }\n";function k(e){let n="";switch(e){case 0:case 1:n+="\n        fn getOutputIndexFromCoords(coords : i32) -> i32 {\n          return coords;\n        }\n        ";break;case 2:n+="\n        fn getOutputIndexFromCoords(coords : vec2<i32>) -> i32 {\n          return dot(coords, vec2<i32>(uniforms.outShapeStrides, 1));\n        }\n        ";break;case 3:n+="\n        fn getOutputIndexFromCoords(coords : vec3<i32>) -> i32 {\n          return dot(coords, vec3<i32>(uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, 1));\n        }\n        ";break;case 4:n+="\n        fn getOutputIndexFromCoords(coords : vec4<i32>) -> i32 {\n          return dot(coords, vec4<i32>(\n            uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, uniforms.outShapeStrides.z, 1));\n        }\n        ";break;case 5:n+="\n        fn getOutputIndexFromCoords(coords : vec5) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u;\n        }\n        ";break;case 6:n+="\n        fn getOutputIndexFromCoords(coords : vec6) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u * uniforms.outShapeStrides.u +\n              coords.v;\n        }\n        ";break;default:t.util.assert(!1,(()=>`Unsupported ${e}D shape`))}return n}function w(e){const n=e.length;if(n<=1)return"fn getCoordsFromIndex(index : i32) -> i32 { return index; }";const o=t.util.computeStrides(e),i=f(n),r=[];for(let e=0;e<n;e++)r.push(`d${e}`);if(1===o.length)return"    fn getCoordsFromIndex(index : i32) -> vec2<i32> {\n      let d0 = index / uniforms.outShapeStrides; let d1 = index - d0 * uniforms.outShapeStrides;\n      return vec2<i32>(d0, d1);\n    }";let a;return a="var index2 = index;"+o.map(((e,t)=>`${`let ${r[t]} = index2 / uniforms.outShapeStrides.${m(t)}`}; ${t===o.length-1?`let ${r[t+1]} = index2 - ${r[t]} * uniforms.outShapeStrides.${m(t)}`:`index2 = index2 - ${r[t]} * uniforms.outShapeStrides.${m(t)}`};`)).join(""),`\n    fn getCoordsFromIndex(index : i32) -> ${i} {\n      ${a}\n      return ${i}(${r.join(",")});\n    }\n  `}const x=e=>{let t=1;for(let n=0;n<e.length;n++)t*=e[n];return t};function v(e,t){if(e.length!==t.length)throw new Error(`Cannot compute whether rank ${e.length} tiles fit evenly into rank ${t.length} shape - ranks must match.`);return t.every(((t,n)=>t%e[n]==0))}function S(e,t,n=[1,1,1],o=[1,1,1]){const[i,r,a]=[Math.ceil(x(e.x.map((e=>t[e])))/(n[0]*o[0])),e.y?Math.ceil(x(e.y.map((e=>t[e])))/(n[1]*o[1])):1,e.z?Math.ceil(x(e.z.map((e=>t[e])))/(n[2]*o[2])):1];return[i,r,a]}function y(e,t){const n=x(e.x.map((e=>t[e]))),o=x(e.y.map((e=>t[e])));return n<=4?[4,16,1]:o<=4?[16,4,1]:[16,16,1]}function C(e,t,n){return 1===e?[32,1,1]:1===n?[1,32,1]:[8,8,1]}function z(e,t){const n=x(e.x.map((e=>t[e]))),o=x(e.y.map((e=>t[e])));return n<=4?[1,2,1]:o<=4?[2,1,1]:[2,2,1]}function _(e){return{x:e.map(((e,t)=>t))}}function G(e){if("float32"===e||"int32"===e||"bool"===e||"string"===e)return 4;if("complex64"===e)return 8;throw new Error(`Unknown dtype ${e}`)}function $(e,t){if("float32"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t||"string"===t)return Uint8Array.from(new Int32Array(e));throw new Error(`Unknown dtype ${t}`)}function A(){return("undefined"!=typeof window||"undefined"!=typeof WorkerGlobalScope)&&!!navigator.gpu}var R={__proto__:null,tilesFitEvenlyIntoShape:v,computeDispatch:S,computeWorkGroupSizeForConv2d:y,computeWorkGroupSizeForMatMul:C,computeWorkPerThreadForConv2d:z,flatDispatchLayout:_,GPUBytesPerElement:G,ArrayBufferToTypedArray:$,isWebGPUSupported:A};function T(e,n,o,i){return t.util.assert(i%4==0&&4===e[0],(()=>"tileInner must be divisible by 4. And ColPerThread must be 4")),`\n  var<workgroup> mm_Asub : array<array<vec4<f32>, ${i/e[0]}>, ${n}>;\n  var<workgroup> mm_Bsub : array<array<vec4<f32>, ${o/e[0]}>, ${i}>;\n\n  let RowPerThread = ${e[1]};\n  let ColPerThread = ${e[0]};\n  let TileInner = ${i};\n\n  \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n\n    let tileRow = ${1===n?"0":"i32(localId.y) * RowPerThread"};\n    let tileCol = i32(localId.x);\n\n    let globalRow = ${1===n?"0":"i32(globalId.y) * RowPerThread"};\n    let globalCol = i32(globalId.x);\n    let numTiles = (uniforms.dimInner - 1) / TileInner + 1;\n\n    var acc: array<vec4<f32>, RowPerThread>;\n    var ACached : vec4<f32>;\n    var BCached : array<vec4<f32>, 4>;\n\n    // Loop over shared dimension.\n    var globalColA = tileCol;\n    let RowPerThreadB = TileInner / i32(workGroupSizeY);\n    let tileRowB = i32(localId.y) * RowPerThreadB;\n    for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileCol;\n            mm_Asub[inputRow][inputCol] = mm_readA(globalRow + innerRow, globalColA, globalId);\n        }\n        globalColA = globalColA + TileInner / ColPerThread;\n\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < RowPerThreadB; innerRow = innerRow + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(t * TileInner + inputRow, globalCol, globalId);\n        }\n\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < TileInner / ColPerThread; k = k + 1) {\n            BCached[0] = mm_Bsub[k * ColPerThread][tileCol];\n            BCached[1] = mm_Bsub[k * ColPerThread + 1][tileCol];\n            BCached[2] = mm_Bsub[k * ColPerThread + 2][tileCol];\n            BCached[3] = mm_Bsub[k * ColPerThread + 3][tileCol];\n\n            for (var i = 0; i < RowPerThread; i = i + 1) {\n                ACached = mm_Asub[tileRow + i][k];\n                acc[i] = BCached[0] * ACached.x + acc[i];\n                acc[i] = BCached[1] * ACached.y + acc[i];\n                acc[i] = BCached[2] * ACached.z + acc[i];\n                acc[i] = BCached[3] * ACached.w + acc[i];\n            }\n        }\n\n        workgroupBarrier();\n    }\n\n    for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n        mm_write(globalRow + innerRow,\n                 globalCol,\n                 acc[innerRow], globalId);\n    }\n  }`}class B{constructor(e,t,n,o,i,r=null,a=null,s=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,8,1],this.isVec4=!0,this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]},1===t[1]?this.elementsPerThread=[4,1,1]:this.elementsPerThread=[4,4,1],this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread);const u=null!=r,l=null!=s;u&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.tileAOuter=1===t[1]?1:this.workGroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=this.tileBOuter,this.aShape=e,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=o,this.batchBEqualOne=i,[this.fitA,this.fitB]=this.getShapeFit(),this.shaderKey=`matMulPackedVec4_${this.activation}_${this.fitA}_${this.fitB}_${this.elementsPerThread}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getShapeFit(){const e=this.aShape[2],t=this.outputShape[2],n=[this.outputShape[0],e,t],o=[this.tileAOuter,this.tileInner],i=[this.tileInner,this.tileBOuter];return[v(o,this.aShape.slice(1)),v(i,n.slice(1))]}getUserCode(){const e=this.fitA?"return A[batch * batchASize + row * uniforms.dimInner / 4 + col]":"if (coordsInBounds2D(vec2<i32>(row, col * 4), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n            return A[batch * batchASize + row * uniforms.dimInner / 4 + col];\n        }\n        return vec4<f32>(0.0)",t=this.fitB?"return B[batch * batchBSize + row * uniforms.dimBOuter / 4 + col]":"if(coordsInBounds2D(vec2<i32>(row, col * 4), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n             return B[batch * batchBSize + row * uniforms.dimBOuter / 4 + col];\n        }\n        return vec4<f32>(0.0)";let n="",o="";if(this.activation){const e=p(this.activation,this.isVec4);n=this.hasPreluActivationWeights?`fn activation(a : vec4<f32>, outCoord : vec3<i32>) -> vec4<f32> {\n                  let b = getPreluActivationWeightsByOutputCoords(outCoord);\n                  ${e}\n                }`:`\n            fn activation(a : vec4<f32>, outCoord : vec3<i32>) -> vec4<f32> {\n              ${e}\n            }`,o="value = activation(value, outCoord);"}const i=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n      ${n}\n      fn mm_readA(row : i32, col : i32,  globalId : vec3<u32>) -> vec4<f32> {\n        ${this.batchAEqualOne?"\n          let batchASize = 0;\n          let batch = 0;\n        ":"\n          let batchASize = uniforms.aShape[1] * uniforms.aShape[2] / 4;\n          let batch = i32(globalId.z);\n        "}\n\n        ${e};\n      }\n\n      fn mm_readB(row : i32, col : i32,  globalId : vec3<u32>) -> vec4<f32> {\n        ${this.batchBEqualOne?"\n          let batchBSize = 0;\n          let batch = 0;\n          ":"\n          let batchBSize = uniforms.bShape[1] * uniforms.bShape[2] / 4;\n          let batch = i32(globalId.z);\n       "}\n        ${t};\n      }\n\n      fn mm_write(row : i32, col : i32, valueIn : vec4<f32>, globalId : vec3<u32>) {\n        if (row < uniforms.aShape[1] && col * 4 < uniforms.bShape[2])\n        {\n          var value = valueIn;\n          let batch = i32(globalId.z);\n          let outCoord = vec3<i32>(batch, row, col * 4);\n          ${i}\n          ${o}\n          setOutputAtCoords(outCoord[0], outCoord[1], outCoord[2], value);\n        }\n      }\n      ${T(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner)}\n    `}}function P(e,t){const n=t[1]*e[1],o=t[0]*e[0],i=n>o?n:o;return`\n    var<workgroup> mm_Asub : array<array<f32, ${i}>, ${n}>;\n    var<workgroup> mm_Bsub : array<array<f32, ${o}>, ${i}>;\n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let tileRow = i32(localId.y) * ${e[1]};\n      let tileCol = i32(localId.x) * ${e[0]};\n\n      let globalRow = i32(globalId.y) * ${e[1]};\n      let globalCol = i32(globalId.x) * ${e[0]};\n\n      let numTiles = (uniforms.dimInner - 1) / ${i} + 1;\n\n      var acc : array<array<f32, ${e[0]}>, ${e[1]}>;\n      var ACached : f32;\n      var BCached : array<f32, ${e[0]}>;\n\n      // Without this initialization strange values show up in acc.\n      for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n        for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n          acc[innerRow][innerCol] = 0.0;\n        }\n      }\n\n      let ColPerThreadA = ${i} / ${t[0]};\n      let tileColA = i32(localId.x) * ColPerThreadA;\n      let RowPerThreadB = ${i} / ${t[1]};\n      let tileRowB = i32(localId.y) * RowPerThreadB;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ColPerThreadA; innerCol = innerCol + 1) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileColA + innerCol;\n\n            mm_Asub[inputRow][inputCol] = mm_readA(\n                globalRow + innerRow,\n                t * ${i} + inputCol, globalId);\n          }\n        }\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < RowPerThreadB; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol + innerCol;\n\n            mm_Bsub[inputRow][inputCol] = mm_readB(\n              t * ${i} + inputRow,\n              globalCol + innerCol, globalId);\n          }\n        }\n\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < ${i}; k = k + 1) {\n          for (var inner = 0; inner < ${e[0]}; inner = inner + 1) {\n            BCached[inner] = mm_Bsub[k][tileCol + inner];\n          }\n\n          for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n            ACached = mm_Asub[tileRow + innerRow][k];\n            for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n              acc[innerRow][innerCol] = acc[innerRow][innerCol] + ACached * BCached[innerCol];\n            }\n          }\n        }\n\n        workgroupBarrier();\n      }\n\n      for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n        for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n\n          if ((globalCol + innerCol) < uniforms.dimBOuter &&\n              (globalRow + innerRow) < uniforms.dimAOuter) {\n            mm_write(globalRow + innerRow,\n                     globalCol + innerCol,\n                     acc[innerRow][innerCol], globalId);\n          }\n        }\n      }\n    }\n  `}class N{constructor(e,n,o,i,r,a=!1,s=!1,u=null,l=null,d=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[16,16,1],this.outputShape=n,this.dispatchLayout={x:[2],y:[1],z:[0]};const c=a?e[1]:e[2];this.workGroupSize=C(n[1],0,n[2]),1!==n[1]&&1!==n[2]||(o=1),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[o,o,1]),t.util.arraysEqual(this.dispatch,[1,1,1])&&(o=1,this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[o,o,1]));const p=null!=u,h=null!=d;p&&this.variableNames.push("bias"),h&&this.variableNames.push("preluActivationWeights"),this.workPerThread=o,this.aShape=e,this.transposeA=a,this.transposeB=s,this.addBias=p,this.activation=l,this.hasPreluActivationWeights=h,this.batchAEqualOne=i,this.batchBEqualOne=r;const f=this.outputShape[2],m=this.transposeB?[this.outputShape[0],f,c]:[this.outputShape[0],c,f];[this.fitA,this.fitB]=this.getShapeFit(m),this.shaderKey=`matMulPacked_${this.workPerThread}_${a}_${s}_${this.activation}_${this.fitA}_${this.fitB}_${this.outputShape[1]>1}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getShapeFit(e){const n=this.workGroupSize[1]*this.workPerThread,o=this.workGroupSize[0]*this.workPerThread;let i=n>o?n:o;1===this.outputShape[1]&&(i*=4),t.util.assert(i%this.workGroupSize[0]==0&&i%this.workGroupSize[1]==0,(()=>"tileInner must be multiple of workgroupsize.x and workgroupsize.y"));const r=[i,o];return[v([n,i],this.aShape.slice(1)),v(r,e.slice(1))]}getUserCode(){let e,t;e=!1===this.transposeA?this.fitA?"return A[batch * batchASize + row * uniforms.dimInner + col];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n             return A[batch * batchASize + row * uniforms.dimInner + col];\n           }\n           return 0.0;":this.fitA?"return A[batch * batchASize + col * uniforms.dimAOuter + row];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n             return A[batch* batchASize + col * uniforms.dimAOuter + row];\n           }\n           return 0.0;",t=!1===this.transposeB?this.fitB?"return B[batch * batchBSize + row * uniforms.dimBOuter + col];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n             return B[batch * batchBSize + row * uniforms.dimBOuter + col];\n           }\n           return 0.0;":this.fitB?"return B[batch * batchBSize + col * uniforms.dimInner + row];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n             return B[batch * batchBSize + col * uniforms.dimInner + row];\n           }\n           return 0.0;";let n="",o="";if(this.activation){const e=p(this.activation,!1);n=this.hasPreluActivationWeights?`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n               let b = getPreluActivationWeightsByOutputCoords(outCoord);\n               ${e}\n            }`:`\n              fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n                ${e}\n              }\n            `,o="value = activation(value, outCoord);"}const i=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";var r;return`\n      ${n}\n\n      fn mm_readA(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchAEqualOne?"\n        let batch = 0;\n        let batchASize = 0;\n        ":"\n        let batch = i32(globalId.z);\n        let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n        "}\n        ${e}\n      }\n\n      fn mm_readB(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchBEqualOne?"\n        let batch = 0;\n        let batchBSize = 0;\n        ":"\n        let batch = i32(globalId.z);\n        let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n        "}\n        ${t}\n      }\n\n      fn mm_write(row : i32, col : i32, valueIn : f32, globalId : vec3<u32>) {\n        var value = valueIn;\n        let batch = i32(globalId.z);\n        let outCoord = vec3<i32>(batch, row, col);\n        ${i}\n        ${o}\n        setOutputAtCoords(batch, row, col, value);\n      }\n      ${this.outputShape[1]>1?P([this.workPerThread,this.workPerThread,1],this.workGroupSize):(r=this.workGroupSize,`\n    let TileSize = ${4*r[0]};\n    var<workgroup> mm_Asub : array<vec4<f32>, ${r[0]}>;\n\n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let tileCol = i32(localId.x);\n      let globalCol = i32(globalId.x);\n      let globalRow = i32(globalId.y);\n\n      let numTiles = (uniforms.dimInner - 1) / TileSize + 1;\n\n      // Without this initialization strange values show up in acc.\n      var acc = 0.0;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        let colA = t * TileSize + tileCol * 4;\n        mm_Asub[tileCol] = vec4<f32>(mm_readA(globalRow, colA, globalId),\n                                mm_readA(globalRow, colA + 1, globalId),\n                                mm_readA(globalRow, colA + 2, globalId),\n                                mm_readA(globalRow, colA + 3, globalId));\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < TileSize / 4; k = k + 1) {\n          let rowB = t * TileSize + k * 4;\n          let BCached = vec4<f32>(mm_readB(rowB, globalCol, globalId),\n                              mm_readB(rowB + 1, globalCol, globalId),\n                              mm_readB(rowB + 2, globalCol, globalId),\n                              mm_readB(rowB + 3, globalCol, globalId));\n\n          let ACached = mm_Asub[k];\n          acc = acc + dot(ACached, BCached);\n        }\n\n        workgroupBarrier();\n      }\n\n      if (globalRow < uniforms.dimAOuter && globalCol < uniforms.dimBOuter) {\n        mm_write(globalRow, globalCol, acc, globalId);\n      }\n    }\n  `)}\n    `}}class E{constructor(e,t,n,o=!1,i=!1,r=null,a=null,s=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout={x:[],y:[1,2],z:[0]},this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize);const u=null!=r,l=null!=s;u&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.transposeA=o,this.transposeB=i,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=t,this.batchBEqualOne=n,this.shaderKey=`matMulReduce_${this.activation}_${o}_${i}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getUserCode(){let e,t;e=!1===this.transposeA?"return f32(A[batch * batchASize + row * uniforms.dimInner + col]);":"return f32(A[batch * batchASize + col * uniforms.dimAOuter + row]);",t=!1===this.transposeB?"return f32(B[batch * batchBSize + row * uniforms.dimBOuter + col]);":"return f32(B[batch * batchBSize + col * uniforms.dimInner + row]);";let n="",o="";if(this.activation){const e=p(this.activation,!1);n=this.hasPreluActivationWeights?`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n               let b = getPreluActivationWeightsByOutputCoords(outCoord);\n               ${e}\n            }`:`\n              fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n                ${e}\n              }\n            `,o="value = activation(value, outCoord);"}const i=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n      ${n}\n\n      fn mm_readA(batchIn: i32, row : i32, col : i32) -> f32 {\n        ${this.batchAEqualOne?"\n          let batchASize = 0;\n          let batch = 0;\n          ":"\n          let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n          let batch = batchIn;\n          "}\n        ${e}\n      }\n\n      fn mm_readB(batchIn: i32, row : i32, col : i32) -> f32 {\n        ${this.batchBEqualOne?"\n          let batch = 0;\n          let batchBSize = 0;\n          ":"\n          let batch = batchIn;\n          let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n          "}\n        ${t}\n      }\n\n      fn mm_write(batch: i32, row : i32, col : i32, valueIn : f32) {\n        var value = valueIn;\n        let outCoord = vec3<i32>(batch, row, col);\n        ${i}\n        ${o}\n        setOutputAtCoords(batch, row, col, value);\n      }\n      \n    var<workgroup> sumValues : array<f32, workGroupSizeX>;\n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let coords = getOutputCoords();\n      let batch = coords[0];\n      let row = coords[1];\n      let col = coords[2];\n      var sum = 0.0;\n      let Length = uniforms.dimInner;\n      for (var k = i32(localId.x); k < Length; k = k + i32(workGroupSizeX)) {\n        let dataA = mm_readA(batch, row, k);\n        let dataB = mm_readB(batch, k, col);\n        sum = sum + dataA * dataB;\n      }\n      sumValues[localId.x] = sum;\n      workgroupBarrier();\n\n      for(var currentSize = workGroupSizeX / 2u; currentSize > 1u;\n          currentSize = currentSize / 2u) {\n        if (localId.x < currentSize)\n        {\n          sumValues[localId.x] = sumValues[localId.x] + sumValues[localId.x + currentSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (localId.x == 0u) {\n        sum = sumValues[0] + sumValues[1];\n        mm_write(batch, row, col, sum);\n      }\n    }\n  \n    `}}class L{constructor(e,n,o,i=null,r=null,a=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,16,1],t.util.assert(e[1]<=16||n[2]<=16,(()=>"This program can be only used when A width or B Height are small")),this.outputShape=o,this.dispatchLayout={x:[2],y:[1],z:[0]},this.dispatch=[Math.ceil(o[2]/this.workGroupSize[0]),Math.ceil(2*o[1]/this.workGroupSize[1]),o[0]];const s=null!=i;s&&this.variableNames.push("bias");const u=null!=a;u&&this.variableNames.push("preluActivationWeights"),this.addBias=s,this.activation=r,this.hasPreluActivationWeights=u,this.batchAEqualOne=1===e[0],this.batchBEqualOne=1===n[0],this.shaderKey=`matMulSmallOutputSize_${this.activation}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getUserCode(){let e="",t="";if(this.activation){const n=p(this.activation,!1);e=this.hasPreluActivationWeights?`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n            let b = getPreluActivationWeightsByOutputCoords(outCoord);\n            ${n}\n            }`:`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n            ${n}\n        }`,t="value = activation(value, outCoord);"}const n=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n      ${e}\n\n      fn mm_readA(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchAEqualOne?"\n          let batch = 0;\n          let batchASize = 0;\n          ":"\n          let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n          let batch = i32(globalId.z);\n          "}\n        if (coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n          return A[batch * batchASize + row * uniforms.dimInner + col];\n        }\n        return 0.0;\n      }\n      fn mm_readB(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchBEqualOne?"\n          let batch = 0;\n          let batchBSize = 0;\n          ":"\n          let batch = i32(globalId.z);\n          let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n          "}\n        if (coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n           return B[batch * batchBSize + row * uniforms.dimBOuter + col];\n         }\n         return 0.0;\n      }\n      fn mm_write(row : i32, col : i32, valueIn : f32, globalId : vec3<u32>) {\n        if (coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimBOuter))) {\n          let batch = i32(globalId.z);\n          let outCoord = vec3<i32>(batch, row, col);\n          var value = valueIn;\n          ${n}\n          ${t}\n          setOutputAtCoords(batch, row, col, value);\n        }\n      }\n      ${function(e){const t=e[1]/2,n=e[0],o=t>n?t:n;return`\n  var<workgroup> mm_Asub1 : array<array<f32, ${o}>, ${t}>;\n  var<workgroup> mm_Bsub1 : array<array<f32, ${n}>, ${o}>;\n  var<workgroup> mm_Asub2 : array<array<f32, ${o}>, ${t}>;\n  var<workgroup> mm_Bsub2 : array<array<f32, ${n}>, ${o}>;\n\n  // If the output size is small for matrix multiplication, avoid to use vec4\n  // and handle some elements per thread to optimally utilize the ALU.\n  // Introduces two shared memory buffers, some logical threads could handle\n  // arithmetic operations and others handle IO operations between barrier api,\n  // makes ALUs and load/store units work simultaneously, could improves\n  // the performance.\n  \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n    let tileRow = i32(localId.y);\n    let tileCol = i32(localId.x);\n    let globalRow = i32(globalId.y);\n    let globalCol = i32(globalId.x);\n\n    // uniforms.dimInner should be greater than 0.\n    let numTiles = (uniforms.dimInner - 1) / ${o} + 1;\n    var acc = 0.0;\n\n    var globalColA = tileCol;\n    var globalRowB = tileRow;\n    for (var t = 0; t < numTiles; t = t + 1) {\n      if (t == 0) {\n        if (tileRow < ${t}) {\n          // Load one tile of A and B into local memory.\n          // globalRow is always greater than or equal tileRow.\n          mm_Asub1[tileRow][tileCol] =\n              mm_readA((globalRow - tileRow) / 2 + tileRow, globalColA, globalId);\n          globalColA = globalColA + ${o};\n          mm_Bsub1[tileRow][tileCol] = mm_readB(globalRowB, globalCol, globalId);\n          globalRowB = globalRowB + ${o};\n        }\n      } else {\n        if (tileRow < ${t}) {\n          // Load one tile of A and B into local memory.\n          // globalRow is always greater than or equal tileRow.\n          mm_Asub1[tileRow][tileCol] =\n              mm_readA((globalRow - tileRow) / 2 + tileRow, globalColA, globalId);\n          globalColA = globalColA + ${o};\n          mm_Bsub1[tileRow][tileCol] = mm_readB(globalRowB, globalCol, globalId);\n          globalRowB = globalRowB + ${o};\n        } else {\n          // Compute acc values for a single thread.\n          for (var k = 0; k < ${o}; k = k + 1) {\n            let subRow = tileRow - ${t};\n            if (subRow < 0) {\n              continue;\n            }\n            acc = acc + mm_Asub2[subRow][k] * mm_Bsub2[k][tileCol];\n          }\n        }\n      }\n      workgroupBarrier();\n      if (t != 0) {\n        t = t + 1;\n      }\n\n      if (t < numTiles) {\n        if (tileRow < ${t}) {\n          // Load one tile of A and B into local memory.\n          // globalRow is always greater than or equal tileRow.\n          mm_Asub2[tileRow][tileCol] =\n              mm_readA((globalRow - tileRow) / 2 + tileRow, globalColA, globalId);\n          globalColA = globalColA + ${o};\n          mm_Bsub2[tileRow][tileCol] = mm_readB(globalRowB, globalCol, globalId);\n          globalRowB = globalRowB + ${o};\n        } else {\n          // Compute acc values for a single thread.\n          for (var k = 0; k < ${o}; k = k + 1) {\n            let subRow = tileRow - ${t};\n            if (subRow < 0) {\n              continue;\n            }\n            acc = acc + mm_Asub1[subRow][k] * mm_Bsub1[k][tileCol];\n          }\n        }\n      }\n      workgroupBarrier();\n    }\n    let writeCol = (globalRow - tileRow) / 2 + tileRow - ${t};\n    if (tileRow >= ${t} && writeCol >= 0) {\n      mm_write(writeCol, globalCol, acc, globalId);\n    }\n  }\n  `}(this.workGroupSize)}\n    `}}function W(e){const{inputs:n,attrs:o}=e,{x:i}=n,{shape:r}=o,a=t.util.sizeFromShape(i.shape),s=t.util.inferFromImplicitShape(r,a),u=t.util.sizeFromShape(s);return t.util.assert(a===u,(()=>`The new shape (${s}) has ${u} elements and the old shape (${i.shape}) has ${a} elements. The new shape and old shape must have the same number of elements.`)),e.backend.incRef(i.dataId),{dataId:i.dataId,shape:s,dtype:i.dtype}}const O={kernelName:t.Reshape,backendName:"webgpu",kernelFunc:W};function F({a:e,b:n,transposeA:o,transposeB:i,backend:r,bias:a=null,preluActivationWeights:s=null,leakyreluAlpha:u=0,activation:l=null}){const d=e.shape.length,c=n.shape.length,p=o?e.shape[d-2]:e.shape[d-1],h=i?n.shape[c-1]:n.shape[c-2],f=o?e.shape[d-1]:e.shape[d-2],m=i?n.shape[c-2]:n.shape[c-1],g=e.shape.slice(0,-2),b=n.shape.slice(0,-2),I=t.util.sizeFromShape(g),k=t.util.sizeFromShape(b),w=t.broadcast_util.assertAndGetBroadcastShape(e.shape.slice(0,-2),n.shape.slice(0,-2)).concat([f,m]);t.util.assert(p===h,(()=>`Error in matMul: inner shapes (${p}) and (${h}) of Tensors with shapes ${e.shape} and ${n.shape} and transposeA=${o} and transposeB=${i} must match.`));const x=o?[I,p,f]:[I,f,p],v=i?[k,m,h]:[k,h,m],S=W({inputs:{x:e},backend:r,attrs:{shape:x}}),y=W({inputs:{x:n},backend:r,attrs:{shape:v}}),C=[S,y],z=Math.max(I,k),_=1===I,G=1===k,$=p%4==0&&m%4==0&&!o&&!i;let A;A=f*m<=32?new E([z,f,m],_,G,o,i,a,l,s):o||i||!(f<=16&&(m<=512||h>=2*m)||m<=16&&(f<=512||p>=2*f))?$?new B(x,[z,f,m],t.env().get("WEBGPU_MATMUL_WORK_PER_THREAD"),_,G,a,l,s):new N(x,[z,f,m],t.env().get("WEBGPU_MATMUL_WORK_PER_THREAD"),_,G,o,i,a,l,s):new L(x,v,[z,f,m],a,l,s);const R=[S,y];a&&R.push(a),s&&R.push(s);const T=[{type:"int32",data:[f]},{type:"int32",data:[m]},{type:"int32",data:[p]}];"leakyrelu"===l&&(T.push({type:"float32",data:[u]}),A.uniforms+=" alpha : f32,");const P=r.runWebGPUProgram(A,R,e.dtype,T),O=W({inputs:{x:P},backend:r,attrs:{shape:w}});C.push(P);for(const e of C)r.disposeData(e.dataId);return O}const D={kernelName:t._FusedMatMul,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{a:i,b:r,bias:a,preluActivationWeights:s}=t,{transposeA:u,transposeB:l,activation:d,leakyreluAlpha:c}=o;return F({a:i,b:r,transposeA:u,transposeB:l,backend:n,bias:a,preluActivationWeights:s,leakyreluAlpha:c,activation:d})}};class U{constructor(e,n,o){this.variableNames=["AReal","AImag","BReal","BImag"],this.workGroupSize=[128,1,1],this.size=!0,this.outputShape=t.backend_util.assertAndGetBroadcastShape(n,o),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`binaryOpComplex_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOpComplex(\n          areal : f32, aimag : f32, breal : f32, bimag : f32) -> f32 {\n        ${l(this.op,!1)}\n      }\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if(index < uniforms.size) {\n          let areal = getARealByOutputIndex(index);\n          let aimag = getAImagByOutputIndex(index);\n          let breal = getBRealByOutputIndex(index);\n          let bimag = getBImagByOutputIndex(index);\n          setOutputAtIndex(index, binaryOpComplex(areal, aimag, breal, bimag));\n        }\n      }\n    `}}class M{constructor(e,n,o,i){this.variableNames=["A","B"],this.size=!0;this.workGroupSize=[256,1,1],this.outputShape=t.backend_util.assertAndGetBroadcastShape(n,o),this.dispatchLayout=_(this.outputShape),this.lastDimensionSize=i?o[0]:n[0],this.lastDimensionSize<256?this.workPerThread=1:this.lastDimensionSize<512?this.workPerThread=2:this.workPerThread=4,this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.useSharedMemoryWithB=i,this.op=e,this.shaderKey=`binaryShared_${e}_${this.lastDimensionSize}_${this.useSharedMemoryWithB}`}getUserCode(){const e=this.lastDimensionSize>1?`coords[${this.outputShape.length-1}]`:"0",t=this.useSharedMemoryWithB?`let a = getAByOutputCoords(coords);\n         let b = sharedBuf[${e}];`:`let a = sharedBuf[${e}];\n         let b = getBByOutputCoords(coords);`;return`\n        fn binaryOperation(a : f32, b : f32) -> f32 {\n          ${l(this.op,!1)}\n        }\n        var<workgroup> sharedBuf : array<f32, ${this.lastDimensionSize}>;\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n          // Fill in the shared memory buffer. Here we need a loop to make sure\n          // that all data in A|B are uploaded when |sharedMemorySize| is larger\n          // than work group size.\n          for(var localIndex = i32(localId.x); localIndex < ${this.lastDimensionSize}; localIndex = localIndex + ${this.workGroupSize[0]}) {\n            sharedBuf[localIndex] = f32(${this.useSharedMemoryWithB?"B":"A"}[localIndex]);\n          }\n          workgroupBarrier();\n\n          for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n            let flatIndex = index * ${this.workPerThread} + i;\n            if(flatIndex < uniforms.size) {\n              let coords = getCoordsFromIndex(flatIndex);\n\n              ${t}\n              setOutputAtIndex(flatIndex, binaryOperation(a, b));\n            }\n          }\n        }\n        `}}class V{constructor(e,n,o){this.variableNames=["A","B"],this.workPerThread=4,this.isVec4=!0,this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=t.backend_util.assertAndGetBroadcastShape(n,o),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.op=e,this.shaderKey=`binaryVec4_${e}`}getUserCode(){return`\n      fn binaryOperation(a : vec4<f32>, b : vec4<f32>) -> vec4<f32> {\n        ${l(this.op,this.isVec4)}\n      }\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          let b = getBByOutputIndex(index);\n          setOutputAtIndex(index, binaryOperation(a, b));\n        }\n      }\n    `}}class X{constructor(e,n,o){this.variableNames=["A","B"],this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=t.backend_util.assertAndGetBroadcastShape(n,o),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`binary_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOperation(a : f32, b : f32) -> f32 {\n        ${l(this.op,!1)}\n      }\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          let b = getBByOutputIndex(index);\n          setOutputAtIndex(index, binaryOperation(a, b));\n        }\n      }\n      `}}function q(e,n,o){if(t.util.arraysEqual(n,o)&&t.util.sizeFromShape(n)%4==0)return new V(e,n,o);const i=1===n.length&&o.length>1&&n[0]<1024,r=1===o.length&&n.length>1&&o[0]<1024;return i||r?new M(e,n,o,r):new X(e,n,o)}function H(e){const{inputs:t}=e,{x:n}=t;return e.backend.incRef(n.dataId),{dataId:n.dataId,shape:n.shape,dtype:n.dtype}}const Y={kernelName:t.Identity,backendName:"webgpu",kernelFunc:H};function K(e){const{inputs:t,backend:n}=e,{real:o,imag:i}=t,r=n.makeTensorInfo(o.shape,"complex64"),a=n.tensorMap.get(r.dataId),s=H({inputs:{x:o},backend:n}),u=H({inputs:{x:i},backend:n});return a.complexTensorInfos={real:s,imag:u},r}const j={kernelName:t.Complex,backendName:"webgpu",kernelFunc:K};class Q{constructor(e,t){this.variableNames=["A"],this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.op=t,this.shaderKey=`unary_${t}`}getUserCode(){return`\n      fn unaryOperation(a : f32) -> f32 {\n        ${c(this.op,!1)}\n      }\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          setOutputAtIndex(index, unaryOperation(a));\n        }\n      }\n      `}}function Z({opType:e,cpuKernelImpl:t,dtype:n}){return({inputs:o,backend:i})=>{const{x:r}=o,a=i,s=n||r.dtype;if(a.shouldExecuteOnCPU([r])&&null!=t){const e=a.tensorMap.get(r.dataId),n=t(e.values,s);return a.makeTensorInfo(r.shape,s,n)}const u=new Q(r.shape,e);return a.runWebGPUProgram(u,[r],s)}}function J({opSnippet:e,cpuKernelImpl:n,supportsComplex:o=!1,dtype:i}){return({inputs:a,backend:s})=>{const{a:u,b:l}=a,d=s;if(o&&"complex64"===u.dtype){const n=d.tensorMap.get(u.dataId),o=d.tensorMap.get(l.dataId);let i,a;if(e!==r.MUL)[i,a]=[[n.complexTensorInfos.real,o.complexTensorInfos.real],[n.complexTensorInfos.imag,o.complexTensorInfos.imag]].map((n=>{const[o,i]=n,r={dataId:o.dataId,dtype:o.dtype,shape:u.shape},a={dataId:i.dataId,dtype:i.dtype,shape:l.shape},s=q(e,u.shape,l.shape);return d.runWebGPUProgram(s,[r,a],t.upcastType(o.dtype,i.dtype))}));else{const e=new U(r.COMPLEX_MULTIPLY_REAL,u.shape,l.shape),t=new U(r.COMPLEX_MULTIPLY_IMAG,u.shape,l.shape),s=[{dataId:n.complexTensorInfos.real.dataId,dtype:n.complexTensorInfos.real.dtype,shape:u.shape},{dataId:n.complexTensorInfos.imag.dataId,dtype:n.complexTensorInfos.imag.dtype,shape:u.shape},{dataId:o.complexTensorInfos.real.dataId,dtype:o.complexTensorInfos.real.dtype,shape:l.shape},{dataId:o.complexTensorInfos.imag.dataId,dtype:o.complexTensorInfos.imag.dtype,shape:l.shape}];i=d.runWebGPUProgram(e,s,"float32"),a=d.runWebGPUProgram(t,s,"float32")}const s=K({inputs:{real:i,imag:a},backend:d});return d.disposeData(i.dataId),d.disposeData(a.dataId),s}const c=i||t.upcastType(u.dtype,l.dtype);if(("string"===u.dtype||"string"===l.dtype||d.shouldExecuteOnCPU([u,l]))&&null!=n){const e=d.tensorMap.get(u.dataId).values,o=d.tensorMap.get(l.dataId).values,i="string"===u.dtype?t.backend_util.fromUint8ToStringArray(e):e,r="string"===u.dtype?t.backend_util.fromUint8ToStringArray(o):o,[a,s]=n(u.shape,l.shape,i,r,c);return d.makeTensorInfo(s,c,a)}const p=q(e,u.shape,l.shape);return d.runWebGPUProgram(p,[u,l],c)}}function ee(e){return(n,o,i,r,a)=>{const s=t.backend_util.assertAndGetBroadcastShape(n,o),u=s.length,l=t.util.computeStrides(s),d=t.util.sizeFromShape(s),c=t.util.getTypedArrayFromDType(a,d),p=n.length,h=o.length,f=t.util.computeStrides(n),m=t.util.computeStrides(o),g=t.backend_util.getBroadcastDims(n,s),b=t.backend_util.getBroadcastDims(o,s);if(g.length+b.length===0)for(let t=0;t<c.length;++t)c[t]=e(i[t%i.length],r[t%r.length]);else for(let n=0;n<c.length;++n){const o=t.util.indexToLoc(n,u,l),a=o.slice(-p);g.forEach((e=>a[e]=0));const s=t.util.locToIndex(a,p,f),d=o.slice(-h);b.forEach((e=>d[e]=0));const I=t.util.locToIndex(d,h,m);c[n]=e(i[s],r[I])}return[c,s]}}const te=ee(((e,t)=>e+t));function ne(e){return(n,o,i)=>{const r=t.util.getTypedArrayFromDType(o,n.length);for(let t=0;t<n.length;++t)r[t]=e(n[t],i);return r}}const oe=ne((e=>Math.ceil(e)));const ie=ee(((e,t)=>e===t?1:0)),re=ne((e=>Math.exp(e))),ae=ne((e=>Math.expm1(e))),se=ne((e=>Math.floor(e)));const ue=ee(((e,t)=>e>t?1:0)),le=ee(((e,t)=>e>=t?1:0)),de=ee(((e,t)=>e<t?1:0)),ce=ee(((e,t)=>e<=t?1:0));const pe=ne((e=>Math.log(e)));const he=ee(((e,t)=>Math.max(e,t))),fe=ee(((e,t)=>Math.min(e,t))),me=ee(((e,t)=>e*t));const ge=ee(((e,t)=>e!==t?1:0));const be=ne((e=>1/Math.sqrt(e)));const Ie=ne((e=>1/(1+Math.exp(-e))));const ke=ne((e=>Math.sqrt(e))),we=ee(((e,t)=>{const n=e-t;return n*n}));class xe{constructor(e,n,o,i,r,a){this.separator=t.util.encodeString(e),this.nGramWidths=n,this.leftPad=t.util.encodeString(o),this.rightPad=t.util.encodeString(i),this.padWidth=r,this.preserveShort=a}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,o,i,r){for(let a=0;a<i;++a){const s=this.getPadWidth(r),u=Math.max(0,s-a),l=Math.max(0,s-(i-(a+1))),d=r-(u+l),c=t+(u>0?0:a-s);let p=0;p+=u*this.leftPad.length;for(let t=0;t<d;++t)p+=e[c+t].length;p+=l*this.rightPad.length;p+=(u+l+d-1)*this.separator.length,n[o+a]=new Uint8Array(p);const h=n[o+a];let f=0;const m=e=>e.forEach((e=>h[f++]=e));for(let e=0;e<u;++e)m(this.leftPad),m(this.separator);for(let t=0;t<d-1;++t)m(e[c+t]),m(this.separator);if(d>0){m(e[c+d-1]);for(let e=0;e<l;++e)m(this.separator),m(this.rightPad)}else{for(let e=0;e<l-1;++e)m(this.rightPad),m(this.separator);m(this.rightPad)}}}compute(e,n){const o=e.length,i=n.length;if(i>0){let e=n[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let t=1;t<i;++t){let i=n[t]>=e;if(i=i&&n[t]<=o,!i)throw new Error(`Invalid split value ${n[t]}, must be in [${e}, ${o}]`);e=n[t]}if(e!==o)throw new Error(`Last split value must be data size. Expected ${o}, got ${e}`)}const r=i-1,a=t.util.getArrayFromDType("int32",i);if(0===o||0===i){const e=new Array(o);for(let e=0;e<=r;++e)a[e]=0;return[e,a]}a[0]=0;for(let e=1;e<=r;++e){const t=n[e]-n[e-1];let o=0;this.nGramWidths.forEach((e=>{o+=this.getNumNGrams(t,e)})),this.preserveShort&&t>0&&0===o&&(o=1),a[e]=a[e-1]+o}const s=new Array(a[r]);for(let t=0;t<r;++t){const o=n[t];let i=a[t];if(this.nGramWidths.forEach((r=>{const a=n[t+1]-n[t],u=this.getNumNGrams(a,r);this.createNGrams(e,o,s,i,u,r),i+=u})),this.preserveShort&&i===a[t]){const r=n[t+1]-n[t];if(0===r)continue;const a=r+2*this.padWidth,u=1;this.createNGrams(e,o,s,i,u,a)}}return[s,a]}}function ve(e,t,n,o){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)o.push(e.subarray(t,t+1));return}if(1===t.length){const i=t[0];let r=e.indexOf(i);for(;-1!==r;){const t=e.subarray(0,r);n&&0===t.length||o.push(t),r=(e=e.subarray(r+1)).indexOf(i)}return void(n&&0===e.length||o.push(e))}let i=0;for(let r=0;r<e.length+1;r++)if(r===e.length||-1!==t.indexOf(e[r])){const t=e.subarray(i,r);n&&0===t.length||o.push(t),i=r+1}}const Se=ee(((e,t)=>e-t));const ye=(e,t)=>{const n=t.value-e.value;return 0===n?e.index-t.index:n};function Ce(e,n,o=0,i=e.length-1){for(;i>o;){if(i-o>600){const t=i-o+1,r=n-o+1,a=Math.log(t),s=.5*Math.exp(2*a/3),u=.5*Math.sqrt(a*s*(t-s)/t)*Math.sign(r-t/2);Ce(e,n,Math.max(o,Math.floor(n-r*s/t+u)),Math.min(i,Math.floor(n+(t-r)*s/t+u)))}const r=e[n];let a=o,s=i;for(t.util.swap(e,o,n),ye(e[i],r)>0&&t.util.swap(e,o,i);a<s;){for(t.util.swap(e,a,s),a++,s--;ye(e[a],r)<0;)a+=1;for(;ye(e[s],r)>0;)s-=1}0===ye(e[o],r)?t.util.swap(e,o,s):(s+=1,t.util.swap(e,s,i)),s<=n&&(o=s+1),n<=s&&(i=s-1)}}var ze={__proto__:null,simpleAbsImpl:function(e){const t=new Float32Array(e.length);for(let n=0;n<e.length;++n)t[n]=Math.abs(e[n]);return t},addImpl:te,bincountImpl:function(e,n,o,i,r){const a=t.util.sizeFromShape(i),s=t.util.makeZerosTypedArray(r,o);for(let t=0;t<e.length;t++){const o=e[t];if(o<0)throw new Error("Input x must be non-negative!");o>=r||(s[o]+=a>0?n[t]:1)}return s},bincountReduceImpl:function(e,n,o,i=!1){const r=e.shape[0],a=e.shape[1],s=t.buffer([r,o],n.dtype);for(let t=0;t<r;t++)for(let r=0;r<a;r++){const a=e.get(t,r);if(a<0)throw new Error("Input x must be non-negative!");a>=o||(i?s.set(1,t,a):n.size>0?s.set(s.get(t,a)+n.get(t,r),t,a):s.set(s.get(t,a)+1,t,a))}return s},ceilImpl:oe,concatImpl:function(e,n,o,i){const r=t.util.getArrayFromDType(o,t.util.sizeFromShape(n));if(i&&"string"!==o){let n=0;e.forEach((e=>{const o=t.util.sizeFromShape(e.shape);r.set(e.vals,n),n+=o}))}else{let i=0;e.forEach((e=>{const a="string"===o?t.backend_util.fromUint8ToStringArray(e.vals):e.vals;let s=0;for(let t=0;t<e.shape[0];++t){const o=t*n[1]+i;for(let t=0;t<e.shape[1];++t)r[o+t]=a[s++]}i+=e.shape[1]}))}return r},equalImpl:ie,expImpl:re,expm1Impl:ae,floorImpl:se,gatherNdImpl:function(e,n,o,i,r,a,s,u,l){const d=t.buffer([i,a],o);for(let t=0;t<i;t++){const o=[];let i=0;for(let n=0;n<r;n++){const a=e[t*r+n];i+=a*s[n],o.push(a)}if(i<0||i>=l/a)throw new Error(`Invalid indices: ${o} does not index into ${u}`);for(let e=0;e<a;e++)d.values[t*a+e]=n.get(...n.indexToLoc(i*a+e))}return d},gatherV2Impl:function(e,n,o){const i=t.buffer(o,e.dtype);for(let t=0;t<i.size;++t){const o=i.indexToLoc(t).slice(),r=o[0],a=o[2],s=n.locToIndex([r,a]);o[2]=n.values[s];const u=e.locToIndex(o);0<=u&&u<e.values.length&&(i.values[t]=e.values[u])}return i},greaterImpl:ue,greaterEqualImpl:le,lessImpl:de,lessEqualImpl:ce,linSpaceImpl:function(e,n,o){const i=(n-e)/(o-1),r=t.util.makeZerosTypedArray(o,"float32");r[0]=e;for(let e=1;e<r.length;e++)r[e]=r[e-1]+i;return r},logImpl:pe,maxImpl:function(e,n,o,i){const r=t.util.getTypedArrayFromDType(i,t.util.sizeFromShape(o));for(let t=0;t<r.length;++t){const o=t*n;let i=e[o];for(let t=0;t<n;++t){const n=e[o+t];(Number.isNaN(n)||n>i)&&(i=n)}r[t]=i}return r},maximumImpl:he,minimumImpl:fe,multiplyImpl:me,negImpl:function(e,n,o){const i=t.util.createScalarValue(-1,o);return me([],n,i,e,o)},notEqualImpl:ge,prodImpl:function(e,n,o,i){const[r,a]=t.backend_util.computeOutAndReduceShapes(e,i),s=t.upcastType(n,"int32"),u=t.util.makeZerosTypedArray(t.util.sizeFromShape(r),s),l=t.util.sizeFromShape(a);for(let e=0;e<u.length;++e){const t=e*l;let n=1;for(let e=0;e<l;++e)n*=o[t+e];u[e]=n}return{outVals:u,outShape:r,outDtype:s}},rangeImpl:function(e,n,o,i){if(e===n||e<n&&o<0||n<e&&o>1)return t.util.makeZerosTypedArray(0,i);const r=Math.abs(Math.ceil((n-e)/o)),a=t.util.makeZerosTypedArray(r,i);n<e&&1===o&&(o=-1),a[0]=e;for(let e=1;e<a.length;e++)a[e]=a[e-1]+o;return a},rsqrtImpl:be,scatterImpl:function(e,n,o,i,r,a,s,u,l,d){const c=[i/r,r],p=e.values,h=n.values;if(0===i)return t.buffer(o,n.dtype);const f=t.buffer(c,n.dtype);"string"==typeof l||"number"==typeof l?f.values.fill(l):"boolean"==typeof l&&f.values.fill(+l);for(let e=0;e<a;e++){const t=[];let a=0;for(let n=0;n<s;n++){const o=p[e*s+n];t.push(o),a+=o*u[n]}if(a<0||a>=i/r)throw new Error(`Invalid indices: ${t} does not index into ${o}`);for(let t=0;t<r;t++)d?f.values[a*r+t]+=h[e*r+t]:f.values[a*r+t]=0===n.rank?h[0]:h[e*r+t]}return f},sigmoidImpl:Ie,sliceImpl:function(e,n,o,i,r){const a=t.slice_util.isSliceContinous(i,n,o),s=t.util.sizeFromShape(o),u=t.util.computeStrides(i);if(a){const o=t.slice_util.computeFlatOffset(n,u);return"string"===r?e.slice(o,o+s):e.subarray(o,o+s)}const l="string"===r?t.backend_util.fromUint8ToStringArray(e):e,d=t.buffer(i,r,l),c=t.buffer(o,r);for(let e=0;e<c.size;++e){const t=c.indexToLoc(e),o=t.map(((e,t)=>e+n[t]));c.set(d.get(...o),...t)}return"string"===r?t.backend_util.fromStringArrayToUint8(c.values):c.values},sparseFillEmptyRowsImpl:function(e,n,o,i,r,a,s){const u=n[0],l=a[0],d=new Array(l),c=new Array(u),p=n[1];if(0===l){if(0!==u)throw new Error(t.backend_util.getSparseFillEmptyRowsIndicesDenseShapeMismatch(u));return[t.util.getArrayFromDType(o,0),[0,p],t.util.getArrayFromDType(r,0),d,c]}let h=!0,f=0;const m=new Array(l).fill(0);for(let n=0;n<u;++n){const o=e[n*p];if(o<0)throw new Error(t.backend_util.getSparseFillEmptyRowsNegativeIndexErrorMessage(n,o));if(o>=l)throw new Error(t.backend_util.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(n,o,l));++m[o],h=h&&o>=f,f=o}let g=!0;for(let e=0;e<l;++e){const t=0===m[e];d[e]=t,g=g&&!t,m[e]=Math.max(m[e],1),e>0&&(m[e]+=m[e-1])}if(g&&h){const t=e,n=i;for(let e=0;e<u;++e)c[e]=e;return[t,[u,p],n,d,c]}{const n=m[l-1],a=t.util.getArrayFromDType(o,n*p),h=t.util.getArrayFromDType(r,n),f=new Array(l).fill(0);for(let t=0;t<u;++t){const n=e[t*p],o=f[n],r=(0===n?0:m[n-1])+o;f[n]++;for(let n=0;n<p;++n)a[r*p+n]=e[t*p+n];h[r]=i[t],c[t]=r}for(let e=0;e<l;++e){if(0===f[e]){const t=0===e?0:m[e-1];a[t*p+0]=e;for(let e=1;e<p;++e)a[t*p+e]=0;h[t]=s}}return[a,[n,p],h,d,c]}},sparseReshapeImpl:function(e,n,o,i,r){const a=t.util.sizeFromShape(i),s=n[0],u=r.length,l=[];let d=1,c=-1;for(let e=0;e<u;++e){const n=r[e];if(-1===n){if(-1!==c)throw new Error(t.backend_util.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(c,e));c=e,l.push(1)}else{if(n<0)throw new Error(t.backend_util.getSparseReshapeNegativeOutputDimErrorMessage(e,n));d*=n,l.push(n)}}if(-1!==c){if(d<=0)throw new Error(t.backend_util.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage());const e=Math.trunc(a/d);if(d*e!==a)throw new Error(t.backend_util.getSparseReshapeInputOutputMultipleErrorMessage(i,l));l[c]=e}if(t.util.sizeFromShape(l)!==a)throw new Error(t.backend_util.getSparseReshapeInputOutputMismatchErrorMessage(i,l));const p=i.length,h=[];if(p>0){h[p-1]=1;for(let e=p-2;e>=0;--e)h[e]=h[e+1]*i[e+1]}const f=[];if(u>0){f[u-1]=1;for(let e=u-2;e>=0;--e)f[e]=f[e+1]*l[e+1]}const m=t.util.getArrayFromDType(o,s*u);for(let t=0;t<s;++t){let n=0;for(let o=0;o<p;++o)n+=e[t*p+o]*h[o];for(let e=0;e<u;++e)m[t*u+e]=Math.trunc(n/f[e]),n%=f[e]}return[m,[s,u],l]},sparseSegmentReductionImpl:function(e,n,o,i,r,a=!1,s=0){const u=i.length,l=[n[0],e.length/n[0]],d=l[1],c=u>0?r[u-1]+1:0;if(c<0)throw new Error(t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const p=n.slice();p[0]=c;const h=p.reduce(((e,t)=>e*t),1),f=t.util.getArrayFromDType(o,h);if(0===u)return c>0&&f.fill(s),[f,p];if(c<=0)throw new Error(t.backend_util.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());let m=0,g=1,b=0,I=r[m];for(;;){let n=0;if(g<u){if(n=r[g],I===n){++g;continue}if(I>=n)throw new Error(t.backend_util.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage())}if(I<0||I>=c)throw new Error(t.backend_util.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(I,c));I>b&&f.fill(s,b*d,I*d);for(let n=m;n<g;++n){const o=i[n];if(o<0||o>=l[0])throw new Error(t.backend_util.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(n,i[n],l[0]));for(let t=0;t<d;t++)f[I*d+t]+=e[o*d+t]}if(a)for(let e=0;e<d;e++)f[I*d+e]/=g-m;if(m=g,++g,b=I+1,I=n,g>u)break}return b<c&&f.fill(s,b*d,c*d),[f,p]},sqrtImpl:ke,squaredDifferenceImpl:we,stridedSliceImpl:function(e,n,o,i){const r=t.buffer(e,n.dtype);for(let e=0;e<r.size;e++){const t=r.indexToLoc(e),a=new Array(t.length);for(let e=0;e<a.length;e++)a[e]=t[e]*o[e]+i[e];r.set(n.get(...a),...t)}return r},stringNGramsImpl:function(e,t,n,o,i,r,a,s){return new xe(n,o,i,r,a,s).compute(e,t)},stringSplitImpl:function(e,n,o){const i=e.length,r=[];let a=0,s=0;const u=new Array(i);for(let t=0;t<i;++t){const i=r.length;ve(e[t],n,o,r);const l=r.length-i;u[t]=l,a+=l,s=Math.max(s,l)}const l=t.util.getArrayFromDType("int32",2*a),d=new Array(a),c=[i,s];let p=0;for(let e=0;e<i;++e)for(let t=0;t<u[e];++t)l[2*p]=e,l[2*p+1]=t,d[p]=r[p],++p;return[l,d,c]},stringToHashBucketFastImpl:function(e,n){const o=t.util.getArrayFromDType("int32",e.length);for(let i=0;i<e.length;++i)o[i]=t.util.fingerPrint64(e[i]).modulo(n).getLowBitsUnsigned();return o},subImpl:Se,tileImpl:function(e,n){const o=new Array(e.rank);for(let t=0;t<o.length;t++)o[t]=e.shape[t]*n[t];const i=t.buffer(o,e.dtype);for(let t=0;t<i.values.length;++t){const n=i.indexToLoc(t),o=new Array(e.rank);for(let t=0;t<o.length;t++)o[t]=n[t]%e.shape[t];const r=e.locToIndex(o);i.values[t]=e.values[r]}return i},topKImpl:function(e,n,o,i,r){const a=n[n.length-1],[s,u]=[e.length/a,a],l=t.util.getTypedArrayFromDType(o,s*i),d=t.util.getTypedArrayFromDType("int32",s*i);for(let t=0;t<s;t++){const n=t*u,o=e.subarray(n,n+u);let a=new Array(o.length);o.forEach(((e,t)=>a[t]={value:e,index:t})),i<a.length&&(Ce(a,i),a=a.slice(0,i)),r&&a.sort(ye);const s=t*i,c=l.subarray(s,s+i),p=d.subarray(s,s+i);for(let e=0;e<i;e++)c[e]=a[e].value,p[e]=a[e].index}const c=n.slice();return c[c.length-1]=i,[t.buffer(c,o,l),t.buffer(c,"int32",d)]},transposeImpl:function(e,n,o,i,r){const a=n.length,s=t.util.sizeFromShape(n),u=t.util.computeStrides(n),l=t.util.computeStrides(r),d=t.util.getTypedArrayFromDType(o,t.util.sizeFromShape(r));for(let n=0;n<s;++n){const o=t.util.indexToLoc(n,a,u),r=new Array(o.length);for(let e=0;e<r.length;e++)r[e]=o[i[e]];d[t.util.locToIndex(r,a,l)]=e[n]}return d},uniqueImpl:function(e,n,o,i){const r=t.util.parseAxisParam(n,o)[0],a=[1,o[0],1];for(let e=0;e<r;e++)a[0]*=o[e];a[1]=o[r];for(let e=r+1;e<o.length;e++)a[2]*=o[e];const s={},u=new Int32Array(o[r]),l=new t.TensorBuffer(a,i,e),d=[],c=1===a[0]&&1===a[2];for(let t=0;t<o[r];t++){let n;if(c)n=e[t].toString();else{const e=[];for(let n=0;n<a[0];n++)for(let o=0;o<a[2];o++)e.push(l.get(n,t,o));n=e.join(",")}if(void 0!==s[n])u[t]=s[n];else{const e=Object.keys(s).length;s[n]=e,u[t]=e,d.push(t)}}const p=a.slice();p[1]=Object.keys(s).length;const h=new t.TensorBuffer(p,i);d.forEach(((e,t)=>{for(let n=0;n<a[0];n++)for(let o=0;o<a[2];o++)h.set(l.get(n,e,o),n,t,o)}));const f=o.slice();return f[r]=p[1],{outputValues:h.values,outputShape:f,indices:u}}};const{addImpl:_e,ceilImpl:Ge,concatImpl:$e,equalImpl:Ae,expImpl:Re,expm1Impl:Te,floorImpl:Be,gatherNdImpl:Pe,gatherV2Impl:Ne,greaterEqualImpl:Ee,greaterImpl:Le,lessEqualImpl:We,lessImpl:Oe,logImpl:Fe,maxImpl:De,maximumImpl:Ue,minimumImpl:Me,multiplyImpl:Ve,negImpl:Xe,notEqualImpl:qe,prodImpl:He,rangeImpl:Ye,rsqrtImpl:Ke,simpleAbsImpl:je,sliceImpl:Qe,stridedSliceImpl:Ze,stringNGramsImpl:Je,subImpl:et,tileImpl:tt,topKImpl:nt,transposeImpl:ot,uniqueImpl:it}=ze,rt=Z({opType:d.ABS,cpuKernelImpl:je}),at={kernelName:t.Abs,backendName:"webgpu",kernelFunc:rt},st=J({opSnippet:r.ADD,cpuKernelImpl:_e,supportsComplex:!0}),ut={kernelName:t.Add,backendName:"webgpu",kernelFunc:st};class lt{constructor(e){this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e[0],this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.shaderKey="addN"}getUserCode(){const e=[];this.variableNames.forEach((t=>{e.push(`let v${t} = get${t}ByOutputCoords(coords);`)}));const t=this.variableNames.map((e=>`v${e}`)).join(" + ");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            ${e.join("\n        ")}\n            setOutputAtIndex(flatIndex, ${t});\n          }\n        }\n      }\n    `}}const dt={kernelName:t.AddN,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o}=e,i=n;if(1===i.length)return H({inputs:{x:i[0]},backend:o});const r=i.map((e=>e.dtype)).reduce(((e,n)=>t.upcastType(e,n))),a=i.map((e=>e.shape)),s=new lt(a);return o.runWebGPUProgram(s,i,r)}};class ct{constructor(e,n,o){this.workGroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="infinityValue : f32,",this.size=!0;const i=[n];t.backend_util.assertAxesAreInnerMostDims("arg"+o.charAt(0).toUpperCase()+o.slice(1),i,e.length),this.op="min"===o?"<":">";const[r]=t.backend_util.computeOutAndReduceShapes(e,i);this.outputShape=0===r.length?[1]:r,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,[1,1,1]),this.inputShape=e,this.shaderKey=`argMinMax${this.op}`}getUserCode(){return`\n      fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n      }\n\n      ${`\n      var<workgroup> xBestIndices : array<i32, ${this.workGroupSize[0]}>;\n      var<workgroup> xBestValues : array<f32, ${this.workGroupSize[0]}>;\n    `}\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        let outputIndex = index / i32(workGroupSizeX);\n        let reduceLength = ${(()=>1===this.inputShape.length?"uniforms.xShape":`uniforms.xShape.${m(this.inputShape.length-1)}`)()};\n\n        var bestIndex = i32(localId.x);\n        var bestValue = uniforms.infinityValue;\n        let outputCoords = getCoordsFromIndex(outputIndex);\n        for (var k = i32(localId.x); k < reduceLength && outputIndex < uniforms.size;\n            k = k + i32(workGroupSizeX)) {\n          let candidate = getX(${(()=>{let e="";if(1===this.outputShape.length)1!==this.inputShape.length&&(e+="outputCoords,");else for(let t=0;t<this.outputShape.length;t++)e+=`outputCoords.${m(t)},`;return e})()} k);\n          if (!isnan(candidate) && candidate ${this.op} bestValue) {\n            bestValue = candidate;\n            bestIndex = k;\n          }\n        }\n        xBestValues[localId.x] = bestValue;\n        xBestIndices[localId.x] = bestIndex;\n        workgroupBarrier();\n\n        var reduceSize = min(u32(reduceLength), workGroupSizeX);\n        for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n            currentSize = reduceSize / 2u) {\n          let interval = DIV_CEIL(reduceSize, 2u);\n          if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              xBestValues[localId.x] = bestValue;\n              xBestIndices[localId.x] = xBestIndices[localId.x + interval];\n            }\n          }\n          reduceSize = interval;\n          workgroupBarrier();\n        }\n\n        if (localId.x == 0u && outputIndex < uniforms.size) {\n          setOutputAtIndexI32(outputIndex, xBestIndices[localId.x]);\n        }\n      }\n    `}}class pt{constructor(e,t){this.variableNames=["A"],this.workGroupSize=[16,16,1];const n=new Array(e.length);for(let o=0;o<n.length;o++)n[o]=e[t[o]];this.outputShape=n,this.dispatchLayout={x:[0],y:[1]},this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[1,1,1]),this.shaderKey="transposeShared"}getUserCode(){return`\n      let TILE_DIM = ${this.workGroupSize[0]};\n      var<workgroup> tile : array<array<f32, ${this.workGroupSize[0]+1}>, ${this.workGroupSize[0]}>;\n      \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(local_invocation_id) localId : vec3<u32>,\n              @builtin(workgroup_id) workgroupId : vec3<u32>) {\n        var x = i32(workgroupId.x) * TILE_DIM + i32(localId.x);\n        var y = i32(workgroupId.y) * TILE_DIM + i32(localId.y);\n        let width = uniforms.outShape[0];\n        let height = uniforms.outShape[1];\n        if (x < width && y < height) {\n          tile[localId.y][localId.x] = A[y * width + x];\n        }\n        workgroupBarrier();\n\n        x = i32(workgroupId.y) * TILE_DIM + i32(localId.x);\n        y = i32(workgroupId.x) * TILE_DIM + i32(localId.y);\n        if (x < height && y < width) {\n          setOutputAtIndex((y * height + x), tile[localId.x]\n            [localId.y]);\n        }\n      }\n    `}}class ht{constructor(e,t){this.variableNames=["A"],this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let o=0;o<n.length;o++)n[o]=e[t[o]];this.outputShape=n,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.newDim=t,this.shaderKey=`transpose_${t}`}getUserCode(){const e=f(this.outputShape.length),t=function(e){const t=e.length;if(t>6)throw Error(`Transpose for rank ${t} is not yet supported`);const n=new Array(t);for(let t=0;t<e.length;t++)n[e[t]]=`resRC.${m(t)}`;return n.join()}(this.newDim);return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let resRC = getCoordsFromIndex(flatIndex);\n            setOutputAtIndex(flatIndex, A[getIndexFromCoords${this.outputShape.length}D(\n              ${e}(${t}), uniforms.aShape)]);\n          }\n        }\n      }\n    `}}function ft(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{perm:a}=i,s=o,u=r.shape.length,l=new Array(u);for(let e=0;e<l.length;e++)l[e]=r.shape[a[e]];if(o.shouldExecuteOnCPU([r])){const e=s.tensorMap.get(r.dataId).values,t=ot(e,r.shape,r.dtype,a,l);return o.makeTensorInfo(l,r.dtype,t)}if(2===r.shape.length&&t.util.arraysEqual(a,[1,0])){const e=new pt(r.shape,a);return s.runWebGPUProgram(e,[r],r.dtype)}const d=new ht(r.shape,a);return s.runWebGPUProgram(d,[r],r.dtype)}const mt={kernelName:t.Transpose,backendName:"webgpu",kernelFunc:ft};const gt={kernelName:t.ArgMax,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{axis:a}=i;let s=t.util.parseAxisParam(a,r.shape);const u=t.backend_util.getAxesPermutation(s,r.shape.length);let l=r;const d=[];null!=u&&(l=ft({inputs:{x:r},backend:o,attrs:{perm:u}}),d.push(l),s=t.backend_util.getInnerMostAxes(s.length,l.shape.length)),t.backend_util.assertAxesAreInnerMostDims("argMax",[s[0]],l.shape.length);const c=new ct(l.shape,s[0],"max"),p=[{type:"float32",data:[Number.NEGATIVE_INFINITY]}],h=o.runWebGPUProgram(c,[l],"int32",p);return d.forEach((e=>o.disposeData(e.dataId))),h}};const bt={kernelName:t.ArgMin,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{axis:a}=i;let s=t.util.parseAxisParam(a,r.shape);const u=t.backend_util.getAxesPermutation(s,r.shape.length);let l=r;const d=[];null!=u&&(l=ft({inputs:{x:r},backend:o,attrs:{perm:u}}),d.push(l),s=t.backend_util.getInnerMostAxes(s.length,l.shape.length)),t.backend_util.assertAxesAreInnerMostDims("argMin",[s[0]],l.shape.length);const c=new ct(l.shape,s[0],"min"),p=[{type:"float32",data:[Number.POSITIVE_INFINITY]}],h=o.runWebGPUProgram(c,[l],"int32",p);return d.forEach((e=>o.disposeData(e.dataId))),h}};class It{constructor(e,t){this.variableNames=["x"],this.uniforms="stride : vec2<i32>, pad : vec2<i32>, dilation : vec2<i32>, convDims : vec2<i32>, filterDims : vec2<i32>,",this.workGroupSize=[128,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`pool2D_${t}`,this.poolType=t}getUserCode(){let e="resultValue = max(value, resultValue);";"avg"===this.poolType&&(e="resultValue = resultValue + value; count = count + 1.0;");let t="resultValue";"avg"===this.poolType&&(t="resultValue / count");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let xRCCorner = vec2<i32>(coords.yz) * uniforms.stride - uniforms.pad;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};\n          var count = 0.0;\n\n          for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + uniforms.dilation.x) {\n            let xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + uniforms.dilation.y) {\n              let xC = xCCorner + wC;\n              if (xC < 0 || xC >= uniforms.convDims.y) {\n                continue;\n              }\n\n              let value = getX(batch, xR, xC, coords[3]);\n              ${e}\n            }\n          }\n\n          setOutputAtIndex(index, ${t});\n        }\n      }\n    `}}class kt{constructor(e){this.variableNames=["x"],this.uniforms="stride : vec2<i32>,",this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="poolWithFilterSizeEqualsOne"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n\n          let xRCCorner = coords.yz * uniforms.stride;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          let value = getX(batch, xRCorner, xCCorner, d);\n          setOutputAtIndex(index, value);\n        }\n      }\n    "}}const wt={kernelName:t.AvgPool,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{filterSize:a,strides:s,pad:u,dimRoundingMode:l}=i,d=t.backend_util.computePool2DInfo(r.shape,a,s,1,u,l);if(1===d.filterWidth&&1===d.filterHeight&&t.util.arraysEqual(d.inShape,d.outShape))return H({inputs:{x:r},backend:o});let c;const p=[{type:"int32",data:[d.strideHeight,d.strideWidth]}];return 1===d.filterHeight&&1===d.filterWidth?c=new kt(d):(c=new It(d,"avg"),p.push({type:"int32",data:[d.padInfo.top,d.padInfo.left]},{type:"int32",data:[d.dilationHeight,d.dilationWidth]},{type:"int32",data:[d.inHeight,d.inWidth]},{type:"int32",data:[d.effectiveFilterHeight,d.effectiveFilterWidth]})),o.runWebGPUProgram(c,[r],r.dtype,p)}};const xt={kernelName:t.BatchMatMul,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{a:i,b:r}=t,{transposeA:a,transposeB:s}=o;return F({a:i,b:r,transposeA:a,transposeB:s,backend:n})}};class vt{constructor(e,t){this.variableNames=["source"],this.workPerThread=1,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.rank=t.length,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.start=e,this.uniforms=`start : ${f(e.length)}, `,this.shaderKey="slice"}getUserCode(){const e=f(this.rank),t=function(e){if(1===e)return"sourceLoc";if(e<=6)return St.slice(0,e).map((e=>`sourceLoc.${e}`)).join(",");throw Error(`Slicing for rank ${e} is not yet supported`)}(this.rank);let n;n=1===this.start.length?this.outputShape.map(((e,t)=>"sourceLoc = uniforms.start + coords;")):this.outputShape.map(((e,t)=>`sourceLoc.${St[t]} = uniforms.start[${t}] + coords.${St[t]};`));return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          var sourceLoc : ${e};\n          let coords = getCoordsFromIndex(index);\n          ${n.join("\n")}\n          setOutputAtIndex(index, getSource(${t}));\n        }\n      }\n    `}}const St=["x","y","z","w","u","v"];function yt(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{begin:a,size:s}=i,[u,l]=t.slice_util.parseSliceParams(r,a,s);if(t.slice_util.assertParamsValid(r,u,l),o.shouldExecuteOnCPU([r])||"string"===r.dtype){const e=o.tensorMap.get(r.dataId),t=Qe(e.values,u,l,r.shape,r.dtype);return o.makeTensorInfo(l,r.dtype,t)}if(0===t.util.sizeFromShape(l))return o.makeTensorInfo(l,r.dtype,[]);const d=new vt(u,l),c=[{type:"int32",data:u}];return o.runWebGPUProgram(d,[r],r.dtype,c)}const Ct={kernelName:t.Slice,backendName:"webgpu",kernelFunc:yt},zt={kernelName:t.BatchToSpaceND,backendName:"webgpu",kernelFunc:e=>{const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{blockShape:a,crops:s}=i;t.util.assert(r.shape.length<=4,(()=>"batchToSpaceND for rank > 4 with a WebGPU backend not implemented yet"));const u=a.reduce(((e,t)=>e*t)),l=t.backend_util.getReshaped(r.shape,a,u),d=t.backend_util.getPermuted(l.length,a.length),c=t.backend_util.getReshapedPermuted(r.shape,a,u),p=t.backend_util.getSliceBeginCoords(s,a.length),h=t.backend_util.getSliceSize(c,s,a.length),f=[],m=W({inputs:{x:r},backend:o,attrs:{shape:l}}),g=ft({inputs:{x:m},backend:o,attrs:{perm:d}}),b=W({inputs:{x:g},backend:o,attrs:{shape:c}}),I=yt({inputs:{x:b},backend:o,attrs:{begin:p,size:h}});return f.push(m),f.push(g),f.push(b),f.forEach((e=>o.disposeData(e.dataId))),I}},_t=J({opSnippet:r.NOT_EQUAL,dtype:"bool",cpuKernelImpl:qe}),Gt={kernelName:t.NotEqual,backendName:"webgpu",kernelFunc:_t};function $t(e){const{inputs:t,backend:n}=e,{input:o}=t;return H({inputs:{x:n.tensorMap.get(o.dataId).complexTensorInfos.real},backend:n})}const At={kernelName:t.Real,backendName:"webgpu",kernelFunc:$t};const Rt={kernelName:t.Cast,backendName:"webgpu",kernelFunc:function e(n){const{inputs:i,backend:r,attrs:a}=n,{x:s}=i,{dtype:u}=a;if("complex64"===u){if("complex64"===s.dtype)return H({inputs:{x:s},backend:r});const t=o.zeros(s.shape),n=e({inputs:{x:s},backend:r,attrs:{dtype:"float32"}}),i=K({inputs:{real:n,imag:t},backend:r});return t.dispose(),r.disposeData(n.dataId),i}if("complex64"===s.dtype){const t=$t({inputs:{input:s},backend:r}),n=e({inputs:{x:t},backend:r,attrs:{dtype:u}});return r.disposeData(t.dataId),n}if(!t.util.hasEncodingLoss(s.dtype,u)){const e=H({inputs:{x:s},backend:r});return{dataId:e.dataId,shape:e.shape,dtype:u}}if("int32"===u)return function(e,t){const n=new Q(e.shape,d.TO_INT),o=t.runWebGPUProgram(n,[e],"int32");return{dataId:o.dataId,shape:o.shape,dtype:o.dtype}}(s,r);if("bool"===u){const e=r.makeTensorInfo([],"bool",t.util.getTypedArrayFromDType("bool",1)),n=_t({inputs:{a:s,b:e},backend:r});return r.disposeData(e.dataId),n}throw new Error(`Error in Cast: failed to cast ${s.dtype} to ${u}`)}},Tt=Z({opType:d.CEIL,cpuKernelImpl:Ge}),Bt={kernelName:t.Ceil,backendName:"webgpu",kernelFunc:Tt};class Pt{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workPerThread=4,this.workGroupSize=[64,1,1],this.isVec4=!0,this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.shaderKey="clipVec4"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          var clampedValue : vec4<f32>;\n          for (var i = 0; i < 4; i = i + 1) {\n            if (isnan(value[i])) {\n              clampedValue[i] = value[i];\n            } else {\n              clampedValue[i] = clamp(value[i], uniforms.minVal, uniforms.maxVal);\n            }\n          }\n\n          setOutputAtIndex(index, clampedValue);\n        }\n      }\n    "}}class Nt{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="clip"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          if (isnan(value)) {\n            setOutputAtIndex(index, value);\n            return;\n          }\n          setOutputAtIndex(index, clamp(value, uniforms.minVal, uniforms.maxVal));\n        }\n      }\n    "}}const Et={kernelName:t.ClipByValue,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{clipValueMin:a,clipValueMax:s}=i;let u;const l=[{type:"float32",data:[a]},{type:"float32",data:[s]}];return u=t.util.sizeFromShape(r.shape)%4==0?new Pt(r.shape):new Nt(r.shape),o.runWebGPUProgram(u,[r],r.dtype,l)}};class Lt{constructor(e){this.uniforms="",this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.backend_util.computeOutShape(e,1),this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.offsetLength=e.length-1;for(let e=0;e<this.offsetLength;e++)this.uniforms+=`offset${e} : i32,`;this.shaderKey="concat"}getUserCode(){const e=[];if(this.offsetLength>0){e.push("if (yC < uniforms.offset0){ setOutputAtCoords(coords.x, coords.y, getT0(yR, yC)); }");for(let t=1;t<this.offsetLength;t++)e.push(`else if (yC < uniforms.offset${[t]}){ setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${t-1})); }`);const t=this.offsetLength,n=this.offsetLength-1;e.push(`else { setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${n})); }`)}else e.push("setOutputAtCoords(coords.x, coords.y, getT0(yR, yC));");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            let yR = coords.x;\n            let yC = coords.y;\n\n            ${e.join("\n        ")}\n          }\n        }\n      }\n    `}}function Wt(e){const{inputs:t,backend:n}=e,{input:o}=t;return H({inputs:{x:n.tensorMap.get(o.dataId).complexTensorInfos.imag},backend:n})}const Ot={kernelName:t.Imag,backendName:"webgpu",kernelFunc:Wt};function Ft(e,n,o){const i=e[0].dtype;if("complex64"===i){const t=e.map((e=>$t({inputs:{input:e},backend:o}))),i=e.map((e=>Wt({inputs:{input:e},backend:o}))),r=Ft(t,n,o),a=Ft(i,n,o),s=K({inputs:{real:r,imag:a},backend:o});return t.forEach((e=>o.disposeData(e.dataId))),i.forEach((e=>o.disposeData(e.dataId))),o.disposeData(r.dataId),o.disposeData(a.dataId),s}let r=o.shouldExecuteOnCPU(e);if("string"===i&&(r=!0),r){const r=e.map((e=>{const i=t.util.sizeFromShape(e.shape.slice(n));return W({inputs:{x:e},backend:o,attrs:{shape:[-1,i]}})})),a=r.map((e=>({vals:o.readSync(e.dataId),shape:e.shape}))),s=t.backend_util.computeOutShape(r.map((e=>e.shape)),1),u=1===r[0].shape[0],l=$e(a,s,i,u),d=t.backend_util.computeOutShape(e.map((e=>e.shape)),n),c=o.makeTensorInfo(d,i,l);return r.forEach((e=>o.disposeData(e.dataId))),c}const{tensors2D:a,outShape:s}=function(e,n,o){const i=t.backend_util.computeOutShape(e.map((e=>e.shape)),n);return{tensors2D:e.map((e=>W({inputs:{x:e},backend:o,attrs:{shape:[t.util.sizeFromShape(e.shape.slice(0,n)),t.util.sizeFromShape(e.shape.slice(n))]}}))),outShape:i}}(e,n,o),u=a.map((e=>e.shape)),l=new Lt(u),d=[],c=new Array(u.length-1);if(c.length>0){c[0]=u[0][1],d.push({type:"int32",data:[c[0]]});for(let e=1;e<c.length;e++)c[e]=c[e-1]+u[e][1],d.push({type:"int32",data:[c[e]]})}const p=o.runWebGPUProgram(l,a,a[0].dtype,d);a.forEach((e=>o.disposeData(e.dataId)));const h=W({inputs:{x:p},backend:o,attrs:{shape:s}});return o.disposeData(p.dataId),h}function Dt(e){const{inputs:n,backend:o,attrs:i}=e,{axis:r}=i,a=t.util.parseAxisParam(r,n[0].shape)[0],s=t.backend_util.computeOutShape(n.map((e=>e.shape)),a);if(0===t.util.sizeFromShape(s))return o.makeTensorInfo(s,n[0].dtype,[]);const u=n.filter((e=>t.util.sizeFromShape(e.shape)>0));if(1===u.length)return H({inputs:{x:u[0]},backend:o});const l=u.map((e=>e.shape));return t.backend_util.assertParamsConsistent(l,a),Ft(u,a,o)}const Ut={kernelName:t.Concat,backendName:"webgpu",kernelFunc:Dt};class Mt{constructor(e,n=!1,o=null,i=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>,\n      dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,8,1],this.isVec4=!0,this.outputShape=e.outShape,t.util.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.dispatchLayout={x:[3],y:[1,2],z:[0]},1===this.outputShape[1]?this.elementsPerThread=[4,1,1]:this.elementsPerThread=[4,4,1],this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),this.convInfo=e,this.addBias=n,this.activation=o,this.hasPreluActivationWeights=i,this.addBias&&this.variableNames.push("bias"),this.hasPreluActivationWeights&&this.variableNames.push("preluActivationWeights"),this.tileAOuter=1===this.outputShape[1]?1:this.workGroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=this.tileBOuter,[this.fitA,this.fitB]=this.getShapeFit(),this.remainder=this.convInfo.inChannels%4==0,this.shaderKey=`conv2DMMVec4_${this.activation}_${this.fitA}_${this.fitB}_${this.elementsPerThread}_${this.remainder}`}getShapeFit(){const e=[this.tileAOuter,this.tileInner],t=[this.tileInner,this.tileBOuter],n=this.outputShape[1]*this.outputShape[2],o=this.outputShape[3],i=this.convInfo.filterHeight*this.convInfo.filterWidth*this.convInfo.inChannels;return[v(e,[n,i]),v(t,[i,o])]}getSampleAWithRemainder(e){return`let flatIndex${e} = getIndexFromCoords4D(coord, uniforms.xShape);\n    let divBy4Remainder${e} = flatIndex${e} % 4;\n    let divBy4Index${e} = flatIndex${e} / 4;\n    let curData${e} = x[divBy4Index${e}];\n    if (divBy4Remainder${e} == 0) {\n      temp = curData${e};\n    } else {\n      // TODO: This could end up being a redundant load with another one in\n      // the same shader invocation. Perhaps there's an opportunity for\n      // optimization\n      let nextData${e} = x[divBy4Index${e} + 1];\n      if (divBy4Remainder${e} == 1) {\n        temp = vec4<f32>(curData${e}.yzw, nextData${e}.x);\n      } else if (divBy4Remainder${e} == 2) {\n        temp = vec4<f32>(curData${e}.zw, nextData${e}.xy);\n      } else if (divBy4Remainder${e} == 3) {\n        temp = vec4<f32>(curData${e}.w, nextData${e}.xyz);\n      }\n    }\n    `}getUserCode(){const e=T(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner),t=`let outRow = r / uniforms.outShape[2];\n        let outCol = r % uniforms.outShape[2];\n        let WRow = c / (uniforms.filterDims[1] * uniforms.xShape[3]);\n        let WCol = c / uniforms.xShape[3] % uniforms.filterDims[1];\n        let inChCoord = c % uniforms.xShape[3];\n        var coord = vec4<i32>(\n            batch,\n            outRow * uniforms.stride[0] + uniforms.dilation[0] * WRow - uniforms.pad[0],\n            outCol * uniforms.stride[1] + uniforms.dilation[1] * WCol - uniforms.pad[1],\n            inChCoord);\n        var resData = vec4<f32>(0.0);\n        ${this.remainder?"// The bounds checking is always needed since we use it to pad zero for\n          // the 'same' padding type.\n          if (coordsInBounds4D(coord, uniforms.xShape)) {\n            resData = x[getIndexFromCoords4D(coord, uniforms.xShape) / 4];\n          } else {\n            resData = vec4<f32>(0.0); }":`var temp = vec4<f32>(0.0);\n          ${this.getSampleAWithRemainder(1)}\n          resData = temp;\n          if (WCol == (uniforms.filterDims[1] - 1)) {\n            coord = vec4<i32>(\n              coord.x, coord.y + 1, coord.z + 1 - uniforms.filterDims[1], 0);\n              ${this.getSampleAWithRemainder(2)}\n            if (inChCoord == 0) {\n              resData = vec4<f32>(resData.xyz, temp.x);\n            } else if (inChCoord == 1) {\n              resData = vec4<f32>(resData.xy, temp.xy);\n            } else {\n              resData = vec4<f32>(resData.x, temp.xyz);\n            }\n          }\n          `}\n        return resData;`,n=this.fitA?`${t}`:`if (r < uniforms.dimAOuter && c < uniforms.dimInner) {\n          ${t}\n         }\n         return vec4<f32>(0.0);\n        `,o=this.fitB?"return W[row * uniforms.dimBOuter / 4 + col];":"if(coordsInBounds2D(vec2<i32>(row, col * 4), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n           return W[row * uniforms.dimBOuter / 4 + col];\n         }\n         return vec4<f32>(0.0);\n        ";let i="",r="";if(this.activation){const e=p(this.activation,this.isVec4);i=this.hasPreluActivationWeights?`fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n          let b = getPreluActivationWeightsByOutputCoords(outCoord);\n          ${e}\n        }`:`\n        fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n          ${e}\n        }`,r="value = activation(value, outCoord);"}return`\n        ${i}\n        fn mm_readA(row : i32, col : i32, globalId : vec3<u32>) -> vec4<f32> {\n          let r = row;\n          let c = col * 4;\n          var batch = i32(globalId.z);\n          ${n}\n        }\n\n        fn mm_readB(row : i32, col : i32, globalId : vec3<u32>) -> vec4<f32> {\n          ${o}\n        }\n\n        fn mm_write(row : i32, col : i32, valueInput : vec4<f32>, globalId : vec3<u32>) {\n          var batch = i32(globalId.z);\n          var value = valueInput;\n          if (row < uniforms.dimAOuter && col * 4 < uniforms.dimBOuter)\n          {\n            let outCoord = vec4<i32>(\n              batch,\n              row / uniforms.outShape[2],\n              row % uniforms.outShape[2],\n              col * 4);\n            ${this.addBias?"value = value + getBiasByOutputCoords(outCoord);":""}\n            ${r}\n            setOutputAtCoords(outCoord[0], outCoord[1], outCoord[2], outCoord[3],\n              value);\n          }\n        }\n        ${e}\n      `}}class Vt{constructor(e,t=!1,n=null,o=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.dispatchLayout=this.isChannelsLast?{x:[3],y:[1,2],z:[0]}:{x:[1],y:[2,3],z:[0]},this.workGroupSize=y(this.dispatchLayout,this.outputShape),this.elementsPerThread=z(this.dispatchLayout,this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),t&&this.variableNames.push("bias"),o&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivationWeights=o,[this.fitA,this.fitB]=this.getShapeFit(),this.shaderKey=`conv2DMM_${this.elementsPerThread}_${this.activation}_${this.fitA}_${this.fitB}_${this.isChannelsLast}`}getShapeFit(){const e=this.workGroupSize[1]*this.elementsPerThread[1],n=this.workGroupSize[0]*this.elementsPerThread[0],o=e>n?e:n;t.util.assert(o%this.workGroupSize[0]==0&&o%this.workGroupSize[1]==0,(()=>"tileInner must be multiple of workgroupsize.x and workgroupsize.y"));const i=[e,o],r=[o,n],a=this.convInfo.outHeight*this.convInfo.outWidth,s=this.convInfo.outChannels,u=this.convInfo.filterHeight*this.convInfo.filterWidth*this.convInfo.inChannels;return[v(i,[a,u]),v(r,[u,s])]}getUserCode(){const e=this.isChannelsLast?"\n    let coord = vec4<i32>(batch, xRow, xCol, col % inChannels);\n    ":"\n    let coord = vec4<i32>(batch, col % inChannels, xRow, xCol);\n    ",t=this.isChannelsLast?"\n    let outCoord = vec4<i32>(\n      batch,\n      row / outWidth,\n      row % outWidth,\n      col);\n    ":"\n    let outCoord = vec4<i32>(\n      batch,\n      col,\n      row / outWidth,\n      row % outWidth);\n    ",n=P(this.elementsPerThread,this.workGroupSize),o=`\n    let inChannels = uniforms.wShape[2];\n    let outWidth = ${this.isChannelsLast?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n    let outRow = row / outWidth;\n    let outCol = row % outWidth;\n\n    let WRow = col / (uniforms.filterDims[1] * inChannels);\n    let WCol = col / inChannels % uniforms.filterDims[1];\n    let xRow = outRow * uniforms.stride[0] + uniforms.dilation[0] * WRow - uniforms.pad[0];\n    let xCol = outCol * uniforms.stride[1] + uniforms.dilation[1] * WCol - uniforms.pad[1];\n    ${e}\n    // The bounds checking is always needed since we use it to pad zero for the\n    // 'same' padding type.\n    if(coordsInBounds4D(coord, uniforms.xShape)) {\n      return x[getIndexFromCoords4D(coord, uniforms.xShape)];\n    }\n    return 0.0;`,i=this.fitA?`${o}`:`if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n      ${o}\n    }\n    return 0.0;\n    `,r=this.fitB?"return W[row * uniforms.dimBOuter + col];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n           return W[row * uniforms.dimBOuter + col];\n\t }\n\t return 0.0;\n\t ";let a="",s="";if(this.activation){const e=p(this.activation,!1);a=this.hasPreluActivationWeights?`fn activation(a: f32, outCoord : vec4<i32>) -> f32 {\n                  let b = getPreluActivationWeightsByOutputCoords(outCoord);\n                  ${e}\n                }`:`\n                  fn activation(a : f32, outCoord : vec4<i32>) -> f32 {\n                    ${e}\n                  }\n                `,s="value = activation(value, outCoord);"}const u=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n    ${a}\n    fn mm_readA(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      var batch = i32(globalId.z);\n      ${i}\n    }\n\n    fn mm_readB(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      ${r}\n    }\n\n    fn mm_write(row : i32, col : i32, valueInput : f32, globalId : vec3<u32>) {\n      var batch = i32(globalId.z);\n      var value = valueInput;\n      let outWidth = ${this.isChannelsLast?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n      ${t}\n      ${u}\n      ${s}\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)] = value;\n    }\n    ${n}\n  `}}function Xt({x:e,filter:t,convInfo:n,backend:o,bias:i=null,preluActivationWeights:r=null,leakyreluAlpha:a=0,activation:s=null}){const u=null!=i,l=null!=r,d="channelsLast"===n.dataFormat;let c;if(d&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type||1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return function({x:e,filter:t,convInfo:n,backend:o,bias:i=null,preluActivationWeights:r=null,leakyreluAlpha:a=0,activation:s=null}){const u="channelsLast"===n.dataFormat,l=!u;let d,c;if(u&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type){const i=n.inHeight*n.inWidth*n.inChannels;d=W({inputs:{x:e},backend:o,attrs:{shape:[1,n.batchSize,i]}}),c=W({inputs:{x:t},backend:o,attrs:{shape:[1,i,n.outChannels]}})}else d=W({inputs:{x:e},backend:o,attrs:{shape:u?[n.batchSize,n.inHeight*n.inWidth,n.inChannels]:[n.batchSize,n.inChannels,n.inHeight*n.inWidth]}}),c=W({inputs:{x:t},backend:o,attrs:{shape:[1,n.inChannels,n.outChannels]}});const p=F({a:u?d:c,b:u?c:d,transposeA:l,transposeB:!1,backend:o,bias:i,activation:s,preluActivationWeights:r,leakyreluAlpha:a}),h=W({inputs:{x:p},backend:o,attrs:{shape:n.outShape}});return o.disposeData(d.dataId),o.disposeData(c.dataId),o.disposeData(p.dataId),h}({x:e,filter:t,convInfo:n,backend:o,bias:i,activation:s,preluActivationWeights:r,leakyreluAlpha:a});const p=(n.inChannels%4==0||3===n.inChannels&&"VALID"===n.padInfo.type)&&n.outChannels%4==0&&d,h=[n.padInfo.top,n.padInfo.left],f=[{type:"int32",data:[n.filterHeight,n.filterWidth]},{type:"int32",data:[...h]},{type:"int32",data:[n.strideHeight,n.strideWidth]},{type:"int32",data:[n.dilationHeight,n.dilationWidth]}];c=p?new Mt(n,u,s,l):new Vt(n,u,s,l);const m=n.outHeight*n.outWidth,g=n.outChannels,b=n.filterHeight*n.filterWidth*n.inChannels;f.push({type:"int32",data:[m]},{type:"int32",data:[g]},{type:"int32",data:[b]});const I=[e,t];return u&&I.push(i),l&&I.push(r),"leakyrelu"===s&&(f.push({type:"float32",data:[a]}),c.uniforms+=" alpha : f32,"),o.runWebGPUProgram(c,I,e.dtype,f)}const qt={kernelName:t.Conv2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,attrs:o,backend:i}=e,{x:r,filter:a}=n,{strides:s,pad:u,dataFormat:l,dilations:d,dimRoundingMode:c}=o,p=t.backend_util.convertConv2DDataFormat(l);return Xt({x:r,filter:a,convInfo:t.backend_util.computeConv2DInfo(r.shape,a.shape,s,d,u,c,!1,p),backend:i})}};class Ht{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, stride : vec2<i32>, outBackprop : vec4<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.inShape,t.util.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.dispatchLayout={x:[3],y:[1,2],z:[0]},this.workGroupSize=y(this.dispatchLayout,this.outputShape),this.elementsPerThread=z(this.dispatchLayout,this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),this.shaderKey=`conv2DDerInputMM_${this.elementsPerThread}`}getUserCode(){return`\n    fn mm_readA(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      var batch = i32(globalId.z);\n      if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n      \n    let outRow = row / uniforms.outShape[2];\n    let outCol = row % uniforms.outShape[2];\n\n    let WRow = col / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n    let WCol = col / uniforms.outBackprop[3] % uniforms.filterDims[1];\n    let xR = f32(outRow - uniforms.pads[0] + WRow) / f32(uniforms.stride[0]);\n    let xC = f32(outCol - uniforms.pads[1] + WCol) / f32(uniforms.stride[1]);\n    if (xR < 0.0 || xR >= f32(uniforms.outBackprop[1]) || fract(xR) > 0.0) {\n      return 0.0;\n    }\n    if (xC < 0.0 || xC >= f32(uniforms.outBackprop[2]) || fract(xC) > 0.0) {\n      return 0.0;\n    }\n    let coord = vec4<i32>(\n        batch,\n        i32(xR),\n        i32(xC),\n        col % uniforms.outBackprop[3]);\n    return x[getIndexFromCoords4D(coord, uniforms.xShape)];\n    }\n    return 0.0;\n    }\n\n    fn mm_readB(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      let coordX = uniforms.filterDims.x - 1 -\n          row / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n      let coordY = uniforms.filterDims.y - 1 -\n          (row / uniforms.outBackprop[3]) % uniforms.filterDims[1];\n      if (row < uniforms.dimInner && col < uniforms.dimBOuter &&\n          coordX >= 0 && coordY >= 0) {\n        let coord = vec4<i32>(coordX, coordY, col,\n            row % uniforms.outBackprop[3]);\n        return W[getIndexFromCoords4D(coord, uniforms.wShape)];\n      }\n      return 0.0;\n    }\n\n    fn mm_write(row : i32, col : i32, valueInput : f32, globalId : vec3<u32>) {\n      var batch = i32(globalId.z);\n      var value = valueInput;\n      let outCoord = vec4<i32>(\n          batch,\n          row / uniforms.outShape[2],\n          row % uniforms.outShape[2],\n          col);\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)] = value;\n    }\n\n    ${P(this.elementsPerThread,this.workGroupSize)}\n  `}}class Yt{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, stride : vec2<i32>, outBackprop : vec4<i32>,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,this.shaderKey=`conv2DDerInput_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3;return`\n    \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[${this.isChannelsLast?3:1}];\n\n        let dyCorner = vec2<i32>(coords[${e}]), coords[${t}]) - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n          let dyR = (f32(dyRCorner) + f32(wR)) / f32(uniforms.stride.x);\n          let wRPerm = uniforms.filterDims.x - 1 - wR;\n          if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) || fract(dyR) > 0.0 ||\n              wRPerm < 0) {\n            continue;\n          }\n          let idyR = dyR;\n\n          for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n            let dyC = (f32(dyCCorner) + f32(wC)) / f32(uniforms.stride.y);\n            let wCPerm = uniforms.filterDims.y - 1 - wC;\n            if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n                fract(dyC) > 0.0 || wCPerm < 0) {\n              continue;\n            }\n            let idyC = dyC;\n\n            for (var d2 = 0; d2 < uniforms.outBackprop[3]; d2 = d2 + 1) {\n              if (${this.isChannelsLast}) {\n                let xValue = getDy(batch, idyR, idyC, d2);\n                let wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd = dotProd + xValue * wValue;\n              } else {\n                let xValue = getDy(batch, d2, idyR, idyC);\n                let wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd = dotProd + xValue * wValue;\n              }\n\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}const Kt={kernelName:t.Conv2DBackpropInput,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{dy:r,filter:a}=n,{inputShape:s,strides:u,pad:l,dataFormat:d,dimRoundingMode:c}=i,p=t.backend_util.convertConv2DDataFormat(d),h=t.backend_util.computeConv2DInfo(s,a.shape,u,1,l,c,!1,p),f=[{type:"int32",data:[h.filterHeight,h.filterWidth]},{type:"int32",data:[h.filterHeight-1-h.padInfo.top,h.filterWidth-1-h.padInfo.left]},{type:"int32",data:[h.strideHeight,h.strideWidth]},{type:"int32",data:[h.batchSize,h.outHeight,h.outWidth,h.outChannels]}];let m;if(t.env().getBool("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE"))m=new Yt(h);else{m=new Ht(h);const e=h.inShape[1]*h.inShape[2],t=h.inShape[3],n=h.filterHeight*h.filterWidth*h.outChannels;f.push({type:"uint32",data:[e]},{type:"uint32",data:[t]},{type:"uint32",data:[n]})}return o.runWebGPUProgram(m,[r,a],"float32",f)}},jt=Z({opType:d.COS}),Qt={kernelName:t.Cos,backendName:"webgpu",kernelFunc:jt},Zt=Z({opType:d.COSH}),Jt={kernelName:t.Cosh,backendName:"webgpu",kernelFunc:Zt};class en{constructor(e,t,n,o){this.variableNames=["Image","Boxes","BoxInd"],this.uniforms="extrapolationValue : f32,",this.workGroupSize=[64,1,1],this.size=!0;const[i]=t;this.outputShape=[i,n[0],n[1],e],this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.methodId="bilinear"===o?1:0,this.cropHeightBiggerThan1=this.outputShape[1]>1,this.cropWidthBiggerThan1=this.outputShape[2]>1,this.shaderKey=`cropAndResize_${this.methodId}_${this.cropHeightBiggerThan1}_${this.cropWidthBiggerThan1}`}getUserCode(){const[e,t]=["f32(uniforms.imageShape[1] - 1)","f32(uniforms.imageShape[2] - 1)"],[n,o,i]=this.cropHeightBiggerThan1?[`(${e} / f32(uniforms.outShape[1] - 1))`,"(y2-y1) * height_ratio",`y1*${e} + f32(y)*(height_scale)`]:["0.0","0.0",`0.5 * (y1+y2) * ${e}`],[r,a,s]=this.cropWidthBiggerThan1?[`(${t} / f32(uniforms.outShape[2] - 1))`,"(x2-x1) * width_ratio",`x1*${t} + f32(x)*(width_scale)`]:["0.0","0.0",`0.5 * (x1+x2) * ${t}`];return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let height_ratio = f32(${n});\n        let width_ratio = f32(${r});\n        let b = coords[0];\n        let y = coords[1];\n        let x = coords[2];\n        let d = coords[3];\n        // get box vals\n        let y1 = getBoxes(b, 0);\n        let x1 = getBoxes(b, 1);\n        let y2 = getBoxes(b, 2);\n        let x2 = getBoxes(b, 3);\n        // get image in batch index\n        let bInd = i32(round(getBoxInd(b)));\n        if(bInd < 0 || bInd >= uniforms.outShape[0]) {\n          return;\n        }\n        let height_scale = ${o};\n        let width_scale = ${a};\n        let in_y = ${i};\n        if( in_y < 0.0 || in_y > ${e} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let in_x = ${s};\n        if( in_x < 0.0 || in_x > ${t} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let sourceFracIndexCR = vec2<f32>(in_x,in_y);\n        if(${this.methodId} == 1) {\n          // Compute the four integer indices.\n          let sourceFloorCR = vec2<i32>(sourceFracIndexCR);\n          let sourceCeilCR = vec2<i32>(ceil(sourceFracIndexCR));\n          let topLeft = getImage(bInd, sourceFloorCR.y, sourceFloorCR.x, d);\n          let bottomLeft = getImage(bInd, sourceCeilCR.y, sourceFloorCR.x, d);\n          let topRight = getImage(bInd, sourceFloorCR.y, sourceCeilCR.x, d);\n          let bottomRight = getImage(bInd, sourceCeilCR.y, sourceCeilCR.x, d);\n          let fracCR = sourceFracIndexCR - vec2<f32>(sourceFloorCR);\n          let top = topLeft + (topRight - topLeft) * fracCR.x;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          let newValue = top + (bottom - top) * fracCR.y;\n          setOutputAtIndex(index, newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          let sourceNearestCR = vec2<i32>(floor(\n            sourceFracIndexCR + vec2<f32>(0.5,0.5)));\n          let newValue = getImage(\n            bInd, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    }\n    `}}const tn={kernelName:t.CropAndResize,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n,attrs:o}=e,{image:i,boxes:r,boxInd:a}=t,{cropSize:s,method:u,extrapolationValue:l}=o,d=new en(i.shape[3],r.shape,s,u),c=[{type:"float32",data:[l]}];return n.runWebGPUProgram(d,[i,r,a],"float32",c)}};var nn;!function(e){e.Prod="*",e.Sum="+"}(nn||(nn={}));class on{constructor(e,t,n,o){this.variableNames=["x"],this.uniforms="index : f32,",this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=t,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.exclusive=n,this.reverse=o,this.op=e,this.shaderKey=`cum_${this.op}_${this.exclusive}_${this.reverse}`}getUserCode(){const e=this.outputShape.length,t=this.op===nn.Prod?"1.0":"0.0",n=this.exclusive?t:`getX(${rn(e,"coords",this.op)})`,o=this.outputShape[this.outputShape.length-1];let i="",r="";return this.exclusive?(i=this.reverse?"end != "+(o-1):"end != 0",r=this.reverse?"end + 1":"end - 1"):(i=this.reverse?`end + pow2 < ${o}`:"end >= pow2",r=this.reverse?"end + pow2":"end - pow2"),`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n       if (index < uniforms.size) {\n         var coords = getCoordsFromIndex(index);\n\n         let end = ${an(e,"coords",this.op)};\n         var val = ${n};\n         let pow2 = i32(pow(2.0, uniforms.index));\n         if (${i}) {\n           let idx = ${r};\n           ${an(e,"coords",this.op)} = idx;\n           val ${this.op}= getX(${rn(e,"coords",this.op)});\n         }\n         setOutputAtIndex(index, val);\n       }\n      }\n    `}}function rn(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.x, ${t}.y`;if(3===e)return`${t}.x, ${t}.y, ${t}.z`;if(4===e)return`${t}.x, ${t}.y, ${t}.z, ${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function an(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.y`;if(3===e)return`${t}.z`;if(4===e)return`${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function sn(e,n,o,i,r,a){const s=n.shape.length,u=t.backend_util.getAxesPermutation([i],s);let l=n;null!=u&&(l=ft({inputs:{x:n},backend:o,attrs:{perm:u}}));const d=t.backend_util.getInnerMostAxes(1,s)[0];if(d!==s-1)throw new Error(`WebGPU cumprod shader expects an inner-most axis=${n.shape.length-1} but got axis=${i}`);const c=l.shape[d];let p=H({inputs:{x:l},backend:o});for(let t=0;t<=Math.ceil(Math.log2(c))-1;t++){const n=new on(e,l.shape,!1,a),i=p,r=[{type:"float32",data:[t]}];p=o.runWebGPUProgram(n,[p],p.dtype,r),o.disposeData(i.dataId)}if(r){const t=new on(e,l.shape,r,a),n=p,i=[{type:"float32",data:[0]}];p=o.runWebGPUProgram(t,[p],p.dtype,i),o.disposeData(n.dataId)}if(null!=u){const e=ft({inputs:{x:p},backend:o,attrs:{perm:t.backend_util.getUndoAxesPermutation(u)}});return o.disposeData(p.dataId),o.disposeData(l.dataId),e}return p}const un={kernelName:t.Cumprod,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{axis:r,exclusive:a,reverse:s}=o;return sn(nn.Prod,i,n,r,a,s)}};const ln={kernelName:t.Cumsum,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{axis:r,exclusive:a,reverse:s}=o;return sn(nn.Sum,i,n,r,a,s)}};class dn{constructor(e,t){this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.uniforms="blockSize : i32,",this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`depthToSpace_${t}`,this.dataFormat=t}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let h = ${this.getHeightCoordString()};\n          let w = ${this.getWidthCoordString()};\n          let d = ${this.getDepthCoordString()};\n\n          let in_h = h / uniforms.blockSize;\n          let offset_h = h % uniforms.blockSize;\n          let in_w = w / uniforms.blockSize;\n          let offset_w = w % uniforms.blockSize;\n          let offset_d = (offset_h * uniforms.blockSize + offset_w) *\n            ${this.getOutputDepthSize()};\n          let in_d = d + offset_d;\n\n          let rlt = ${this.getInputSamplingString()};\n          setOutputAtIndex(index, rlt);\n        }\n      }`}getHeightCoordString(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"}getWidthCoordString(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"}getDepthCoordString(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"}getOutputDepthSize(){return"NHWC"===this.dataFormat?"uniforms.outShape[3]":"uniforms.outShape[1]"}getInputSamplingString(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"}}const cn={kernelName:t.DepthToSpace,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{blockSize:r,dataFormat:a}=o,s=i.shape[0],u=("NHWC"===a?i.shape[1]:i.shape[2])*r,l=("NHWC"===a?i.shape[2]:i.shape[3])*r,d=("NHWC"===a?i.shape[3]:i.shape[1])/(r*r),c=[{type:"int32",data:[r]}],p=new dn("NHWC"===a?[s,u,l,d]:[s,d,u,l],a);return n.runWebGPUProgram(p,[i],i.dtype,c)}};class pn{constructor(e,n=!1,o=null,i=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>, inDims : vec2<i32>,",this.workGroupSize=[4,4,4],this.isVec4=!0,this.outputShape=e.outShape,this.dispatchLayout={x:[0,1],y:[2],z:[3]},this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[1,4,4]),t.util.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),n&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=n,this.activation=o,this.hasPreluActivation=i,this.shaderKey=`depthwise3x3_${o}`}getUserCode(){let e="",t="";if(this.activation){const n=p(this.activation,this.isVec4);e=this.hasPreluActivation?`fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n          let b = getPreluActivationWeightsByOutputCoords(outCoord);\n          ${n}\n        }`:`\n        fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n            ${n}\n          }\n        `,t="dotProd[i] = activation(dotProd[i], coords);"}return`\n      ${e}\n\n      \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(global_invocation_id) globalId: vec3<u32>) {\n        let batch = 0;\n        let r = i32(globalId.x);\n        let c = i32(globalId.y) * 4;\n        let d2 = i32(globalId.z) * 4;\n        let xRCCorner = vec2<i32>(r, c) * uniforms.stride - uniforms.pad;\n        let d1 = d2;\n        let q = 0;\n\n        let xRCorner = xRCCorner.x;\n        let xCCorner = xRCCorner.y;\n\n        var wVals : array<vec4<f32>, 9>;\n        wVals[0] = getW(0, 0, d1, q);\n        wVals[1] = getW(0, 1, d1, q);\n        wVals[2] = getW(0, 2, d1, q);\n        wVals[3] = getW(1, 0, d1, q);\n        wVals[4] = getW(1, 1, d1, q);\n        wVals[5] = getW(1, 2, d1, q);\n        wVals[6] = getW(2, 0, d1, q);\n        wVals[7] = getW(2, 1, d1, q);\n        wVals[8] = getW(2, 2, d1, q);\n\n        var xVals : array<array<vec4<f32>, 6>, 3>;\n        for (var wR = 0; wR < 3; wR = wR + 1) {\n          let xR = xRCorner + wR * uniforms.dilation[0];\n          for (var wC = 0; wC < 6; wC = wC + 1) {\n            let xC = xCCorner + wC * uniforms.dilation[1];\n            if (xR < 0 || xR >= uniforms.inDims[0] || xC < 0 || xC >= uniforms.inDims[1]) {\n              xVals[wR][wC] = vec4<f32>(0.0);\n            } else {\n              xVals[wR][wC] = getX(batch, xR, xC, d1);\n            }\n          }\n        }\n\n        var dotProd : array<vec4<f32>, 4>;\n        dotProd[0] = vec4<f32>(0.0);\n        dotProd[1] = vec4<f32>(0.0);\n        dotProd[2] = vec4<f32>(0.0);\n        dotProd[3] = vec4<f32>(0.0);\n\n        for (var wR = 0; wR < 3; wR = wR + 1) {\n          for (var wC = 0; wC < 3; wC = wC + 1) {\n            let indexW = wR * 3 + wC;\n            dotProd[0] = dotProd[0] + xVals[wR][0 + wC] * wVals[indexW];\n            dotProd[1] = dotProd[1] + xVals[wR][1 + wC] * wVals[indexW];\n            dotProd[2] = dotProd[2] + xVals[wR][2 + wC] * wVals[indexW];\n            dotProd[3] = dotProd[3] + xVals[wR][3 + wC] * wVals[indexW];\n          }\n        }\n\n        for (var i = 0; i < 4; i = i + 1) {\n          let coords = vec4<i32>(batch, r, c + i, d2);\n          if (coordsInBounds4D(coords, uniforms.outShape)) {\n            ${this.addBias?"dotProd[i] = dotProd[i] + getBiasByOutputCoords(coords);":""}\n            ${t}\n            setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], dotProd[i]);\n          }\n        }\n      }\n    `}}class hn{constructor(e,n=!1,o=null,i=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>,\n      inDims : vec2<i32>, filterHeight : i32, filterWidth : i32,\n      channelMul : i32,",this.workGroupSize=[256,1,1],this.outputShape=e.outShape,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),t.util.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),n&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=n,this.activation=o,this.hasPreluActivation=i,this.shaderKey=`depthwise_${this.activation}`}getUserCode(){let e="",t="";if(this.activation){const n=p(this.activation,!1);e=this.hasPreluActivation?`fn activation(a : f32, outCoord : vec4<i32>) -> f32 {\n          let b = getPreluActivationWeightsByOutputCoords(outCoord);\n          ${n}\n        }`:`\n          fn activation(a : f32, outCoord : vec4<i32>) -> f32 {\n            ${n}\n          }\n        `,t="dotProd = activation(dotProd, coords);"}return`\n      ${e}\n\n      fn writeResult(batch : i32, row : i32, col : i32, chan : i32,\n          value : f32) {\n        let coord = vec4<i32>(batch, row, col, chan);\n        if (coordsInBounds4D(coord, uniforms.outShape)) {\n          setOutputAtCoords(batch, row, col, chan, value);\n        }\n      }\n\n      \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n        let coords = getOutputCoords();\n        let batch = coords[0];\n        let xRCCorner = vec2<i32>(coords.yz) * uniforms.stride - uniforms.pad;\n        let d2 = coords[3];\n        let d1 = d2 / uniforms.channelMul;\n        let q = d2 - d1 * uniforms.channelMul;\n\n        let inputRowStart = xRCCorner.x;\n        let inputColStart = xRCCorner.y;\n        let inputRowEnd = inputRowStart + uniforms.filterHeight *\n            uniforms.dilation[0];\n        let inputColEnd = inputColStart + uniforms.filterWidth *\n            uniforms.dilation[1];\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n\n        // Extract if checking out of for loop for performance.\n        if (inputRowStart >= 0 && inputColStart >= 0 &&\n          inputRowEnd < uniforms.inDims[0] &&\n              inputColEnd < uniforms.inDims[1]) {\n            // Here using a constant value |this.convInfo.filterHeight| instead\n            // of uniform value is in order to loop unrolling.\n            for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n              let xR = inputRowStart + wR * uniforms.dilation[0];\n\n              for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                let xC = inputColStart + wC * uniforms.dilation[1];\n\n                let xVal = getX(batch, xR, xC, d1);\n                let wVal = getW(wR, wC, d1, q);\n                dotProd = dotProd + xVal * wVal;\n              }\n            }\n          } else {\n            for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n              let xR = inputRowStart + wR * uniforms.dilation[0];\n\n              if (xR < 0 || xR >= uniforms.inDims[0]) {\n                continue;\n              }\n\n              for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                let xC = inputColStart + wC * uniforms.dilation[1];\n\n                if (xC < 0 || xC >= uniforms.inDims[1]) {\n                  continue;\n                }\n\n                let xVal = getX(batch, xR, xC, d1);\n                let wVal = getW(wR, wC, d1, q);\n                dotProd = dotProd + xVal * wVal;\n              }\n            }\n          }\n\n        ${this.addBias?"dotProd = dotProd + getBiasByOutputCoords(coords);":""}\n        ${t}\n        writeResult(batch, coords[1], coords[2], d2, dotProd);\n      }\n    `}}const fn={kernelName:t.DepthwiseConv2dNative,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r,filter:a}=n,{strides:s,pad:u,dilations:l,dimRoundingMode:d}=i;let c=l;null==c&&(c=[1,1]);const p=t.backend_util.computeConv2DInfo(r.shape,a.shape,s,c,u,d,!0),h=[{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.dilationHeight,p.dilationWidth]},{type:"int32",data:[p.inHeight,p.inWidth]}];let f;return 1===p.batchSize&&p.inHeight===p.outHeight&&p.inWidth===p.outWidth&&1===p.strideHeight&&1===p.strideWidth&&p.filterHeight===p.filterWidth&&p.inChannels===p.outChannels&&1===p.dilationHeight&&1===p.dilationWidth&&3===p.filterHeight&&p.inChannels%4==0?f=new pn(p):(f=new hn(p),h.push({type:"int32",data:[p.filterHeight]},{type:"int32",data:[p.filterWidth]},{type:"int32",data:[p.outChannels/p.inChannels]})),o.runWebGPUProgram(f,[r,a],r.dtype,h)}},mn=J({opSnippet:r.MUL,cpuKernelImpl:Ve,supportsComplex:!0}),gn={kernelName:t.Multiply,backendName:"webgpu",kernelFunc:mn};class bn{constructor(e,n){this.workGroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="reduceSize : i32,",this.size=!0,this.inputShape=[e.batchSize,e.inSize];const[o]=t.backend_util.computeOutAndReduceShapes(this.inputShape,[1]);this.outputShape=0===o.length?[1]:o,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,[1,1,1]),this.reduceType=n,this.shaderKey=`reduce_${n}`}getUserCode(){let e="",t="0.0";"min"===this.reduceType||"max"===this.reduceType?(e=`\n         if (isnan(candidate)) {\n          bestValue = uniforms.NAN;\n         } else if (!isnan(bestValue) && candidate ${"min"===this.reduceType?"<":">"} bestValue)\n           {  bestValue = candidate; }`,t="f32(x[offset])"):"sum"===this.reduceType||"mean"===this.reduceType?e=" bestValue = bestValue + candidate; ":"prod"===this.reduceType&&(e=" bestValue = bestValue * candidate; ",t="1.0");const n="mean"===this.reduceType?"setOutputAtIndex(outputIndex, bestValue / f32(uniforms.reduceSize));":"setOutputAtIndex(outputIndex, bestValue);";return`\n       fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n       }\n\n       ${`\n         var<workgroup> xBestValues : array<f32, ${this.workGroupSize[0]}>;\n       `}\n       fn getOffset(outputIndex : i32) -> i32 {\n         let outputCoords = getCoordsFromIndex(outputIndex);\n         let offset = ${1===this.outputShape.length?"outputCoords":"outputCoords[0]"} * uniforms.reduceSize;\n          return offset;\n       }\n       \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n         let outputIndex = index / i32(workGroupSizeX);\n         let offset = getOffset(outputIndex);\n         var bestValue = ${t};\n         let Length = uniforms.reduceSize;\n         let WorkPerThread = DIV_CEIL(u32(Length), workGroupSizeX);\n         for (var k = i32(localId.x); k < Length && outputIndex < uniforms.size;\n             k = k + i32(workGroupSizeX)) {\n           let candidate = f32(x[offset + k]);\n           ${e}\n         }\n         xBestValues[localId.x] = bestValue;\n         workgroupBarrier();\n\n         var reduceSize = min(u32(Length), workGroupSizeX);\n         for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n             currentSize = reduceSize / 2u) {\n           let interval = DIV_CEIL(reduceSize, 2u);\n           if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            ${e}\n            xBestValues[localId.x] = bestValue;\n           }\n           reduceSize = interval;\n           workgroupBarrier();\n         }\n\n         if (localId.x == 0u && outputIndex < uniforms.size) {\n          ${n}\n        }\n       }\n     `}}function In(e,n,o,i,r){const a=e.shape.length,s=[],u=t.util.parseAxisParam(n,e.shape);let l=u;const d=t.backend_util.getAxesPermutation(l,a);let c=e;null!=d&&(c=ft({inputs:{x:e},attrs:{perm:d},backend:r}),l=t.backend_util.getInnerMostAxes(l.length,a),s.push(c)),t.backend_util.assertAxesAreInnerMostDims(i,l,a);const[p,h]=t.backend_util.computeOutAndReduceShapes(c.shape,l);let f,m=p;if(o&&(m=t.backend_util.expandShapeToKeepDim(p,u)),"max"!==i&&"prod"!==i||!r.shouldExecuteOnCPU([c])){const n=t.util.sizeFromShape(h),o={windowSize:n,inSize:n,batchSize:t.util.sizeFromShape(c.shape)/n,outSize:1},a="mean"===i?"float32":t.sumOutType(e.dtype),u=[{type:"int32",data:[n]}],l=new bn(o,i),d=r.runWebGPUProgram(l,[c],a,u);s.push(d),f=W({inputs:{x:d},attrs:{shape:m},backend:r})}else{const n=r.tensorMap.get(c.dataId).values;switch(i){case"max":const o=De(n,t.util.sizeFromShape(h),m,e.dtype);f=r.makeTensorInfo(m,e.dtype,o);break;case"prod":const{outVals:a,outShape:s,outDtype:u}=He(c.shape,c.dtype,n,l);f=r.makeTensorInfo(s,u,a);break;default:throw new Error(`${i} CPU implementation is not yet supported.`)}}return s.forEach((e=>r.disposeData(e.dataId))),f}function kn(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{axis:r,keepDims:a}=o;return In(i,r,a,"sum",n)}const wn={kernelName:t.Sum,backendName:"webgpu",kernelFunc:kn};const xn={kernelName:t.Einsum,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{equation:r}=i,a=n,{allDims:s,summedDims:u,idDims:l}=t.backend_util.decodeEinsumEquation(r,a.length);t.backend_util.checkEinsumDimSizes(s.length,l,a);const{path:d,steps:c}=t.backend_util.getEinsumComputePath(u,l),p=c.length;let h=null,f=s.length;const m=[];for(let e=0;e<p;++e){for(const n of c[e]){const{permutationIndices:e,expandDims:i}=t.backend_util.getEinsumPermutation(f,l[n]);let r;t.backend_util.isIdentityPermutation(e)?r=a[n]:(r=ft({inputs:{x:a[n]},backend:o,attrs:{perm:e}}),m.push(r));const s=r.shape.slice();for(let e=0;e<i.length;++e)s.splice(i[e],0,1);t.util.arraysEqual(r.shape,s)||(r=W({inputs:{x:r},backend:o,attrs:{shape:s}}),m.push(r)),null===h?h=r:(h=mn({inputs:{a:r,b:h},backend:o}),m.push(h))}e<p-1&&(d[e]>=0&&(h=kn({inputs:{x:h},backend:o,attrs:{axis:d[e]-(s.length-f),keepDims:!1}}),m.push(h)),f--)}for(const e of m)e!==h&&o.disposeData(e.dataId);return h}},vn=Z({opType:d.ELU}),Sn={kernelName:t.Elu,backendName:"webgpu",kernelFunc:vn},yn=J({opSnippet:r.EQUAL,dtype:"bool",cpuKernelImpl:Ae}),Cn={kernelName:t.Equal,backendName:"webgpu",kernelFunc:yn},zn=Z({opType:d.EXP,cpuKernelImpl:Re,dtype:"float32"}),_n={kernelName:t.Exp,backendName:"webgpu",kernelFunc:zn};function Gn(e){const{inputs:n,attrs:o,backend:i}=e,{dim:r}=o,{input:a}=n,s=a.shape.length,u=a.shape.slice();let l=r;return r<0&&(t.util.assert(-(s+1)<=r,(()=>`Axis must be in the interval [${-(s+1)}, ${s}]`)),l=s+r+1),u.splice(l,0,1),W({inputs:{x:a},backend:i,attrs:{shape:u}})}const $n={kernelName:t.ExpandDims,backendName:"webgpu",kernelFunc:Gn},An=Z({opType:d.EXPM1,cpuKernelImpl:Te}),Rn={kernelName:t.Expm1,backendName:"webgpu",kernelFunc:An};class Tn{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="value : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="fill"}getUserCode(){return"\n    \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n      if (index < uniforms.size) {\n        setOutputAtIndex(index, uniforms.value);\n      }\n    }\n  "}}function Bn(e){const{backend:n,attrs:o}=e,{shape:i,value:r}=o;let{dtype:a}=o;if(a=a||t.util.inferDtype(r),"string"===a){const e=t.util.getArrayFromDType(a,t.util.sizeFromShape(i));return e.fill(r),n.makeTensorInfo(i,a,e)}{const e=new Tn(i),t=[{type:"float32",data:[r]}];return n.runWebGPUProgram(e,[],a,t)}}const Pn={kernelName:t.Fill,backendName:"webgpu",kernelFunc:Bn};class Nn{constructor(e){this.outputShape=[],this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="flipLeftRight"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let coordX = uniforms.xShape[2] - coords[2] - 1;\n          let outputValue = getX(coords[0], coords[1], coordX, coords[3]);\n          setOutputAtIndex(index, outputValue);\n        }\n      }\n    "}}const En={kernelName:t.FlipLeftRight,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{image:n}=e,o=t,i=new Nn(n.shape);return o.runWebGPUProgram(i,[n],n.dtype)}},Ln=Z({opType:d.FLOOR,cpuKernelImpl:Be}),Wn={kernelName:t.Floor,backendName:"webgpu",kernelFunc:Ln},On=J({opSnippet:r.INT_DIV,dtype:"int32"}),Fn={kernelName:t.FloorDiv,backendName:"webgpu",kernelFunc:On};class Dn{constructor(e,t=!1){this.outputShape=[0],this.variableNames=[],this.workGroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.useImport=t,this.shaderKey=`fromPixels_${this.useImport}`}getUserCode(){const e=this.useImport?"textureLoad(src, vec2<i32>(coords.yx));":"textureLoad(src, vec2<i32>(coords.yx), 0)";return`\n      @binding(1) @group(0) var src: ${this.useImport?"texture_external":"texture_2d<f32>"};\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        let flatIndexBase = index * uniforms.numChannels;\n        for (var i = 0; i < uniforms.numChannels; i = i + 1) {\n          let flatIndex = flatIndexBase + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndexBase);\n            let values = ${e};\n            result[flatIndex] = i32(floor(255.0 * values[i]));\n          }\n        }\n      }\n  `}}const Un={kernelName:t.FromPixels,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e;let{pixels:r}=n;const{numChannels:a}=i;if(null==r)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");const s="undefined"!=typeof HTMLVideoElement&&r instanceof HTMLVideoElement,u="undefined"!=typeof HTMLImageElement&&r instanceof HTMLImageElement,l="undefined"!=typeof HTMLCanvasElement&&r instanceof HTMLCanvasElement||"undefined"!=typeof OffscreenCanvas&&r instanceof OffscreenCanvas,d="undefined"!=typeof ImageBitmap&&r instanceof ImageBitmap,[c,p]=s?[r.videoWidth,r.videoHeight]:[r.width,r.height],h=[p,c,a];if(t.env().getBool("WEBGPU_USE_IMPORT")&&s)return Vn({externalImage:r,backend:o,attrs:i,outShape:h,useImport:!0});(s||u)&&(null==Mn&&(Mn=document.createElement("canvas").getContext("2d")),Mn.canvas.width=c,Mn.canvas.height=p,Mn.drawImage(r,0,0,c,p),r=Mn.canvas);if(d||l||s||u)return Vn({externalImage:r,backend:o,attrs:i,outShape:h,useImport:!1});const f=r.data;let m=f;if(null!=a&&4!==a){m=new Uint8Array(r.width*r.height*a);const e=f.length;let t=0;for(let n=0;n<e;n++)n%4<a&&(m[t++]=f[n])}const g=o.makeTensorInfo(h,"int32");return o.tensorMap.get(g.dataId).values=new Int32Array(m),o.maybeReleaseBuffer(g.dataId),o.uploadToGPU(g.dataId),g}};let Mn;function Vn(e){const{externalImage:n,backend:o,attrs:i,outShape:r,useImport:a}=e,{numChannels:s}=i,u=t.util.sizeFromShape(r),l=t.util.computeStrides(r),d=new Dn(r,a),c=[{type:"uint32",data:[u]},{type:"uint32",data:[s]},{type:"uint32",data:[...l]},{type:"uint32",data:[...d.dispatch]}];return o.runFromPixelsProgram(d,r,c,a,n)}class Xn{constructor(e,n,o,i,r){this.uniforms="varianceEpsilon : f32,",this.workGroupSize=[128,1,1],this.size=!0,this.variableNames=["x","mean","variance"],t.backend_util.assertAndGetBroadcastShape(e,n),t.backend_util.assertAndGetBroadcastShape(e,o),this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),null!=i&&(t.backend_util.assertAndGetBroadcastShape(e,i),this.variableNames.push("offset")),null!=r&&(t.backend_util.assertAndGetBroadcastShape(e,r),this.variableNames.push("scale")),this.offsetShape=i,this.scaleShape=r,this.shaderKey="batchNorm"}getUserCode(){let e="0.0";null!=this.offsetShape&&(e="getOffsetByOutputIndex(index)");let t="1.0";null!=this.scaleShape&&(t="getScaleByOutputIndex(index)");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size)\n        {\n          let xValue = getXByOutputIndex(index);\n          let meanValue = getMeanByOutputIndex(index);\n          let varianValue = getVarianceByOutputIndex(index);\n          let offsetValue = ${e};\n          let scaleValue = ${t};\n          let inv = scaleValue * inverseSqrt(varianValue + f32(uniforms.varianceEpsilon));\n          setOutputAtIndex(index,dot(vec3<f32>(xValue, -meanValue, offsetValue), vec3<f32>(inv, inv, 1.0)));\n        }\n      }\n  `}}const qn={kernelName:t.FusedBatchNorm,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:o,scale:i,offset:r,mean:a,variance:s}=e,{varianceEpsilon:u}=t,l=n,d=[o,a,s];let c=null;null!=r&&(c=r.shape,d.push(r));let p=null;null!=i&&(p=i.shape,d.push(i));const h=new Xn(o.shape,a.shape,s.shape,c,p),f=[{type:"float32",data:[u]}];return l.runWebGPUProgram(h,d,o.dtype,f)}};const Hn={kernelName:t.FusedConv2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r,filter:a,bias:s,preluActivationWeights:u}=n,{strides:l,pad:d,dataFormat:c,dilations:p,dimRoundingMode:h,activation:f,leakyreluAlpha:m}=i,g=t.backend_util.convertConv2DDataFormat(c);return Xt({x:r,filter:a,convInfo:t.backend_util.computeConv2DInfo(r.shape,a.shape,l,p,d,h,!1,g),backend:o,bias:s,preluActivationWeights:u,leakyreluAlpha:m,activation:f})}};const Yn={kernelName:t.FusedDepthwiseConv2D,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r,filter:a,bias:s,preluActivationWeights:u}=n,{strides:l,pad:d,dilations:c,dimRoundingMode:p,activation:h,leakyreluAlpha:f}=i;let m=c;null==m&&(m=[1,1]),t.util.assert(t.backend_util.eitherStridesOrDilationsAreOne(l,m),(()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${l} and dilations '${m}'`));const g=t.backend_util.computeConv2DInfo(r.shape,a.shape,l,m,d,p,!0),b=[r,a],I=null!=s,k=null!=u;I&&b.push(s),k&&b.push(u);const w=[{type:"int32",data:[g.padInfo.top,g.padInfo.left]},{type:"int32",data:[g.strideHeight,g.strideWidth]},{type:"int32",data:[g.dilationHeight,g.dilationWidth]},{type:"int32",data:[g.inHeight,g.inWidth]}];let x;return 1===g.batchSize&&g.inHeight===g.outHeight&&g.inWidth===g.outWidth&&1===g.strideHeight&&1===g.strideWidth&&g.filterHeight===g.filterWidth&&g.inChannels===g.outChannels&&1===g.dilationHeight&&1===g.dilationWidth&&3===g.filterHeight&&g.inChannels%4==0?x=new pn(g,I,h,k):(x=new hn(g,I,h,k),w.push({type:"int32",data:[g.filterHeight]},{type:"int32",data:[g.filterWidth]},{type:"int32",data:[g.outChannels/g.inChannels]})),"leakyrelu"===h&&(w.push({type:"float32",data:[f]}),x.uniforms+=" alpha : f32,"),o.runWebGPUProgram(x,b,"float32",w)}};class Kn{constructor(e,t){this.variableNames=["A","indices"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`gathernd_${e}`,this.sliceDim=e,this.uniforms=`sliceDim : i32, strides : ${f(e)},`}getUserCode(){let e;e=this.sliceDim>1?"uniforms.strides[j]":"uniforms.strides";return`\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          var flattenIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexTemp = i32(round(getIndices(coords[0], j)));\n            let strideNum = ${e};\n            flattenIndex = flattenIndex + indexTemp * strideNum;\n          }\n\n          setOutputAtIndex(index, getA(flattenIndex, coords[1]));\n        }\n      }\n      `}}const jn={kernelName:t.GatherNd,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o}=e,{params:i,indices:r}=n,a=r.shape,s=a[a.length-1],u=t.util.sizeFromShape(i.shape),[l,d,c,p]=t.backend_util.prepareAndValidate(i,r),h=W({inputs:{x:r},backend:o,attrs:{shape:[d,s]}}),f=W({inputs:{x:i},backend:o,attrs:{shape:[t.util.sizeFromShape(i.shape)/c,c]}});if(o.shouldExecuteOnCPU([i,r])||"string"===i.dtype){const e=o.readSync(r.dataId),t=o.bufferSync(i),n=Pe(e,t,i.dtype,d,s,c,p,i.shape,u);return o.makeTensorInfo(l,i.dtype,n.values)}const m=new Kn(s,[d,c]),g=[{type:"int32",data:[s]},{type:"int32",data:p}],b=o.runWebGPUProgram(m,[f,h],f.dtype,g),I=W({inputs:{x:b},backend:o,attrs:{shape:l}});return o.disposeData(h.dataId),o.disposeData(f.dataId),o.disposeData(b.dataId),I}};class Qn{constructor(e,t){this.variableNames=["A","indices"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e.slice(),this.aShape=e,this.outputShape=t,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="gather"}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let indexZ = i32(getIndices(resRC.x, resRC.z));\n          let inBounds = select(0.0, 1.0, indexZ >= 0 && indexZ < uniforms.aShape[2]);\n          setOutputAtIndex(index, inBounds * getA(${function(e){const t=["resRC.x","resRC.y","resRC.z","resRC.w"],n=[];for(let o=0;o<e.length;o++)2===o?n.push("indexZ"):n.push(`${t[o]}`);return n.join()}(this.aShape)}));\n        }\n      }\n    `}}function Zn(e){const{inputs:n,backend:o,attrs:i}=e,{x:r,indices:a}=n,{axis:s,batchDims:u}=i,l=t.util.parseAxisParam(s,r.shape)[0],d=t.backend_util.segment_util.collectGatherOpShapeInfo(r,a,l,u),c=t.util.sizeFromShape(a.shape),p=[],h=W({inputs:{x:r},backend:o,attrs:{shape:[d.batchSize,d.outerSize,d.dimSize,d.sliceSize]}}),f=W({inputs:{x:a},backend:o,attrs:{shape:[d.batchSize,c/d.batchSize]}});p.push(h),p.push(f);const m=[d.batchSize,d.outerSize,c/d.batchSize,d.sliceSize];if(o.shouldExecuteOnCPU([r,a])){const e=o.tensorMap.get(f.dataId).values,n=t.buffer(f.shape,f.dtype,e),i=o.tensorMap.get(h.dataId).values,r=t.buffer(h.shape,h.dtype,i),a=Ne(r,n,m);return p.forEach((e=>o.disposeData(e.dataId))),o.makeTensorInfo(d.outputShape,a.dtype,a.values)}const g=new Qn(h.shape,m),b=o.runWebGPUProgram(g,[h,f],h.dtype);p.push(b);const I=W({inputs:{x:b},backend:o,attrs:{shape:d.outputShape}});return p.forEach((e=>o.disposeData(e.dataId))),I}const Jn={kernelName:t.GatherV2,backendName:"webgpu",kernelFunc:Zn},eo=J({opSnippet:r.GREATER,cpuKernelImpl:Le,dtype:"bool"}),to={kernelName:t.Greater,backendName:"webgpu",kernelFunc:eo},no=J({opSnippet:r.GREATER_EQUAL,dtype:"bool",cpuKernelImpl:Ee}),oo={kernelName:t.GreaterEqual,backendName:"webgpu",kernelFunc:no};const io={kernelName:t.LeakyRelu,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{alpha:r}=o,a=[{type:"float32",data:[r]}],s=new Q(i.shape,d.LEAKYRELU);return s.uniforms="alpha : f32,",n.runWebGPUProgram(s,[i],"float32",a)}},ro=J({opSnippet:r.LESS,dtype:"bool",cpuKernelImpl:Oe}),ao={kernelName:t.Less,backendName:"webgpu",kernelFunc:ro},so=J({opSnippet:r.LESS_EQUAL,dtype:"bool",cpuKernelImpl:We}),uo={kernelName:t.LessEqual,backendName:"webgpu",kernelFunc:so},lo=Z({opType:d.LOG,cpuKernelImpl:Fe}),co={kernelName:t.Log,backendName:"webgpu",kernelFunc:lo},po=J({opSnippet:r.LOGICAL_AND,dtype:"bool"}),ho={kernelName:t.LogicalAnd,backendName:"webgpu",kernelFunc:po},fo=Z({opType:d.LOGICAL_NOT}),mo={kernelName:t.LogicalNot,backendName:"webgpu",kernelFunc:fo};function go(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{reductionIndices:r,keepDims:a}=o;return In(i,r,a,"max",n)}const bo={kernelName:t.Max,backendName:"webgpu",kernelFunc:go},Io=J({opSnippet:r.MAX,cpuKernelImpl:Ue}),ko={kernelName:t.Maximum,backendName:"webgpu",kernelFunc:Io};const wo={kernelName:t.MaxPool,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{filterSize:a,strides:s,pad:u,dimRoundingMode:l}=i,d=t.backend_util.computePool2DInfo(r.shape,a,s,1,u,l);let c;const p=[];if(1===d.filterHeight&&1===d.filterWidth){if(t.util.arraysEqual(d.inShape,d.outShape))return H({inputs:{x:r},backend:o});c=new kt(d),p.push({type:"int32",data:[d.strideHeight,d.strideWidth]})}else c=new It(d,"max"),p.push({type:"int32",data:[d.strideHeight,d.strideWidth]},{type:"int32",data:[d.padInfo.top,d.padInfo.left]},{type:"int32",data:[d.dilationHeight,d.dilationWidth]},{type:"int32",data:[d.inHeight,d.inWidth]},{type:"int32",data:[d.effectiveFilterHeight,d.effectiveFilterWidth]});return o.runWebGPUProgram(c,[r],r.dtype,p)}};const xo={kernelName:t.Mean,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{keepDims:r,axis:a}=o;return In(i,a,r,"mean",n)}};const vo={kernelName:t.Min,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{axis:r,keepDims:a}=o;return In(i,r,a,"min",n)}},So=J({opSnippet:r.MIN,cpuKernelImpl:Me}),yo={kernelName:t.Minimum,backendName:"webgpu",kernelFunc:So};class Co{constructor(e,t,n){this.uniforms="",this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.xShape=e,t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.offset="reflect"===n?0:1,this.shaderKey=`mirrorPad_${n}`}getUserCode(){const e=this.xShape.length,t=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),n=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),o=1===e?"start":"start[i]",i=1===e?"end":"end[i]",r=1===e?"outC":"outC[i]",a=f(e),s=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let start = ${a}(${t});\n          let end = ${a}(${n});\n          var outC = getCoordsFromIndex(index);\n          for (var i = 0; i < ${e}; i = i + 1) {\n            if (${r} < ${o}) {\n              ${r} = ${o} * 2 - ${r} - ${this.offset};\n            } else if(${r} >= ${i}) {\n              ${r} = (${i} - 1) * 2 - ${r} + ${this.offset};\n            }\n          }\n          let coords = outC - start;\n          setOutputAtIndex(index, getX(${s}));\n        }\n      }\n    `}}const zo={kernelName:t.MirrorPad,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:o}=e,{paddings:i,mode:r}=t,a=n,s=i.map((e=>({type:"int32",data:[e[0],e[1]]}))),u=new Co(o.shape,i,r);return a.runWebGPUProgram(u,[o],o.dtype,s)}};const _o={kernelName:t.Neg,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:o}=t;if(n.shouldExecuteOnCPU([o])){const e=n.tensorMap.get(o.dataId),[t,i]=Xe(e.values,o.shape,o.dtype);return n.makeTensorInfo(i,o.dtype,t)}const i=new Q(o.shape,d.NEG);return n.runWebGPUProgram(i,[o],o.dtype)}};const Go={kernelName:t.NonMaxSuppressionV3,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:n,backend:o,attrs:i}=e,{boxes:r,scores:a}=n,{maxOutputSize:s,iouThreshold:u,scoreThreshold:l}=i,d=o.readSync(r.dataId),c=o.readSync(a.dataId),{selectedIndices:p}=t.kernel_impls.nonMaxSuppressionV3Impl(d,c,s,u,l);return o.makeTensorInfo([p.length],"int32",new Int32Array(p))}};const $o={kernelName:t.NonMaxSuppressionV5,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:n,backend:o,attrs:i}=e,{boxes:r,scores:a}=n,{maxOutputSize:s,iouThreshold:u,scoreThreshold:l,softNmsSigma:d}=i,c=o.readSync(r.dataId),p=o.readSync(a.dataId),h=s,f=u,m=l,g=d,{selectedIndices:b,selectedScores:I}=t.kernel_impls.nonMaxSuppressionV5Impl(c,p,h,f,m,g);return[o.makeTensorInfo([b.length],"int32",new Int32Array(b)),o.makeTensorInfo([I.length],"float32",new Float32Array(I))]}};function Ao(e){const{inputs:t,backend:n}=e,{x:o}=t;if("complex64"===o.dtype){const e=$t({inputs:{input:o},backend:n}),t=Ao({inputs:{x:e},backend:n}),i=Wt({inputs:{input:o},backend:n}),r=Ao({inputs:{x:i},backend:n}),a=K({inputs:{real:t,imag:r},backend:n});return n.disposeData(e.dataId),n.disposeData(t.dataId),n.disposeData(i.dataId),n.disposeData(r.dataId),a}return Bn({attrs:{shape:o.shape,dtype:o.dtype,value:"string"===o.dtype?"":0},backend:n})}const Ro={kernelName:t.ZerosLike,backendName:"webgpu",kernelFunc:Ao};const To={kernelName:t.OnesLike,backendName:"webgpu",kernelFunc:function e(t){const{inputs:n,backend:o}=t,{x:i}=n;if("string"===i.dtype)throw new Error("onesLike is not supported under string dtype");if("complex64"===i.dtype){const t=$t({inputs:{input:i},backend:o}),n=e({inputs:{x:t},backend:o}),r=Wt({inputs:{input:i},backend:o}),a=Ao({inputs:{x:r},backend:o}),s=K({inputs:{real:n,imag:a},backend:o});return o.disposeData(t.dataId),o.disposeData(n.dataId),o.disposeData(r.dataId),o.disposeData(a.dataId),s}return Bn({attrs:{shape:i.shape,dtype:i.dtype,value:1},backend:o})}};const Bo={kernelName:t.Pack,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{axis:r}=i;if(1===n.length)return Gn({inputs:{input:n[0]},backend:o,attrs:{dim:r}});const a=n[0].shape,s=n[0].dtype;n.forEach((e=>{t.util.assertShapesMatch(a,e.shape,"All tensors passed to stack must have matching shapes"),t.util.assert(s===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const u=[],l=Dt({inputs:n.map((e=>{const t=Gn({inputs:{input:e},backend:o,attrs:{dim:r}});return u.push(t),t})),backend:o,attrs:{axis:r}});return u.forEach((e=>o.disposeData(e.dataId))),l}};class Po{constructor(e,t){this.variableNames=["x"],this.uniforms="constantValue : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.xShape=e,this.shaderKey="pad"}getUserCode(){const e=this.xShape.length,t=f(e),n=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),o=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(",");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let start = ${e>1?`${t}(${n})`:`${n}`};\n          let end = ${e>1?`${t}(${o})`:`${o}`};\n          let outC = getCoordsFromIndex(index);\n\n          if (${e>1?"any(outC < start)":"outC < start"} || ${e>1?"any(outC >= end)":"outC >= end"}) {\n            setOutputAtIndex(index, uniforms.constantValue);\n          } else {\n            let coords = outC - start;\n            setOutputAtIndex(index, getX(${e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords"}));\n          }\n        }\n      }\n    `}}const No=e=>{const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{paddings:a,constantValue:s}=i;if(a.every((e=>t.util.arraysEqual(e,[0,0]))))return H({inputs:{x:r},backend:o});if(0===t.util.sizeFromShape(r.shape)){return Bn({backend:o,attrs:{shape:a.map(((e,t)=>e[0]+r.shape[t]+e[1])),value:s,dtype:r.dtype}})}const u=[{type:"float32",data:[s]}];a.map((e=>u.push({type:"int32",data:[e[0],e[1]]})));const l=new Po(r.shape,a);return o.runWebGPUProgram(l,[r],r.dtype,u)},Eo={kernelName:t.PadV2,backendName:"webgpu",kernelFunc:No},Lo=J({opSnippet:r.POW}),Wo={kernelName:t.Pow,backendName:"webgpu",kernelFunc:Lo};const Oo={kernelName:t.Prelu,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:o,alpha:i}=t,a=new X(r.PRELU,o.shape,i.shape);return n.runWebGPUProgram(a,[o,i],"float32")}};const Fo={kernelName:t.Prod,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:i}=t,{axis:r,keepDims:a}=o;return In(i,r,a,"prod",n)}},Do={kernelName:t.Range,backendName:"webgpu",kernelFunc:e=>{const{backend:t,attrs:n}=e,{start:o,stop:i,step:r,dtype:a}=n,s=Ye(o,i,r,a);return t.makeTensorInfo([s.length],a,s)}},Uo=J({opSnippet:r.DIV}),Mo={kernelName:t.RealDiv,backendName:"webgpu",kernelFunc:Uo},Vo=Z({opType:d.RELU}),Xo={kernelName:t.Relu,backendName:"webgpu",kernelFunc:Vo},qo=Z({opType:d.RELU6}),Ho={kernelName:t.Relu6,backendName:"webgpu",kernelFunc:qo};class Yo{constructor(e,t,n){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, halfPixelCenters : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="resizeBilinear"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC =\n            (vec2<f32>(rc) + vec2<f32>(uniforms.halfPixelCenters)) *\n            effectiveInputOverOutputRatioRC - vec2<f32>(uniforms.halfPixelCenters);\n\n          // Compute the four integer indices.\n          let sourceFloorRC = vec2<i32>(sourceFracIndexRC);\n          let sourceCeilRC = vec2<i32>(\n            min(vec2<f32>(uniforms.xShape.yz) - vec2<f32>(1.0), ceil(sourceFracIndexRC)));\n\n          let topLeft = getX(b, sourceFloorRC.x, sourceFloorRC.y, d);\n          let bottomLeft = getX(b, sourceCeilRC.x, sourceFloorRC.y, d);\n          let topRight = getX(b, sourceFloorRC.x, sourceCeilRC.y, d);\n          let bottomRight = getX(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n          let fracRC = sourceFracIndexRC - vec2<f32>(sourceFloorRC);\n\n          let top = topLeft + (topRight - topLeft) * fracRC.y;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n          let newValue = top + (bottom - top) * fracRC.x;\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    "}}const Ko={kernelName:t.ResizeBilinear,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{images:i}=t,{alignCorners:r,size:a,halfPixelCenters:s}=o,[u,l]=a,d=[{type:"float32",data:[r&&u>1?1:0,r&&l>1?1:0]},{type:"float32",data:[s?.5:0]}],c=new Yo(i.shape,u,l);return n.runWebGPUProgram(c,[i],"float32",d)}};class jo{constructor(e,t,n,o){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, roundBase : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.halfPixelCenters=o,this.shaderKey=`resizeNearest_${o}`}getUserCode(){let e;e=this.halfPixelCenters?"max((vec2<f32>(rc) + vec2<f32>(0.5)) * effectiveInputOverOutputRatioRC, vec2<f32>(0.0))":"vec2<f32>(rc) * effectiveInputOverOutputRatioRC";return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC = ${e};\n\n          // Compute the coordinators of nearest neighbor point.\n          let inputShapeRC = vec2<f32>(f32(uniforms.xShape.y), f32(uniforms.xShape.z));\n          let sourceNearestRC = vec2<i32>(\n            min(inputShapeRC - 1.0, floor(sourceFracIndexRC + uniforms.roundBase)));\n          let newValue = getX(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const Qo={kernelName:t.ResizeNearestNeighbor,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{images:i}=t,{alignCorners:r,halfPixelCenters:a,size:s}=o,[u,l]=s,d=[{type:"float32",data:[r&&u>1?1:0,r&&l>1?1:0]},{type:"float32",data:[r?.5:0]}],c=new jo(i.shape,u,l,a);return n.runWebGPUProgram(c,[i],i.dtype,d)}};class Zo{constructor(e,t){this.outputShape=[],this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="centerX : f32, centerY : f32, sinRadians : f32,\n          cosRadians : f32,",this.shaderKey="rotate",this.outputShape=e,"number"==typeof t?(this.uniforms+=" fillValue : f32,",this.fillSnippet="var outputValue = uniforms.fillValue;",this.shaderKey+="_float"):(this.uniforms+=" fillValue : vec3<f32>,",this.fillSnippet="var outputValue = uniforms.fillValue[coords[3]];",this.shaderKey+="_vec3")}getUserCode(){return`\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n          if (index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            let coordXFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.cosRadians - (f32(coords[1]) - uniforms.centerY) *\n                uniforms.sinRadians;\n            let coordYFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.sinRadians + (f32(coords[1]) - uniforms.centerY) *\n                uniforms.cosRadians;\n            let coordX = i32(round(coordXFloat + uniforms.centerX));\n            let coordY = i32(round(coordYFloat + uniforms.centerY));\n            ${this.fillSnippet}\n            if(coordX >= 0 && coordX < uniforms.xShape[2] && coordY >= 0 &&\n                coordY < uniforms.xShape[1]) {\n              outputValue = getX(coords[0], coordY, coordX, coords[3]);\n            }\n            setOutputAtIndex(index, outputValue);\n          }\n        }\n      `}}const Jo={kernelName:t.RotateWithOffset,backendName:"webgpu",kernelFunc:({inputs:e,attrs:n,backend:o})=>{const{image:i}=e,{radians:r,fillValue:a,center:s}=n,u=o,l=new Zo(i.shape,a),[d,c]=t.backend_util.getImageCenter(s,i.shape[1],i.shape[2]),p=[{type:"float32",data:[d]},{type:"float32",data:[c]},{type:"float32",data:[Math.sin(r)]},{type:"float32",data:[Math.cos(r)]}];"number"==typeof a?p.push({type:"float32",data:[Number.parseFloat(a.toFixed(2))]}):p.push({type:"float32",data:a});return u.runWebGPUProgram(l,[i],i.dtype,p)}},ei=Z({opType:d.RSQRT,cpuKernelImpl:Ke}),ti={kernelName:t.Rsqrt,backendName:"webgpu",kernelFunc:ei};class ni{constructor(e,t,n,o,i,r,a){this.variableNames=["updates","indices"],this.workGroupSize=[64,1,1],this.atomic=!0,this.outputShape=r,this.type=a,this.dispatchLayout=_(e),this.dispatch=S(this.dispatchLayout,e,this.workGroupSize),this.sliceDimGreaterThanOne=t>1,this.shaderKey=`scatter_${n}_${o}_${this.sliceDimGreaterThanOne}_${a}`;const s=f(i.length);this.uniforms=`sliceDim : i32, strides: ${s}, size: i32,`,this.updatesRank=o,this.indicesRank=n}getUserCode(){let e="";1===this.indicesRank?e="coords[0]":2===this.indicesRank&&(e="coords[0], j");const t=`getIndices(${e})`,n=this.sliceDimGreaterThanOne?"uniforms.strides[j]":"uniforms.strides";let o="",i="",r="";1===this.updatesRank?(o="coords[0]",i="flattenedIndex",r="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> i32 {\n        return index;\n      }\n      "):2===this.updatesRank&&(o="coords[0], coords[1]",i="vec2<i32>(flattenedIndex, coords[1])",r="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> vec2<i32> {\n        let d0 = index / uniforms.updatesShape[1];\n        let d1 = index - d0 * uniforms.updatesShape[1];\n        return vec2<i32>(d0, d1);\n      }\n      ");return`\n    ${r}\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n        if (index < uniforms.size) {\n          let coords = getUpdatesCoordsFromFlatIndex(index);\n          var flattenedIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexInside = i32(round(${t}));\n            flattenedIndex = flattenedIndex + indexInside * ${n};\n          }\n          let updateValue = ${`getUpdates(${o})`};\n          let flatIndex = getOutputIndexFromCoords(${i});\n\n         ${"int32"===this.type?"atomicAdd(&(result[flatIndex]), i32(updateValue));":"\n     var assumed = atomicLoad(&(result[flatIndex]));\n     var success = 0;\n     for (; success == 0;) {\n       let new = bitcast<f32>(assumed) + updateValue;\n       let newI32 = bitcast<i32>(new);\n       let resValue = atomicCompareExchangeWeak(&(result[flatIndex]), assumed, newI32);\n       assumed = resValue[0];\n       success = resValue[1];\n     }\n     "}\n        }\n      }`}}const oi={kernelName:t.ScatterNd,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{indices:r,updates:a}=n,{shape:s}=i,{sliceRank:u,numUpdates:l,sliceSize:d,strides:c,outputSize:p}=t.backend_util.calculateShapes(a,r,s),h=[p/d,d];if(0===p)return o.makeTensorInfo(s,r.dtype);const f=W({inputs:{x:r},backend:o,attrs:{shape:[l,u]}}),m=W({inputs:{x:a},backend:o,attrs:{shape:[l,d]}}),g=m.dtype,b=Bn({backend:o,attrs:{shape:h,value:0,dtype:g}}),I=[{type:"int32",data:[u]},{type:"int32",data:c},{type:"int32",data:[t.util.sizeFromShape(m.shape)]}],k=new ni(m.shape,u,f.shape.length,m.shape.length,c,h,g),w=o.runWebGPUProgram(k,[m,f],g,I,b),x=W({inputs:{x:w},backend:o,attrs:{shape:s}});return o.disposeData(f.dataId),o.disposeData(m.dataId),o.disposeData(w.dataId),x}};class ii{constructor(e,t,n){this.variableNames=["c","a","b"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.cRank=e,this.rank=n,this.shaderKey="select"}getUserCode(){let e,t;if(this.rank>4)throw Error(`Where for rank ${this.rank} is not yet supported`);if(1===this.rank)t="resRC",e="resRC";else{const n=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[],i=[];for(let e=0;e<this.outputShape.length;e++)i.push(`${n[e]}`),e<this.cRank&&o.push(`${n[e]}`);e=o.join(),t=i.join()}return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let cVal = getC(${e});\n          if (cVal >= 1.0) {\n            setOutputAtIndex(index, getA(${t}));\n          } else {\n            setOutputAtIndex(index, getB(${t}));\n          }\n        }\n      }\n    `}}const ri={kernelName:t.Select,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o}=e,{condition:i,t:r,e:a}=n,s=new ii(i.shape.length,r.shape,r.shape.length);return o.runWebGPUProgram(s,[i,r,a],t.upcastType(r.dtype,a.dtype))}},ai=Z({opType:d.SIGMOID}),si={kernelName:t.Sigmoid,backendName:"webgpu",kernelFunc:ai},ui=Z({opType:d.SIN}),li={kernelName:t.Sin,backendName:"webgpu",kernelFunc:ui},di=Z({opType:d.SINH}),ci={kernelName:t.Sinh,backendName:"webgpu",kernelFunc:di},pi=J({opSnippet:r.SUB,cpuKernelImpl:et,supportsComplex:!0}),hi={kernelName:t.Sub,backendName:"webgpu",kernelFunc:pi};const fi={kernelName:t.Softmax,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{logits:r}=n,{dim:a}=i,s=t.util.parseAxisParam([a],r.shape),u=go({inputs:{x:r},backend:o,attrs:{reductionIndices:s,keepDims:!1}}),l=t.backend_util.expandShapeToKeepDim(u.shape,s),d=W({inputs:{x:u},backend:o,attrs:{shape:l}}),c=pi({inputs:{a:r,b:d},backend:o}),p=zn({inputs:{x:c},backend:o}),h=kn({inputs:{x:p},backend:o,attrs:{axis:s,keepDims:!1}}),f=W({inputs:{x:h},backend:o,attrs:{shape:l}}),m=Uo({inputs:{a:p,b:f},backend:o});return o.disposeData(u.dataId),o.disposeData(d.dataId),o.disposeData(c.dataId),o.disposeData(p.dataId),o.disposeData(h.dataId),o.disposeData(f.dataId),m}},mi={kernelName:t.SpaceToBatchND,backendName:"webgpu",kernelFunc:e=>{const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{blockShape:a,paddings:s}=i;t.util.assert(r.shape.length<=4,(()=>"spaceToBatchND for rank > 4 with a WebGPU backend not implemented yet"));const u=a.reduce(((e,t)=>e*t)),l=[[0,0]];l.push(...s);for(let e=1+a.length;e<r.shape.length;++e)l.push([0,0]);const d=[],c=No({inputs:{x:r},backend:o,attrs:{paddings:l,constantValue:0}}),p=t.backend_util.getReshaped(c.shape,a,u,!1),h=t.backend_util.getPermuted(p.length,a.length,!1),f=t.backend_util.getReshapedPermuted(c.shape,a,u,!1),m=W({inputs:{x:c},backend:o,attrs:{shape:p}}),g=ft({inputs:{x:m},backend:o,attrs:{perm:h}}),b=W({inputs:{x:g},backend:o,attrs:{shape:f}});return d.push(c),d.push(m),d.push(g),d.forEach((e=>o.disposeData(e.dataId))),b}};class gi{constructor(e,t,n,o,i,r,a=!0){this.variableNames=["updates","indices","defaultValue"],this.workGroupSize=[64,1,1],this.workPerThread=4,this.size=!0,this.outputShape=r,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]);const s=t>1;this.shaderKey=`scatter_${n}_${o}_${s}`;const u=f(i.length);this.uniforms=`updateSize : i32, sliceDim : i32, strides: ${u},`;let l="";1===n?l="i":2===n&&(l="i, j"),this.indicesSnippet=`getIndices(${l})`;let d="";1===o?d="i":2===o&&(d="i, coords[1]"),this.updatesSnippet=`getUpdates(${d})`,this.strideString=s?"uniforms.strides[j]":"uniforms.strides"}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n        let globalIndex = index * ${this.workPerThread};\n        if (globalIndex < uniforms.size) {\n          var sum = vec4<f32>(0.0);\n          var found = vec4<bool>(false);\n          for (var i = 0; i < uniforms.updateSize; i = i + 1) {\n            var flattenedIndex = 0;\n            for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n              let indexInside = i32(round(${this.indicesSnippet}));\n              flattenedIndex = flattenedIndex + indexInside * ${this.strideString};\n            }\n            for (var innerIndex = 0; innerIndex < ${this.workPerThread}; innerIndex = innerIndex + 1) {\n              let curIndex = globalIndex + innerIndex;\n              let coords = getCoordsFromIndex(curIndex);\n              if (flattenedIndex == coords[0]) {\n                sum[innerIndex] = sum[innerIndex] + ${this.updatesSnippet};\n                found[innerIndex] = true;\n              }\n            }\n          }\n          for (var innerIndex = 0; innerIndex < ${this.workPerThread}; innerIndex = innerIndex + 1) {\n            let curIndex = globalIndex + innerIndex;\n            if (curIndex < uniforms.size)\n            {\n              setOutputAtIndex(curIndex, mix(getDefaultValue(), sum[innerIndex], f32(found[innerIndex])));\n            }\n          }\n        }\n      }`}}const bi={kernelName:t.SparseToDense,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{sparseIndices:r,sparseValues:a,defaultValue:s}=n,{outputShape:u}=i,{sliceRank:l,numUpdates:d,strides:c,outputSize:p}=t.backend_util.calculateShapes(a,r,u),h=[{type:"int32",data:[d]},{type:"int32",data:[l]},{type:"int32",data:c}],f=new gi(d,l,r.shape.length,a.shape.length,c,[p,1],!1),m=o.runWebGPUProgram(f,[a,r,s],a.dtype,h),g=W({inputs:{x:m},backend:o,attrs:{shape:u}});return o.disposeData(m.dataId),g}};const Ii={kernelName:t.SplitV,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{numOrSizeSplits:a,axis:s}=i,u=t.util.parseAxisParam(s,r.shape)[0],l=t.backend_util.prepareSplitSize(r,a,u),d=r.shape.length,c=new Array(d).fill(0),p=r.shape.slice();return l.map((e=>{const t=[...p];t[u]=e;const n=yt({inputs:{x:r},backend:o,attrs:{begin:c,size:t}});return c[u]+=e,n}))}},ki=Z({opType:d.SQRT}),wi={kernelName:t.Sqrt,backendName:"webgpu",kernelFunc:ki},xi={kernelName:t.Square,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{x:n}=e,o=t,i=new Q(n.shape,d.SQUARE);return o.runWebGPUProgram(i,[n],n.dtype)}},vi=J({opSnippet:r.SQUARED_DIFFERENCE}),Si={kernelName:t.SquaredDifference,backendName:"webgpu",kernelFunc:vi};class yi{constructor(e){this.variableNames=["x"],this.workPerThread=1,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]);const t=f(this.outputShape.length);this.uniforms=`begin : ${t},  strides : ${t}, `,this.shaderKey="stridedSlice"}getUserCode(){let e="";if(1===this.outputShape.length)e="coords * uniforms.strides + uniforms.begin";else{let t=0;e=this.outputShape.map(((e,n)=>(t++,1===this.outputShape.length?`coords * uniforms.strides[${n}] + uniforms.begin[${n}]`:`coords[${t-1}] * uniforms.strides[${n}] + uniforms.begin[${n}]`))).join(",")}return`\n       \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index);\n           setOutputAtIndex(index, getX(${e}));\n         }\n       }\n     `}}const Ci={kernelName:t.StridedSlice,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{begin:a,end:s,strides:u,beginMask:l,endMask:d,ellipsisMask:c,newAxisMask:p,shrinkAxisMask:h}=i,{finalShapeSparse:f,finalShape:m,isIdentity:g,sliceDim0:b,isSimpleSlice:I,begin:k,end:w,strides:x}=t.slice_util.sliceInfo(r.shape,a,s,u,l,d,c,p,h);let v;if(g)v=W({inputs:{x:r},backend:o,attrs:{shape:m}});else if(b||I){t.util.assert(r.shape.length>=1,(()=>`Input must have rank at least 1, got: ${r.shape.length}`));const e=t.slice_util.computeOutShape(k,w,x),n=yt({inputs:{x:r},backend:o,attrs:{begin:k,size:e}});v=W({inputs:{x:n},backend:o,attrs:{shape:m}}),o.disposeData(n.dataId)}else{if(o.shouldExecuteOnCPU([r])){const e=o.readSync(r.dataId),n=t.buffer(r.shape,r.dtype,e),i=Ze(f,n,x,k);v=o.makeTensorInfo(m,r.dtype,i.values)}else{const e=new yi(f),t=[{type:"int32",data:k},{type:"int32",data:x}],n=o.runWebGPUProgram(e,[r],r.dtype,t);v=W({inputs:{x:n},backend:o,attrs:{shape:m}}),o.disposeData(n.dataId)}}return v}};const zi={kernelName:t.StringNGrams,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{separator:i,nGramWidths:r,leftPad:a,rightPad:s,padWidth:u,preserveShortSequences:l}=o,{data:d,dataSplits:c}=t,p=n.readSync(d.dataId),h=n.readSync(c.dataId),[f,m]=Je(p,h,i,r,a,s,u,l);return[n.makeTensorInfo([f.length],"string",f),n.makeTensorInfo(c.shape,"int32",m)]}},_i=Z({opType:d.TANH}),Gi={kernelName:t.Tanh,backendName:"webgpu",kernelFunc:_i};class $i{constructor(e,t){this.variableNames=["A"],this.workGroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let o=0;o<n.length;o++)n[o]=e[o]*t[o];this.outputShape=n,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.rank=this.outputShape.length,this.shaderKey="tile"}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          setOutputAtIndex(index, getA(${function(e,t=""){if(e>=5)throw Error(`Tile for rank ${e} is not yet supported`);if(1===e)return`(resRC % ${t}aShape)`;const n=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[];for(let i=0;i<e;i++)o.push(`(${n[i]} % ${t}aShape[${i}])`);return o.join()}(this.rank,"uniforms.")}));\n        }\n      }\n    `}}const Ai={kernelName:t.Tile,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{reps:a}=i;if(o.shouldExecuteOnCPU([r])||"string"===r.dtype||r.shape.length>=5){const e=o.readSync(r.dataId),n="string"===r.dtype?e.map((e=>t.util.decodeString(e))):e,i=t.buffer(r.shape,r.dtype,n),s=tt(i,a);return o.makeTensorInfo(s.shape,s.dtype,s.values)}const s=new $i(r.shape,a);return o.runWebGPUProgram(s,[r],r.dtype)}};class Ri{constructor(e){this.variableNames=["x","indices"],this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="inputSize : i32, firstPass : i32, negativeInf : f32,\n        dir : i32, inc : i32,",this.shaderKey="swap"}getUserCode(){return"\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // We compare elements pair-wise within a group of size 2 * inc.\n            // The comparing rule for each group alternates between ascending\n            // and descending. Within each group, we compare each pair at\n            // positions i and i+inc. To decide whether an element at position i\n            // is x0 or x1, we mod it by 2 * inc, if the result is smaller than\n            // inc, it is in the first half of the group, we denote it as x0,\n            // otherwise we denote it as x1.\n            // For example, as shown in the Bitonic top K paper referenced\n            // above, Figure5(a) shows that element[1] is in the second half of\n            // the group when group size is 2, but it is in the first half of\n            // the group when group size is 4.\n            let isFirstInPair = elemIdx % (2 * uniforms.inc) < uniforms.inc;\n            var i = 0;\n            if (isFirstInPair) {\n              i = elemIdx;\n            } else {\n              i = elemIdx - uniforms.inc;\n            }\n\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.inc;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.inc));\n            }\n\n            var x0 = f32(0.0);\n            var x1 = f32(0.0);\n            if (i0 < uniforms.inputSize) {\n              x0 = getX(batch, i0);\n            } else {\n              x0 = uniforms.negativeInf;\n            }\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = uniforms.negativeInf;\n            }\n\n            let reverse = elemIdx % (2 * uniforms.dir) >= uniforms.dir;\n            let isGreater = x0 > x1 || (x0 == x1 && i1 > i0);\n            if (reverse == isGreater) {\n              // Elements in opposite order of direction\n              let iTemp = i0;\n              i0 = i1;\n              i1 = iTemp;\n            }\n            if (isFirstInPair) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      "}}class Ti{constructor(e){this.variableNames=["x","indices"],this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="inputSize : i32, firstPass : i32, k : i32,",this.shaderKey="merge"}getUserCode(){return"\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // The output size is half of the previous size.\n            // If the previous sequence is | | | | _ _ _ _  | | | |  _ _ _ _\n            // (k=4), we only need to output the indices at positions |, the\n            // indices at positions _ can be thrown away, see Figure5(b) After\n            // Phase 2 (Merge phase) in the Bitonic Top K paper referenced\n            // above.\n            // For example, the paper shows we only need to output the orange\n            // bars. The output sequence should look like this | | | | | | | |.\n            // Because the sequence is halved, to map the output index back to\n            // the previous sequence to find the corresponding value, we need\n            // to double the index. When we double the index, we basically\n            // interpolate a position, so 2i looks like\n            // | _ | _ | _ | _ | _ | _ | _. We move the | to the first k\n            // position of each 2k positions by - elemIdx % k. E.g. for output\n            // at index 4,5,6,7, we want to get the corresponding element at\n            // original index 8,9,10,11, for output at index 8,9,10,11,\n            // we want to get the corresponding element at original index\n            // 16,17,18,19, so on and so forth.\n\n            var i = 0;\n            if (elemIdx < uniforms.k) {\n              i = elemIdx;\n            } else {\n              i = elemIdx * 2 - elemIdx % uniforms.k;\n            }\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.k;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.k));\n            }\n\n            let x0 = getX(batch, i0);\n            var x1 = f32(0.0);\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = x0;\n            }\n\n            if (x0 >= x1) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      "}}function Bi(e,t){null!==t&&e.disposeData(t.dataId)}function Pi(e){let t=1;for(;t<e;)t*=2;return t}const Ni={kernelName:t.TopK,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:i}=e,{x:r}=n,{k:a,sorted:s}=i,u=r.shape,l=u[u.length-1];if(o.shouldExecuteOnCPU([r])){const e=o.readSync(r.dataId),[t,n]=nt(e,u,r.dtype,a,s);return[o.makeTensorInfo(t.shape,t.dtype,t.values),o.makeTensorInfo(n.shape,n.dtype,n.values)]}if(0===a)return u[u.length-1]=0,[o.makeTensorInfo(u,r.dtype,[]),o.makeTensorInfo(u,"int32",[])];if(1===l)return[r,Bn({attrs:{shape:u,dtype:"int32",value:0},backend:o})];const d=t.util.sizeFromShape(u)/l,c=W({inputs:{x:r},attrs:{shape:[d,l]},backend:o}),p=Pi(a),h=Pi(l);let f=null;const m=()=>null===f?[c,c]:[c,f],g=(e,t,n)=>{const i=m(),r=new Ri(n),a=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"float32",data:[Number.NEGATIVE_INFINITY]},{type:"int32",data:[e]},{type:"int32",data:[t]}],s=f;f=o.runWebGPUProgram(r,i,"int32",a),Bi(o,s)};for(let e=1;e<p;e*=2){const t=2*e;for(let n=e;n>=1;n/=2)g(t,n,[d,h])}for(let e=h;e>p;e/=2){const t=m(),n=new Ti([d,e/2]),i=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"int32",data:[p]}],r=f;f=o.runWebGPUProgram(n,t,"int32",i),Bi(o,r);const a=p/2,s=2*a;for(let e=a;e>=1;e/=2)g(s,e,f.shape)}let b=f;f=yt({inputs:{x:f},backend:o,attrs:{begin:0,size:[d,a]}}),Bi(o,b);let I=Zn({inputs:{x:c,indices:f},backend:o,attrs:{axis:1,batchDims:1}});Bi(o,c);const k=u.slice(0,-1);k.push(a),b=f,f=W({inputs:{x:f},attrs:{shape:k},backend:o}),Bi(o,b);const w=I;return I=W({inputs:{x:I},attrs:{shape:k},backend:o}),Bi(o,w),[I,f]}};class Ei{constructor(e){this.variableNames=["Image","Transforms"],this.uniforms="interpolationModeId : i32, fillModeId : i32, fillValue : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=_(this.outputShape),this.dispatch=S(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="transform"}getUserCode(){return"\n          fn mapCoord(outCoord : f32, len : f32) -> f32{\n            var inCoord = outCoord;\n            if(uniforms.fillModeId == 2) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  if (inCoord < sz2) {\n                    inCoord = sz2 * f32(i32(f32(-inCoord / sz2))) +\n                    inCoord;\n                  }\n                  if (inCoord < -len) {\n                    inCoord = inCoord + sz2;\n                  } else {\n                    inCoord = -inCoord - 1.0;\n                  }\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  inCoord = inCoord - sz2 * f32(i32(f32(inCoord / sz2)));\n                  if (inCoord >= len) {\n                    inCoord = sz2 - inCoord - 1.0;\n                  }\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 3) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord + len * (f32(i32(f32(-inCoord / sz))) + 1.0);\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord - len * f32(i32(f32(inCoord / sz)));\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 4) {\n              return clamp(outCoord, 0.0, len - 1.0);\n            }\n            return outCoord;\n          }\n          fn readWithFillValue(batch : i32, coordY : i32, coordX : i32,\n            channel : i32) -> f32 {\n            var outputValue : f32;\n            if (0 <= coordY && coordY < uniforms.imageShape[1] && 0 <= coordX && coordX < uniforms.imageShape[2]) {\n                outputValue = getImage(batch, coordY, coordX, channel);\n            } else {\n              outputValue = uniforms.fillValue;\n            }\n            return outputValue;\n          }\n\n          \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n            if (index < uniforms.size) {\n              let coords = getCoordsFromIndex(index);\n              var outputValue : f32;\n              let batch = coords[0];\n              let x = coords[2];\n              let y = coords[1];\n              let channel = coords[3];\n              let xf = f32(x);\n              let yf = f32(y);\n              let a1 = getTransforms(batch, 0);\n              let a2 = getTransforms(batch, 1);\n              let a3 = getTransforms(batch, 2);\n              let b1 = getTransforms(batch, 3);\n              let b2 = getTransforms(batch, 4);\n              let b3 = getTransforms(batch, 5);\n              let c1 = getTransforms(batch, 6);\n              let c2 = getTransforms(batch, 7);\n              let projection = c1 * xf + c2 * yf + 1.0;\n              if (projection == 0.0) {\n                outputValue = uniforms.fillValue;\n              } else {\n                let inX = (a1 * xf + a2 * yf + a3) / projection;\n                let inY = (b1 * xf + b2 * yf + b3) / projection;\n                let mapX = mapCoord(inX, f32(uniforms.imageShape[2]));\n                let mapY = mapCoord(inY, f32(uniforms.imageShape[1]));\n\n                if (uniforms.interpolationModeId == 1) {\n                  let coordY = i32(round(mapY));\n                  let coordX = i32(round(mapX));\n                  outputValue = readWithFillValue(batch, coordY, coordX,\n                    channel);\n                } else {\n                  let yFloor = floor(mapY);\n                  let xFloor = floor(mapX);\n                  let yCeil = yFloor + 1.0;\n                  let xCeil = xFloor + 1.0;\n                  let valueYFloor = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yFloor), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yFloor), i32(xCeil), channel);\n                  let valueYCeil = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yCeil), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yCeil), i32(xCeil), channel);\n                  outputValue = (yCeil - mapY) * valueYFloor +\n                  (mapY - yFloor) * valueYCeil;\n                }\n              }\n              setOutputAtIndex(index, outputValue);\n            }\n          }\n        "}}const Li=[D,at,ut,dt,gt,bt,wt,xt,zt,Rt,Bt,Et,j,Ut,qt,Kt,Qt,Jt,tn,un,ln,cn,fn,xn,Sn,Cn,_n,$n,Rn,Pn,En,Un,Wn,Fn,qn,Hn,Yn,jn,Jn,to,oo,Y,Ot,io,ao,uo,co,ho,mo,bo,ko,wo,xo,vo,yo,zo,gn,_o,Go,$o,Gt,To,Bo,Eo,Wo,Oo,Fo,Do,At,Mo,Xo,Ho,O,Ko,Qo,Jo,ti,oi,ri,si,li,ci,Ct,Ci,zi,fi,mi,bi,Ii,wi,xi,Si,hi,wn,Gi,Ai,Ni,{kernelName:t.Transform,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{image:i,transforms:r}=t,{interpolation:a,fillMode:s,fillValue:u,outputShape:l}=o,[d,c,p,h]=i.shape,[f,m]=null!=l?l:[c,p],g=new Ei([d,f,m,h]),b="nearest"===a?1:2;let I;switch(s){case"constant":I=1;break;case"reflect":I=2;break;case"wrap":I=3;break;case"nearest":I=4;break;default:I=1}const k=[{type:"int32",data:[b]},{type:"int32",data:[I]},{type:"float32",data:[u]}];return n.runWebGPUProgram(g,[i,r],"float32",k)}},mt,{kernelName:t.Unpack,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{value:i}=t;let{axis:r}=o;r<0&&(r+=i.shape.length);const a=i,s=a.shape.length,u=i.shape[r],l=new Array(s-1);let d=0;for(let e=0;e<s;e++)e!==r&&(l[d++]=a.shape[e]);const c=[],p=new Array(s).fill(0),h=a.shape.slice();h[r]=1;const f=new Array(u);for(let e=0;e<f.length;e++){p[r]=e;const t=yt({inputs:{x:a},backend:n,attrs:{begin:p,size:h}}),o=W({inputs:{x:t},backend:n,attrs:{shape:l}});f[e]=o,c.push(t)}return c.forEach((e=>n.disposeData(e.dataId))),f}},Ro];for(const e of Li)t.registerKernel(e);class Wi{constructor(e){this.device=e,this.numUsedBuffers=0,this.numFreeBuffers=0,this.freeBuffers=new Map,this.usedBuffers=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireUploadBuffer(e,t){return this.acquireBuffer(e,t,!0)}acquireBuffer(e,t,n=!1){const o=Oi(e,t);if(this.freeBuffers.has(o)||this.freeBuffers.set(o,[]),this.usedBuffers.has(o)||this.usedBuffers.set(o,[]),this.numBytesUsed+=e,this.numUsedBuffers++,this.freeBuffers.get(o).length>0){this.numFreeBuffers--;const e=this.freeBuffers.get(o).shift();return this.usedBuffers.get(o).push(e),e}this.numBytesAllocated+=e;const i=this.device.createBuffer({mappedAtCreation:n,size:e,usage:t});return this.usedBuffers.get(o).push(i),i}releaseBuffer(e,t,n){if(0===this.freeBuffers.size)return;const o=Oi(t,n);this.freeBuffers.has(o)||this.freeBuffers.set(o,[]),this.freeBuffers.get(o).push(e),this.numFreeBuffers++,this.numUsedBuffers--;const i=this.usedBuffers.get(o),r=i.indexOf(e);if(r<0)throw new Error("Cannot release a buffer that was never provided by this buffer manager");i.splice(r,1),this.numBytesUsed-=t}releaseUploadBuffer(e,t,n){e.mapAsync(GPUMapMode.WRITE).then((()=>{this.releaseBuffer(e,t,n)}),(e=>{}))}getNumUsedBuffers(){return this.numUsedBuffers}getNumFreeBuffers(){return this.numFreeBuffers}dispose(){this.freeBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeBuffers=new Map,this.usedBuffers=new Map,this.numUsedBuffers=0,this.numFreeBuffers=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function Oi(e,t){return`${e}_${t}`}class Fi{constructor(e){this.device=e,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures=new Map,this.usedTextures=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireTexture(e,t,n,o){const i=e*t*Ui(n),r=Di(e,t,n,o);if(this.freeTextures.has(r)||this.freeTextures.set(r,[]),this.usedTextures.has(r)||this.usedTextures.set(r,[]),this.numBytesUsed+=i,this.numUsedTextures++,this.freeTextures.get(r).length>0){this.numFreeTextures--;const e=this.freeTextures.get(r).shift();return this.usedTextures.get(r).push(e),e}this.numBytesAllocated+=i;const a=this.device.createTexture({size:[e,t],format:n,usage:o});return this.usedTextures.get(r).push(a),a}releaseTexture(e,t,n,o,i){if(0===this.freeTextures.size)return;const r=Di(t,n,o,i);this.freeTextures.has(r)||this.freeTextures.set(r,[]),this.freeTextures.get(r).push(e),this.numFreeTextures++,this.numUsedTextures--;const a=this.usedTextures.get(r),s=a.indexOf(e);if(s<0)throw new Error("Cannot release a texture that was never provided by this texture manager");a.splice(s,1);const u=t*n*Ui(o);this.numBytesUsed-=u}getNumUsedTextures(){return this.numUsedTextures}getNumFreeTextures(){return this.numFreeTextures}dispose(){this.freeTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeTextures=new Map,this.usedTextures=new Map,this.numUsedTextures=0,this.numFreeTextures=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function Di(e,t,n,o){return`${e}_${t}_${n}_${o}`}function Ui(e){if("rgba8unorm"===e)return 16;throw new Error(`${e} is not supported!`)}const Mi=(e,t,n,o,i,r=!1)=>{const a=b(o,{dtype:i.dtype,shape:i.shape},t,r),s=e.createShaderModule({code:a,label:t.constructor.name});return e.createComputePipeline({layout:n,compute:{module:s,entryPoint:"main"},label:t.constructor.name})};function Vi(e,t,n=[],o="",i=""){return e.shaderKey+"_"+(e.workGroupSize?e.workGroupSize.join(","):"")+t.map((e=>e.length)).join(",")+n.join(",")+e.variableNames.join(",")+o+i}const Xi=t.env().getNumber("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD"),qi=(e,n)=>{const o=e.limits.maxComputeWorkgroupsPerDimension,i=n.dispatchLayout,r=n.dispatch;if(r.every((e=>e<=o)))return r;t.util.assert(r[0]>o&&void 0===i.y&&void 0===i.z,(()=>"Dispatch size exceeds WebGPU limits in Y or Z dimension."));let a=Math.ceil(Math.sqrt(r[0]));return a>o?(a=Math.ceil(Math.cbrt(r[0])),t.util.assert(a<=o,(()=>"Total dispatch size exceeds WebGPU maximum.")),[a,a,a]):[a,a,1]};class Hi extends t.KernelBackend{constructor(e,n=!1){if(super(),this.commandQueueOwnedIds=new WeakSet,this.tensorDisposalQueue=[],this.uniformDisposalQueue=[],this.stagingDisposalQueue=[],this.textureDisposalQueue=[],this.disposed=!1,this.uploadWaitMs=0,this.downloadWaitMs=0,this.dispatchNumberInEncoder=0,this.fromPixelTextureLayout=null,this.fromPixelImportTextureLayout=null,!A())throw new Error("WebGPU is not supported on this device");this.layoutCache={},this.pipelineCache={},this.device=e,this.queue=e.queue,this.currentCommandEncoder=null,this.currentComputePass=null,this.supportTimeQuery=n,this.bufferManager=new Wi(this.device),this.textureManager=new Fi(this.device),this.tensorMap=new t.DataStorage(this,t.engine()),this.supportTimeQuery&&(this.querySet=this.device.createQuerySet({type:"timestamp",count:2})),t.env().getBool("WEBGPU_USE_PROFILE_TOOL")&&(this.dummyCanvas=document.createElement("canvas"),this.dummyCanvas.width=1,this.dummyCanvas.height=1,this.dummyContext=this.dummyCanvas.getContext("webgpu"),this.dummyContext.configure({device:e,format:"bgra8unorm"}),document.body.appendChild(this.dummyCanvas))}nextDataId(){return Hi.nextDataId++}floatPrecision(){return 32}defaultGpuBufferUsage(){return GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST}flushDisposalQueue(){this.tensorDisposalQueue.forEach((e=>{this.maybeReleaseBuffer(e),this.tensorMap.delete(e)})),this.uniformDisposalQueue.forEach((e=>this.bufferManager.releaseBuffer(e.buffer,e.byteSize,e.usage))),this.stagingDisposalQueue.forEach((e=>this.bufferManager.releaseUploadBuffer(e.buffer,e.byteSize,e.usage))),this.textureDisposalQueue.forEach((e=>this.textureManager.releaseTexture(e.texture,e.width,e.height,e.format,e.usage))),this.tensorDisposalQueue=[],this.uniformDisposalQueue=[],this.stagingDisposalQueue=[],this.textureDisposalQueue=[]}disposeData(e,t=!1){if(this.tensorMap.has(e)){const n=this.tensorMap.get(e);if(n.refCount--,!t&&n.refCount>0)return!1;if(this.commandQueueOwnedIds.has(e))return this.tensorDisposalQueue.push(e),!1;this.maybeReleaseBuffer(e);const{complexTensorInfos:o}=this.tensorMap.get(e);null!=o&&(this.disposeData(o.real.dataId,!0),this.disposeData(o.imag.dataId,!0)),this.tensorMap.delete(e)}return!0}memory(){return{numBytesInGPU:this.bufferManager.numBytesUsed,numBytesAllocatedInGPU:this.bufferManager.numBytesAllocated,unreliable:!1}}getBufferManager(){return this.bufferManager}getTextureManager(){return this.textureManager}acquireBuffer(e,t=this.defaultGpuBufferUsage()){return this.bufferManager.acquireBuffer(e,t)}maybeReleaseBuffer(e){const t=this.tensorMap.get(e);null!=t&&null!=t.bufferInfo.buffer&&(this.bufferManager.releaseBuffer(t.bufferInfo.buffer,t.bufferInfo.byteSize,t.bufferInfo.usage),t.bufferInfo.buffer=null)}refCount(e){if(this.tensorMap.has(e)){return this.tensorMap.get(e).refCount}return 0}incRef(e){this.tensorMap.get(e).refCount++}decRef(e){if(this.tensorMap.has(e)){this.tensorMap.get(e).refCount--}}write(e,n,o){if("complex64"===o&&null!=e)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const i={id:this.nextDataId()},r=t.util.sizeFromShape(n)*G(o);return this.tensorMap.set(i,{dtype:o,shape:n,values:e,bufferInfo:{byteSize:r,usage:this.defaultGpuBufferUsage()},refCount:1}),i}move(e,n,o,i,r){if("complex64"===i)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const a=t.util.sizeFromShape(o)*G(i);this.tensorMap.set(e,{dtype:i,shape:o,values:n,bufferInfo:{byteSize:a,usage:this.defaultGpuBufferUsage()},refCount:r})}submitQueue(){this.ensureComputePassEnded(),this.queue.submit([this.currentCommandEncoder.finish()]),this.currentCommandEncoder=null,this.dispatchNumberInEncoder=0,this.commandQueueOwnedIds=new WeakSet,this.flushDisposalQueue()}getBuffer(e){return this.uploadToGPU(e),this.tensorMap.get(e).bufferInfo.buffer}ensureCommandEncoderReady(){this.currentCommandEncoder||(this.currentCommandEncoder=this.device.createCommandEncoder())}ensureComputePassEnded(){this.currentComputePass&&(this.currentComputePass.end(),this.currentComputePass=null)}getComputePass(){return this.currentComputePass||(this.currentComputePass=this.currentCommandEncoder.beginComputePass()),this.currentComputePass}async getBufferData(e,n){const o=this.acquireBuffer(n,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,o,0,n),this.submitQueue(),await o.mapAsync(GPUMapMode.READ);const i=o.getMappedRange().slice(0);return o.unmap(),null!=o&&this.bufferManager.releaseBuffer(o,n,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ),t.env().getBool("WEBGPU_USE_PROFILE_TOOL")&&(t.util.assert(void 0!==this.dummyContext,(()=>"Fail to get context for profiling tool")),this.dummyContext.getCurrentTexture()),i}convertAndCacheOnCPU(e,t){const n=this.tensorMap.get(e);return this.maybeReleaseBuffer(e),n.values=t,n.values}readSync(e){const t=this.tensorMap.get(e),{values:n}=t;if(null==n)throw new Error("WebGPU readSync is only available for CPU-resident tensors.");return n}async read(e){if(!this.tensorMap.has(e))throw new Error(`Tensor ${e} was not registered!`);const n=this.tensorMap.get(e),{values:o}=n;if(null!=o)return this.convertAndCacheOnCPU(e,o);let i;if("complex64"===n.dtype){const e=await Promise.all([this.read(n.complexTensorInfos.real.dataId),this.read(n.complexTensorInfos.imag.dataId)]),o=e[0],r=e[1];i=t.backend_util.mergeRealAndImagArrays(o,r)}else{i=$(null!=n.values?n.values:await this.getBufferData(n.bufferInfo.buffer,n.bufferInfo.byteSize),n.dtype)}return this.convertAndCacheOnCPU(e,i),i}readToGPU(e,n={}){const o=this.tensorMap.get(e),{values:i,dtype:r,shape:a,bufferInfo:s}=o;if("complex64"===r)throw new Error("Does not support reading buffer for complex64 dtype.");if(null==s.buffer)throw null!=i?new Error("Data is not on GPU but on CPU."):new Error("There is no data on GPU or CPU.");const u=t.util.sizeFromShape(a)*G(r);null!=n.customBufSize&&t.util.assert(n.customBufSize>=u,(()=>`customBufSize should be equal or larger than the source tensor size ${u} bytes.`));const l=null!=n.customBufSize?n.customBufSize:u,d=this.acquireBuffer(l);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(s.buffer,0,d,0,u),this.submitQueue();const c=this.makeTensorInfo(a,r),p=t.engine().makeTensorFromTensorInfo(c),h=this.tensorMap.get(c.dataId);return h.bufferInfo.buffer=d,h.bufferInfo.byteSize=l,{tensorRef:p,buffer:d,bufSize:l}}bufferSync(e){const n=this.readSync(e.dataId);if("string"===e.dtype)try{const o=n.map((e=>t.util.decodeString(e)));return t.buffer(e.shape,e.dtype,o)}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8")}return t.buffer(e.shape,e.dtype,n)}async time(e){const n=this.activeTimers,o=[];let i=!1;null==this.programTimersStack?(this.programTimersStack=o,i=!0):this.activeTimers.push(o),this.activeTimers=o,e();const r=t.util.flatten(this.activeTimers.map((e=>e.query))).filter((e=>null!=e)),a=t.util.flatten(this.activeTimers.map((e=>e.name))).filter((e=>null!=e));this.activeTimers=n,i&&(this.programTimersStack=null);const s={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},u=await Promise.all(r);return s.kernelMs=t.util.sum(u),s.getExtraProfileInfo=()=>u.map(((e,t)=>({name:a[t],ms:e}))).map((e=>`${e.name}: ${e.ms}`)).join(", "),this.uploadWaitMs=0,this.downloadWaitMs=0,s}getAndSavePipeline(e,t){return e in this.pipelineCache||(this.pipelineCache[e]=t()),this.pipelineCache[e]}makeTensorInfo(e,n,o){let i;if("string"===n&&null!=o&&o.length>0&&t.util.isString(o[0])){const r=o.map((e=>t.util.encodeString(e)));i=this.write(r,e,n)}else i=this.write(o,e,n);return{dataId:i,shape:e,dtype:n}}tensorToBinding(e){if(!e)return null;const t=this.tensorMap.get(e.dataId);return{offset:0,size:t.bufferInfo.byteSize,buffer:t.bufferInfo.buffer}}async getQueryTime(e){return this.supportTimeQuery?this.getTimeFromQuerySet(e):0}uploadToGPU(e){const t=this.tensorMap.get(e);if(null==t.bufferInfo.buffer&&(t.bufferInfo.buffer=this.acquireBuffer(t.bufferInfo.byteSize),t.values)){const e=this.bufferManager.acquireUploadBuffer(t.bufferInfo.byteSize,GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC),n=e.getMappedRange();"int32"===t.dtype||"bool"===t.dtype?new Int32Array(n).set(t.values):new Float32Array(n).set(t.values),e.unmap(),this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,t.bufferInfo.buffer,0,t.bufferInfo.byteSize);const o={byteSize:t.bufferInfo.byteSize,usage:GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC,buffer:e};this.stagingDisposalQueue.push(o)}}makeUniforms(e){let n=0,o=0;const i=[];e.forEach((e=>{let r;switch(0===e.data.length&&(e.data=[1]),e.data.length){case 1:r=4;break;case 2:r=8;break;case 3:case 4:case 5:case 6:r=16;break;default:t.util.assert(!1,(()=>`Unsupported ${e.data.length}D shape`))}5!==o&&6!==o||(r=16),n=Math.ceil(n/r)*r,o=e.data.length,i.push(n),n+=4*e.data.length}));const r=new ArrayBuffer(n);e.forEach(((e,t)=>{const n=i[t];"int32"===e.type?new Int32Array(r,n,e.data.length).set(e.data):"uint32"===e.type?new Uint32Array(r,n,e.data.length).set(e.data):new Float32Array(r,n,e.data.length).set(e.data)}));const a=this.acquireBuffer(n,GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM);this.queue.writeBuffer(a,0,r,0,n);const s={byteSize:n,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM,buffer:a};return this.uniformDisposalQueue.push(s),{offset:0,size:n,buffer:a}}createLayout(e){const t=[];t.push({binding:0,visibility:GPUShaderStage.COMPUTE,buffer:{type:"storage"}});for(let n=0;n<e;n++)t.push({binding:n+1,visibility:GPUShaderStage.COMPUTE,buffer:{type:"read-only-storage"}});t.push({binding:e+1,visibility:GPUShaderStage.COMPUTE,buffer:{type:"uniform"}});const n=this.device.createBindGroupLayout({entries:t});return{bindGroupLayout:n,pipelineLayout:this.device.createPipelineLayout({bindGroupLayouts:[n]})}}getCachedOrCreateLayout(e){return e in this.layoutCache||(this.layoutCache[e]=this.createLayout(e)),this.layoutCache[e]}runWebGPUProgram(e,n,o,i,r){if(!r){if(r=this.makeTensorInfo(e.outputShape,o),0===t.util.sizeFromShape(r.shape)){return this.tensorMap.get(r.dataId).values=t.util.getTypedArrayFromDType(r.dtype,0),r}this.uploadToGPU(r.dataId)}e.dispatch=qi(this.device,e);let a=[{type:"float32",data:[NaN]}];const s=n.concat(r).map((e=>e.shape)),u="int32";s.map((e=>{a.push({type:u,data:e})}));const l=t.util.computeStrides(r.shape);if(a.push({type:u,data:l}),e.size){const n=t.util.sizeFromShape(e.outputShape);a.push({type:u,data:[e.isVec4?n/4:n]})}i&&(a=[...a,...i]);const d=this.makeUniforms(a),c=n.map(((t,n)=>{if("complex64"===t.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");return this.uploadToGPU(t.dataId),{dtype:this.tensorMap.get(t.dataId).dtype,shape:t.shape,name:e.variableNames[n]}})),p=c.map((e=>e.dtype)).concat(r.dtype),h=c.map((e=>t.backend_util.getBroadcastDims(e.shape,r.shape))),f=c.map((e=>t.util.arraysEqual(e.shape,r.shape))).join("_"),m=h.map((e=>e.join("_"))).join(";"),g=Vi(e,s,p,m,f),{bindGroupLayout:b,pipelineLayout:I}=this.getCachedOrCreateLayout(e.variableNames.length),k=this.getAndSavePipeline(g,(()=>Mi(this.device,e,I,c,r))),w=null!=this.activeTimers,x=((e,t,n,o,i)=>{const r=[o,...n];return i&&r.push(i),e.createBindGroup({layout:t,entries:r.map(((e,t)=>({binding:t,resource:e})))})})(this.device,b,n.map((e=>this.tensorToBinding(e))),this.tensorToBinding(r),d);this.ensureCommandEncoderReady();const v=this.getComputePass();return w&&this.supportTimeQuery&&v.writeTimestamp(this.querySet,0),v.setPipeline(k),v.setBindGroup(0,x),v.dispatch(e.dispatch[0],e.dispatch[1],e.dispatch[2]),w&&this.supportTimeQuery&&v.writeTimestamp(this.querySet,1),this.dispatchNumberInEncoder++,n.forEach((e=>{this.commandQueueOwnedIds.add(e.dataId)})),this.commandQueueOwnedIds.add(r.dataId),t.env().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchNumberInEncoder&&this.submitQueue(),w&&this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime(this.querySet)}),r}getFromPixelTextureLayout(e){return e?(null===this.fromPixelImportTextureLayout&&(this.fromPixelImportTextureLayout=this.createFromPixelTextureLayout(!0)),this.fromPixelImportTextureLayout):(null===this.fromPixelTextureLayout&&(this.fromPixelTextureLayout=this.createFromPixelTextureLayout(!1)),this.fromPixelTextureLayout)}createFromPixelTextureLayout(e){const t=[];t.push({binding:0,visibility:GPUShaderStage.COMPUTE,buffer:{type:"storage"}}),e?t.push({binding:1,visibility:GPUShaderStage.COMPUTE,externalTexture:{}}):t.push({binding:1,visibility:GPUShaderStage.COMPUTE,texture:{}}),t.push({binding:2,visibility:GPUShaderStage.COMPUTE,buffer:{}});const n=this.device.createBindGroupLayout({entries:t});return{bindGroupLayout:n,pipelineLayout:this.device.createPipelineLayout({bindGroupLayouts:[n]})}}copyExternalImageToTexture(e,t){const n=GPUTextureUsage.COPY_DST|GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.TEXTURE_BINDING,o="rgba8unorm",i=this.textureManager.acquireTexture(t[1],t[0],o,n),r=i.createView();this.queue.copyExternalImageToTexture({source:e},{texture:i},[t[1],t[0]]);const a={width:t[1],height:t[0],format:o,usage:n,texture:i};return this.textureDisposalQueue.push(a),r}runFromPixelsProgram(e,n,o,i,r){e.dispatch=qi(this.device,e);const a=this.makeTensorInfo(n,"int32");if(0===t.util.sizeFromShape(a.shape)){return this.tensorMap.get(a.dataId).values=t.util.getTypedArrayFromDType(a.dtype,0),a}this.uploadToGPU(a.dataId);const s=Vi(e,[a.shape]),u=this.getFromPixelTextureLayout(i),l=this.getAndSavePipeline(s,(()=>Mi(this.device,e,u.pipelineLayout,[],a,!0)));let d;if(i){const e={source:r};d=this.device.importExternalTexture(e)}else d=this.copyExternalImageToTexture(r,a.shape);const c=this.tensorToBinding(a),p=this.makeUniforms(o),h=this.device.createBindGroup({layout:u.bindGroupLayout,entries:[{binding:0,resource:{buffer:c.buffer}},{binding:1,resource:d},{binding:2,resource:{buffer:p.buffer}}]});this.ensureCommandEncoderReady();const f=this.getComputePass(),m=null!=this.activeTimers;return m&&this.supportTimeQuery&&f.writeTimestamp(this.querySet,0),f.setPipeline(l),f.setBindGroup(0,h),f.dispatch(e.dispatch[0],e.dispatch[1],e.dispatch[2]),m&&this.supportTimeQuery&&f.writeTimestamp(this.querySet,1),this.commandQueueOwnedIds.add(a.dataId),this.dispatchNumberInEncoder++,t.env().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchNumberInEncoder&&this.submitQueue(),m&&this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime(this.querySet)}),a}async getTimeFromQuerySet(e){const t=this.acquireBuffer(16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),n=this.acquireBuffer(16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.resolveQuerySet(e,0,2,t,0),this.currentCommandEncoder.copyBufferToBuffer(t,0,n,0,16),this.submitQueue(),await n.mapAsync(GPUMapMode.READ);const o=new BigUint64Array(n.getMappedRange()),i=Number(o[1]-o[0]);return n.unmap(),this.bufferManager.releaseBuffer(n,16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST),this.bufferManager.releaseBuffer(t,16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),i/1e6}shouldExecuteOnCPU(e,n=Xi){return t.env().getBool("WEBGPU_CPU_FORWARD")&&e.every((e=>null==this.tensorMap.get(e.dataId).bufferInfo.buffer&&t.util.sizeFromShape(e.shape)<n))}numDataIds(){return this.tensorMap.numDataIds()-this.tensorDisposalQueue.length}dispose(){this.disposed||(this.bufferManager.dispose(),this.textureManager.dispose(),this.disposed=!0)}}Hi.nextDataId=0;var Yi={__proto__:null,webgpu_util:R,WebGPUBackend:Hi};A()&&t.registerBackend("webgpu",(async()=>{t.env().set("CHECK_COMPUTATION_FOR_ERRORS",!1);const e={powerPreference:t.env().get("WEBGPU_USE_LOW_POWER_GPU")?"low-power":"high-performance"},n=await navigator.gpu.requestAdapter(e),o=n.limits,i={},r=n.features.has("timestamp-query");i.requiredLimits={maxComputeWorkgroupStorageSize:o.maxComputeWorkgroupStorageSize,maxComputeWorkgroupsPerDimension:o.maxComputeWorkgroupsPerDimension},r?i.requiredFeatures=["timestamp-query"]:console.warn("This device doesn't support timestamp-query extension. Start Chrome browser with flag --disable-dawn-features=disallow_unsafe_apis then try again. Or zero will shown for the kernel time when profiling mode isenabled. Using performance.now is not workable for webgpu sinceit doesn't support synchronously to read data from GPU.");const a=await n.requestDevice(i);return new Hi(a,r)}),3),e.webgpu=Yi,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-webgpu.es2017.min.js.map
