/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import*as e from"@tensorflow/tfjs-core";import{env as t,util as n,backend_util as o,Reshape as r,broadcast_util as i,_FusedMatMul as a,Identity as s,Complex as u,upcastType as l,buffer as d,slice_util as c,TensorBuffer as p,Abs as h,Add as f,AddN as m,Transpose as g,ArgMax as b,ArgMin as I,AvgPool as w,BatchMatMul as x,Slice as k,BatchToSpaceND as v,NotEqual as S,Real as y,Cast as C,Ceil as z,ClipByValue as _,Imag as $,Concat as G,Conv2D as A,Conv2DBackpropInput as R,Cos as B,Cosh as T,CropAndResize as P,Cumprod as N,Cumsum as E,DepthToSpace as L,DepthwiseConv2dNative as W,Multiply as O,sumOutType as F,Sum as U,Einsum as D,Elu as M,Equal as V,Exp as X,ExpandDims as H,Expm1 as q,Fill as Y,FlipLeftRight as K,Floor as j,FloorDiv as Q,FromPixels as Z,FusedBatchNorm as J,FusedConv2D as ee,FusedDepthwiseConv2D as te,GatherNd as ne,GatherV2 as oe,Greater as re,GreaterEqual as ie,LeakyRelu as ae,Less as se,LessEqual as ue,Log as le,LogicalAnd as de,LogicalNot as ce,Max as pe,Maximum as he,MaxPool as fe,Mean as me,Min as ge,Minimum as be,MirrorPad as Ie,Neg as we,NonMaxSuppressionV3 as xe,kernel_impls as ke,NonMaxSuppressionV5 as ve,ZerosLike as Se,OnesLike as ye,Pack as Ce,PadV2 as ze,Pow as _e,Prelu as $e,Prod as Ge,Range as Ae,RealDiv as Re,Relu as Be,Relu6 as Te,ResizeBilinear as Pe,ResizeNearestNeighbor as Ne,RotateWithOffset as Ee,Rsqrt as Le,ScatterNd as We,Select as Oe,Sigmoid as Fe,Sin as Ue,Sinh as De,Sub as Me,Softmax as Ve,SpaceToBatchND as Xe,SparseToDense as He,SplitV as qe,Sqrt as Ye,Square as Ke,SquaredDifference as je,StridedSlice as Qe,StringNGrams as Ze,Tanh as Je,Tile as et,TopK as tt,Transform as nt,Unpack as ot,registerKernel as rt,KernelBackend as it,DataStorage as at,engine as st,registerBackend as ut}from"@tensorflow/tfjs-core";const lt=t();var dt;lt.registerFlag("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE",(()=>15)),lt.registerFlag("WEBGPU_CPU_FORWARD",(()=>!0)),lt.registerFlag("WEBGPU_MATMUL_WORK_PER_THREAD",(()=>4)),lt.registerFlag("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE",(()=>!1)),lt.registerFlag("WEBGPU_USE_LOW_POWER_GPU",(()=>!1)),lt.registerFlag("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD",(()=>1e3)),lt.registerFlag("WEBGPU_USE_PROFILE_TOOL",(()=>!1)),lt.registerFlag("WEBGPU_USE_IMPORT",(()=>!1)),function(e){e[e.MUL=0]="MUL",e[e.ADD=1]="ADD",e[e.SUB=2]="SUB",e[e.DIV=3]="DIV",e[e.EQUAL=4]="EQUAL",e[e.GREATER=5]="GREATER",e[e.GREATER_EQUAL=6]="GREATER_EQUAL",e[e.LESS=7]="LESS",e[e.LESS_EQUAL=8]="LESS_EQUAL",e[e.LOGICAL_AND=9]="LOGICAL_AND",e[e.NOT_EQUAL=10]="NOT_EQUAL",e[e.SQUARED_DIFFERENCE=11]="SQUARED_DIFFERENCE",e[e.INT_DIV=12]="INT_DIV",e[e.POW=13]="POW",e[e.PRELU=14]="PRELU",e[e.MAX=15]="MAX",e[e.MIN=16]="MIN",e[e.COMPLEX_MULTIPLY_REAL=17]="COMPLEX_MULTIPLY_REAL",e[e.COMPLEX_MULTIPLY_IMAG=18]="COMPLEX_MULTIPLY_IMAG"}(dt||(dt={}));const ct="\n  if (isNaN.r) {\n    resultTemp.r = uniforms.NAN;\n  }\n  if (isNaN.g) {\n    resultTemp.g = uniforms.NAN;\n  }\n  if (isNaN.b) {\n    resultTemp.b = uniforms.NAN;\n  }\n  if (isNaN.a) {\n    resultTemp.a = uniforms.NAN;\n  }\n  ",pt=`\n  let isModRound1Bool = vec4<i32>(round(abs(b) % vec4<f32>(2.0))) == vec4<i32>(1);\n  let isModRound1 = vec4<f32>(isModRound1Bool);\n  let multiplier = sign(a) * isModRound1 + (vec4<f32>(1.0) - isModRound1);\n  var resultTemp = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  let isExpZero = b == vec4<f32>(0.0);\n  if (isExpZero.r) {\n    resultTemp.r = 1.0;\n  }\n  if (isExpZero.g) {\n    resultTemp.g = 1.0;\n  }\n  if (isExpZero.b) {\n    resultTemp.b = 1.0;\n  }\n  if (isExpZero.a) {\n    resultTemp.a = 1.0;\n  }\n  let isNaN = a < vec4<f32>(0.0) & floor(b) < b;\n  ${ct}\n  return resultTemp;\n  `;function ht(e,t){const n=t?ct:"\n  if (isnan(a)) { return a; }\n  if (isnan(b)) { return b; }\n  ";return t?`\n    var resultTemp = vec4<f32>(${e}(a, b));\n    let isNaN = isnanVec4(a) | isnanVec4(b);\n    `+n+"\n    return resultTemp;\n  ":n+`\n    return ${e}(a, b);\n  `}function ft(e,t){switch(e){case dt.MUL:return"return a * b;";case dt.ADD:return"return a + b;";case dt.SUB:return"return a - b;";case dt.DIV:return"return a / b;";case dt.EQUAL:return t?"return vec4<f32>(a == b);":"return f32(a == b);";case dt.GREATER:return t?"return vec4<f32>(a > b);":"return f32(a > b);";case dt.GREATER_EQUAL:return t?"return vec4<f32>(a >= b);":"return f32(a >= b);";case dt.LESS:return t?"return vec4<f32>(a < b);":"return f32(a < b);";case dt.LESS_EQUAL:return t?"return vec4<f32>(a <= b);":"return f32(a <= b);";case dt.LOGICAL_AND:return t?"return (vec4<f32>(a >= vec4<f32>(1.0)) *\n  vec4<f32>(b >= vec4<f32>(1.0)));":"return f32(f32(a) >= 1.0 && f32(b) >= 1.0);";case dt.NOT_EQUAL:return t?"return vec4<f32>(a != b);":"return f32(a != b);";case dt.SQUARED_DIFFERENCE:return"return (a - b) * (a - b);";case dt.INT_DIV:return t?"\n  let ia = vec4<i32>(round(a));\n  let ib = vec4<i32>(round(b));\n  let cond = ib != vec4<i32>(0);\n  var resultTemp = vec4<i32>(0);\n  let s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    resultTemp[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    resultTemp[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    resultTemp[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    resultTemp[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4<f32>(resultTemp);\n  ":"\n  let s = sign(a) * sign(b);\n  let ia = i32(round(a));\n  let ib = i32(round(b));\n  return f32(idiv(ia, ib, s));\n  ";case dt.PRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (b * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n  ":"if (a < 0.0) { return b * a; }  return a;";case dt.MAX:return ht("max",t);case dt.MIN:return ht("min",t);case dt.POW:return t?pt:"\n  if(a < 0.0 && floor(b) < b) {\n    return uniforms.NAN;\n  }\n  if (b == 0.0) {\n    return 1.0;\n  }\n  if (round(abs(b) % 2.0) != 1.0) {\n    return pow(abs(a), b);\n  }\n  return sign(a) * pow(abs(a), b);\n  ";case dt.COMPLEX_MULTIPLY_REAL:return"return areal * breal - aimag * bimag;";case dt.COMPLEX_MULTIPLY_IMAG:return"return areal * bimag + aimag * breal;";default:throw new Error(`BinaryType ${e} is not implemented!`)}}var mt;!function(e){e[e.ABS=0]="ABS",e[e.CEIL=1]="CEIL",e[e.COS=2]="COS",e[e.COSH=3]="COSH",e[e.ELU=4]="ELU",e[e.EXP=5]="EXP",e[e.EXPM1=6]="EXPM1",e[e.FLOOR=7]="FLOOR",e[e.LINEAR=8]="LINEAR",e[e.LOG=9]="LOG",e[e.LOGICAL_NOT=10]="LOGICAL_NOT",e[e.NEG=11]="NEG",e[e.RELU=12]="RELU",e[e.RELU6=13]="RELU6",e[e.LEAKYRELU=14]="LEAKYRELU",e[e.RSQRT=15]="RSQRT",e[e.SIN=16]="SIN",e[e.SINH=17]="SINH",e[e.SIGMOID=18]="SIGMOID",e[e.SQRT=19]="SQRT",e[e.SQUARE=20]="SQUARE",e[e.TANH=21]="TANH",e[e.TO_INT=22]="TO_INT"}(mt||(mt={}));function gt(e,t){switch(e){case mt.ABS:return"return abs(a);";case mt.COS:return"return cos(a);";case mt.COSH:return"\n  let e2x = exp(-a);\n  return (e2x + 1.0 / e2x) / 2.0;\n";case mt.CEIL:return"return ceil(a);";case mt.ELU:return t?"\n  var resFloat = exp(a) - vec4<f32>(1.0);\n  if (a.r >= 0.0) {\n    resFloat.r = a.r;\n  }\n  if (a.g >= 0.0) {\n    resFloat.g = a.g;\n  }\n  if (a.b >= 0.0) {\n    resFloat.b = a.b;\n  }\n  if (a.a >= 0.0) {\n    resFloat.a = a.a;\n  }\n  return resFloat;\n":"if (a >= 0.0) { return a; }  return (exp(a) - 1.0);";case mt.EXP:return"return exp(a);";case mt.EXPM1:return"return exp(a) - 1.0;";case mt.FLOOR:return"return floor(a);";case mt.LINEAR:return"return a;";case mt.LOG:return"if (a < 0.0) { return 1.0/0.0; }\n  return log(a);";case mt.LOGICAL_NOT:return"return f32(!(a >= 1.0));";case mt.NEG:return"return -a;";case mt.LEAKYRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (uniforms.alpha * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return uniforms.alpha * a; } return a;";case mt.RELU:return t?"\n  return select(a, vec4<f32>(0.0), a < vec4<f32>(0.0));\n":"return select(a, 0.0, a < 0.0);";case mt.RELU6:return t?"return clamp(a, vec4<f32>(0.0, 0.0, 0.0, 0.0), vec4<f32>(6.0, 6.0, 6.0, 6.0));":"return clamp(a, 0.0, 6.0);";case mt.RSQRT:return"return 1.0/sqrt(a);";case mt.SIGMOID:return"return 1.0 / (1.0 + exp(-1.0 * a));";case mt.SIN:return"return sin(a);";case mt.SINH:return"\n  let e2x = exp(a);\n  return (e2x - 1.0 / e2x) / 2.0;\n";case mt.SQRT:return"return sqrt(a);";case mt.SQUARE:return"return a * a;";case mt.TANH:return"\n  let e2x = exp(-2.0 * abs(a));\n  return sign(a) * (1.0 - e2x) / (1.0 + e2x);\n";case mt.TO_INT:return"return f32(i32((a)));";default:throw new Error(`BinaryType ${e} is not implemented!`)}}function bt(e,t=!1){if(null===e)return null;if("linear"===e)return gt(mt.LINEAR);if("relu"===e)return gt(mt.RELU,t);if("elu"===e)return gt(mt.ELU,t);if("relu6"===e)return gt(mt.RELU6,t);if("prelu"===e)return ft(dt.PRELU,t);if("sigmoid"===e)return gt(mt.SIGMOID,t);if("leakyrelu"===e)return gt(mt.LEAKYRELU,t);throw new Error(`Activation ${e} has not been implemented for the WebGPU backend.`)}function It(e,t){if(Math.max(...e)>3)throw new Error("Cannot symbolically compute strides for rank > 4 tensor.");const n=e.length,o=e.map((e=>`${t}[${e}]`)),r=new Array(n-1);r[n-2]=o[n-1];for(let e=n-3;e>=0;--e)r[e]=`(${r[e+1]} * ${o[e+1]})`;return r}function wt(e){if(e<=1)return"i32";if(2===e)return"vec2<i32>";if(3===e)return"vec3<i32>";if(4===e)return"vec4<i32>";if(5===e)return"vec5";if(6===e)return"vec6";throw Error(`GPU for rank ${e} is not yet supported`)}function xt(e){if(0===e)return"x";if(1===e)return"y";if(2===e)return"z";if(3===e)return"w";if(4===e)return"u";if(5===e)return"v";throw Error(`Index ${e} is not yet supported`)}function kt(e,t){return"float32"===e?t?"vec4<f32>":"f32":"int32"===e||"bool"===e?t?"vec4<i32>":"i32":e}function vt(e,t,r,i=!1){const a=[];if(a.push(`\n    let workGroupSizeX = ${r.workGroupSize[0]}u;\n    let workGroupSizeY = ${r.workGroupSize[1]}u;\n    let workGroupSizeZ = ${r.workGroupSize[2]}u;\n\n    var<private> localId: vec3<u32>;\n    var<private> globalId: vec3<u32>;\n    var<private> numWorkgroups: vec3<u32>;\n\n    // Only used when the y/z dimension of workgroup size is 1.\n    fn getGlobalIndex() -> i32 {\n      if (numWorkgroups.y == 1u && numWorkgroups.z == 1u) {\n        return i32(globalId.x);\n      }\n\n      let localInvocationIndex = localId.z * workGroupSizeX * workGroupSizeY +\n          localId.y * workGroupSizeX + localId.x;\n      let workGroupID = (globalId - localId)/vec3<u32>(\n          workGroupSizeX, workGroupSizeY, workGroupSizeZ);\n\n      return i32((workGroupID.z * numWorkgroups.x * numWorkgroups.y +\n        workGroupID.y * numWorkgroups.x + workGroupID.x) *\n        (workGroupSizeX * workGroupSizeY * workGroupSizeZ) +\n        localInvocationIndex);\n    }\n  `),!0===i)return a.push(`\n      struct Uniform {\n        size            : i32,\n        numChannels     : i32,\n        outShapeStrides : vec2<i32>,\n        dispatchSize    : vec3<u32>,\n      };\n\n      @group(0) @binding(0) var<storage, write> result: array<${kt(t.dtype,r.isVec4)}>;\n      @group(0) @binding(2) var<uniform> uniforms: Uniform;\n    `),[St,a.join("\n"),Ct(t.shape),r.getUserCode()].join("\n");let s=!1,u=!1,l="struct Uniforms { NAN : f32, ";r.variableNames.forEach(((t,n)=>{const o=wt(e[n].shape.length);"vec5"!==o&&"vec6"!==o||(u=!0),(s||u)&&(l+="@align(16) "),s=u,l+=`${t.charAt(0).toLowerCase()+t.slice(1)}Shape : ${o}, `}));const d=wt(t.shape.length);u="vec5"===d||"vec6"===d,(s||u)&&(l+="@align(16) "),s=u,l+=`outShape : ${d}, `;const c=wt(t.shape.length-1);u="vec5"===c||"vec6"===c,(s||u)&&(l+="@align(16) "),s=u,l+=`\n       outShapeStrides: ${c}, `,r.size&&(s&&(l+="@align(16) "),s=!1,l+="size : i32, "),r.uniforms&&(s&&(l+="@align(16) "),l+=r.uniforms),l+="};",a.push(l),r.atomic?a.push("\n    @group(0) @binding(0) var<storage, read_write> result: array<atomic<i32>>;\n  "):a.push(`\n    @group(0) @binding(0) var<storage, write> result: array<${kt(t.dtype,r.isVec4)}>;\n  `),r.variableNames.forEach(((t,n)=>{a.push(`\n    @group(0) @binding(${1+n}) var<storage, read> ${t}: array<${kt(e[n].dtype,r.isVec4)}>;\n    `)})),""!==l&&a.push(`\n    @group(0) @binding(${1+r.variableNames.length}) var<uniform> uniforms: Uniforms;\n    `);const[p,h]=function(e,t){const{x:n,y:o=[],z:r=[]}=t,i=e.length;if(n.length===i){return[`fn getOutputCoords() -> ${wt(i)}{\n      let globalIndex = getGlobalIndex();\n      return getCoordsFromIndex(globalIndex);\n    }\n    `,i]}let a="";const s=[n,o,r];let u=0;for(let e=0;e<s.length;e++){const t=s[e];if(0!==t.length)if(u+=t.length,1===t.length)a+=`let d${t[0]} = i32(globalId[${e}]);`;else{const n=It(t,"uniforms.outShape");a+=`var index${e} = i32(globalId[${e}]);`;for(let o=0;o<n.length;o++)a+=`let d${t[o]} = index${e} / ${n[o]};`,o===n.length-1?a+=`let d${t[o+1]} = index${e} - d${t[o]} * ${n[o]};`:a+=`index${e} = index${e} - d${t[o]} * ${n[o]};`}}const l=[];for(let e=0;e<u;e++)l.push(`d${e}`);const d=wt(u);let c=`fn getOutputCoords() -> ${d} {\n    ${a}\n  `;0===l.length?c+=`return ${d}(0); }`:c+=`return ${d}(${l.join(",")}); }`;return[c,u]}(t.shape,r.dispatchLayout),f=[St,a.join("\n"),Ct(t.shape),p,yt(t.shape.length)];if(r.atomic||f.push(function(e,t,n){const o=e.length,r=kt(t,n);let i;i=n?`fn setOutputAtIndex(flatIndex : i32, value : vec4<f32>) {\n      result[flatIndex] = ${r}(value);\n    }\n    fn setOutputAtIndexI32(flatIndex : i32, value : vec4<i32>) {\n      result[flatIndex] = ${r}(value);\n    }`:`fn setOutputAtIndex(flatIndex : i32, value : f32) {\n      result[flatIndex] = ${r}(value);\n    }\n    fn setOutputAtIndexI32(flatIndex : i32, value : i32) {\n      result[flatIndex] = ${r}(value);\n    }`;if(o>=2){const e=["d0","d1","d2","d3","d4","d5"].slice(0,o),t=wt(o);i+=n?`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : vec4<f32>) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex / 4, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : vec4<i32>) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex / 4, value);\n      }\n    `:`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : f32) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : i32) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex, value);\n      }\n    `}return i}(t.shape,t.dtype,r.isVec4)),h===t.shape.length){const i=e.map((e=>function(e,t,r,i){let a=function(e,t){const n=e.name,o=e.shape.length,r=wt(o),i="get"+n.charAt(0).toUpperCase()+n.slice(1),a=["d0","d1","d2","d3","d4","d5"].slice(0,o),s=a.map((e=>`${e} : i32`)).join(", ");if(o<1)return t?`\n        fn ${i}() -> vec4<f32> {\n          return vec4<f32>(${n}[0]);\n        }\n      `:`\n      fn ${i}() ->f32 {\n        return f32(${n}[0]);\n      }\n    `;const u=`uniforms.${n.charAt(0).toLowerCase()+n.slice(1)}Shape`;let l=`${o}D`;0===o&&(l="1D");if(t)return`\n      fn ${i}(${s}) -> vec4<f32> {\n        return vec4<f32>(${n}[getIndexFromCoords${l}(${r}(${a.join(",")}),\n          ${u}) / 4]);\n      }\n      `;return`\n    fn ${i}(${s}) -> f32 {\n      return f32(${n}[getIndexFromCoords${l}(${r}(${a.join(",")}),\n        ${u})]);\n    }\n   `}(e,r);e.shape.length<=t.length&&(a+=function(e,t,r,i){const a=e.name,s=a.charAt(0).toUpperCase()+a.slice(1),u="get"+s+"ByOutput",l=e.shape.length,d=t.length,c=wt(d);if(n.arraysEqual(e.shape,t)&&i)return r?`\n        fn ${u}Index(globalIndex : i32) -> vec4<f32> {\n          return vec4<f32>(${a}[globalIndex]);\n        }\n\n        fn ${u}Coords(coords : ${c}) -> vec4<f32> {\n          return vec4<f32>(${a}[${d>1?"getOutputIndexFromCoords(coords)":"coords"} / 4]);\n        }\n        `:`\n      fn ${u}Index(globalIndex : i32) -> f32 {\n        return f32(${a}[globalIndex]);\n      }\n\n      fn ${u}Coords(coords : ${c}) -> f32 {\n        return f32(${a}[${d>1?"getOutputIndexFromCoords(coords)":"coords"}]);\n      }\n      `;const p=o.getBroadcastDims(e.shape,t),h=d-l;let f="";if(0===l)return r?`\n      fn ${u}Index(globalIndex : i32) -> vec4<f32> {\n        return get${s}();\n      }\n\n      fn ${u}Coords(coords : ${c}) -> vec4<f32> {\n        return get${s}();\n      }\n    `:`\n      fn ${u}Index(globalIndex : i32) -> f32{\n        return get${s}();\n      }\n\n      fn ${u}Coords(coords : ${c}) -> f32{\n        return get${s}();\n      }\n    `;f=d<2&&p.length>=1?"coords = 0;":p.map((e=>`coords.${xt(e+h)} = 0;`)).join("\n");let m="";if(d<2&&l>0)m="coords";else if(d>1){m=`${wt(l)}(${e.shape.map(((e,t)=>`coords.${xt(t+h)}`)).join(", ")})`}else m="coords";const g=`uniforms.${a.charAt(0).toLowerCase()+a.slice(1)}Shape`,b=`${l}D`;if(r)return`\n      fn ${u}Index(globalIndex : i32) -> vec4<f32> {\n        var coords = getCoordsFromIndex(globalIndex);\n        ${f}\n        return ${a}[getIndexFromCoords${b}(${m}, ${g}) / 4];\n      }\n\n      fn ${u}Coords(coordsIn : ${c}) -> vec4<f32> {\n        var coords = coordsIn;\n        ${f}\n        return ${a}[getIndexFromCoords${b}(${m}, ${g}) / 4];\n      }\n    `;return`\n    fn ${u}Index(globalIndex : i32) -> f32 {\n      var coords = getCoordsFromIndex(globalIndex);\n      ${f}\n      return f32(${a}[getIndexFromCoords${b}(${m}, ${g})]);\n    }\n\n    fn ${u}Coords(coordsIn : ${c}) -> f32 {\n      var coords = coordsIn;\n      ${f}\n      return f32(${a}[getIndexFromCoords${b}(${m}, ${g})]);\n    }\n  `}(e,t,r,i));return a}(e,t.shape,r.isVec4,r.dispatchLayout.x.length===t.shape.length))).join("\n");f.push(i)}f.push(r.getUserCode());return f.join("\n")}const St="\n  struct vec5 {x: i32, y: i32, z: i32, w: i32, u: i32};\n  struct vec6 {x: i32, y: i32, z: i32, w: i32, u: i32, v: i32};\n\n  // Checks whether coordinates lie within the bounds of the shape.\n  fn coordsInBounds2D(coord : vec2<i32>, shape : vec2<i32>) -> bool {\n    return all(coord >= vec2<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds3D(coord : vec3<i32>, shape : vec3<i32>) -> bool {\n    return all(coord >= vec3<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds4D(coord : vec4<i32>, shape : vec4<i32>) -> bool {\n    return all(coord >= vec4<i32>(0)) && all(coord < shape);\n  }\n\n  fn getIndexFromCoords1D(coord : i32, shape : i32) -> i32 {\n    return coord;\n  }\n  fn getIndexFromCoords2D(coords : vec2<i32>, shape : vec2<i32>) -> i32 {\n    return dot(coords, vec2<i32>(shape.y, 1));\n  }\n  fn getIndexFromCoords3D(coords : vec3<i32>, shape : vec3<i32>) -> i32 {\n    return dot(coords, vec3<i32>(shape.y * shape.z, shape.z, 1));\n  }\n  fn getIndexFromCoords4D(coords : vec4<i32>, shape : vec4<i32>) -> i32 {\n    return dot(coords, vec4<i32>(\n        shape.y * shape.z * shape.w, shape.z * shape.w, shape.w, 1));\n  }\n  fn getIndexFromCoords5D(coords : vec5, shape : vec5) -> i32 {\n    let shapeStrides: vec5 = vec5(shape.y * shape.z * shape.w * shape.u, shape.z * shape.w * shape.u, shape.w * shape.u, shape.u, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u;\n  }\n  fn getIndexFromCoords6D(coords : vec6, shape : vec6) -> i32 {\n    let shapeStrides: vec6 = vec6(shape.y * shape.z * shape.w * shape.u * shape.v, shape.z * shape.w * shape.u * shape.v, shape.w * shape.u * shape.v, shape.u * shape.v, shape.v, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u + coords.v*shapeStrides.v;\n  }\n\n  fn idiv(a: i32, b: i32, sign: f32) -> i32 {\n    var res: i32 = a / b;\n    let mod: i32 = a % b;\n    if (sign < 0. && mod != 0) {\n      res = res - 1;\n    }\n    return res;\n  }\n\n  // NaN defination in IEEE 754-1985 is :\n  //   - sign = either 0 or 1.\n  //   - biased exponent = all 1 bits.\n  //   - fraction = anything except all 0 bits (since all 0 bits represents infinity).\n  // https://en.wikipedia.org/wiki/IEEE_754-1985#Representation_of_non-numbers\n  fn isnan(val: f32) -> bool {\n    let floatToUint: u32 = bitcast<u32>(val);\n    return (floatToUint & 0x7fffffffu) > 0x7f800000u;\n  }\n  fn isnanVec4(val : vec4<f32>) -> vec4<bool> {\n    return vec4<bool>(isnan(val[0]), isnan(val[1]), isnan(val[2]), isnan(val[3]));\n  }\n";function yt(e){let t="";switch(e){case 0:case 1:t+="\n        fn getOutputIndexFromCoords(coords : i32) -> i32 {\n          return coords;\n        }\n        ";break;case 2:t+="\n        fn getOutputIndexFromCoords(coords : vec2<i32>) -> i32 {\n          return dot(coords, vec2<i32>(uniforms.outShapeStrides, 1));\n        }\n        ";break;case 3:t+="\n        fn getOutputIndexFromCoords(coords : vec3<i32>) -> i32 {\n          return dot(coords, vec3<i32>(uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, 1));\n        }\n        ";break;case 4:t+="\n        fn getOutputIndexFromCoords(coords : vec4<i32>) -> i32 {\n          return dot(coords, vec4<i32>(\n            uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, uniforms.outShapeStrides.z, 1));\n        }\n        ";break;case 5:t+="\n        fn getOutputIndexFromCoords(coords : vec5) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u;\n        }\n        ";break;case 6:t+="\n        fn getOutputIndexFromCoords(coords : vec6) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u * uniforms.outShapeStrides.u +\n              coords.v;\n        }\n        ";break;default:n.assert(!1,(()=>`Unsupported ${e}D shape`))}return t}function Ct(e){const t=e.length;if(t<=1)return"fn getCoordsFromIndex(index : i32) -> i32 { return index; }";const o=n.computeStrides(e),r=wt(t),i=[];for(let e=0;e<t;e++)i.push(`d${e}`);if(1===o.length)return"    fn getCoordsFromIndex(index : i32) -> vec2<i32> {\n      let d0 = index / uniforms.outShapeStrides; let d1 = index - d0 * uniforms.outShapeStrides;\n      return vec2<i32>(d0, d1);\n    }";let a;return a="var index2 = index;"+o.map(((e,t)=>`${`let ${i[t]} = index2 / uniforms.outShapeStrides.${xt(t)}`}; ${t===o.length-1?`let ${i[t+1]} = index2 - ${i[t]} * uniforms.outShapeStrides.${xt(t)}`:`index2 = index2 - ${i[t]} * uniforms.outShapeStrides.${xt(t)}`};`)).join(""),`\n    fn getCoordsFromIndex(index : i32) -> ${r} {\n      ${a}\n      return ${r}(${i.join(",")});\n    }\n  `}const zt=e=>{let t=1;for(let n=0;n<e.length;n++)t*=e[n];return t};function _t(e,t){if(e.length!==t.length)throw new Error(`Cannot compute whether rank ${e.length} tiles fit evenly into rank ${t.length} shape - ranks must match.`);return t.every(((t,n)=>t%e[n]==0))}function $t(e,t,n=[1,1,1],o=[1,1,1]){const[r,i,a]=[Math.ceil(zt(e.x.map((e=>t[e])))/(n[0]*o[0])),e.y?Math.ceil(zt(e.y.map((e=>t[e])))/(n[1]*o[1])):1,e.z?Math.ceil(zt(e.z.map((e=>t[e])))/(n[2]*o[2])):1];return[r,i,a]}function Gt(e,t){const n=zt(e.x.map((e=>t[e]))),o=zt(e.y.map((e=>t[e])));return n<=4?[4,16,1]:o<=4?[16,4,1]:[16,16,1]}function At(e,t,n){return 1===e?[32,1,1]:1===n?[1,32,1]:[8,8,1]}function Rt(e,t){const n=zt(e.x.map((e=>t[e]))),o=zt(e.y.map((e=>t[e])));return n<=4?[1,2,1]:o<=4?[2,1,1]:[2,2,1]}function Bt(e){return{x:e.map(((e,t)=>t))}}function Tt(e){if("float32"===e||"int32"===e||"bool"===e||"string"===e)return 4;if("complex64"===e)return 8;throw new Error(`Unknown dtype ${e}`)}function Pt(e,t){if("float32"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t||"string"===t)return Uint8Array.from(new Int32Array(e));throw new Error(`Unknown dtype ${t}`)}function Nt(){return("undefined"!=typeof window||"undefined"!=typeof WorkerGlobalScope)&&!!navigator.gpu}var Et={__proto__:null,tilesFitEvenlyIntoShape:_t,computeDispatch:$t,computeWorkGroupSizeForConv2d:Gt,computeWorkGroupSizeForMatMul:At,computeWorkPerThreadForConv2d:Rt,flatDispatchLayout:Bt,GPUBytesPerElement:Tt,ArrayBufferToTypedArray:Pt,isWebGPUSupported:Nt};function Lt(e,t,o,r){return n.assert(r%4==0&&4===e[0],(()=>"tileInner must be divisible by 4. And ColPerThread must be 4")),`\n  var<workgroup> mm_Asub : array<array<vec4<f32>, ${r/e[0]}>, ${t}>;\n  var<workgroup> mm_Bsub : array<array<vec4<f32>, ${o/e[0]}>, ${r}>;\n\n  let RowPerThread = ${e[1]};\n  let ColPerThread = ${e[0]};\n  let TileInner = ${r};\n\n  \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n\n    let tileRow = ${1===t?"0":"i32(localId.y) * RowPerThread"};\n    let tileCol = i32(localId.x);\n\n    let globalRow = ${1===t?"0":"i32(globalId.y) * RowPerThread"};\n    let globalCol = i32(globalId.x);\n    let numTiles = (uniforms.dimInner - 1) / TileInner + 1;\n\n    var acc: array<vec4<f32>, RowPerThread>;\n    var ACached : vec4<f32>;\n    var BCached : array<vec4<f32>, 4>;\n\n    // Loop over shared dimension.\n    var globalColA = tileCol;\n    let RowPerThreadB = TileInner / i32(workGroupSizeY);\n    let tileRowB = i32(localId.y) * RowPerThreadB;\n    for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileCol;\n            mm_Asub[inputRow][inputCol] = mm_readA(globalRow + innerRow, globalColA, globalId);\n        }\n        globalColA = globalColA + TileInner / ColPerThread;\n\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < RowPerThreadB; innerRow = innerRow + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(t * TileInner + inputRow, globalCol, globalId);\n        }\n\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < TileInner / ColPerThread; k = k + 1) {\n            BCached[0] = mm_Bsub[k * ColPerThread][tileCol];\n            BCached[1] = mm_Bsub[k * ColPerThread + 1][tileCol];\n            BCached[2] = mm_Bsub[k * ColPerThread + 2][tileCol];\n            BCached[3] = mm_Bsub[k * ColPerThread + 3][tileCol];\n\n            for (var i = 0; i < RowPerThread; i = i + 1) {\n                ACached = mm_Asub[tileRow + i][k];\n                acc[i] = BCached[0] * ACached.x + acc[i];\n                acc[i] = BCached[1] * ACached.y + acc[i];\n                acc[i] = BCached[2] * ACached.z + acc[i];\n                acc[i] = BCached[3] * ACached.w + acc[i];\n            }\n        }\n\n        workgroupBarrier();\n    }\n\n    for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n        mm_write(globalRow + innerRow,\n                 globalCol,\n                 acc[innerRow], globalId);\n    }\n  }`}class Wt{constructor(e,t,n,o,r,i=null,a=null,s=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,8,1],this.isVec4=!0,this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]},1===t[1]?this.elementsPerThread=[4,1,1]:this.elementsPerThread=[4,4,1],this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread);const u=null!=i,l=null!=s;u&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.tileAOuter=1===t[1]?1:this.workGroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=this.tileBOuter,this.aShape=e,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=o,this.batchBEqualOne=r,[this.fitA,this.fitB]=this.getShapeFit(),this.shaderKey=`matMulPackedVec4_${this.activation}_${this.fitA}_${this.fitB}_${this.elementsPerThread}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getShapeFit(){const e=this.aShape[2],t=this.outputShape[2],n=[this.outputShape[0],e,t],o=[this.tileAOuter,this.tileInner],r=[this.tileInner,this.tileBOuter];return[_t(o,this.aShape.slice(1)),_t(r,n.slice(1))]}getUserCode(){const e=this.fitA?"return A[batch * batchASize + row * uniforms.dimInner / 4 + col]":"if (coordsInBounds2D(vec2<i32>(row, col * 4), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n            return A[batch * batchASize + row * uniforms.dimInner / 4 + col];\n        }\n        return vec4<f32>(0.0)",t=this.fitB?"return B[batch * batchBSize + row * uniforms.dimBOuter / 4 + col]":"if(coordsInBounds2D(vec2<i32>(row, col * 4), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n             return B[batch * batchBSize + row * uniforms.dimBOuter / 4 + col];\n        }\n        return vec4<f32>(0.0)";let n="",o="";if(this.activation){const e=bt(this.activation,this.isVec4);n=this.hasPreluActivationWeights?`fn activation(a : vec4<f32>, outCoord : vec3<i32>) -> vec4<f32> {\n                  let b = getPreluActivationWeightsByOutputCoords(outCoord);\n                  ${e}\n                }`:`\n            fn activation(a : vec4<f32>, outCoord : vec3<i32>) -> vec4<f32> {\n              ${e}\n            }`,o="value = activation(value, outCoord);"}const r=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n      ${n}\n      fn mm_readA(row : i32, col : i32,  globalId : vec3<u32>) -> vec4<f32> {\n        ${this.batchAEqualOne?"\n          let batchASize = 0;\n          let batch = 0;\n        ":"\n          let batchASize = uniforms.aShape[1] * uniforms.aShape[2] / 4;\n          let batch = i32(globalId.z);\n        "}\n\n        ${e};\n      }\n\n      fn mm_readB(row : i32, col : i32,  globalId : vec3<u32>) -> vec4<f32> {\n        ${this.batchBEqualOne?"\n          let batchBSize = 0;\n          let batch = 0;\n          ":"\n          let batchBSize = uniforms.bShape[1] * uniforms.bShape[2] / 4;\n          let batch = i32(globalId.z);\n       "}\n        ${t};\n      }\n\n      fn mm_write(row : i32, col : i32, valueIn : vec4<f32>, globalId : vec3<u32>) {\n        if (row < uniforms.aShape[1] && col * 4 < uniforms.bShape[2])\n        {\n          var value = valueIn;\n          let batch = i32(globalId.z);\n          let outCoord = vec3<i32>(batch, row, col * 4);\n          ${r}\n          ${o}\n          setOutputAtCoords(outCoord[0], outCoord[1], outCoord[2], value);\n        }\n      }\n      ${Lt(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner)}\n    `}}function Ot(e,t){const n=t[1]*e[1],o=t[0]*e[0],r=n>o?n:o;return`\n    var<workgroup> mm_Asub : array<array<f32, ${r}>, ${n}>;\n    var<workgroup> mm_Bsub : array<array<f32, ${o}>, ${r}>;\n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let tileRow = i32(localId.y) * ${e[1]};\n      let tileCol = i32(localId.x) * ${e[0]};\n\n      let globalRow = i32(globalId.y) * ${e[1]};\n      let globalCol = i32(globalId.x) * ${e[0]};\n\n      let numTiles = (uniforms.dimInner - 1) / ${r} + 1;\n\n      var acc : array<array<f32, ${e[0]}>, ${e[1]}>;\n      var ACached : f32;\n      var BCached : array<f32, ${e[0]}>;\n\n      // Without this initialization strange values show up in acc.\n      for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n        for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n          acc[innerRow][innerCol] = 0.0;\n        }\n      }\n\n      let ColPerThreadA = ${r} / ${t[0]};\n      let tileColA = i32(localId.x) * ColPerThreadA;\n      let RowPerThreadB = ${r} / ${t[1]};\n      let tileRowB = i32(localId.y) * RowPerThreadB;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ColPerThreadA; innerCol = innerCol + 1) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileColA + innerCol;\n\n            mm_Asub[inputRow][inputCol] = mm_readA(\n                globalRow + innerRow,\n                t * ${r} + inputCol, globalId);\n          }\n        }\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < RowPerThreadB; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol + innerCol;\n\n            mm_Bsub[inputRow][inputCol] = mm_readB(\n              t * ${r} + inputRow,\n              globalCol + innerCol, globalId);\n          }\n        }\n\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < ${r}; k = k + 1) {\n          for (var inner = 0; inner < ${e[0]}; inner = inner + 1) {\n            BCached[inner] = mm_Bsub[k][tileCol + inner];\n          }\n\n          for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n            ACached = mm_Asub[tileRow + innerRow][k];\n            for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n              acc[innerRow][innerCol] = acc[innerRow][innerCol] + ACached * BCached[innerCol];\n            }\n          }\n        }\n\n        workgroupBarrier();\n      }\n\n      for (var innerRow = 0; innerRow < ${e[1]}; innerRow = innerRow + 1) {\n        for (var innerCol = 0; innerCol < ${e[0]}; innerCol = innerCol + 1) {\n\n          if ((globalCol + innerCol) < uniforms.dimBOuter &&\n              (globalRow + innerRow) < uniforms.dimAOuter) {\n            mm_write(globalRow + innerRow,\n                     globalCol + innerCol,\n                     acc[innerRow][innerCol], globalId);\n          }\n        }\n      }\n    }\n  `}class Ft{constructor(e,t,o,r,i,a=!1,s=!1,u=null,l=null,d=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[16,16,1],this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]};const c=a?e[1]:e[2];this.workGroupSize=At(t[1],0,t[2]),1!==t[1]&&1!==t[2]||(o=1),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[o,o,1]),n.arraysEqual(this.dispatch,[1,1,1])&&(o=1,this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[o,o,1]));const p=null!=u,h=null!=d;p&&this.variableNames.push("bias"),h&&this.variableNames.push("preluActivationWeights"),this.workPerThread=o,this.aShape=e,this.transposeA=a,this.transposeB=s,this.addBias=p,this.activation=l,this.hasPreluActivationWeights=h,this.batchAEqualOne=r,this.batchBEqualOne=i;const f=this.outputShape[2],m=this.transposeB?[this.outputShape[0],f,c]:[this.outputShape[0],c,f];[this.fitA,this.fitB]=this.getShapeFit(m),this.shaderKey=`matMulPacked_${this.workPerThread}_${a}_${s}_${this.activation}_${this.fitA}_${this.fitB}_${this.outputShape[1]>1}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getShapeFit(e){const t=this.workGroupSize[1]*this.workPerThread,o=this.workGroupSize[0]*this.workPerThread;let r=t>o?t:o;1===this.outputShape[1]&&(r*=4),n.assert(r%this.workGroupSize[0]==0&&r%this.workGroupSize[1]==0,(()=>"tileInner must be multiple of workgroupsize.x and workgroupsize.y"));const i=[r,o];return[_t([t,r],this.aShape.slice(1)),_t(i,e.slice(1))]}getUserCode(){let e,t;e=!1===this.transposeA?this.fitA?"return A[batch * batchASize + row * uniforms.dimInner + col];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n             return A[batch * batchASize + row * uniforms.dimInner + col];\n           }\n           return 0.0;":this.fitA?"return A[batch * batchASize + col * uniforms.dimAOuter + row];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n             return A[batch* batchASize + col * uniforms.dimAOuter + row];\n           }\n           return 0.0;",t=!1===this.transposeB?this.fitB?"return B[batch * batchBSize + row * uniforms.dimBOuter + col];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n             return B[batch * batchBSize + row * uniforms.dimBOuter + col];\n           }\n           return 0.0;":this.fitB?"return B[batch * batchBSize + col * uniforms.dimInner + row];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n             return B[batch * batchBSize + col * uniforms.dimInner + row];\n           }\n           return 0.0;";let n="",o="";if(this.activation){const e=bt(this.activation,!1);n=this.hasPreluActivationWeights?`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n               let b = getPreluActivationWeightsByOutputCoords(outCoord);\n               ${e}\n            }`:`\n              fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n                ${e}\n              }\n            `,o="value = activation(value, outCoord);"}const r=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";var i;return`\n      ${n}\n\n      fn mm_readA(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchAEqualOne?"\n        let batch = 0;\n        let batchASize = 0;\n        ":"\n        let batch = i32(globalId.z);\n        let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n        "}\n        ${e}\n      }\n\n      fn mm_readB(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchBEqualOne?"\n        let batch = 0;\n        let batchBSize = 0;\n        ":"\n        let batch = i32(globalId.z);\n        let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n        "}\n        ${t}\n      }\n\n      fn mm_write(row : i32, col : i32, valueIn : f32, globalId : vec3<u32>) {\n        var value = valueIn;\n        let batch = i32(globalId.z);\n        let outCoord = vec3<i32>(batch, row, col);\n        ${r}\n        ${o}\n        setOutputAtCoords(batch, row, col, value);\n      }\n      ${this.outputShape[1]>1?Ot([this.workPerThread,this.workPerThread,1],this.workGroupSize):(i=this.workGroupSize,`\n    let TileSize = ${4*i[0]};\n    var<workgroup> mm_Asub : array<vec4<f32>, ${i[0]}>;\n\n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let tileCol = i32(localId.x);\n      let globalCol = i32(globalId.x);\n      let globalRow = i32(globalId.y);\n\n      let numTiles = (uniforms.dimInner - 1) / TileSize + 1;\n\n      // Without this initialization strange values show up in acc.\n      var acc = 0.0;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        let colA = t * TileSize + tileCol * 4;\n        mm_Asub[tileCol] = vec4<f32>(mm_readA(globalRow, colA, globalId),\n                                mm_readA(globalRow, colA + 1, globalId),\n                                mm_readA(globalRow, colA + 2, globalId),\n                                mm_readA(globalRow, colA + 3, globalId));\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < TileSize / 4; k = k + 1) {\n          let rowB = t * TileSize + k * 4;\n          let BCached = vec4<f32>(mm_readB(rowB, globalCol, globalId),\n                              mm_readB(rowB + 1, globalCol, globalId),\n                              mm_readB(rowB + 2, globalCol, globalId),\n                              mm_readB(rowB + 3, globalCol, globalId));\n\n          let ACached = mm_Asub[k];\n          acc = acc + dot(ACached, BCached);\n        }\n\n        workgroupBarrier();\n      }\n\n      if (globalRow < uniforms.dimAOuter && globalCol < uniforms.dimBOuter) {\n        mm_write(globalRow, globalCol, acc, globalId);\n      }\n    }\n  `)}\n    `}}class Ut{constructor(e,t,n,o=!1,r=!1,i=null,a=null,s=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout={x:[],y:[1,2],z:[0]},this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize);const u=null!=i,l=null!=s;u&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.transposeA=o,this.transposeB=r,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=t,this.batchBEqualOne=n,this.shaderKey=`matMulReduce_${this.activation}_${o}_${r}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getUserCode(){let e,t;e=!1===this.transposeA?"return f32(A[batch * batchASize + row * uniforms.dimInner + col]);":"return f32(A[batch * batchASize + col * uniforms.dimAOuter + row]);",t=!1===this.transposeB?"return f32(B[batch * batchBSize + row * uniforms.dimBOuter + col]);":"return f32(B[batch * batchBSize + col * uniforms.dimInner + row]);";let n="",o="";if(this.activation){const e=bt(this.activation,!1);n=this.hasPreluActivationWeights?`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n               let b = getPreluActivationWeightsByOutputCoords(outCoord);\n               ${e}\n            }`:`\n              fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n                ${e}\n              }\n            `,o="value = activation(value, outCoord);"}const r=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n      ${n}\n\n      fn mm_readA(batchIn: i32, row : i32, col : i32) -> f32 {\n        ${this.batchAEqualOne?"\n          let batchASize = 0;\n          let batch = 0;\n          ":"\n          let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n          let batch = batchIn;\n          "}\n        ${e}\n      }\n\n      fn mm_readB(batchIn: i32, row : i32, col : i32) -> f32 {\n        ${this.batchBEqualOne?"\n          let batch = 0;\n          let batchBSize = 0;\n          ":"\n          let batch = batchIn;\n          let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n          "}\n        ${t}\n      }\n\n      fn mm_write(batch: i32, row : i32, col : i32, valueIn : f32) {\n        var value = valueIn;\n        let outCoord = vec3<i32>(batch, row, col);\n        ${r}\n        ${o}\n        setOutputAtCoords(batch, row, col, value);\n      }\n      \n    var<workgroup> sumValues : array<f32, workGroupSizeX>;\n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let coords = getOutputCoords();\n      let batch = coords[0];\n      let row = coords[1];\n      let col = coords[2];\n      var sum = 0.0;\n      let Length = uniforms.dimInner;\n      for (var k = i32(localId.x); k < Length; k = k + i32(workGroupSizeX)) {\n        let dataA = mm_readA(batch, row, k);\n        let dataB = mm_readB(batch, k, col);\n        sum = sum + dataA * dataB;\n      }\n      sumValues[localId.x] = sum;\n      workgroupBarrier();\n\n      for(var currentSize = workGroupSizeX / 2u; currentSize > 1u;\n          currentSize = currentSize / 2u) {\n        if (localId.x < currentSize)\n        {\n          sumValues[localId.x] = sumValues[localId.x] + sumValues[localId.x + currentSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (localId.x == 0u) {\n        sum = sumValues[0] + sumValues[1];\n        mm_write(batch, row, col, sum);\n      }\n    }\n  \n    `}}class Dt{constructor(e,t,o,r=null,i=null,a=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,16,1],n.assert(e[1]<=16||t[2]<=16,(()=>"This program can be only used when A width or B Height are small")),this.outputShape=o,this.dispatchLayout={x:[2],y:[1],z:[0]},this.dispatch=[Math.ceil(o[2]/this.workGroupSize[0]),Math.ceil(2*o[1]/this.workGroupSize[1]),o[0]];const s=null!=r;s&&this.variableNames.push("bias");const u=null!=a;u&&this.variableNames.push("preluActivationWeights"),this.addBias=s,this.activation=i,this.hasPreluActivationWeights=u,this.batchAEqualOne=1===e[0],this.batchBEqualOne=1===t[0],this.shaderKey=`matMulSmallOutputSize_${this.activation}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getUserCode(){let e="",t="";if(this.activation){const n=bt(this.activation,!1);e=this.hasPreluActivationWeights?`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n            let b = getPreluActivationWeightsByOutputCoords(outCoord);\n            ${n}\n            }`:`fn activation(a : f32, outCoord : vec3<i32>) -> f32 {\n            ${n}\n        }`,t="value = activation(value, outCoord);"}const n=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n      ${e}\n\n      fn mm_readA(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchAEqualOne?"\n          let batch = 0;\n          let batchASize = 0;\n          ":"\n          let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n          let batch = i32(globalId.z);\n          "}\n        if (coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimInner))) {\n          return A[batch * batchASize + row * uniforms.dimInner + col];\n        }\n        return 0.0;\n      }\n      fn mm_readB(row : i32, col : i32,  globalId : vec3<u32>) -> f32 {\n        ${this.batchBEqualOne?"\n          let batch = 0;\n          let batchBSize = 0;\n          ":"\n          let batch = i32(globalId.z);\n          let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n          "}\n        if (coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n           return B[batch * batchBSize + row * uniforms.dimBOuter + col];\n         }\n         return 0.0;\n      }\n      fn mm_write(row : i32, col : i32, valueIn : f32, globalId : vec3<u32>) {\n        if (coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimAOuter, uniforms.dimBOuter))) {\n          let batch = i32(globalId.z);\n          let outCoord = vec3<i32>(batch, row, col);\n          var value = valueIn;\n          ${n}\n          ${t}\n          setOutputAtCoords(batch, row, col, value);\n        }\n      }\n      ${function(e){const t=e[1]/2,n=e[0],o=t>n?t:n;return`\n  var<workgroup> mm_Asub1 : array<array<f32, ${o}>, ${t}>;\n  var<workgroup> mm_Bsub1 : array<array<f32, ${n}>, ${o}>;\n  var<workgroup> mm_Asub2 : array<array<f32, ${o}>, ${t}>;\n  var<workgroup> mm_Bsub2 : array<array<f32, ${n}>, ${o}>;\n\n  // If the output size is small for matrix multiplication, avoid to use vec4\n  // and handle some elements per thread to optimally utilize the ALU.\n  // Introduces two shared memory buffers, some logical threads could handle\n  // arithmetic operations and others handle IO operations between barrier api,\n  // makes ALUs and load/store units work simultaneously, could improves\n  // the performance.\n  \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n    let tileRow = i32(localId.y);\n    let tileCol = i32(localId.x);\n    let globalRow = i32(globalId.y);\n    let globalCol = i32(globalId.x);\n\n    // uniforms.dimInner should be greater than 0.\n    let numTiles = (uniforms.dimInner - 1) / ${o} + 1;\n    var acc = 0.0;\n\n    var globalColA = tileCol;\n    var globalRowB = tileRow;\n    for (var t = 0; t < numTiles; t = t + 1) {\n      if (t == 0) {\n        if (tileRow < ${t}) {\n          // Load one tile of A and B into local memory.\n          // globalRow is always greater than or equal tileRow.\n          mm_Asub1[tileRow][tileCol] =\n              mm_readA((globalRow - tileRow) / 2 + tileRow, globalColA, globalId);\n          globalColA = globalColA + ${o};\n          mm_Bsub1[tileRow][tileCol] = mm_readB(globalRowB, globalCol, globalId);\n          globalRowB = globalRowB + ${o};\n        }\n      } else {\n        if (tileRow < ${t}) {\n          // Load one tile of A and B into local memory.\n          // globalRow is always greater than or equal tileRow.\n          mm_Asub1[tileRow][tileCol] =\n              mm_readA((globalRow - tileRow) / 2 + tileRow, globalColA, globalId);\n          globalColA = globalColA + ${o};\n          mm_Bsub1[tileRow][tileCol] = mm_readB(globalRowB, globalCol, globalId);\n          globalRowB = globalRowB + ${o};\n        } else {\n          // Compute acc values for a single thread.\n          for (var k = 0; k < ${o}; k = k + 1) {\n            let subRow = tileRow - ${t};\n            if (subRow < 0) {\n              continue;\n            }\n            acc = acc + mm_Asub2[subRow][k] * mm_Bsub2[k][tileCol];\n          }\n        }\n      }\n      workgroupBarrier();\n      if (t != 0) {\n        t = t + 1;\n      }\n\n      if (t < numTiles) {\n        if (tileRow < ${t}) {\n          // Load one tile of A and B into local memory.\n          // globalRow is always greater than or equal tileRow.\n          mm_Asub2[tileRow][tileCol] =\n              mm_readA((globalRow - tileRow) / 2 + tileRow, globalColA, globalId);\n          globalColA = globalColA + ${o};\n          mm_Bsub2[tileRow][tileCol] = mm_readB(globalRowB, globalCol, globalId);\n          globalRowB = globalRowB + ${o};\n        } else {\n          // Compute acc values for a single thread.\n          for (var k = 0; k < ${o}; k = k + 1) {\n            let subRow = tileRow - ${t};\n            if (subRow < 0) {\n              continue;\n            }\n            acc = acc + mm_Asub1[subRow][k] * mm_Bsub1[k][tileCol];\n          }\n        }\n      }\n      workgroupBarrier();\n    }\n    let writeCol = (globalRow - tileRow) / 2 + tileRow - ${t};\n    if (tileRow >= ${t} && writeCol >= 0) {\n      mm_write(writeCol, globalCol, acc, globalId);\n    }\n  }\n  `}(this.workGroupSize)}\n    `}}function Mt(e){const{inputs:t,attrs:o}=e,{x:r}=t,{shape:i}=o,a=n.sizeFromShape(r.shape),s=n.inferFromImplicitShape(i,a),u=n.sizeFromShape(s);return n.assert(a===u,(()=>`The new shape (${s}) has ${u} elements and the old shape (${r.shape}) has ${a} elements. The new shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:s,dtype:r.dtype}}const Vt={kernelName:r,backendName:"webgpu",kernelFunc:Mt};function Xt({a:e,b:o,transposeA:r,transposeB:a,backend:s,bias:u=null,preluActivationWeights:l=null,leakyreluAlpha:d=0,activation:c=null}){const p=e.shape.length,h=o.shape.length,f=r?e.shape[p-2]:e.shape[p-1],m=a?o.shape[h-1]:o.shape[h-2],g=r?e.shape[p-1]:e.shape[p-2],b=a?o.shape[h-2]:o.shape[h-1],I=e.shape.slice(0,-2),w=o.shape.slice(0,-2),x=n.sizeFromShape(I),k=n.sizeFromShape(w),v=i.assertAndGetBroadcastShape(e.shape.slice(0,-2),o.shape.slice(0,-2)).concat([g,b]);n.assert(f===m,(()=>`Error in matMul: inner shapes (${f}) and (${m}) of Tensors with shapes ${e.shape} and ${o.shape} and transposeA=${r} and transposeB=${a} must match.`));const S=r?[x,f,g]:[x,g,f],y=a?[k,b,m]:[k,m,b],C=Mt({inputs:{x:e},backend:s,attrs:{shape:S}}),z=Mt({inputs:{x:o},backend:s,attrs:{shape:y}}),_=[C,z],$=Math.max(x,k),G=1===x,A=1===k,R=f%4==0&&b%4==0&&!r&&!a;let B;B=g*b<=32?new Ut([$,g,b],G,A,r,a,u,c,l):r||a||!(g<=16&&(b<=512||m>=2*b)||b<=16&&(g<=512||f>=2*g))?R?new Wt(S,[$,g,b],t().get("WEBGPU_MATMUL_WORK_PER_THREAD"),G,A,u,c,l):new Ft(S,[$,g,b],t().get("WEBGPU_MATMUL_WORK_PER_THREAD"),G,A,r,a,u,c,l):new Dt(S,y,[$,g,b],u,c,l);const T=[C,z];u&&T.push(u),l&&T.push(l);const P=[{type:"int32",data:[g]},{type:"int32",data:[b]},{type:"int32",data:[f]}];"leakyrelu"===c&&(P.push({type:"float32",data:[d]}),B.uniforms+=" alpha : f32,");const N=s.runWebGPUProgram(B,T,e.dtype,P),E=Mt({inputs:{x:N},backend:s,attrs:{shape:v}});_.push(N);for(const e of _)s.disposeData(e.dataId);return E}const Ht={kernelName:a,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{a:r,b:i,bias:a,preluActivationWeights:s}=t,{transposeA:u,transposeB:l,activation:d,leakyreluAlpha:c}=o;return Xt({a:r,b:i,transposeA:u,transposeB:l,backend:n,bias:a,preluActivationWeights:s,leakyreluAlpha:c,activation:d})}};class qt{constructor(e,t,n){this.variableNames=["AReal","AImag","BReal","BImag"],this.workGroupSize=[128,1,1],this.size=!0,this.outputShape=o.assertAndGetBroadcastShape(t,n),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`binaryOpComplex_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOpComplex(\n          areal : f32, aimag : f32, breal : f32, bimag : f32) -> f32 {\n        ${ft(this.op,!1)}\n      }\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if(index < uniforms.size) {\n          let areal = getARealByOutputIndex(index);\n          let aimag = getAImagByOutputIndex(index);\n          let breal = getBRealByOutputIndex(index);\n          let bimag = getBImagByOutputIndex(index);\n          setOutputAtIndex(index, binaryOpComplex(areal, aimag, breal, bimag));\n        }\n      }\n    `}}class Yt{constructor(e,t,n,r){this.variableNames=["A","B"],this.size=!0;this.workGroupSize=[256,1,1],this.outputShape=o.assertAndGetBroadcastShape(t,n),this.dispatchLayout=Bt(this.outputShape),this.lastDimensionSize=r?n[0]:t[0],this.lastDimensionSize<256?this.workPerThread=1:this.lastDimensionSize<512?this.workPerThread=2:this.workPerThread=4,this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.useSharedMemoryWithB=r,this.op=e,this.shaderKey=`binaryShared_${e}_${this.lastDimensionSize}_${this.useSharedMemoryWithB}`}getUserCode(){const e=this.lastDimensionSize>1?`coords[${this.outputShape.length-1}]`:"0",t=this.useSharedMemoryWithB?`let a = getAByOutputCoords(coords);\n         let b = sharedBuf[${e}];`:`let a = sharedBuf[${e}];\n         let b = getBByOutputCoords(coords);`;return`\n        fn binaryOperation(a : f32, b : f32) -> f32 {\n          ${ft(this.op,!1)}\n        }\n        var<workgroup> sharedBuf : array<f32, ${this.lastDimensionSize}>;\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n          // Fill in the shared memory buffer. Here we need a loop to make sure\n          // that all data in A|B are uploaded when |sharedMemorySize| is larger\n          // than work group size.\n          for(var localIndex = i32(localId.x); localIndex < ${this.lastDimensionSize}; localIndex = localIndex + ${this.workGroupSize[0]}) {\n            sharedBuf[localIndex] = f32(${this.useSharedMemoryWithB?"B":"A"}[localIndex]);\n          }\n          workgroupBarrier();\n\n          for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n            let flatIndex = index * ${this.workPerThread} + i;\n            if(flatIndex < uniforms.size) {\n              let coords = getCoordsFromIndex(flatIndex);\n\n              ${t}\n              setOutputAtIndex(flatIndex, binaryOperation(a, b));\n            }\n          }\n        }\n        `}}class Kt{constructor(e,t,n){this.variableNames=["A","B"],this.workPerThread=4,this.isVec4=!0,this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=o.assertAndGetBroadcastShape(t,n),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.op=e,this.shaderKey=`binaryVec4_${e}`}getUserCode(){return`\n      fn binaryOperation(a : vec4<f32>, b : vec4<f32>) -> vec4<f32> {\n        ${ft(this.op,this.isVec4)}\n      }\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          let b = getBByOutputIndex(index);\n          setOutputAtIndex(index, binaryOperation(a, b));\n        }\n      }\n    `}}class jt{constructor(e,t,n){this.variableNames=["A","B"],this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=o.assertAndGetBroadcastShape(t,n),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`binary_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOperation(a : f32, b : f32) -> f32 {\n        ${ft(this.op,!1)}\n      }\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          let b = getBByOutputIndex(index);\n          setOutputAtIndex(index, binaryOperation(a, b));\n        }\n      }\n      `}}function Qt(e,t,o){if(n.arraysEqual(t,o)&&n.sizeFromShape(t)%4==0)return new Kt(e,t,o);const r=1===t.length&&o.length>1&&t[0]<1024,i=1===o.length&&t.length>1&&o[0]<1024;return r||i?new Yt(e,t,o,i):new jt(e,t,o)}function Zt(e){const{inputs:t}=e,{x:n}=t;return e.backend.incRef(n.dataId),{dataId:n.dataId,shape:n.shape,dtype:n.dtype}}const Jt={kernelName:s,backendName:"webgpu",kernelFunc:Zt};function en(e){const{inputs:t,backend:n}=e,{real:o,imag:r}=t,i=n.makeTensorInfo(o.shape,"complex64"),a=n.tensorMap.get(i.dataId),s=Zt({inputs:{x:o},backend:n}),u=Zt({inputs:{x:r},backend:n});return a.complexTensorInfos={real:s,imag:u},i}const tn={kernelName:u,backendName:"webgpu",kernelFunc:en};class nn{constructor(e,t){this.variableNames=["A"],this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.op=t,this.shaderKey=`unary_${t}`}getUserCode(){return`\n      fn unaryOperation(a : f32) -> f32 {\n        ${gt(this.op,!1)}\n      }\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          setOutputAtIndex(index, unaryOperation(a));\n        }\n      }\n      `}}function on({opType:e,cpuKernelImpl:t,dtype:n}){return({inputs:o,backend:r})=>{const{x:i}=o,a=r,s=n||i.dtype;if(a.shouldExecuteOnCPU([i])&&null!=t){const e=a.tensorMap.get(i.dataId),n=t(e.values,s);return a.makeTensorInfo(i.shape,s,n)}const u=new nn(i.shape,e);return a.runWebGPUProgram(u,[i],s)}}function rn({opSnippet:e,cpuKernelImpl:t,supportsComplex:n=!1,dtype:r}){return({inputs:i,backend:a})=>{const{a:s,b:u}=i,d=a;if(n&&"complex64"===s.dtype){const t=d.tensorMap.get(s.dataId),n=d.tensorMap.get(u.dataId);let o,r;if(e!==dt.MUL)[o,r]=[[t.complexTensorInfos.real,n.complexTensorInfos.real],[t.complexTensorInfos.imag,n.complexTensorInfos.imag]].map((t=>{const[n,o]=t,r={dataId:n.dataId,dtype:n.dtype,shape:s.shape},i={dataId:o.dataId,dtype:o.dtype,shape:u.shape},a=Qt(e,s.shape,u.shape);return d.runWebGPUProgram(a,[r,i],l(n.dtype,o.dtype))}));else{const e=new qt(dt.COMPLEX_MULTIPLY_REAL,s.shape,u.shape),i=new qt(dt.COMPLEX_MULTIPLY_IMAG,s.shape,u.shape),a=[{dataId:t.complexTensorInfos.real.dataId,dtype:t.complexTensorInfos.real.dtype,shape:s.shape},{dataId:t.complexTensorInfos.imag.dataId,dtype:t.complexTensorInfos.imag.dtype,shape:s.shape},{dataId:n.complexTensorInfos.real.dataId,dtype:n.complexTensorInfos.real.dtype,shape:u.shape},{dataId:n.complexTensorInfos.imag.dataId,dtype:n.complexTensorInfos.imag.dtype,shape:u.shape}];o=d.runWebGPUProgram(e,a,"float32"),r=d.runWebGPUProgram(i,a,"float32")}const i=en({inputs:{real:o,imag:r},backend:d});return d.disposeData(o.dataId),d.disposeData(r.dataId),i}const c=r||l(s.dtype,u.dtype);if(("string"===s.dtype||"string"===u.dtype||d.shouldExecuteOnCPU([s,u]))&&null!=t){const e=d.tensorMap.get(s.dataId).values,n=d.tensorMap.get(u.dataId).values,r="string"===s.dtype?o.fromUint8ToStringArray(e):e,i="string"===s.dtype?o.fromUint8ToStringArray(n):n,[a,l]=t(s.shape,u.shape,r,i,c);return d.makeTensorInfo(l,c,a)}const p=Qt(e,s.shape,u.shape);return d.runWebGPUProgram(p,[s,u],c)}}function an(e){return(t,r,i,a,s)=>{const u=o.assertAndGetBroadcastShape(t,r),l=u.length,d=n.computeStrides(u),c=n.sizeFromShape(u),p=n.getTypedArrayFromDType(s,c),h=t.length,f=r.length,m=n.computeStrides(t),g=n.computeStrides(r),b=o.getBroadcastDims(t,u),I=o.getBroadcastDims(r,u);if(b.length+I.length===0)for(let t=0;t<p.length;++t)p[t]=e(i[t%i.length],a[t%a.length]);else for(let t=0;t<p.length;++t){const o=n.indexToLoc(t,l,d),r=o.slice(-h);b.forEach((e=>r[e]=0));const s=n.locToIndex(r,h,m),u=o.slice(-f);I.forEach((e=>u[e]=0));const c=n.locToIndex(u,f,g);p[t]=e(i[s],a[c])}return[p,u]}}const sn=an(((e,t)=>e+t));function un(e){return(t,o,r)=>{const i=n.getTypedArrayFromDType(o,t.length);for(let n=0;n<t.length;++n)i[n]=e(t[n],r);return i}}const ln=un((e=>Math.ceil(e)));const dn=an(((e,t)=>e===t?1:0)),cn=un((e=>Math.exp(e))),pn=un((e=>Math.expm1(e))),hn=un((e=>Math.floor(e)));const fn=an(((e,t)=>e>t?1:0)),mn=an(((e,t)=>e>=t?1:0)),gn=an(((e,t)=>e<t?1:0)),bn=an(((e,t)=>e<=t?1:0));const In=un((e=>Math.log(e)));const wn=an(((e,t)=>Math.max(e,t))),xn=an(((e,t)=>Math.min(e,t))),kn=an(((e,t)=>e*t));const vn=an(((e,t)=>e!==t?1:0));const Sn=un((e=>1/Math.sqrt(e)));const yn=un((e=>1/(1+Math.exp(-e))));const Cn=un((e=>Math.sqrt(e))),zn=an(((e,t)=>{const n=e-t;return n*n}));class _n{constructor(e,t,o,r,i,a){this.separator=n.encodeString(e),this.nGramWidths=t,this.leftPad=n.encodeString(o),this.rightPad=n.encodeString(r),this.padWidth=i,this.preserveShort=a}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,o,r,i){for(let a=0;a<r;++a){const s=this.getPadWidth(i),u=Math.max(0,s-a),l=Math.max(0,s-(r-(a+1))),d=i-(u+l),c=t+(u>0?0:a-s);let p=0;p+=u*this.leftPad.length;for(let t=0;t<d;++t)p+=e[c+t].length;p+=l*this.rightPad.length;p+=(u+l+d-1)*this.separator.length,n[o+a]=new Uint8Array(p);const h=n[o+a];let f=0;const m=e=>e.forEach((e=>h[f++]=e));for(let e=0;e<u;++e)m(this.leftPad),m(this.separator);for(let t=0;t<d-1;++t)m(e[c+t]),m(this.separator);if(d>0){m(e[c+d-1]);for(let e=0;e<l;++e)m(this.separator),m(this.rightPad)}else{for(let e=0;e<l-1;++e)m(this.rightPad),m(this.separator);m(this.rightPad)}}}compute(e,t){const o=e.length,r=t.length;if(r>0){let e=t[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let n=1;n<r;++n){let r=t[n]>=e;if(r=r&&t[n]<=o,!r)throw new Error(`Invalid split value ${t[n]}, must be in [${e}, ${o}]`);e=t[n]}if(e!==o)throw new Error(`Last split value must be data size. Expected ${o}, got ${e}`)}const i=r-1,a=n.getArrayFromDType("int32",r);if(0===o||0===r){const e=new Array(o);for(let e=0;e<=i;++e)a[e]=0;return[e,a]}a[0]=0;for(let e=1;e<=i;++e){const n=t[e]-t[e-1];let o=0;this.nGramWidths.forEach((e=>{o+=this.getNumNGrams(n,e)})),this.preserveShort&&n>0&&0===o&&(o=1),a[e]=a[e-1]+o}const s=new Array(a[i]);for(let n=0;n<i;++n){const o=t[n];let r=a[n];if(this.nGramWidths.forEach((i=>{const a=t[n+1]-t[n],u=this.getNumNGrams(a,i);this.createNGrams(e,o,s,r,u,i),r+=u})),this.preserveShort&&r===a[n]){const i=t[n+1]-t[n];if(0===i)continue;const a=i+2*this.padWidth,u=1;this.createNGrams(e,o,s,r,u,a)}}return[s,a]}}function $n(e,t,n,o){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)o.push(e.subarray(t,t+1));return}if(1===t.length){const r=t[0];let i=e.indexOf(r);for(;-1!==i;){const t=e.subarray(0,i);n&&0===t.length||o.push(t),i=(e=e.subarray(i+1)).indexOf(r)}return void(n&&0===e.length||o.push(e))}let r=0;for(let i=0;i<e.length+1;i++)if(i===e.length||-1!==t.indexOf(e[i])){const t=e.subarray(r,i);n&&0===t.length||o.push(t),r=i+1}}const Gn=an(((e,t)=>e-t));const An=(e,t)=>{const n=t.value-e.value;return 0===n?e.index-t.index:n};function Rn(e,t,o=0,r=e.length-1){for(;r>o;){if(r-o>600){const n=r-o+1,i=t-o+1,a=Math.log(n),s=.5*Math.exp(2*a/3),u=.5*Math.sqrt(a*s*(n-s)/n)*Math.sign(i-n/2);Rn(e,t,Math.max(o,Math.floor(t-i*s/n+u)),Math.min(r,Math.floor(t+(n-i)*s/n+u)))}const i=e[t];let a=o,s=r;for(n.swap(e,o,t),An(e[r],i)>0&&n.swap(e,o,r);a<s;){for(n.swap(e,a,s),a++,s--;An(e[a],i)<0;)a+=1;for(;An(e[s],i)>0;)s-=1}0===An(e[o],i)?n.swap(e,o,s):(s+=1,n.swap(e,s,r)),s<=t&&(o=s+1),t<=s&&(r=s-1)}}var Bn={__proto__:null,simpleAbsImpl:function(e){const t=new Float32Array(e.length);for(let n=0;n<e.length;++n)t[n]=Math.abs(e[n]);return t},addImpl:sn,bincountImpl:function(e,t,o,r,i){const a=n.sizeFromShape(r),s=n.makeZerosTypedArray(i,o);for(let n=0;n<e.length;n++){const o=e[n];if(o<0)throw new Error("Input x must be non-negative!");o>=i||(s[o]+=a>0?t[n]:1)}return s},bincountReduceImpl:function(e,t,n,o=!1){const r=e.shape[0],i=e.shape[1],a=d([r,n],t.dtype);for(let s=0;s<r;s++)for(let r=0;r<i;r++){const i=e.get(s,r);if(i<0)throw new Error("Input x must be non-negative!");i>=n||(o?a.set(1,s,i):t.size>0?a.set(a.get(s,i)+t.get(s,r),s,i):a.set(a.get(s,i)+1,s,i))}return a},ceilImpl:ln,concatImpl:function(e,t,r,i){const a=n.getArrayFromDType(r,n.sizeFromShape(t));if(i&&"string"!==r){let t=0;e.forEach((e=>{const o=n.sizeFromShape(e.shape);a.set(e.vals,t),t+=o}))}else{let n=0;e.forEach((e=>{const i="string"===r?o.fromUint8ToStringArray(e.vals):e.vals;let s=0;for(let o=0;o<e.shape[0];++o){const r=o*t[1]+n;for(let t=0;t<e.shape[1];++t)a[r+t]=i[s++]}n+=e.shape[1]}))}return a},equalImpl:dn,expImpl:cn,expm1Impl:pn,floorImpl:hn,gatherNdImpl:function(e,t,n,o,r,i,a,s,u){const l=d([o,i],n);for(let n=0;n<o;n++){const o=[];let d=0;for(let t=0;t<r;t++){const i=e[n*r+t];d+=i*a[t],o.push(i)}if(d<0||d>=u/i)throw new Error(`Invalid indices: ${o} does not index into ${s}`);for(let e=0;e<i;e++)l.values[n*i+e]=t.get(...t.indexToLoc(d*i+e))}return l},gatherV2Impl:function(e,t,n){const o=d(n,e.dtype);for(let n=0;n<o.size;++n){const r=o.indexToLoc(n).slice(),i=r[0],a=r[2],s=t.locToIndex([i,a]);r[2]=t.values[s];const u=e.locToIndex(r);0<=u&&u<e.values.length&&(o.values[n]=e.values[u])}return o},greaterImpl:fn,greaterEqualImpl:mn,lessImpl:gn,lessEqualImpl:bn,linSpaceImpl:function(e,t,o){const r=(t-e)/(o-1),i=n.makeZerosTypedArray(o,"float32");i[0]=e;for(let e=1;e<i.length;e++)i[e]=i[e-1]+r;return i},logImpl:In,maxImpl:function(e,t,o,r){const i=n.getTypedArrayFromDType(r,n.sizeFromShape(o));for(let n=0;n<i.length;++n){const o=n*t;let r=e[o];for(let n=0;n<t;++n){const t=e[o+n];(Number.isNaN(t)||t>r)&&(r=t)}i[n]=r}return i},maximumImpl:wn,minimumImpl:xn,multiplyImpl:kn,negImpl:function(e,t,o){const r=n.createScalarValue(-1,o);return kn([],t,r,e,o)},notEqualImpl:vn,prodImpl:function(e,t,r,i){const[a,s]=o.computeOutAndReduceShapes(e,i),u=l(t,"int32"),d=n.makeZerosTypedArray(n.sizeFromShape(a),u),c=n.sizeFromShape(s);for(let e=0;e<d.length;++e){const t=e*c;let n=1;for(let e=0;e<c;++e)n*=r[t+e];d[e]=n}return{outVals:d,outShape:a,outDtype:u}},rangeImpl:function(e,t,o,r){if(e===t||e<t&&o<0||t<e&&o>1)return n.makeZerosTypedArray(0,r);const i=Math.abs(Math.ceil((t-e)/o)),a=n.makeZerosTypedArray(i,r);t<e&&1===o&&(o=-1),a[0]=e;for(let e=1;e<a.length;e++)a[e]=a[e-1]+o;return a},rsqrtImpl:Sn,scatterImpl:function(e,t,n,o,r,i,a,s,u,l){const c=[o/r,r],p=e.values,h=t.values;if(0===o)return d(n,t.dtype);const f=d(c,t.dtype);"string"==typeof u||"number"==typeof u?f.values.fill(u):"boolean"==typeof u&&f.values.fill(+u);for(let e=0;e<i;e++){const i=[];let u=0;for(let t=0;t<a;t++){const n=p[e*a+t];i.push(n),u+=n*s[t]}if(u<0||u>=o/r)throw new Error(`Invalid indices: ${i} does not index into ${n}`);for(let n=0;n<r;n++)l?f.values[u*r+n]+=h[e*r+n]:f.values[u*r+n]=0===t.rank?h[0]:h[e*r+n]}return f},sigmoidImpl:yn,sliceImpl:function(e,t,r,i,a){const s=c.isSliceContinous(i,t,r),u=n.sizeFromShape(r),l=n.computeStrides(i);if(s){const n=c.computeFlatOffset(t,l);return"string"===a?e.slice(n,n+u):e.subarray(n,n+u)}const p="string"===a?o.fromUint8ToStringArray(e):e,h=d(i,a,p),f=d(r,a);for(let e=0;e<f.size;++e){const n=f.indexToLoc(e),o=n.map(((e,n)=>e+t[n]));f.set(h.get(...o),...n)}return"string"===a?o.fromStringArrayToUint8(f.values):f.values},sparseFillEmptyRowsImpl:function(e,t,r,i,a,s,u){const l=t[0],d=s[0],c=new Array(d),p=new Array(l),h=t[1];if(0===d){if(0!==l)throw new Error(o.getSparseFillEmptyRowsIndicesDenseShapeMismatch(l));return[n.getArrayFromDType(r,0),[0,h],n.getArrayFromDType(a,0),c,p]}let f=!0,m=0;const g=new Array(d).fill(0);for(let t=0;t<l;++t){const n=e[t*h];if(n<0)throw new Error(o.getSparseFillEmptyRowsNegativeIndexErrorMessage(t,n));if(n>=d)throw new Error(o.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(t,n,d));++g[n],f=f&&n>=m,m=n}let b=!0;for(let e=0;e<d;++e){const t=0===g[e];c[e]=t,b=b&&!t,g[e]=Math.max(g[e],1),e>0&&(g[e]+=g[e-1])}if(b&&f){const t=e,n=i;for(let e=0;e<l;++e)p[e]=e;return[t,[l,h],n,c,p]}{const t=g[d-1],o=n.getArrayFromDType(r,t*h),s=n.getArrayFromDType(a,t),f=new Array(d).fill(0);for(let t=0;t<l;++t){const n=e[t*h],r=f[n],a=(0===n?0:g[n-1])+r;f[n]++;for(let n=0;n<h;++n)o[a*h+n]=e[t*h+n];s[a]=i[t],p[t]=a}for(let e=0;e<d;++e){if(0===f[e]){const t=0===e?0:g[e-1];o[t*h+0]=e;for(let e=1;e<h;++e)o[t*h+e]=0;s[t]=u}}return[o,[t,h],s,c,p]}},sparseReshapeImpl:function(e,t,r,i,a){const s=n.sizeFromShape(i),u=t[0],l=a.length,d=[];let c=1,p=-1;for(let e=0;e<l;++e){const t=a[e];if(-1===t){if(-1!==p)throw new Error(o.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(p,e));p=e,d.push(1)}else{if(t<0)throw new Error(o.getSparseReshapeNegativeOutputDimErrorMessage(e,t));c*=t,d.push(t)}}if(-1!==p){if(c<=0)throw new Error(o.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage());const e=Math.trunc(s/c);if(c*e!==s)throw new Error(o.getSparseReshapeInputOutputMultipleErrorMessage(i,d));d[p]=e}if(n.sizeFromShape(d)!==s)throw new Error(o.getSparseReshapeInputOutputMismatchErrorMessage(i,d));const h=i.length,f=[];if(h>0){f[h-1]=1;for(let e=h-2;e>=0;--e)f[e]=f[e+1]*i[e+1]}const m=[];if(l>0){m[l-1]=1;for(let e=l-2;e>=0;--e)m[e]=m[e+1]*d[e+1]}const g=n.getArrayFromDType(r,u*l);for(let t=0;t<u;++t){let n=0;for(let o=0;o<h;++o)n+=e[t*h+o]*f[o];for(let e=0;e<l;++e)g[t*l+e]=Math.trunc(n/m[e]),n%=m[e]}return[g,[u,l],d]},sparseSegmentReductionImpl:function(e,t,r,i,a,s=!1,u=0){const l=i.length,d=[t[0],e.length/t[0]],c=d[1],p=l>0?a[l-1]+1:0;if(p<0)throw new Error(o.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const h=t.slice();h[0]=p;const f=h.reduce(((e,t)=>e*t),1),m=n.getArrayFromDType(r,f);if(0===l)return p>0&&m.fill(u),[m,h];if(p<=0)throw new Error(o.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());let g=0,b=1,I=0,w=a[g];for(;;){let t=0;if(b<l){if(t=a[b],w===t){++b;continue}if(w>=t)throw new Error(o.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage())}if(w<0||w>=p)throw new Error(o.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(w,p));w>I&&m.fill(u,I*c,w*c);for(let t=g;t<b;++t){const n=i[t];if(n<0||n>=d[0])throw new Error(o.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(t,i[t],d[0]));for(let t=0;t<c;t++)m[w*c+t]+=e[n*c+t]}if(s)for(let e=0;e<c;e++)m[w*c+e]/=b-g;if(g=b,++b,I=w+1,w=t,b>l)break}return I<p&&m.fill(u,I*c,p*c),[m,h]},sqrtImpl:Cn,squaredDifferenceImpl:zn,stridedSliceImpl:function(e,t,n,o){const r=d(e,t.dtype);for(let e=0;e<r.size;e++){const i=r.indexToLoc(e),a=new Array(i.length);for(let e=0;e<a.length;e++)a[e]=i[e]*n[e]+o[e];r.set(t.get(...a),...i)}return r},stringNGramsImpl:function(e,t,n,o,r,i,a,s){return new _n(n,o,r,i,a,s).compute(e,t)},stringSplitImpl:function(e,t,o){const r=e.length,i=[];let a=0,s=0;const u=new Array(r);for(let n=0;n<r;++n){const r=i.length;$n(e[n],t,o,i);const l=i.length-r;u[n]=l,a+=l,s=Math.max(s,l)}const l=n.getArrayFromDType("int32",2*a),d=new Array(a),c=[r,s];let p=0;for(let e=0;e<r;++e)for(let t=0;t<u[e];++t)l[2*p]=e,l[2*p+1]=t,d[p]=i[p],++p;return[l,d,c]},stringToHashBucketFastImpl:function(e,t){const o=n.getArrayFromDType("int32",e.length);for(let r=0;r<e.length;++r)o[r]=n.fingerPrint64(e[r]).modulo(t).getLowBitsUnsigned();return o},subImpl:Gn,tileImpl:function(e,t){const n=new Array(e.rank);for(let o=0;o<n.length;o++)n[o]=e.shape[o]*t[o];const o=d(n,e.dtype);for(let t=0;t<o.values.length;++t){const n=o.indexToLoc(t),r=new Array(e.rank);for(let t=0;t<r.length;t++)r[t]=n[t]%e.shape[t];const i=e.locToIndex(r);o.values[t]=e.values[i]}return o},topKImpl:function(e,t,o,r,i){const a=t[t.length-1],[s,u]=[e.length/a,a],l=n.getTypedArrayFromDType(o,s*r),c=n.getTypedArrayFromDType("int32",s*r);for(let t=0;t<s;t++){const n=t*u,o=e.subarray(n,n+u);let a=new Array(o.length);o.forEach(((e,t)=>a[t]={value:e,index:t})),r<a.length&&(Rn(a,r),a=a.slice(0,r)),i&&a.sort(An);const s=t*r,d=l.subarray(s,s+r),p=c.subarray(s,s+r);for(let e=0;e<r;e++)d[e]=a[e].value,p[e]=a[e].index}const p=t.slice();return p[p.length-1]=r,[d(p,o,l),d(p,"int32",c)]},transposeImpl:function(e,t,o,r,i){const a=t.length,s=n.sizeFromShape(t),u=n.computeStrides(t),l=n.computeStrides(i),d=n.getTypedArrayFromDType(o,n.sizeFromShape(i));for(let t=0;t<s;++t){const o=n.indexToLoc(t,a,u),i=new Array(o.length);for(let e=0;e<i.length;e++)i[e]=o[r[e]];d[n.locToIndex(i,a,l)]=e[t]}return d},uniqueImpl:function(e,t,o,r){const i=n.parseAxisParam(t,o)[0],a=[1,o[0],1];for(let e=0;e<i;e++)a[0]*=o[e];a[1]=o[i];for(let e=i+1;e<o.length;e++)a[2]*=o[e];const s={},u=new Int32Array(o[i]),l=new p(a,r,e),d=[],c=1===a[0]&&1===a[2];for(let t=0;t<o[i];t++){let n;if(c)n=e[t].toString();else{const e=[];for(let n=0;n<a[0];n++)for(let o=0;o<a[2];o++)e.push(l.get(n,t,o));n=e.join(",")}if(void 0!==s[n])u[t]=s[n];else{const e=Object.keys(s).length;s[n]=e,u[t]=e,d.push(t)}}const h=a.slice();h[1]=Object.keys(s).length;const f=new p(h,r);d.forEach(((e,t)=>{for(let n=0;n<a[0];n++)for(let o=0;o<a[2];o++)f.set(l.get(n,e,o),n,t,o)}));const m=o.slice();return m[i]=h[1],{outputValues:f.values,outputShape:m,indices:u}}};const{addImpl:Tn,ceilImpl:Pn,concatImpl:Nn,equalImpl:En,expImpl:Ln,expm1Impl:Wn,floorImpl:On,gatherNdImpl:Fn,gatherV2Impl:Un,greaterEqualImpl:Dn,greaterImpl:Mn,lessEqualImpl:Vn,lessImpl:Xn,logImpl:Hn,maxImpl:qn,maximumImpl:Yn,minimumImpl:Kn,multiplyImpl:jn,negImpl:Qn,notEqualImpl:Zn,prodImpl:Jn,rangeImpl:eo,rsqrtImpl:to,simpleAbsImpl:no,sliceImpl:oo,stridedSliceImpl:ro,stringNGramsImpl:io,subImpl:ao,tileImpl:so,topKImpl:uo,transposeImpl:lo,uniqueImpl:co}=Bn,po={kernelName:h,backendName:"webgpu",kernelFunc:on({opType:mt.ABS,cpuKernelImpl:no})},ho={kernelName:f,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.ADD,cpuKernelImpl:Tn,supportsComplex:!0})};class fo{constructor(e){this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e[0],this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.shaderKey="addN"}getUserCode(){const e=[];this.variableNames.forEach((t=>{e.push(`let v${t} = get${t}ByOutputCoords(coords);`)}));const t=this.variableNames.map((e=>`v${e}`)).join(" + ");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            ${e.join("\n        ")}\n            setOutputAtIndex(flatIndex, ${t});\n          }\n        }\n      }\n    `}}const mo={kernelName:m,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,o=t;if(1===o.length)return Zt({inputs:{x:o[0]},backend:n});const r=o.map((e=>e.dtype)).reduce(((e,t)=>l(e,t))),i=o.map((e=>e.shape)),a=new fo(i);return n.runWebGPUProgram(a,o,r)}};class go{constructor(e,t,n){this.workGroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="infinityValue : f32,",this.size=!0;const r=[t];o.assertAxesAreInnerMostDims("arg"+n.charAt(0).toUpperCase()+n.slice(1),r,e.length),this.op="min"===n?"<":">";const[i]=o.computeOutAndReduceShapes(e,r);this.outputShape=0===i.length?[1]:i,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,[1,1,1]),this.inputShape=e,this.shaderKey=`argMinMax${this.op}`}getUserCode(){return`\n      fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n      }\n\n      ${`\n      var<workgroup> xBestIndices : array<i32, ${this.workGroupSize[0]}>;\n      var<workgroup> xBestValues : array<f32, ${this.workGroupSize[0]}>;\n    `}\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        let outputIndex = index / i32(workGroupSizeX);\n        let reduceLength = ${(()=>1===this.inputShape.length?"uniforms.xShape":`uniforms.xShape.${xt(this.inputShape.length-1)}`)()};\n\n        var bestIndex = i32(localId.x);\n        var bestValue = uniforms.infinityValue;\n        let outputCoords = getCoordsFromIndex(outputIndex);\n        for (var k = i32(localId.x); k < reduceLength && outputIndex < uniforms.size;\n            k = k + i32(workGroupSizeX)) {\n          let candidate = getX(${(()=>{let e="";if(1===this.outputShape.length)1!==this.inputShape.length&&(e+="outputCoords,");else for(let t=0;t<this.outputShape.length;t++)e+=`outputCoords.${xt(t)},`;return e})()} k);\n          if (!isnan(candidate) && candidate ${this.op} bestValue) {\n            bestValue = candidate;\n            bestIndex = k;\n          }\n        }\n        xBestValues[localId.x] = bestValue;\n        xBestIndices[localId.x] = bestIndex;\n        workgroupBarrier();\n\n        var reduceSize = min(u32(reduceLength), workGroupSizeX);\n        for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n            currentSize = reduceSize / 2u) {\n          let interval = DIV_CEIL(reduceSize, 2u);\n          if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              xBestValues[localId.x] = bestValue;\n              xBestIndices[localId.x] = xBestIndices[localId.x + interval];\n            }\n          }\n          reduceSize = interval;\n          workgroupBarrier();\n        }\n\n        if (localId.x == 0u && outputIndex < uniforms.size) {\n          setOutputAtIndexI32(outputIndex, xBestIndices[localId.x]);\n        }\n      }\n    `}}class bo{constructor(e,t){this.variableNames=["A"],this.workGroupSize=[16,16,1];const n=new Array(e.length);for(let o=0;o<n.length;o++)n[o]=e[t[o]];this.outputShape=n,this.dispatchLayout={x:[0],y:[1]},this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[1,1,1]),this.shaderKey="transposeShared"}getUserCode(){return`\n      let TILE_DIM = ${this.workGroupSize[0]};\n      var<workgroup> tile : array<array<f32, ${this.workGroupSize[0]+1}>, ${this.workGroupSize[0]}>;\n      \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(local_invocation_id) localId : vec3<u32>,\n              @builtin(workgroup_id) workgroupId : vec3<u32>) {\n        var x = i32(workgroupId.x) * TILE_DIM + i32(localId.x);\n        var y = i32(workgroupId.y) * TILE_DIM + i32(localId.y);\n        let width = uniforms.outShape[0];\n        let height = uniforms.outShape[1];\n        if (x < width && y < height) {\n          tile[localId.y][localId.x] = A[y * width + x];\n        }\n        workgroupBarrier();\n\n        x = i32(workgroupId.y) * TILE_DIM + i32(localId.x);\n        y = i32(workgroupId.x) * TILE_DIM + i32(localId.y);\n        if (x < height && y < width) {\n          setOutputAtIndex((y * height + x), tile[localId.x]\n            [localId.y]);\n        }\n      }\n    `}}class Io{constructor(e,t){this.variableNames=["A"],this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let o=0;o<n.length;o++)n[o]=e[t[o]];this.outputShape=n,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.newDim=t,this.shaderKey=`transpose_${t}`}getUserCode(){const e=wt(this.outputShape.length),t=function(e){const t=e.length;if(t>6)throw Error(`Transpose for rank ${t} is not yet supported`);const n=new Array(t);for(let t=0;t<e.length;t++)n[e[t]]=`resRC.${xt(t)}`;return n.join()}(this.newDim);return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let resRC = getCoordsFromIndex(flatIndex);\n            setOutputAtIndex(flatIndex, A[getIndexFromCoords${this.outputShape.length}D(\n              ${e}(${t}), uniforms.aShape)]);\n          }\n        }\n      }\n    `}}function wo(e){const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{perm:a}=r,s=o,u=i.shape.length,l=new Array(u);for(let e=0;e<l.length;e++)l[e]=i.shape[a[e]];if(o.shouldExecuteOnCPU([i])){const e=s.tensorMap.get(i.dataId).values,t=lo(e,i.shape,i.dtype,a,l);return o.makeTensorInfo(l,i.dtype,t)}if(2===i.shape.length&&n.arraysEqual(a,[1,0])){const e=new bo(i.shape,a);return s.runWebGPUProgram(e,[i],i.dtype)}const d=new Io(i.shape,a);return s.runWebGPUProgram(d,[i],i.dtype)}const xo={kernelName:g,backendName:"webgpu",kernelFunc:wo};const ko={kernelName:b,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{axis:s}=i;let u=n.parseAxisParam(s,a.shape);const l=o.getAxesPermutation(u,a.shape.length);let d=a;const c=[];null!=l&&(d=wo({inputs:{x:a},backend:r,attrs:{perm:l}}),c.push(d),u=o.getInnerMostAxes(u.length,d.shape.length)),o.assertAxesAreInnerMostDims("argMax",[u[0]],d.shape.length);const p=new go(d.shape,u[0],"max"),h=[{type:"float32",data:[Number.NEGATIVE_INFINITY]}],f=r.runWebGPUProgram(p,[d],"int32",h);return c.forEach((e=>r.disposeData(e.dataId))),f}};const vo={kernelName:I,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{axis:s}=i;let u=n.parseAxisParam(s,a.shape);const l=o.getAxesPermutation(u,a.shape.length);let d=a;const c=[];null!=l&&(d=wo({inputs:{x:a},backend:r,attrs:{perm:l}}),c.push(d),u=o.getInnerMostAxes(u.length,d.shape.length)),o.assertAxesAreInnerMostDims("argMin",[u[0]],d.shape.length);const p=new go(d.shape,u[0],"min"),h=[{type:"float32",data:[Number.POSITIVE_INFINITY]}],f=r.runWebGPUProgram(p,[d],"int32",h);return c.forEach((e=>r.disposeData(e.dataId))),f}};class So{constructor(e,t){this.variableNames=["x"],this.uniforms="stride : vec2<i32>, pad : vec2<i32>, dilation : vec2<i32>, convDims : vec2<i32>, filterDims : vec2<i32>,",this.workGroupSize=[128,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`pool2D_${t}`,this.poolType=t}getUserCode(){let e="resultValue = max(value, resultValue);";"avg"===this.poolType&&(e="resultValue = resultValue + value; count = count + 1.0;");let t="resultValue";"avg"===this.poolType&&(t="resultValue / count");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let xRCCorner = vec2<i32>(coords.yz) * uniforms.stride - uniforms.pad;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};\n          var count = 0.0;\n\n          for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + uniforms.dilation.x) {\n            let xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + uniforms.dilation.y) {\n              let xC = xCCorner + wC;\n              if (xC < 0 || xC >= uniforms.convDims.y) {\n                continue;\n              }\n\n              let value = getX(batch, xR, xC, coords[3]);\n              ${e}\n            }\n          }\n\n          setOutputAtIndex(index, ${t});\n        }\n      }\n    `}}class yo{constructor(e){this.variableNames=["x"],this.uniforms="stride : vec2<i32>,",this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="poolWithFilterSizeEqualsOne"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n\n          let xRCCorner = coords.yz * uniforms.stride;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          let value = getX(batch, xRCorner, xCCorner, d);\n          setOutputAtIndex(index, value);\n        }\n      }\n    "}}const Co={kernelName:w,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{filterSize:s,strides:u,pad:l,dimRoundingMode:d}=i,c=o.computePool2DInfo(a.shape,s,u,1,l,d);if(1===c.filterWidth&&1===c.filterHeight&&n.arraysEqual(c.inShape,c.outShape))return Zt({inputs:{x:a},backend:r});let p;const h=[{type:"int32",data:[c.strideHeight,c.strideWidth]}];return 1===c.filterHeight&&1===c.filterWidth?p=new yo(c):(p=new So(c,"avg"),h.push({type:"int32",data:[c.padInfo.top,c.padInfo.left]},{type:"int32",data:[c.dilationHeight,c.dilationWidth]},{type:"int32",data:[c.inHeight,c.inWidth]},{type:"int32",data:[c.effectiveFilterHeight,c.effectiveFilterWidth]})),r.runWebGPUProgram(p,[a],a.dtype,h)}};const zo={kernelName:x,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{a:r,b:i}=t,{transposeA:a,transposeB:s}=o;return Xt({a:r,b:i,transposeA:a,transposeB:s,backend:n})}};class _o{constructor(e,t){this.variableNames=["source"],this.workPerThread=1,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.rank=t.length,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.start=e,this.uniforms=`start : ${wt(e.length)}, `,this.shaderKey="slice"}getUserCode(){const e=wt(this.rank),t=function(e){if(1===e)return"sourceLoc";if(e<=6)return $o.slice(0,e).map((e=>`sourceLoc.${e}`)).join(",");throw Error(`Slicing for rank ${e} is not yet supported`)}(this.rank);let n;n=1===this.start.length?this.outputShape.map(((e,t)=>"sourceLoc = uniforms.start + coords;")):this.outputShape.map(((e,t)=>`sourceLoc.${$o[t]} = uniforms.start[${t}] + coords.${$o[t]};`));return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          var sourceLoc : ${e};\n          let coords = getCoordsFromIndex(index);\n          ${n.join("\n")}\n          setOutputAtIndex(index, getSource(${t}));\n        }\n      }\n    `}}const $o=["x","y","z","w","u","v"];function Go(e){const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{begin:a,size:s}=r,[u,l]=c.parseSliceParams(i,a,s);if(c.assertParamsValid(i,u,l),o.shouldExecuteOnCPU([i])||"string"===i.dtype){const e=o.tensorMap.get(i.dataId),t=oo(e.values,u,l,i.shape,i.dtype);return o.makeTensorInfo(l,i.dtype,t)}if(0===n.sizeFromShape(l))return o.makeTensorInfo(l,i.dtype,[]);const d=new _o(u,l),p=[{type:"int32",data:u}];return o.runWebGPUProgram(d,[i],i.dtype,p)}const Ao={kernelName:k,backendName:"webgpu",kernelFunc:Go},Ro={kernelName:v,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{blockShape:s,crops:u}=i;n.assert(a.shape.length<=4,(()=>"batchToSpaceND for rank > 4 with a WebGPU backend not implemented yet"));const l=s.reduce(((e,t)=>e*t)),d=o.getReshaped(a.shape,s,l),c=o.getPermuted(d.length,s.length),p=o.getReshapedPermuted(a.shape,s,l),h=o.getSliceBeginCoords(u,s.length),f=o.getSliceSize(p,u,s.length),m=[],g=Mt({inputs:{x:a},backend:r,attrs:{shape:d}}),b=wo({inputs:{x:g},backend:r,attrs:{perm:c}}),I=Mt({inputs:{x:b},backend:r,attrs:{shape:p}}),w=Go({inputs:{x:I},backend:r,attrs:{begin:h,size:f}});return m.push(g),m.push(b),m.push(I),m.forEach((e=>r.disposeData(e.dataId))),w}},Bo=rn({opSnippet:dt.NOT_EQUAL,dtype:"bool",cpuKernelImpl:Zn}),To={kernelName:S,backendName:"webgpu",kernelFunc:Bo};function Po(e){const{inputs:t,backend:n}=e,{input:o}=t;return Zt({inputs:{x:n.tensorMap.get(o.dataId).complexTensorInfos.real},backend:n})}const No={kernelName:y,backendName:"webgpu",kernelFunc:Po};const Eo={kernelName:C,backendName:"webgpu",kernelFunc:function t(o){const{inputs:r,backend:i,attrs:a}=o,{x:s}=r,{dtype:u}=a;if("complex64"===u){if("complex64"===s.dtype)return Zt({inputs:{x:s},backend:i});const n=e.zeros(s.shape),o=t({inputs:{x:s},backend:i,attrs:{dtype:"float32"}}),r=en({inputs:{real:o,imag:n},backend:i});return n.dispose(),i.disposeData(o.dataId),r}if("complex64"===s.dtype){const e=Po({inputs:{input:s},backend:i}),n=t({inputs:{x:e},backend:i,attrs:{dtype:u}});return i.disposeData(e.dataId),n}if(!n.hasEncodingLoss(s.dtype,u)){const e=Zt({inputs:{x:s},backend:i});return{dataId:e.dataId,shape:e.shape,dtype:u}}if("int32"===u)return function(e,t){const n=new nn(e.shape,mt.TO_INT),o=t.runWebGPUProgram(n,[e],"int32");return{dataId:o.dataId,shape:o.shape,dtype:o.dtype}}(s,i);if("bool"===u){const e=i.makeTensorInfo([],"bool",n.getTypedArrayFromDType("bool",1)),t=Bo({inputs:{a:s,b:e},backend:i});return i.disposeData(e.dataId),t}throw new Error(`Error in Cast: failed to cast ${s.dtype} to ${u}`)}},Lo={kernelName:z,backendName:"webgpu",kernelFunc:on({opType:mt.CEIL,cpuKernelImpl:Pn})};class Wo{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workPerThread=4,this.workGroupSize=[64,1,1],this.isVec4=!0,this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.shaderKey="clipVec4"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          var clampedValue : vec4<f32>;\n          for (var i = 0; i < 4; i = i + 1) {\n            if (isnan(value[i])) {\n              clampedValue[i] = value[i];\n            } else {\n              clampedValue[i] = clamp(value[i], uniforms.minVal, uniforms.maxVal);\n            }\n          }\n\n          setOutputAtIndex(index, clampedValue);\n        }\n      }\n    "}}class Oo{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="clip"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          if (isnan(value)) {\n            setOutputAtIndex(index, value);\n            return;\n          }\n          setOutputAtIndex(index, clamp(value, uniforms.minVal, uniforms.maxVal));\n        }\n      }\n    "}}const Fo={kernelName:_,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{clipValueMin:a,clipValueMax:s}=r;let u;const l=[{type:"float32",data:[a]},{type:"float32",data:[s]}];return u=n.sizeFromShape(i.shape)%4==0?new Wo(i.shape):new Oo(i.shape),o.runWebGPUProgram(u,[i],i.dtype,l)}};class Uo{constructor(e){this.uniforms="",this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=o.computeOutShape(e,1),this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.offsetLength=e.length-1;for(let e=0;e<this.offsetLength;e++)this.uniforms+=`offset${e} : i32,`;this.shaderKey="concat"}getUserCode(){const e=[];if(this.offsetLength>0){e.push("if (yC < uniforms.offset0){ setOutputAtCoords(coords.x, coords.y, getT0(yR, yC)); }");for(let t=1;t<this.offsetLength;t++)e.push(`else if (yC < uniforms.offset${[t]}){ setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${t-1})); }`);const t=this.offsetLength,n=this.offsetLength-1;e.push(`else { setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${n})); }`)}else e.push("setOutputAtCoords(coords.x, coords.y, getT0(yR, yC));");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            let yR = coords.x;\n            let yC = coords.y;\n\n            ${e.join("\n        ")}\n          }\n        }\n      }\n    `}}function Do(e){const{inputs:t,backend:n}=e,{input:o}=t;return Zt({inputs:{x:n.tensorMap.get(o.dataId).complexTensorInfos.imag},backend:n})}const Mo={kernelName:$,backendName:"webgpu",kernelFunc:Do};function Vo(e,t,r){const i=e[0].dtype;if("complex64"===i){const n=e.map((e=>Po({inputs:{input:e},backend:r}))),o=e.map((e=>Do({inputs:{input:e},backend:r}))),i=Vo(n,t,r),a=Vo(o,t,r),s=en({inputs:{real:i,imag:a},backend:r});return n.forEach((e=>r.disposeData(e.dataId))),o.forEach((e=>r.disposeData(e.dataId))),r.disposeData(i.dataId),r.disposeData(a.dataId),s}let a=r.shouldExecuteOnCPU(e);if("string"===i&&(a=!0),a){const a=e.map((e=>{const o=n.sizeFromShape(e.shape.slice(t));return Mt({inputs:{x:e},backend:r,attrs:{shape:[-1,o]}})})),s=a.map((e=>({vals:r.readSync(e.dataId),shape:e.shape}))),u=o.computeOutShape(a.map((e=>e.shape)),1),l=1===a[0].shape[0],d=Nn(s,u,i,l),c=o.computeOutShape(e.map((e=>e.shape)),t),p=r.makeTensorInfo(c,i,d);return a.forEach((e=>r.disposeData(e.dataId))),p}const{tensors2D:s,outShape:u}=function(e,t,r){const i=o.computeOutShape(e.map((e=>e.shape)),t);return{tensors2D:e.map((e=>Mt({inputs:{x:e},backend:r,attrs:{shape:[n.sizeFromShape(e.shape.slice(0,t)),n.sizeFromShape(e.shape.slice(t))]}}))),outShape:i}}(e,t,r),l=s.map((e=>e.shape)),d=new Uo(l),c=[],p=new Array(l.length-1);if(p.length>0){p[0]=l[0][1],c.push({type:"int32",data:[p[0]]});for(let e=1;e<p.length;e++)p[e]=p[e-1]+l[e][1],c.push({type:"int32",data:[p[e]]})}const h=r.runWebGPUProgram(d,s,s[0].dtype,c);s.forEach((e=>r.disposeData(e.dataId)));const f=Mt({inputs:{x:h},backend:r,attrs:{shape:u}});return r.disposeData(h.dataId),f}function Xo(e){const{inputs:t,backend:r,attrs:i}=e,{axis:a}=i,s=n.parseAxisParam(a,t[0].shape)[0],u=o.computeOutShape(t.map((e=>e.shape)),s);if(0===n.sizeFromShape(u))return r.makeTensorInfo(u,t[0].dtype,[]);const l=t.filter((e=>n.sizeFromShape(e.shape)>0));if(1===l.length)return Zt({inputs:{x:l[0]},backend:r});const d=l.map((e=>e.shape));return o.assertParamsConsistent(d,s),Vo(l,s,r)}const Ho={kernelName:G,backendName:"webgpu",kernelFunc:Xo};class qo{constructor(e,t=!1,o=null,r=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>,\n      dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,8,1],this.isVec4=!0,this.outputShape=e.outShape,n.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.dispatchLayout={x:[3],y:[1,2],z:[0]},1===this.outputShape[1]?this.elementsPerThread=[4,1,1]:this.elementsPerThread=[4,4,1],this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),this.convInfo=e,this.addBias=t,this.activation=o,this.hasPreluActivationWeights=r,this.addBias&&this.variableNames.push("bias"),this.hasPreluActivationWeights&&this.variableNames.push("preluActivationWeights"),this.tileAOuter=1===this.outputShape[1]?1:this.workGroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=this.tileBOuter,[this.fitA,this.fitB]=this.getShapeFit(),this.remainder=this.convInfo.inChannels%4==0,this.shaderKey=`conv2DMMVec4_${this.activation}_${this.fitA}_${this.fitB}_${this.elementsPerThread}_${this.remainder}`}getShapeFit(){const e=[this.tileAOuter,this.tileInner],t=[this.tileInner,this.tileBOuter],n=this.outputShape[1]*this.outputShape[2],o=this.outputShape[3],r=this.convInfo.filterHeight*this.convInfo.filterWidth*this.convInfo.inChannels;return[_t(e,[n,r]),_t(t,[r,o])]}getSampleAWithRemainder(e){return`let flatIndex${e} = getIndexFromCoords4D(coord, uniforms.xShape);\n    let divBy4Remainder${e} = flatIndex${e} % 4;\n    let divBy4Index${e} = flatIndex${e} / 4;\n    let curData${e} = x[divBy4Index${e}];\n    if (divBy4Remainder${e} == 0) {\n      temp = curData${e};\n    } else {\n      // TODO: This could end up being a redundant load with another one in\n      // the same shader invocation. Perhaps there's an opportunity for\n      // optimization\n      let nextData${e} = x[divBy4Index${e} + 1];\n      if (divBy4Remainder${e} == 1) {\n        temp = vec4<f32>(curData${e}.yzw, nextData${e}.x);\n      } else if (divBy4Remainder${e} == 2) {\n        temp = vec4<f32>(curData${e}.zw, nextData${e}.xy);\n      } else if (divBy4Remainder${e} == 3) {\n        temp = vec4<f32>(curData${e}.w, nextData${e}.xyz);\n      }\n    }\n    `}getUserCode(){const e=Lt(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner),t=`let outRow = r / uniforms.outShape[2];\n        let outCol = r % uniforms.outShape[2];\n        let WRow = c / (uniforms.filterDims[1] * uniforms.xShape[3]);\n        let WCol = c / uniforms.xShape[3] % uniforms.filterDims[1];\n        let inChCoord = c % uniforms.xShape[3];\n        var coord = vec4<i32>(\n            batch,\n            outRow * uniforms.stride[0] + uniforms.dilation[0] * WRow - uniforms.pad[0],\n            outCol * uniforms.stride[1] + uniforms.dilation[1] * WCol - uniforms.pad[1],\n            inChCoord);\n        var resData = vec4<f32>(0.0);\n        ${this.remainder?"// The bounds checking is always needed since we use it to pad zero for\n          // the 'same' padding type.\n          if (coordsInBounds4D(coord, uniforms.xShape)) {\n            resData = x[getIndexFromCoords4D(coord, uniforms.xShape) / 4];\n          } else {\n            resData = vec4<f32>(0.0); }":`var temp = vec4<f32>(0.0);\n          ${this.getSampleAWithRemainder(1)}\n          resData = temp;\n          if (WCol == (uniforms.filterDims[1] - 1)) {\n            coord = vec4<i32>(\n              coord.x, coord.y + 1, coord.z + 1 - uniforms.filterDims[1], 0);\n              ${this.getSampleAWithRemainder(2)}\n            if (inChCoord == 0) {\n              resData = vec4<f32>(resData.xyz, temp.x);\n            } else if (inChCoord == 1) {\n              resData = vec4<f32>(resData.xy, temp.xy);\n            } else {\n              resData = vec4<f32>(resData.x, temp.xyz);\n            }\n          }\n          `}\n        return resData;`,n=this.fitA?`${t}`:`if (r < uniforms.dimAOuter && c < uniforms.dimInner) {\n          ${t}\n         }\n         return vec4<f32>(0.0);\n        `,o=this.fitB?"return W[row * uniforms.dimBOuter / 4 + col];":"if(coordsInBounds2D(vec2<i32>(row, col * 4), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n           return W[row * uniforms.dimBOuter / 4 + col];\n         }\n         return vec4<f32>(0.0);\n        ";let r="",i="";if(this.activation){const e=bt(this.activation,this.isVec4);r=this.hasPreluActivationWeights?`fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n          let b = getPreluActivationWeightsByOutputCoords(outCoord);\n          ${e}\n        }`:`\n        fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n          ${e}\n        }`,i="value = activation(value, outCoord);"}return`\n        ${r}\n        fn mm_readA(row : i32, col : i32, globalId : vec3<u32>) -> vec4<f32> {\n          let r = row;\n          let c = col * 4;\n          var batch = i32(globalId.z);\n          ${n}\n        }\n\n        fn mm_readB(row : i32, col : i32, globalId : vec3<u32>) -> vec4<f32> {\n          ${o}\n        }\n\n        fn mm_write(row : i32, col : i32, valueInput : vec4<f32>, globalId : vec3<u32>) {\n          var batch = i32(globalId.z);\n          var value = valueInput;\n          if (row < uniforms.dimAOuter && col * 4 < uniforms.dimBOuter)\n          {\n            let outCoord = vec4<i32>(\n              batch,\n              row / uniforms.outShape[2],\n              row % uniforms.outShape[2],\n              col * 4);\n            ${this.addBias?"value = value + getBiasByOutputCoords(outCoord);":""}\n            ${i}\n            setOutputAtCoords(outCoord[0], outCoord[1], outCoord[2], outCoord[3],\n              value);\n          }\n        }\n        ${e}\n      `}}class Yo{constructor(e,t=!1,n=null,o=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.dispatchLayout=this.isChannelsLast?{x:[3],y:[1,2],z:[0]}:{x:[1],y:[2,3],z:[0]},this.workGroupSize=Gt(this.dispatchLayout,this.outputShape),this.elementsPerThread=Rt(this.dispatchLayout,this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),t&&this.variableNames.push("bias"),o&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivationWeights=o,[this.fitA,this.fitB]=this.getShapeFit(),this.shaderKey=`conv2DMM_${this.elementsPerThread}_${this.activation}_${this.fitA}_${this.fitB}_${this.isChannelsLast}`}getShapeFit(){const e=this.workGroupSize[1]*this.elementsPerThread[1],t=this.workGroupSize[0]*this.elementsPerThread[0],o=e>t?e:t;n.assert(o%this.workGroupSize[0]==0&&o%this.workGroupSize[1]==0,(()=>"tileInner must be multiple of workgroupsize.x and workgroupsize.y"));const r=[e,o],i=[o,t],a=this.convInfo.outHeight*this.convInfo.outWidth,s=this.convInfo.outChannels,u=this.convInfo.filterHeight*this.convInfo.filterWidth*this.convInfo.inChannels;return[_t(r,[a,u]),_t(i,[u,s])]}getUserCode(){const e=this.isChannelsLast?"\n    let coord = vec4<i32>(batch, xRow, xCol, col % inChannels);\n    ":"\n    let coord = vec4<i32>(batch, col % inChannels, xRow, xCol);\n    ",t=this.isChannelsLast?"\n    let outCoord = vec4<i32>(\n      batch,\n      row / outWidth,\n      row % outWidth,\n      col);\n    ":"\n    let outCoord = vec4<i32>(\n      batch,\n      col,\n      row / outWidth,\n      row % outWidth);\n    ",n=Ot(this.elementsPerThread,this.workGroupSize),o=`\n    let inChannels = uniforms.wShape[2];\n    let outWidth = ${this.isChannelsLast?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n    let outRow = row / outWidth;\n    let outCol = row % outWidth;\n\n    let WRow = col / (uniforms.filterDims[1] * inChannels);\n    let WCol = col / inChannels % uniforms.filterDims[1];\n    let xRow = outRow * uniforms.stride[0] + uniforms.dilation[0] * WRow - uniforms.pad[0];\n    let xCol = outCol * uniforms.stride[1] + uniforms.dilation[1] * WCol - uniforms.pad[1];\n    ${e}\n    // The bounds checking is always needed since we use it to pad zero for the\n    // 'same' padding type.\n    if(coordsInBounds4D(coord, uniforms.xShape)) {\n      return x[getIndexFromCoords4D(coord, uniforms.xShape)];\n    }\n    return 0.0;`,r=this.fitA?`${o}`:`if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n      ${o}\n    }\n    return 0.0;\n    `,i=this.fitB?"return W[row * uniforms.dimBOuter + col];":"if(coordsInBounds2D(vec2<i32>(row, col), vec2<i32>(uniforms.dimInner, uniforms.dimBOuter))) {\n           return W[row * uniforms.dimBOuter + col];\n\t }\n\t return 0.0;\n\t ";let a="",s="";if(this.activation){const e=bt(this.activation,!1);a=this.hasPreluActivationWeights?`fn activation(a: f32, outCoord : vec4<i32>) -> f32 {\n                  let b = getPreluActivationWeightsByOutputCoords(outCoord);\n                  ${e}\n                }`:`\n                  fn activation(a : f32, outCoord : vec4<i32>) -> f32 {\n                    ${e}\n                  }\n                `,s="value = activation(value, outCoord);"}const u=this.addBias?"value = value + getBiasByOutputCoords(outCoord);":"";return`\n    ${a}\n    fn mm_readA(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      var batch = i32(globalId.z);\n      ${r}\n    }\n\n    fn mm_readB(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      ${i}\n    }\n\n    fn mm_write(row : i32, col : i32, valueInput : f32, globalId : vec3<u32>) {\n      var batch = i32(globalId.z);\n      var value = valueInput;\n      let outWidth = ${this.isChannelsLast?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n      ${t}\n      ${u}\n      ${s}\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)] = value;\n    }\n    ${n}\n  `}}function Ko({x:e,filter:t,convInfo:n,backend:o,bias:r=null,preluActivationWeights:i=null,leakyreluAlpha:a=0,activation:s=null}){const u=null!=r,l=null!=i,d="channelsLast"===n.dataFormat;let c;if(d&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type||1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return function({x:e,filter:t,convInfo:n,backend:o,bias:r=null,preluActivationWeights:i=null,leakyreluAlpha:a=0,activation:s=null}){const u="channelsLast"===n.dataFormat,l=!u;let d,c;if(u&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type){const r=n.inHeight*n.inWidth*n.inChannels;d=Mt({inputs:{x:e},backend:o,attrs:{shape:[1,n.batchSize,r]}}),c=Mt({inputs:{x:t},backend:o,attrs:{shape:[1,r,n.outChannels]}})}else d=Mt({inputs:{x:e},backend:o,attrs:{shape:u?[n.batchSize,n.inHeight*n.inWidth,n.inChannels]:[n.batchSize,n.inChannels,n.inHeight*n.inWidth]}}),c=Mt({inputs:{x:t},backend:o,attrs:{shape:[1,n.inChannels,n.outChannels]}});const p=Xt({a:u?d:c,b:u?c:d,transposeA:l,transposeB:!1,backend:o,bias:r,activation:s,preluActivationWeights:i,leakyreluAlpha:a}),h=Mt({inputs:{x:p},backend:o,attrs:{shape:n.outShape}});return o.disposeData(d.dataId),o.disposeData(c.dataId),o.disposeData(p.dataId),h}({x:e,filter:t,convInfo:n,backend:o,bias:r,activation:s,preluActivationWeights:i,leakyreluAlpha:a});const p=(n.inChannels%4==0||3===n.inChannels&&"VALID"===n.padInfo.type)&&n.outChannels%4==0&&d,h=[n.padInfo.top,n.padInfo.left],f=[{type:"int32",data:[n.filterHeight,n.filterWidth]},{type:"int32",data:[...h]},{type:"int32",data:[n.strideHeight,n.strideWidth]},{type:"int32",data:[n.dilationHeight,n.dilationWidth]}];c=p?new qo(n,u,s,l):new Yo(n,u,s,l);const m=n.outHeight*n.outWidth,g=n.outChannels,b=n.filterHeight*n.filterWidth*n.inChannels;f.push({type:"int32",data:[m]},{type:"int32",data:[g]},{type:"int32",data:[b]});const I=[e,t];return u&&I.push(r),l&&I.push(i),"leakyrelu"===s&&(f.push({type:"float32",data:[a]}),c.uniforms+=" alpha : f32,"),o.runWebGPUProgram(c,I,e.dtype,f)}const jo={kernelName:A,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,attrs:n,backend:r}=e,{x:i,filter:a}=t,{strides:s,pad:u,dataFormat:l,dilations:d,dimRoundingMode:c}=n,p=o.convertConv2DDataFormat(l);return Ko({x:i,filter:a,convInfo:o.computeConv2DInfo(i.shape,a.shape,s,d,u,c,!1,p),backend:r})}};class Qo{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, stride : vec2<i32>, outBackprop : vec4<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.inShape,n.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.dispatchLayout={x:[3],y:[1,2],z:[0]},this.workGroupSize=Gt(this.dispatchLayout,this.outputShape),this.elementsPerThread=Rt(this.dispatchLayout,this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),this.shaderKey=`conv2DDerInputMM_${this.elementsPerThread}`}getUserCode(){return`\n    fn mm_readA(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      var batch = i32(globalId.z);\n      if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n      \n    let outRow = row / uniforms.outShape[2];\n    let outCol = row % uniforms.outShape[2];\n\n    let WRow = col / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n    let WCol = col / uniforms.outBackprop[3] % uniforms.filterDims[1];\n    let xR = f32(outRow - uniforms.pads[0] + WRow) / f32(uniforms.stride[0]);\n    let xC = f32(outCol - uniforms.pads[1] + WCol) / f32(uniforms.stride[1]);\n    if (xR < 0.0 || xR >= f32(uniforms.outBackprop[1]) || fract(xR) > 0.0) {\n      return 0.0;\n    }\n    if (xC < 0.0 || xC >= f32(uniforms.outBackprop[2]) || fract(xC) > 0.0) {\n      return 0.0;\n    }\n    let coord = vec4<i32>(\n        batch,\n        i32(xR),\n        i32(xC),\n        col % uniforms.outBackprop[3]);\n    return x[getIndexFromCoords4D(coord, uniforms.xShape)];\n    }\n    return 0.0;\n    }\n\n    fn mm_readB(row : i32, col : i32, globalId : vec3<u32>) -> f32 {\n      let coordX = uniforms.filterDims.x - 1 -\n          row / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n      let coordY = uniforms.filterDims.y - 1 -\n          (row / uniforms.outBackprop[3]) % uniforms.filterDims[1];\n      if (row < uniforms.dimInner && col < uniforms.dimBOuter &&\n          coordX >= 0 && coordY >= 0) {\n        let coord = vec4<i32>(coordX, coordY, col,\n            row % uniforms.outBackprop[3]);\n        return W[getIndexFromCoords4D(coord, uniforms.wShape)];\n      }\n      return 0.0;\n    }\n\n    fn mm_write(row : i32, col : i32, valueInput : f32, globalId : vec3<u32>) {\n      var batch = i32(globalId.z);\n      var value = valueInput;\n      let outCoord = vec4<i32>(\n          batch,\n          row / uniforms.outShape[2],\n          row % uniforms.outShape[2],\n          col);\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)] = value;\n    }\n\n    ${Ot(this.elementsPerThread,this.workGroupSize)}\n  `}}class Zo{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, stride : vec2<i32>, outBackprop : vec4<i32>,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,this.shaderKey=`conv2DDerInput_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3;return`\n    \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[${this.isChannelsLast?3:1}];\n\n        let dyCorner = vec2<i32>(coords[${e}]), coords[${t}]) - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n          let dyR = (f32(dyRCorner) + f32(wR)) / f32(uniforms.stride.x);\n          let wRPerm = uniforms.filterDims.x - 1 - wR;\n          if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) || fract(dyR) > 0.0 ||\n              wRPerm < 0) {\n            continue;\n          }\n          let idyR = dyR;\n\n          for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n            let dyC = (f32(dyCCorner) + f32(wC)) / f32(uniforms.stride.y);\n            let wCPerm = uniforms.filterDims.y - 1 - wC;\n            if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n                fract(dyC) > 0.0 || wCPerm < 0) {\n              continue;\n            }\n            let idyC = dyC;\n\n            for (var d2 = 0; d2 < uniforms.outBackprop[3]; d2 = d2 + 1) {\n              if (${this.isChannelsLast}) {\n                let xValue = getDy(batch, idyR, idyC, d2);\n                let wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd = dotProd + xValue * wValue;\n              } else {\n                let xValue = getDy(batch, d2, idyR, idyC);\n                let wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd = dotProd + xValue * wValue;\n              }\n\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}const Jo={kernelName:R,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:r,attrs:i}=e,{dy:a,filter:s}=n,{inputShape:u,strides:l,pad:d,dataFormat:c,dimRoundingMode:p}=i,h=o.convertConv2DDataFormat(c),f=o.computeConv2DInfo(u,s.shape,l,1,d,p,!1,h),m=[{type:"int32",data:[f.filterHeight,f.filterWidth]},{type:"int32",data:[f.filterHeight-1-f.padInfo.top,f.filterWidth-1-f.padInfo.left]},{type:"int32",data:[f.strideHeight,f.strideWidth]},{type:"int32",data:[f.batchSize,f.outHeight,f.outWidth,f.outChannels]}];let g;if(t().getBool("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE"))g=new Zo(f);else{g=new Qo(f);const e=f.inShape[1]*f.inShape[2],t=f.inShape[3],n=f.filterHeight*f.filterWidth*f.outChannels;m.push({type:"uint32",data:[e]},{type:"uint32",data:[t]},{type:"uint32",data:[n]})}return r.runWebGPUProgram(g,[a,s],"float32",m)}},er={kernelName:B,backendName:"webgpu",kernelFunc:on({opType:mt.COS})},tr={kernelName:T,backendName:"webgpu",kernelFunc:on({opType:mt.COSH})};class nr{constructor(e,t,n,o){this.variableNames=["Image","Boxes","BoxInd"],this.uniforms="extrapolationValue : f32,",this.workGroupSize=[64,1,1],this.size=!0;const[r]=t;this.outputShape=[r,n[0],n[1],e],this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.methodId="bilinear"===o?1:0,this.cropHeightBiggerThan1=this.outputShape[1]>1,this.cropWidthBiggerThan1=this.outputShape[2]>1,this.shaderKey=`cropAndResize_${this.methodId}_${this.cropHeightBiggerThan1}_${this.cropWidthBiggerThan1}`}getUserCode(){const[e,t]=["f32(uniforms.imageShape[1] - 1)","f32(uniforms.imageShape[2] - 1)"],[n,o,r]=this.cropHeightBiggerThan1?[`(${e} / f32(uniforms.outShape[1] - 1))`,"(y2-y1) * height_ratio",`y1*${e} + f32(y)*(height_scale)`]:["0.0","0.0",`0.5 * (y1+y2) * ${e}`],[i,a,s]=this.cropWidthBiggerThan1?[`(${t} / f32(uniforms.outShape[2] - 1))`,"(x2-x1) * width_ratio",`x1*${t} + f32(x)*(width_scale)`]:["0.0","0.0",`0.5 * (x1+x2) * ${t}`];return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let height_ratio = f32(${n});\n        let width_ratio = f32(${i});\n        let b = coords[0];\n        let y = coords[1];\n        let x = coords[2];\n        let d = coords[3];\n        // get box vals\n        let y1 = getBoxes(b, 0);\n        let x1 = getBoxes(b, 1);\n        let y2 = getBoxes(b, 2);\n        let x2 = getBoxes(b, 3);\n        // get image in batch index\n        let bInd = i32(round(getBoxInd(b)));\n        if(bInd < 0 || bInd >= uniforms.outShape[0]) {\n          return;\n        }\n        let height_scale = ${o};\n        let width_scale = ${a};\n        let in_y = ${r};\n        if( in_y < 0.0 || in_y > ${e} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let in_x = ${s};\n        if( in_x < 0.0 || in_x > ${t} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let sourceFracIndexCR = vec2<f32>(in_x,in_y);\n        if(${this.methodId} == 1) {\n          // Compute the four integer indices.\n          let sourceFloorCR = vec2<i32>(sourceFracIndexCR);\n          let sourceCeilCR = vec2<i32>(ceil(sourceFracIndexCR));\n          let topLeft = getImage(bInd, sourceFloorCR.y, sourceFloorCR.x, d);\n          let bottomLeft = getImage(bInd, sourceCeilCR.y, sourceFloorCR.x, d);\n          let topRight = getImage(bInd, sourceFloorCR.y, sourceCeilCR.x, d);\n          let bottomRight = getImage(bInd, sourceCeilCR.y, sourceCeilCR.x, d);\n          let fracCR = sourceFracIndexCR - vec2<f32>(sourceFloorCR);\n          let top = topLeft + (topRight - topLeft) * fracCR.x;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          let newValue = top + (bottom - top) * fracCR.y;\n          setOutputAtIndex(index, newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          let sourceNearestCR = vec2<i32>(floor(\n            sourceFracIndexCR + vec2<f32>(0.5,0.5)));\n          let newValue = getImage(\n            bInd, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    }\n    `}}const or={kernelName:P,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n,attrs:o}=e,{image:r,boxes:i,boxInd:a}=t,{cropSize:s,method:u,extrapolationValue:l}=o,d=new nr(r.shape[3],i.shape,s,u),c=[{type:"float32",data:[l]}];return n.runWebGPUProgram(d,[r,i,a],"float32",c)}};var rr;!function(e){e.Prod="*",e.Sum="+"}(rr||(rr={}));class ir{constructor(e,t,n,o){this.variableNames=["x"],this.uniforms="index : f32,",this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=t,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.exclusive=n,this.reverse=o,this.op=e,this.shaderKey=`cum_${this.op}_${this.exclusive}_${this.reverse}`}getUserCode(){const e=this.outputShape.length,t=this.op===rr.Prod?"1.0":"0.0",n=this.exclusive?t:`getX(${ar(e,"coords",this.op)})`,o=this.outputShape[this.outputShape.length-1];let r="",i="";return this.exclusive?(r=this.reverse?"end != "+(o-1):"end != 0",i=this.reverse?"end + 1":"end - 1"):(r=this.reverse?`end + pow2 < ${o}`:"end >= pow2",i=this.reverse?"end + pow2":"end - pow2"),`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n       if (index < uniforms.size) {\n         var coords = getCoordsFromIndex(index);\n\n         let end = ${sr(e,"coords",this.op)};\n         var val = ${n};\n         let pow2 = i32(pow(2.0, uniforms.index));\n         if (${r}) {\n           let idx = ${i};\n           ${sr(e,"coords",this.op)} = idx;\n           val ${this.op}= getX(${ar(e,"coords",this.op)});\n         }\n         setOutputAtIndex(index, val);\n       }\n      }\n    `}}function ar(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.x, ${t}.y`;if(3===e)return`${t}.x, ${t}.y, ${t}.z`;if(4===e)return`${t}.x, ${t}.y, ${t}.z, ${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function sr(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.y`;if(3===e)return`${t}.z`;if(4===e)return`${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function ur(e,t,n,r,i,a){const s=t.shape.length,u=o.getAxesPermutation([r],s);let l=t;null!=u&&(l=wo({inputs:{x:t},backend:n,attrs:{perm:u}}));const d=o.getInnerMostAxes(1,s)[0];if(d!==s-1)throw new Error(`WebGPU cumprod shader expects an inner-most axis=${t.shape.length-1} but got axis=${r}`);const c=l.shape[d];let p=Zt({inputs:{x:l},backend:n});for(let t=0;t<=Math.ceil(Math.log2(c))-1;t++){const o=new ir(e,l.shape,!1,a),r=p,i=[{type:"float32",data:[t]}];p=n.runWebGPUProgram(o,[p],p.dtype,i),n.disposeData(r.dataId)}if(i){const t=new ir(e,l.shape,i,a),o=p,r=[{type:"float32",data:[0]}];p=n.runWebGPUProgram(t,[p],p.dtype,r),n.disposeData(o.dataId)}if(null!=u){const e=wo({inputs:{x:p},backend:n,attrs:{perm:o.getUndoAxesPermutation(u)}});return n.disposeData(p.dataId),n.disposeData(l.dataId),e}return p}const lr={kernelName:N,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{axis:i,exclusive:a,reverse:s}=o;return ur(rr.Prod,r,n,i,a,s)}};const dr={kernelName:E,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{axis:i,exclusive:a,reverse:s}=o;return ur(rr.Sum,r,n,i,a,s)}};class cr{constructor(e,t){this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.uniforms="blockSize : i32,",this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`depthToSpace_${t}`,this.dataFormat=t}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let h = ${this.getHeightCoordString()};\n          let w = ${this.getWidthCoordString()};\n          let d = ${this.getDepthCoordString()};\n\n          let in_h = h / uniforms.blockSize;\n          let offset_h = h % uniforms.blockSize;\n          let in_w = w / uniforms.blockSize;\n          let offset_w = w % uniforms.blockSize;\n          let offset_d = (offset_h * uniforms.blockSize + offset_w) *\n            ${this.getOutputDepthSize()};\n          let in_d = d + offset_d;\n\n          let rlt = ${this.getInputSamplingString()};\n          setOutputAtIndex(index, rlt);\n        }\n      }`}getHeightCoordString(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"}getWidthCoordString(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"}getDepthCoordString(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"}getOutputDepthSize(){return"NHWC"===this.dataFormat?"uniforms.outShape[3]":"uniforms.outShape[1]"}getInputSamplingString(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"}}const pr={kernelName:L,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{blockSize:i,dataFormat:a}=o,s=r.shape[0],u=("NHWC"===a?r.shape[1]:r.shape[2])*i,l=("NHWC"===a?r.shape[2]:r.shape[3])*i,d=("NHWC"===a?r.shape[3]:r.shape[1])/(i*i),c=[{type:"int32",data:[i]}],p=new cr("NHWC"===a?[s,u,l,d]:[s,d,u,l],a);return n.runWebGPUProgram(p,[r],r.dtype,c)}};class hr{constructor(e,t=!1,o=null,r=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>, inDims : vec2<i32>,",this.workGroupSize=[4,4,4],this.isVec4=!0,this.outputShape=e.outShape,this.dispatchLayout={x:[0,1],y:[2],z:[3]},this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[1,4,4]),n.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),t&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=o,this.hasPreluActivation=r,this.shaderKey=`depthwise3x3_${o}`}getUserCode(){let e="",t="";if(this.activation){const n=bt(this.activation,this.isVec4);e=this.hasPreluActivation?`fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n          let b = getPreluActivationWeightsByOutputCoords(outCoord);\n          ${n}\n        }`:`\n        fn activation(a : vec4<f32>, outCoord : vec4<i32>) -> vec4<f32> {\n            ${n}\n          }\n        `,t="dotProd[i] = activation(dotProd[i], coords);"}return`\n      ${e}\n\n      \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(global_invocation_id) globalId: vec3<u32>) {\n        let batch = 0;\n        let r = i32(globalId.x);\n        let c = i32(globalId.y) * 4;\n        let d2 = i32(globalId.z) * 4;\n        let xRCCorner = vec2<i32>(r, c) * uniforms.stride - uniforms.pad;\n        let d1 = d2;\n        let q = 0;\n\n        let xRCorner = xRCCorner.x;\n        let xCCorner = xRCCorner.y;\n\n        var wVals : array<vec4<f32>, 9>;\n        wVals[0] = getW(0, 0, d1, q);\n        wVals[1] = getW(0, 1, d1, q);\n        wVals[2] = getW(0, 2, d1, q);\n        wVals[3] = getW(1, 0, d1, q);\n        wVals[4] = getW(1, 1, d1, q);\n        wVals[5] = getW(1, 2, d1, q);\n        wVals[6] = getW(2, 0, d1, q);\n        wVals[7] = getW(2, 1, d1, q);\n        wVals[8] = getW(2, 2, d1, q);\n\n        var xVals : array<array<vec4<f32>, 6>, 3>;\n        for (var wR = 0; wR < 3; wR = wR + 1) {\n          let xR = xRCorner + wR * uniforms.dilation[0];\n          for (var wC = 0; wC < 6; wC = wC + 1) {\n            let xC = xCCorner + wC * uniforms.dilation[1];\n            if (xR < 0 || xR >= uniforms.inDims[0] || xC < 0 || xC >= uniforms.inDims[1]) {\n              xVals[wR][wC] = vec4<f32>(0.0);\n            } else {\n              xVals[wR][wC] = getX(batch, xR, xC, d1);\n            }\n          }\n        }\n\n        var dotProd : array<vec4<f32>, 4>;\n        dotProd[0] = vec4<f32>(0.0);\n        dotProd[1] = vec4<f32>(0.0);\n        dotProd[2] = vec4<f32>(0.0);\n        dotProd[3] = vec4<f32>(0.0);\n\n        for (var wR = 0; wR < 3; wR = wR + 1) {\n          for (var wC = 0; wC < 3; wC = wC + 1) {\n            let indexW = wR * 3 + wC;\n            dotProd[0] = dotProd[0] + xVals[wR][0 + wC] * wVals[indexW];\n            dotProd[1] = dotProd[1] + xVals[wR][1 + wC] * wVals[indexW];\n            dotProd[2] = dotProd[2] + xVals[wR][2 + wC] * wVals[indexW];\n            dotProd[3] = dotProd[3] + xVals[wR][3 + wC] * wVals[indexW];\n          }\n        }\n\n        for (var i = 0; i < 4; i = i + 1) {\n          let coords = vec4<i32>(batch, r, c + i, d2);\n          if (coordsInBounds4D(coords, uniforms.outShape)) {\n            ${this.addBias?"dotProd[i] = dotProd[i] + getBiasByOutputCoords(coords);":""}\n            ${t}\n            setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], dotProd[i]);\n          }\n        }\n      }\n    `}}class fr{constructor(e,t=!1,o=null,r=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>,\n      inDims : vec2<i32>, filterHeight : i32, filterWidth : i32,\n      channelMul : i32,",this.workGroupSize=[256,1,1],this.outputShape=e.outShape,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),n.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),t&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=o,this.hasPreluActivation=r,this.shaderKey=`depthwise_${this.activation}`}getUserCode(){let e="",t="";if(this.activation){const n=bt(this.activation,!1);e=this.hasPreluActivation?`fn activation(a : f32, outCoord : vec4<i32>) -> f32 {\n          let b = getPreluActivationWeightsByOutputCoords(outCoord);\n          ${n}\n        }`:`\n          fn activation(a : f32, outCoord : vec4<i32>) -> f32 {\n            ${n}\n          }\n        `,t="dotProd = activation(dotProd, coords);"}return`\n      ${e}\n\n      fn writeResult(batch : i32, row : i32, col : i32, chan : i32,\n          value : f32) {\n        let coord = vec4<i32>(batch, row, col, chan);\n        if (coordsInBounds4D(coord, uniforms.outShape)) {\n          setOutputAtCoords(batch, row, col, chan, value);\n        }\n      }\n\n      \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n        let coords = getOutputCoords();\n        let batch = coords[0];\n        let xRCCorner = vec2<i32>(coords.yz) * uniforms.stride - uniforms.pad;\n        let d2 = coords[3];\n        let d1 = d2 / uniforms.channelMul;\n        let q = d2 - d1 * uniforms.channelMul;\n\n        let inputRowStart = xRCCorner.x;\n        let inputColStart = xRCCorner.y;\n        let inputRowEnd = inputRowStart + uniforms.filterHeight *\n            uniforms.dilation[0];\n        let inputColEnd = inputColStart + uniforms.filterWidth *\n            uniforms.dilation[1];\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n\n        // Extract if checking out of for loop for performance.\n        if (inputRowStart >= 0 && inputColStart >= 0 &&\n          inputRowEnd < uniforms.inDims[0] &&\n              inputColEnd < uniforms.inDims[1]) {\n            // Here using a constant value |this.convInfo.filterHeight| instead\n            // of uniform value is in order to loop unrolling.\n            for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n              let xR = inputRowStart + wR * uniforms.dilation[0];\n\n              for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                let xC = inputColStart + wC * uniforms.dilation[1];\n\n                let xVal = getX(batch, xR, xC, d1);\n                let wVal = getW(wR, wC, d1, q);\n                dotProd = dotProd + xVal * wVal;\n              }\n            }\n          } else {\n            for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n              let xR = inputRowStart + wR * uniforms.dilation[0];\n\n              if (xR < 0 || xR >= uniforms.inDims[0]) {\n                continue;\n              }\n\n              for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                let xC = inputColStart + wC * uniforms.dilation[1];\n\n                if (xC < 0 || xC >= uniforms.inDims[1]) {\n                  continue;\n                }\n\n                let xVal = getX(batch, xR, xC, d1);\n                let wVal = getW(wR, wC, d1, q);\n                dotProd = dotProd + xVal * wVal;\n              }\n            }\n          }\n\n        ${this.addBias?"dotProd = dotProd + getBiasByOutputCoords(coords);":""}\n        ${t}\n        writeResult(batch, coords[1], coords[2], d2, dotProd);\n      }\n    `}}const mr={kernelName:W,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:i,filter:a}=t,{strides:s,pad:u,dilations:l,dimRoundingMode:d}=r;let c=l;null==c&&(c=[1,1]);const p=o.computeConv2DInfo(i.shape,a.shape,s,c,u,d,!0),h=[{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.dilationHeight,p.dilationWidth]},{type:"int32",data:[p.inHeight,p.inWidth]}];let f;return 1===p.batchSize&&p.inHeight===p.outHeight&&p.inWidth===p.outWidth&&1===p.strideHeight&&1===p.strideWidth&&p.filterHeight===p.filterWidth&&p.inChannels===p.outChannels&&1===p.dilationHeight&&1===p.dilationWidth&&3===p.filterHeight&&p.inChannels%4==0?f=new hr(p):(f=new fr(p),h.push({type:"int32",data:[p.filterHeight]},{type:"int32",data:[p.filterWidth]},{type:"int32",data:[p.outChannels/p.inChannels]})),n.runWebGPUProgram(f,[i,a],i.dtype,h)}},gr=rn({opSnippet:dt.MUL,cpuKernelImpl:jn,supportsComplex:!0}),br={kernelName:O,backendName:"webgpu",kernelFunc:gr};class Ir{constructor(e,t){this.workGroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="reduceSize : i32,",this.size=!0,this.inputShape=[e.batchSize,e.inSize];const[n]=o.computeOutAndReduceShapes(this.inputShape,[1]);this.outputShape=0===n.length?[1]:n,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,[1,1,1]),this.reduceType=t,this.shaderKey=`reduce_${t}`}getUserCode(){let e="",t="0.0";"min"===this.reduceType||"max"===this.reduceType?(e=`\n         if (isnan(candidate)) {\n          bestValue = uniforms.NAN;\n         } else if (!isnan(bestValue) && candidate ${"min"===this.reduceType?"<":">"} bestValue)\n           {  bestValue = candidate; }`,t="f32(x[offset])"):"sum"===this.reduceType||"mean"===this.reduceType?e=" bestValue = bestValue + candidate; ":"prod"===this.reduceType&&(e=" bestValue = bestValue * candidate; ",t="1.0");const n="mean"===this.reduceType?"setOutputAtIndex(outputIndex, bestValue / f32(uniforms.reduceSize));":"setOutputAtIndex(outputIndex, bestValue);";return`\n       fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n       }\n\n       ${`\n         var<workgroup> xBestValues : array<f32, ${this.workGroupSize[0]}>;\n       `}\n       fn getOffset(outputIndex : i32) -> i32 {\n         let outputCoords = getCoordsFromIndex(outputIndex);\n         let offset = ${1===this.outputShape.length?"outputCoords":"outputCoords[0]"} * uniforms.reduceSize;\n          return offset;\n       }\n       \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n         let outputIndex = index / i32(workGroupSizeX);\n         let offset = getOffset(outputIndex);\n         var bestValue = ${t};\n         let Length = uniforms.reduceSize;\n         let WorkPerThread = DIV_CEIL(u32(Length), workGroupSizeX);\n         for (var k = i32(localId.x); k < Length && outputIndex < uniforms.size;\n             k = k + i32(workGroupSizeX)) {\n           let candidate = f32(x[offset + k]);\n           ${e}\n         }\n         xBestValues[localId.x] = bestValue;\n         workgroupBarrier();\n\n         var reduceSize = min(u32(Length), workGroupSizeX);\n         for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n             currentSize = reduceSize / 2u) {\n           let interval = DIV_CEIL(reduceSize, 2u);\n           if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            ${e}\n            xBestValues[localId.x] = bestValue;\n           }\n           reduceSize = interval;\n           workgroupBarrier();\n         }\n\n         if (localId.x == 0u && outputIndex < uniforms.size) {\n          ${n}\n        }\n       }\n     `}}function wr(e,t,r,i,a){const s=e.shape.length,u=[],l=n.parseAxisParam(t,e.shape);let d=l;const c=o.getAxesPermutation(d,s);let p=e;null!=c&&(p=wo({inputs:{x:e},attrs:{perm:c},backend:a}),d=o.getInnerMostAxes(d.length,s),u.push(p)),o.assertAxesAreInnerMostDims(i,d,s);const[h,f]=o.computeOutAndReduceShapes(p.shape,d);let m,g=h;if(r&&(g=o.expandShapeToKeepDim(h,l)),"max"!==i&&"prod"!==i||!a.shouldExecuteOnCPU([p])){const t=n.sizeFromShape(f),o={windowSize:t,inSize:t,batchSize:n.sizeFromShape(p.shape)/t,outSize:1},r="mean"===i?"float32":F(e.dtype),s=[{type:"int32",data:[t]}],l=new Ir(o,i),d=a.runWebGPUProgram(l,[p],r,s);u.push(d),m=Mt({inputs:{x:d},attrs:{shape:g},backend:a})}else{const t=a.tensorMap.get(p.dataId).values;switch(i){case"max":const o=qn(t,n.sizeFromShape(f),g,e.dtype);m=a.makeTensorInfo(g,e.dtype,o);break;case"prod":const{outVals:r,outShape:s,outDtype:u}=Jn(p.shape,p.dtype,t,d);m=a.makeTensorInfo(s,u,r);break;default:throw new Error(`${i} CPU implementation is not yet supported.`)}}return u.forEach((e=>a.disposeData(e.dataId))),m}function xr(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{axis:i,keepDims:a}=o;return wr(r,i,a,"sum",n)}const kr={kernelName:U,backendName:"webgpu",kernelFunc:xr};const vr={kernelName:D,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{equation:a}=i,s=t,{allDims:u,summedDims:l,idDims:d}=o.decodeEinsumEquation(a,s.length);o.checkEinsumDimSizes(u.length,d,s);const{path:c,steps:p}=o.getEinsumComputePath(l,d),h=p.length;let f=null,m=u.length;const g=[];for(let e=0;e<h;++e){for(const t of p[e]){const{permutationIndices:e,expandDims:i}=o.getEinsumPermutation(m,d[t]);let a;o.isIdentityPermutation(e)?a=s[t]:(a=wo({inputs:{x:s[t]},backend:r,attrs:{perm:e}}),g.push(a));const u=a.shape.slice();for(let e=0;e<i.length;++e)u.splice(i[e],0,1);n.arraysEqual(a.shape,u)||(a=Mt({inputs:{x:a},backend:r,attrs:{shape:u}}),g.push(a)),null===f?f=a:(f=gr({inputs:{a:a,b:f},backend:r}),g.push(f))}e<h-1&&(c[e]>=0&&(f=xr({inputs:{x:f},backend:r,attrs:{axis:c[e]-(u.length-m),keepDims:!1}}),g.push(f)),m--)}for(const e of g)e!==f&&r.disposeData(e.dataId);return f}},Sr={kernelName:M,backendName:"webgpu",kernelFunc:on({opType:mt.ELU})},yr={kernelName:V,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.EQUAL,dtype:"bool",cpuKernelImpl:En})},Cr=on({opType:mt.EXP,cpuKernelImpl:Ln,dtype:"float32"}),zr={kernelName:X,backendName:"webgpu",kernelFunc:Cr};function _r(e){const{inputs:t,attrs:o,backend:r}=e,{dim:i}=o,{input:a}=t,s=a.shape.length,u=a.shape.slice();let l=i;return i<0&&(n.assert(-(s+1)<=i,(()=>`Axis must be in the interval [${-(s+1)}, ${s}]`)),l=s+i+1),u.splice(l,0,1),Mt({inputs:{x:a},backend:r,attrs:{shape:u}})}const $r={kernelName:H,backendName:"webgpu",kernelFunc:_r},Gr={kernelName:q,backendName:"webgpu",kernelFunc:on({opType:mt.EXPM1,cpuKernelImpl:Wn})};class Ar{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="value : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="fill"}getUserCode(){return"\n    \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n      if (index < uniforms.size) {\n        setOutputAtIndex(index, uniforms.value);\n      }\n    }\n  "}}function Rr(e){const{backend:t,attrs:o}=e,{shape:r,value:i}=o;let{dtype:a}=o;if(a=a||n.inferDtype(i),"string"===a){const e=n.getArrayFromDType(a,n.sizeFromShape(r));return e.fill(i),t.makeTensorInfo(r,a,e)}{const e=new Ar(r),n=[{type:"float32",data:[i]}];return t.runWebGPUProgram(e,[],a,n)}}const Br={kernelName:Y,backendName:"webgpu",kernelFunc:Rr};class Tr{constructor(e){this.outputShape=[],this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="flipLeftRight"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let coordX = uniforms.xShape[2] - coords[2] - 1;\n          let outputValue = getX(coords[0], coords[1], coordX, coords[3]);\n          setOutputAtIndex(index, outputValue);\n        }\n      }\n    "}}const Pr={kernelName:K,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{image:n}=e,o=t,r=new Tr(n.shape);return o.runWebGPUProgram(r,[n],n.dtype)}},Nr={kernelName:j,backendName:"webgpu",kernelFunc:on({opType:mt.FLOOR,cpuKernelImpl:On})},Er={kernelName:Q,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.INT_DIV,dtype:"int32"})};class Lr{constructor(e,t=!1){this.outputShape=[0],this.variableNames=[],this.workGroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.useImport=t,this.shaderKey=`fromPixels_${this.useImport}`}getUserCode(){const e=this.useImport?"textureLoad(src, vec2<i32>(coords.yx));":"textureLoad(src, vec2<i32>(coords.yx), 0)";return`\n      @binding(1) @group(0) var src: ${this.useImport?"texture_external":"texture_2d<f32>"};\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        let flatIndexBase = index * uniforms.numChannels;\n        for (var i = 0; i < uniforms.numChannels; i = i + 1) {\n          let flatIndex = flatIndexBase + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndexBase);\n            let values = ${e};\n            result[flatIndex] = i32(floor(255.0 * values[i]));\n          }\n        }\n      }\n  `}}const Wr={kernelName:Z,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:o,attrs:r}=e;let{pixels:i}=n;const{numChannels:a}=r;if(null==i)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");const s="undefined"!=typeof HTMLVideoElement&&i instanceof HTMLVideoElement,u="undefined"!=typeof HTMLImageElement&&i instanceof HTMLImageElement,l="undefined"!=typeof HTMLCanvasElement&&i instanceof HTMLCanvasElement||"undefined"!=typeof OffscreenCanvas&&i instanceof OffscreenCanvas,d="undefined"!=typeof ImageBitmap&&i instanceof ImageBitmap,[c,p]=s?[i.videoWidth,i.videoHeight]:[i.width,i.height],h=[p,c,a];if(t().getBool("WEBGPU_USE_IMPORT")&&s)return Fr({externalImage:i,backend:o,attrs:r,outShape:h,useImport:!0});(s||u)&&(null==Or&&(Or=document.createElement("canvas").getContext("2d")),Or.canvas.width=c,Or.canvas.height=p,Or.drawImage(i,0,0,c,p),i=Or.canvas);if(d||l||s||u)return Fr({externalImage:i,backend:o,attrs:r,outShape:h,useImport:!1});const f=i.data;let m=f;if(null!=a&&4!==a){m=new Uint8Array(i.width*i.height*a);const e=f.length;let t=0;for(let n=0;n<e;n++)n%4<a&&(m[t++]=f[n])}const g=o.makeTensorInfo(h,"int32");return o.tensorMap.get(g.dataId).values=new Int32Array(m),o.maybeReleaseBuffer(g.dataId),o.uploadToGPU(g.dataId),g}};let Or;function Fr(e){const{externalImage:t,backend:o,attrs:r,outShape:i,useImport:a}=e,{numChannels:s}=r,u=n.sizeFromShape(i),l=n.computeStrides(i),d=new Lr(i,a),c=[{type:"uint32",data:[u]},{type:"uint32",data:[s]},{type:"uint32",data:[...l]},{type:"uint32",data:[...d.dispatch]}];return o.runFromPixelsProgram(d,i,c,a,t)}class Ur{constructor(e,t,n,r,i){this.uniforms="varianceEpsilon : f32,",this.workGroupSize=[128,1,1],this.size=!0,this.variableNames=["x","mean","variance"],o.assertAndGetBroadcastShape(e,t),o.assertAndGetBroadcastShape(e,n),this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),null!=r&&(o.assertAndGetBroadcastShape(e,r),this.variableNames.push("offset")),null!=i&&(o.assertAndGetBroadcastShape(e,i),this.variableNames.push("scale")),this.offsetShape=r,this.scaleShape=i,this.shaderKey="batchNorm"}getUserCode(){let e="0.0";null!=this.offsetShape&&(e="getOffsetByOutputIndex(index)");let t="1.0";null!=this.scaleShape&&(t="getScaleByOutputIndex(index)");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size)\n        {\n          let xValue = getXByOutputIndex(index);\n          let meanValue = getMeanByOutputIndex(index);\n          let varianValue = getVarianceByOutputIndex(index);\n          let offsetValue = ${e};\n          let scaleValue = ${t};\n          let inv = scaleValue * inverseSqrt(varianValue + f32(uniforms.varianceEpsilon));\n          setOutputAtIndex(index,dot(vec3<f32>(xValue, -meanValue, offsetValue), vec3<f32>(inv, inv, 1.0)));\n        }\n      }\n  `}}const Dr={kernelName:J,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:o,scale:r,offset:i,mean:a,variance:s}=e,{varianceEpsilon:u}=t,l=n,d=[o,a,s];let c=null;null!=i&&(c=i.shape,d.push(i));let p=null;null!=r&&(p=r.shape,d.push(r));const h=new Ur(o.shape,a.shape,s.shape,c,p),f=[{type:"float32",data:[u]}];return l.runWebGPUProgram(h,d,o.dtype,f)}};const Mr={kernelName:ee,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:i,filter:a,bias:s,preluActivationWeights:u}=t,{strides:l,pad:d,dataFormat:c,dilations:p,dimRoundingMode:h,activation:f,leakyreluAlpha:m}=r,g=o.convertConv2DDataFormat(c);return Ko({x:i,filter:a,convInfo:o.computeConv2DInfo(i.shape,a.shape,l,p,d,h,!1,g),backend:n,bias:s,preluActivationWeights:u,leakyreluAlpha:m,activation:f})}};const Vr={kernelName:te,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{x:a,filter:s,bias:u,preluActivationWeights:l}=t,{strides:d,pad:c,dilations:p,dimRoundingMode:h,activation:f,leakyreluAlpha:m}=i;let g=p;null==g&&(g=[1,1]),n.assert(o.eitherStridesOrDilationsAreOne(d,g),(()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${d} and dilations '${g}'`));const b=o.computeConv2DInfo(a.shape,s.shape,d,g,c,h,!0),I=[a,s],w=null!=u,x=null!=l;w&&I.push(u),x&&I.push(l);const k=[{type:"int32",data:[b.padInfo.top,b.padInfo.left]},{type:"int32",data:[b.strideHeight,b.strideWidth]},{type:"int32",data:[b.dilationHeight,b.dilationWidth]},{type:"int32",data:[b.inHeight,b.inWidth]}];let v;return 1===b.batchSize&&b.inHeight===b.outHeight&&b.inWidth===b.outWidth&&1===b.strideHeight&&1===b.strideWidth&&b.filterHeight===b.filterWidth&&b.inChannels===b.outChannels&&1===b.dilationHeight&&1===b.dilationWidth&&3===b.filterHeight&&b.inChannels%4==0?v=new hr(b,w,f,x):(v=new fr(b,w,f,x),k.push({type:"int32",data:[b.filterHeight]},{type:"int32",data:[b.filterWidth]},{type:"int32",data:[b.outChannels/b.inChannels]})),"leakyrelu"===f&&(k.push({type:"float32",data:[m]}),v.uniforms+=" alpha : f32,"),r.runWebGPUProgram(v,I,"float32",k)}};class Xr{constructor(e,t){this.variableNames=["A","indices"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`gathernd_${e}`,this.sliceDim=e,this.uniforms=`sliceDim : i32, strides : ${wt(e)},`}getUserCode(){let e;e=this.sliceDim>1?"uniforms.strides[j]":"uniforms.strides";return`\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          var flattenIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexTemp = i32(round(getIndices(coords[0], j)));\n            let strideNum = ${e};\n            flattenIndex = flattenIndex + indexTemp * strideNum;\n          }\n\n          setOutputAtIndex(index, getA(flattenIndex, coords[1]));\n        }\n      }\n      `}}const Hr={kernelName:ne,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r}=e,{params:i,indices:a}=t,s=a.shape,u=s[s.length-1],l=n.sizeFromShape(i.shape),[d,c,p,h]=o.prepareAndValidate(i,a),f=Mt({inputs:{x:a},backend:r,attrs:{shape:[c,u]}}),m=Mt({inputs:{x:i},backend:r,attrs:{shape:[n.sizeFromShape(i.shape)/p,p]}});if(r.shouldExecuteOnCPU([i,a])||"string"===i.dtype){const e=r.readSync(a.dataId),t=r.bufferSync(i),n=Fn(e,t,i.dtype,c,u,p,h,i.shape,l);return r.makeTensorInfo(d,i.dtype,n.values)}const g=new Xr(u,[c,p]),b=[{type:"int32",data:[u]},{type:"int32",data:h}],I=r.runWebGPUProgram(g,[m,f],m.dtype,b),w=Mt({inputs:{x:I},backend:r,attrs:{shape:d}});return r.disposeData(f.dataId),r.disposeData(m.dataId),r.disposeData(I.dataId),w}};class qr{constructor(e,t){this.variableNames=["A","indices"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e.slice(),this.aShape=e,this.outputShape=t,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="gather"}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let indexZ = i32(getIndices(resRC.x, resRC.z));\n          let inBounds = select(0.0, 1.0, indexZ >= 0 && indexZ < uniforms.aShape[2]);\n          setOutputAtIndex(index, inBounds * getA(${function(e){const t=["resRC.x","resRC.y","resRC.z","resRC.w"],n=[];for(let o=0;o<e.length;o++)2===o?n.push("indexZ"):n.push(`${t[o]}`);return n.join()}(this.aShape)}));\n        }\n      }\n    `}}function Yr(e){const{inputs:t,backend:r,attrs:i}=e,{x:a,indices:s}=t,{axis:u,batchDims:l}=i,c=n.parseAxisParam(u,a.shape)[0],p=o.segment_util.collectGatherOpShapeInfo(a,s,c,l),h=n.sizeFromShape(s.shape),f=[],m=Mt({inputs:{x:a},backend:r,attrs:{shape:[p.batchSize,p.outerSize,p.dimSize,p.sliceSize]}}),g=Mt({inputs:{x:s},backend:r,attrs:{shape:[p.batchSize,h/p.batchSize]}});f.push(m),f.push(g);const b=[p.batchSize,p.outerSize,h/p.batchSize,p.sliceSize];if(r.shouldExecuteOnCPU([a,s])){const e=r.tensorMap.get(g.dataId).values,t=d(g.shape,g.dtype,e),n=r.tensorMap.get(m.dataId).values,o=d(m.shape,m.dtype,n),i=Un(o,t,b);return f.forEach((e=>r.disposeData(e.dataId))),r.makeTensorInfo(p.outputShape,i.dtype,i.values)}const I=new qr(m.shape,b),w=r.runWebGPUProgram(I,[m,g],m.dtype);f.push(w);const x=Mt({inputs:{x:w},backend:r,attrs:{shape:p.outputShape}});return f.forEach((e=>r.disposeData(e.dataId))),x}const Kr={kernelName:oe,backendName:"webgpu",kernelFunc:Yr},jr={kernelName:re,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.GREATER,cpuKernelImpl:Mn,dtype:"bool"})},Qr={kernelName:ie,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.GREATER_EQUAL,dtype:"bool",cpuKernelImpl:Dn})};const Zr={kernelName:ae,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{alpha:i}=o,a=[{type:"float32",data:[i]}],s=new nn(r.shape,mt.LEAKYRELU);return s.uniforms="alpha : f32,",n.runWebGPUProgram(s,[r],"float32",a)}},Jr={kernelName:se,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.LESS,dtype:"bool",cpuKernelImpl:Xn})},ei={kernelName:ue,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.LESS_EQUAL,dtype:"bool",cpuKernelImpl:Vn})},ti={kernelName:le,backendName:"webgpu",kernelFunc:on({opType:mt.LOG,cpuKernelImpl:Hn})},ni={kernelName:de,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.LOGICAL_AND,dtype:"bool"})},oi={kernelName:ce,backendName:"webgpu",kernelFunc:on({opType:mt.LOGICAL_NOT})};function ri(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{reductionIndices:i,keepDims:a}=o;return wr(r,i,a,"max",n)}const ii={kernelName:pe,backendName:"webgpu",kernelFunc:ri},ai={kernelName:he,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.MAX,cpuKernelImpl:Yn})};const si={kernelName:fe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{filterSize:s,strides:u,pad:l,dimRoundingMode:d}=i,c=o.computePool2DInfo(a.shape,s,u,1,l,d);let p;const h=[];if(1===c.filterHeight&&1===c.filterWidth){if(n.arraysEqual(c.inShape,c.outShape))return Zt({inputs:{x:a},backend:r});p=new yo(c),h.push({type:"int32",data:[c.strideHeight,c.strideWidth]})}else p=new So(c,"max"),h.push({type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.padInfo.top,c.padInfo.left]},{type:"int32",data:[c.dilationHeight,c.dilationWidth]},{type:"int32",data:[c.inHeight,c.inWidth]},{type:"int32",data:[c.effectiveFilterHeight,c.effectiveFilterWidth]});return r.runWebGPUProgram(p,[a],a.dtype,h)}};const ui={kernelName:me,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{keepDims:i,axis:a}=o;return wr(r,a,i,"mean",n)}};const li={kernelName:ge,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{axis:i,keepDims:a}=o;return wr(r,i,a,"min",n)}},di={kernelName:be,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.MIN,cpuKernelImpl:Kn})};class ci{constructor(e,t,n){this.uniforms="",this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.xShape=e,t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.offset="reflect"===n?0:1,this.shaderKey=`mirrorPad_${n}`}getUserCode(){const e=this.xShape.length,t=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),n=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),o=1===e?"start":"start[i]",r=1===e?"end":"end[i]",i=1===e?"outC":"outC[i]",a=wt(e),s=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let start = ${a}(${t});\n          let end = ${a}(${n});\n          var outC = getCoordsFromIndex(index);\n          for (var i = 0; i < ${e}; i = i + 1) {\n            if (${i} < ${o}) {\n              ${i} = ${o} * 2 - ${i} - ${this.offset};\n            } else if(${i} >= ${r}) {\n              ${i} = (${r} - 1) * 2 - ${i} + ${this.offset};\n            }\n          }\n          let coords = outC - start;\n          setOutputAtIndex(index, getX(${s}));\n        }\n      }\n    `}}const pi={kernelName:Ie,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:o}=e,{paddings:r,mode:i}=t,a=n,s=r.map((e=>({type:"int32",data:[e[0],e[1]]}))),u=new ci(o.shape,r,i);return a.runWebGPUProgram(u,[o],o.dtype,s)}};const hi={kernelName:we,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:o}=t;if(n.shouldExecuteOnCPU([o])){const e=n.tensorMap.get(o.dataId),[t,r]=Qn(e.values,o.shape,o.dtype);return n.makeTensorInfo(r,o.dtype,t)}const r=new nn(o.shape,mt.NEG);return n.runWebGPUProgram(r,[o],o.dtype)}};const fi={kernelName:xe,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:t,backend:n,attrs:o}=e,{boxes:r,scores:i}=t,{maxOutputSize:a,iouThreshold:s,scoreThreshold:u}=o,l=n.readSync(r.dataId),d=n.readSync(i.dataId),{selectedIndices:c}=ke.nonMaxSuppressionV3Impl(l,d,a,s,u);return n.makeTensorInfo([c.length],"int32",new Int32Array(c))}};const mi={kernelName:ve,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:t,backend:n,attrs:o}=e,{boxes:r,scores:i}=t,{maxOutputSize:a,iouThreshold:s,scoreThreshold:u,softNmsSigma:l}=o,d=n.readSync(r.dataId),c=n.readSync(i.dataId),p=a,h=s,f=u,m=l,{selectedIndices:g,selectedScores:b}=ke.nonMaxSuppressionV5Impl(d,c,p,h,f,m);return[n.makeTensorInfo([g.length],"int32",new Int32Array(g)),n.makeTensorInfo([b.length],"float32",new Float32Array(b))]}};function gi(e){const{inputs:t,backend:n}=e,{x:o}=t;if("complex64"===o.dtype){const e=Po({inputs:{input:o},backend:n}),t=gi({inputs:{x:e},backend:n}),r=Do({inputs:{input:o},backend:n}),i=gi({inputs:{x:r},backend:n}),a=en({inputs:{real:t,imag:i},backend:n});return n.disposeData(e.dataId),n.disposeData(t.dataId),n.disposeData(r.dataId),n.disposeData(i.dataId),a}return Rr({attrs:{shape:o.shape,dtype:o.dtype,value:"string"===o.dtype?"":0},backend:n})}const bi={kernelName:Se,backendName:"webgpu",kernelFunc:gi};const Ii={kernelName:ye,backendName:"webgpu",kernelFunc:function e(t){const{inputs:n,backend:o}=t,{x:r}=n;if("string"===r.dtype)throw new Error("onesLike is not supported under string dtype");if("complex64"===r.dtype){const t=Po({inputs:{input:r},backend:o}),n=e({inputs:{x:t},backend:o}),i=Do({inputs:{input:r},backend:o}),a=gi({inputs:{x:i},backend:o}),s=en({inputs:{real:n,imag:a},backend:o});return o.disposeData(t.dataId),o.disposeData(n.dataId),o.disposeData(i.dataId),o.disposeData(a.dataId),s}return Rr({attrs:{shape:r.shape,dtype:r.dtype,value:1},backend:o})}};const wi={kernelName:Ce,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:o,attrs:r}=e,{axis:i}=r;if(1===t.length)return _r({inputs:{input:t[0]},backend:o,attrs:{dim:i}});const a=t[0].shape,s=t[0].dtype;t.forEach((e=>{n.assertShapesMatch(a,e.shape,"All tensors passed to stack must have matching shapes"),n.assert(s===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const u=[],l=Xo({inputs:t.map((e=>{const t=_r({inputs:{input:e},backend:o,attrs:{dim:i}});return u.push(t),t})),backend:o,attrs:{axis:i}});return u.forEach((e=>o.disposeData(e.dataId))),l}};class xi{constructor(e,t){this.variableNames=["x"],this.uniforms="constantValue : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.xShape=e,this.shaderKey="pad"}getUserCode(){const e=this.xShape.length,t=wt(e),n=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),o=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(",");return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let start = ${e>1?`${t}(${n})`:`${n}`};\n          let end = ${e>1?`${t}(${o})`:`${o}`};\n          let outC = getCoordsFromIndex(index);\n\n          if (${e>1?"any(outC < start)":"outC < start"} || ${e>1?"any(outC >= end)":"outC >= end"}) {\n            setOutputAtIndex(index, uniforms.constantValue);\n          } else {\n            let coords = outC - start;\n            setOutputAtIndex(index, getX(${e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords"}));\n          }\n        }\n      }\n    `}}const ki=e=>{const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{paddings:a,constantValue:s}=r;if(a.every((e=>n.arraysEqual(e,[0,0]))))return Zt({inputs:{x:i},backend:o});if(0===n.sizeFromShape(i.shape)){return Rr({backend:o,attrs:{shape:a.map(((e,t)=>e[0]+i.shape[t]+e[1])),value:s,dtype:i.dtype}})}const u=[{type:"float32",data:[s]}];a.map((e=>u.push({type:"int32",data:[e[0],e[1]]})));const l=new xi(i.shape,a);return o.runWebGPUProgram(l,[i],i.dtype,u)},vi={kernelName:ze,backendName:"webgpu",kernelFunc:ki},Si={kernelName:_e,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.POW})};const yi={kernelName:$e,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:o,alpha:r}=t,i=new jt(dt.PRELU,o.shape,r.shape);return n.runWebGPUProgram(i,[o,r],"float32")}};const Ci={kernelName:Ge,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{x:r}=t,{axis:i,keepDims:a}=o;return wr(r,i,a,"prod",n)}},zi={kernelName:Ae,backendName:"webgpu",kernelFunc:e=>{const{backend:t,attrs:n}=e,{start:o,stop:r,step:i,dtype:a}=n,s=eo(o,r,i,a);return t.makeTensorInfo([s.length],a,s)}},_i=rn({opSnippet:dt.DIV}),$i={kernelName:Re,backendName:"webgpu",kernelFunc:_i},Gi={kernelName:Be,backendName:"webgpu",kernelFunc:on({opType:mt.RELU})},Ai={kernelName:Te,backendName:"webgpu",kernelFunc:on({opType:mt.RELU6})};class Ri{constructor(e,t,n){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, halfPixelCenters : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="resizeBilinear"}getUserCode(){return"\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC =\n            (vec2<f32>(rc) + vec2<f32>(uniforms.halfPixelCenters)) *\n            effectiveInputOverOutputRatioRC - vec2<f32>(uniforms.halfPixelCenters);\n\n          // Compute the four integer indices.\n          let sourceFloorRC = vec2<i32>(sourceFracIndexRC);\n          let sourceCeilRC = vec2<i32>(\n            min(vec2<f32>(uniforms.xShape.yz) - vec2<f32>(1.0), ceil(sourceFracIndexRC)));\n\n          let topLeft = getX(b, sourceFloorRC.x, sourceFloorRC.y, d);\n          let bottomLeft = getX(b, sourceCeilRC.x, sourceFloorRC.y, d);\n          let topRight = getX(b, sourceFloorRC.x, sourceCeilRC.y, d);\n          let bottomRight = getX(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n          let fracRC = sourceFracIndexRC - vec2<f32>(sourceFloorRC);\n\n          let top = topLeft + (topRight - topLeft) * fracRC.y;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n          let newValue = top + (bottom - top) * fracRC.x;\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    "}}const Bi={kernelName:Pe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{images:r}=t,{alignCorners:i,size:a,halfPixelCenters:s}=o,[u,l]=a,d=[{type:"float32",data:[i&&u>1?1:0,i&&l>1?1:0]},{type:"float32",data:[s?.5:0]}],c=new Ri(r.shape,u,l);return n.runWebGPUProgram(c,[r],"float32",d)}};class Ti{constructor(e,t,n,o){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, roundBase : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.halfPixelCenters=o,this.shaderKey=`resizeNearest_${o}`}getUserCode(){let e;e=this.halfPixelCenters?"max((vec2<f32>(rc) + vec2<f32>(0.5)) * effectiveInputOverOutputRatioRC, vec2<f32>(0.0))":"vec2<f32>(rc) * effectiveInputOverOutputRatioRC";return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC = ${e};\n\n          // Compute the coordinators of nearest neighbor point.\n          let inputShapeRC = vec2<f32>(f32(uniforms.xShape.y), f32(uniforms.xShape.z));\n          let sourceNearestRC = vec2<i32>(\n            min(inputShapeRC - 1.0, floor(sourceFracIndexRC + uniforms.roundBase)));\n          let newValue = getX(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const Pi={kernelName:Ne,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{images:r}=t,{alignCorners:i,halfPixelCenters:a,size:s}=o,[u,l]=s,d=[{type:"float32",data:[i&&u>1?1:0,i&&l>1?1:0]},{type:"float32",data:[i?.5:0]}],c=new Ti(r.shape,u,l,a);return n.runWebGPUProgram(c,[r],r.dtype,d)}};class Ni{constructor(e,t){this.outputShape=[],this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="centerX : f32, centerY : f32, sinRadians : f32,\n          cosRadians : f32,",this.shaderKey="rotate",this.outputShape=e,"number"==typeof t?(this.uniforms+=" fillValue : f32,",this.fillSnippet="var outputValue = uniforms.fillValue;",this.shaderKey+="_float"):(this.uniforms+=" fillValue : vec3<f32>,",this.fillSnippet="var outputValue = uniforms.fillValue[coords[3]];",this.shaderKey+="_vec3")}getUserCode(){return`\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n          if (index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            let coordXFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.cosRadians - (f32(coords[1]) - uniforms.centerY) *\n                uniforms.sinRadians;\n            let coordYFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.sinRadians + (f32(coords[1]) - uniforms.centerY) *\n                uniforms.cosRadians;\n            let coordX = i32(round(coordXFloat + uniforms.centerX));\n            let coordY = i32(round(coordYFloat + uniforms.centerY));\n            ${this.fillSnippet}\n            if(coordX >= 0 && coordX < uniforms.xShape[2] && coordY >= 0 &&\n                coordY < uniforms.xShape[1]) {\n              outputValue = getX(coords[0], coordY, coordX, coords[3]);\n            }\n            setOutputAtIndex(index, outputValue);\n          }\n        }\n      `}}const Ei={kernelName:Ee,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{image:r}=e,{radians:i,fillValue:a,center:s}=t,u=n,l=new Ni(r.shape,a),[d,c]=o.getImageCenter(s,r.shape[1],r.shape[2]),p=[{type:"float32",data:[d]},{type:"float32",data:[c]},{type:"float32",data:[Math.sin(i)]},{type:"float32",data:[Math.cos(i)]}];"number"==typeof a?p.push({type:"float32",data:[Number.parseFloat(a.toFixed(2))]}):p.push({type:"float32",data:a});return u.runWebGPUProgram(l,[r],r.dtype,p)}},Li={kernelName:Le,backendName:"webgpu",kernelFunc:on({opType:mt.RSQRT,cpuKernelImpl:to})};class Wi{constructor(e,t,n,o,r,i,a){this.variableNames=["updates","indices"],this.workGroupSize=[64,1,1],this.atomic=!0,this.outputShape=i,this.type=a,this.dispatchLayout=Bt(e),this.dispatch=$t(this.dispatchLayout,e,this.workGroupSize),this.sliceDimGreaterThanOne=t>1,this.shaderKey=`scatter_${n}_${o}_${this.sliceDimGreaterThanOne}_${a}`;const s=wt(r.length);this.uniforms=`sliceDim : i32, strides: ${s}, size: i32,`,this.updatesRank=o,this.indicesRank=n}getUserCode(){let e="";1===this.indicesRank?e="coords[0]":2===this.indicesRank&&(e="coords[0], j");const t=`getIndices(${e})`,n=this.sliceDimGreaterThanOne?"uniforms.strides[j]":"uniforms.strides";let o="",r="",i="";1===this.updatesRank?(o="coords[0]",r="flattenedIndex",i="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> i32 {\n        return index;\n      }\n      "):2===this.updatesRank&&(o="coords[0], coords[1]",r="vec2<i32>(flattenedIndex, coords[1])",i="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> vec2<i32> {\n        let d0 = index / uniforms.updatesShape[1];\n        let d1 = index - d0 * uniforms.updatesShape[1];\n        return vec2<i32>(d0, d1);\n      }\n      ");return`\n    ${i}\n\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n        if (index < uniforms.size) {\n          let coords = getUpdatesCoordsFromFlatIndex(index);\n          var flattenedIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexInside = i32(round(${t}));\n            flattenedIndex = flattenedIndex + indexInside * ${n};\n          }\n          let updateValue = ${`getUpdates(${o})`};\n          let flatIndex = getOutputIndexFromCoords(${r});\n\n         ${"int32"===this.type?"atomicAdd(&(result[flatIndex]), i32(updateValue));":"\n     var assumed = atomicLoad(&(result[flatIndex]));\n     var success = 0;\n     for (; success == 0;) {\n       let new = bitcast<f32>(assumed) + updateValue;\n       let newI32 = bitcast<i32>(new);\n       let resValue = atomicCompareExchangeWeak(&(result[flatIndex]), assumed, newI32);\n       assumed = resValue[0];\n       success = resValue[1];\n     }\n     "}\n        }\n      }`}}const Oi={kernelName:We,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{indices:a,updates:s}=t,{shape:u}=i,{sliceRank:l,numUpdates:d,sliceSize:c,strides:p,outputSize:h}=o.calculateShapes(s,a,u),f=[h/c,c];if(0===h)return r.makeTensorInfo(u,a.dtype);const m=Mt({inputs:{x:a},backend:r,attrs:{shape:[d,l]}}),g=Mt({inputs:{x:s},backend:r,attrs:{shape:[d,c]}}),b=g.dtype,I=Rr({backend:r,attrs:{shape:f,value:0,dtype:b}}),w=[{type:"int32",data:[l]},{type:"int32",data:p},{type:"int32",data:[n.sizeFromShape(g.shape)]}],x=new Wi(g.shape,l,m.shape.length,g.shape.length,p,f,b),k=r.runWebGPUProgram(x,[g,m],b,w,I),v=Mt({inputs:{x:k},backend:r,attrs:{shape:u}});return r.disposeData(m.dataId),r.disposeData(g.dataId),r.disposeData(k.dataId),v}};class Fi{constructor(e,t,n){this.variableNames=["c","a","b"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.cRank=e,this.rank=n,this.shaderKey="select"}getUserCode(){let e,t;if(this.rank>4)throw Error(`Where for rank ${this.rank} is not yet supported`);if(1===this.rank)t="resRC",e="resRC";else{const n=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[],r=[];for(let e=0;e<this.outputShape.length;e++)r.push(`${n[e]}`),e<this.cRank&&o.push(`${n[e]}`);e=o.join(),t=r.join()}return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let cVal = getC(${e});\n          if (cVal >= 1.0) {\n            setOutputAtIndex(index, getA(${t}));\n          } else {\n            setOutputAtIndex(index, getB(${t}));\n          }\n        }\n      }\n    `}}const Ui={kernelName:Oe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{condition:o,t:r,e:i}=t,a=new Fi(o.shape.length,r.shape,r.shape.length);return n.runWebGPUProgram(a,[o,r,i],l(r.dtype,i.dtype))}},Di={kernelName:Fe,backendName:"webgpu",kernelFunc:on({opType:mt.SIGMOID})},Mi={kernelName:Ue,backendName:"webgpu",kernelFunc:on({opType:mt.SIN})},Vi={kernelName:De,backendName:"webgpu",kernelFunc:on({opType:mt.SINH})},Xi=rn({opSnippet:dt.SUB,cpuKernelImpl:ao,supportsComplex:!0}),Hi={kernelName:Me,backendName:"webgpu",kernelFunc:Xi};const qi={kernelName:Ve,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{logits:a}=t,{dim:s}=i,u=n.parseAxisParam([s],a.shape),l=ri({inputs:{x:a},backend:r,attrs:{reductionIndices:u,keepDims:!1}}),d=o.expandShapeToKeepDim(l.shape,u),c=Mt({inputs:{x:l},backend:r,attrs:{shape:d}}),p=Xi({inputs:{a:a,b:c},backend:r}),h=Cr({inputs:{x:p},backend:r}),f=xr({inputs:{x:h},backend:r,attrs:{axis:u,keepDims:!1}}),m=Mt({inputs:{x:f},backend:r,attrs:{shape:d}}),g=_i({inputs:{a:h,b:m},backend:r});return r.disposeData(l.dataId),r.disposeData(c.dataId),r.disposeData(p.dataId),r.disposeData(h.dataId),r.disposeData(f.dataId),r.disposeData(m.dataId),g}},Yi={kernelName:Xe,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{blockShape:s,paddings:u}=i;n.assert(a.shape.length<=4,(()=>"spaceToBatchND for rank > 4 with a WebGPU backend not implemented yet"));const l=s.reduce(((e,t)=>e*t)),d=[[0,0]];d.push(...u);for(let e=1+s.length;e<a.shape.length;++e)d.push([0,0]);const c=[],p=ki({inputs:{x:a},backend:r,attrs:{paddings:d,constantValue:0}}),h=o.getReshaped(p.shape,s,l,!1),f=o.getPermuted(h.length,s.length,!1),m=o.getReshapedPermuted(p.shape,s,l,!1),g=Mt({inputs:{x:p},backend:r,attrs:{shape:h}}),b=wo({inputs:{x:g},backend:r,attrs:{perm:f}}),I=Mt({inputs:{x:b},backend:r,attrs:{shape:m}});return c.push(p),c.push(g),c.push(b),c.forEach((e=>r.disposeData(e.dataId))),I}};class Ki{constructor(e,t,n,o,r,i,a=!0){this.variableNames=["updates","indices","defaultValue"],this.workGroupSize=[64,1,1],this.workPerThread=4,this.size=!0,this.outputShape=i,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]);const s=t>1;this.shaderKey=`scatter_${n}_${o}_${s}`;const u=wt(r.length);this.uniforms=`updateSize : i32, sliceDim : i32, strides: ${u},`;let l="";1===n?l="i":2===n&&(l="i, j"),this.indicesSnippet=`getIndices(${l})`;let d="";1===o?d="i":2===o&&(d="i, coords[1]"),this.updatesSnippet=`getUpdates(${d})`,this.strideString=s?"uniforms.strides[j]":"uniforms.strides"}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n\n        let globalIndex = index * ${this.workPerThread};\n        if (globalIndex < uniforms.size) {\n          var sum = vec4<f32>(0.0);\n          var found = vec4<bool>(false);\n          for (var i = 0; i < uniforms.updateSize; i = i + 1) {\n            var flattenedIndex = 0;\n            for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n              let indexInside = i32(round(${this.indicesSnippet}));\n              flattenedIndex = flattenedIndex + indexInside * ${this.strideString};\n            }\n            for (var innerIndex = 0; innerIndex < ${this.workPerThread}; innerIndex = innerIndex + 1) {\n              let curIndex = globalIndex + innerIndex;\n              let coords = getCoordsFromIndex(curIndex);\n              if (flattenedIndex == coords[0]) {\n                sum[innerIndex] = sum[innerIndex] + ${this.updatesSnippet};\n                found[innerIndex] = true;\n              }\n            }\n          }\n          for (var innerIndex = 0; innerIndex < ${this.workPerThread}; innerIndex = innerIndex + 1) {\n            let curIndex = globalIndex + innerIndex;\n            if (curIndex < uniforms.size)\n            {\n              setOutputAtIndex(curIndex, mix(getDefaultValue(), sum[innerIndex], f32(found[innerIndex])));\n            }\n          }\n        }\n      }`}}const ji={kernelName:He,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{sparseIndices:i,sparseValues:a,defaultValue:s}=t,{outputShape:u}=r,{sliceRank:l,numUpdates:d,strides:c,outputSize:p}=o.calculateShapes(a,i,u),h=[{type:"int32",data:[d]},{type:"int32",data:[l]},{type:"int32",data:c}],f=new Ki(d,l,i.shape.length,a.shape.length,c,[p,1],!1),m=n.runWebGPUProgram(f,[a,i,s],a.dtype,h),g=Mt({inputs:{x:m},backend:n,attrs:{shape:u}});return n.disposeData(m.dataId),g}};const Qi={kernelName:qe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:i}=e,{x:a}=t,{numOrSizeSplits:s,axis:u}=i,l=n.parseAxisParam(u,a.shape)[0],d=o.prepareSplitSize(a,s,l),c=a.shape.length,p=new Array(c).fill(0),h=a.shape.slice();return d.map((e=>{const t=[...h];t[l]=e;const n=Go({inputs:{x:a},backend:r,attrs:{begin:p,size:t}});return p[l]+=e,n}))}},Zi={kernelName:Ye,backendName:"webgpu",kernelFunc:on({opType:mt.SQRT})},Ji={kernelName:Ke,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{x:n}=e,o=t,r=new nn(n.shape,mt.SQUARE);return o.runWebGPUProgram(r,[n],n.dtype)}},ea={kernelName:je,backendName:"webgpu",kernelFunc:rn({opSnippet:dt.SQUARED_DIFFERENCE})};class ta{constructor(e){this.variableNames=["x"],this.workPerThread=1,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]);const t=wt(this.outputShape.length);this.uniforms=`begin : ${t},  strides : ${t}, `,this.shaderKey="stridedSlice"}getUserCode(){let e="";if(1===this.outputShape.length)e="coords * uniforms.strides + uniforms.begin";else{let t=0;e=this.outputShape.map(((e,n)=>(t++,1===this.outputShape.length?`coords * uniforms.strides[${n}] + uniforms.begin[${n}]`:`coords[${t-1}] * uniforms.strides[${n}] + uniforms.begin[${n}]`))).join(",")}return`\n       \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index);\n           setOutputAtIndex(index, getX(${e}));\n         }\n       }\n     `}}const na={kernelName:Qe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{begin:a,end:s,strides:u,beginMask:l,endMask:p,ellipsisMask:h,newAxisMask:f,shrinkAxisMask:m}=r,{finalShapeSparse:g,finalShape:b,isIdentity:I,sliceDim0:w,isSimpleSlice:x,begin:k,end:v,strides:S}=c.sliceInfo(i.shape,a,s,u,l,p,h,f,m);let y;if(I)y=Mt({inputs:{x:i},backend:o,attrs:{shape:b}});else if(w||x){n.assert(i.shape.length>=1,(()=>`Input must have rank at least 1, got: ${i.shape.length}`));const e=c.computeOutShape(k,v,S),t=Go({inputs:{x:i},backend:o,attrs:{begin:k,size:e}});y=Mt({inputs:{x:t},backend:o,attrs:{shape:b}}),o.disposeData(t.dataId)}else{if(o.shouldExecuteOnCPU([i])){const e=o.readSync(i.dataId),t=d(i.shape,i.dtype,e),n=ro(g,t,S,k);y=o.makeTensorInfo(b,i.dtype,n.values)}else{const e=new ta(g),t=[{type:"int32",data:k},{type:"int32",data:S}],n=o.runWebGPUProgram(e,[i],i.dtype,t);y=Mt({inputs:{x:n},backend:o,attrs:{shape:b}}),o.disposeData(n.dataId)}}return y}};const oa={kernelName:Ze,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{separator:r,nGramWidths:i,leftPad:a,rightPad:s,padWidth:u,preserveShortSequences:l}=o,{data:d,dataSplits:c}=t,p=n.readSync(d.dataId),h=n.readSync(c.dataId),[f,m]=io(p,h,r,i,a,s,u,l);return[n.makeTensorInfo([f.length],"string",f),n.makeTensorInfo(c.shape,"int32",m)]}},ra={kernelName:Je,backendName:"webgpu",kernelFunc:on({opType:mt.TANH})};class ia{constructor(e,t){this.variableNames=["A"],this.workGroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let o=0;o<n.length;o++)n[o]=e[o]*t[o];this.outputShape=n,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.rank=this.outputShape.length,this.shaderKey="tile"}getUserCode(){return`\n      \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          setOutputAtIndex(index, getA(${function(e,t=""){if(e>=5)throw Error(`Tile for rank ${e} is not yet supported`);if(1===e)return`(resRC % ${t}aShape)`;const n=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[];for(let r=0;r<e;r++)o.push(`(${n[r]} % ${t}aShape[${r}])`);return o.join()}(this.rank,"uniforms.")}));\n        }\n      }\n    `}}const aa={kernelName:et,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{reps:a}=r;if(o.shouldExecuteOnCPU([i])||"string"===i.dtype||i.shape.length>=5){const e=o.readSync(i.dataId),t="string"===i.dtype?e.map((e=>n.decodeString(e))):e,r=d(i.shape,i.dtype,t),s=so(r,a);return o.makeTensorInfo(s.shape,s.dtype,s.values)}const s=new ia(i.shape,a);return o.runWebGPUProgram(s,[i],i.dtype)}};class sa{constructor(e){this.variableNames=["x","indices"],this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="inputSize : i32, firstPass : i32, negativeInf : f32,\n        dir : i32, inc : i32,",this.shaderKey="swap"}getUserCode(){return"\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // We compare elements pair-wise within a group of size 2 * inc.\n            // The comparing rule for each group alternates between ascending\n            // and descending. Within each group, we compare each pair at\n            // positions i and i+inc. To decide whether an element at position i\n            // is x0 or x1, we mod it by 2 * inc, if the result is smaller than\n            // inc, it is in the first half of the group, we denote it as x0,\n            // otherwise we denote it as x1.\n            // For example, as shown in the Bitonic top K paper referenced\n            // above, Figure5(a) shows that element[1] is in the second half of\n            // the group when group size is 2, but it is in the first half of\n            // the group when group size is 4.\n            let isFirstInPair = elemIdx % (2 * uniforms.inc) < uniforms.inc;\n            var i = 0;\n            if (isFirstInPair) {\n              i = elemIdx;\n            } else {\n              i = elemIdx - uniforms.inc;\n            }\n\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.inc;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.inc));\n            }\n\n            var x0 = f32(0.0);\n            var x1 = f32(0.0);\n            if (i0 < uniforms.inputSize) {\n              x0 = getX(batch, i0);\n            } else {\n              x0 = uniforms.negativeInf;\n            }\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = uniforms.negativeInf;\n            }\n\n            let reverse = elemIdx % (2 * uniforms.dir) >= uniforms.dir;\n            let isGreater = x0 > x1 || (x0 == x1 && i1 > i0);\n            if (reverse == isGreater) {\n              // Elements in opposite order of direction\n              let iTemp = i0;\n              i0 = i1;\n              i1 = iTemp;\n            }\n            if (isFirstInPair) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      "}}class ua{constructor(e){this.variableNames=["x","indices"],this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="inputSize : i32, firstPass : i32, k : i32,",this.shaderKey="merge"}getUserCode(){return"\n        \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // The output size is half of the previous size.\n            // If the previous sequence is | | | | _ _ _ _  | | | |  _ _ _ _\n            // (k=4), we only need to output the indices at positions |, the\n            // indices at positions _ can be thrown away, see Figure5(b) After\n            // Phase 2 (Merge phase) in the Bitonic Top K paper referenced\n            // above.\n            // For example, the paper shows we only need to output the orange\n            // bars. The output sequence should look like this | | | | | | | |.\n            // Because the sequence is halved, to map the output index back to\n            // the previous sequence to find the corresponding value, we need\n            // to double the index. When we double the index, we basically\n            // interpolate a position, so 2i looks like\n            // | _ | _ | _ | _ | _ | _ | _. We move the | to the first k\n            // position of each 2k positions by - elemIdx % k. E.g. for output\n            // at index 4,5,6,7, we want to get the corresponding element at\n            // original index 8,9,10,11, for output at index 8,9,10,11,\n            // we want to get the corresponding element at original index\n            // 16,17,18,19, so on and so forth.\n\n            var i = 0;\n            if (elemIdx < uniforms.k) {\n              i = elemIdx;\n            } else {\n              i = elemIdx * 2 - elemIdx % uniforms.k;\n            }\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.k;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.k));\n            }\n\n            let x0 = getX(batch, i0);\n            var x1 = f32(0.0);\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = x0;\n            }\n\n            if (x0 >= x1) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      "}}function la(e,t){null!==t&&e.disposeData(t.dataId)}function da(e){let t=1;for(;t<e;)t*=2;return t}const ca={kernelName:tt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:o,attrs:r}=e,{x:i}=t,{k:a,sorted:s}=r,u=i.shape,l=u[u.length-1];if(o.shouldExecuteOnCPU([i])){const e=o.readSync(i.dataId),[t,n]=uo(e,u,i.dtype,a,s);return[o.makeTensorInfo(t.shape,t.dtype,t.values),o.makeTensorInfo(n.shape,n.dtype,n.values)]}if(0===a)return u[u.length-1]=0,[o.makeTensorInfo(u,i.dtype,[]),o.makeTensorInfo(u,"int32",[])];if(1===l)return[i,Rr({attrs:{shape:u,dtype:"int32",value:0},backend:o})];const d=n.sizeFromShape(u)/l,c=Mt({inputs:{x:i},attrs:{shape:[d,l]},backend:o}),p=da(a),h=da(l);let f=null;const m=()=>null===f?[c,c]:[c,f],g=(e,t,n)=>{const r=m(),i=new sa(n),a=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"float32",data:[Number.NEGATIVE_INFINITY]},{type:"int32",data:[e]},{type:"int32",data:[t]}],s=f;f=o.runWebGPUProgram(i,r,"int32",a),la(o,s)};for(let e=1;e<p;e*=2){const t=2*e;for(let n=e;n>=1;n/=2)g(t,n,[d,h])}for(let e=h;e>p;e/=2){const t=m(),n=new ua([d,e/2]),r=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"int32",data:[p]}],i=f;f=o.runWebGPUProgram(n,t,"int32",r),la(o,i);const a=p/2,s=2*a;for(let e=a;e>=1;e/=2)g(s,e,f.shape)}let b=f;f=Go({inputs:{x:f},backend:o,attrs:{begin:0,size:[d,a]}}),la(o,b);let I=Yr({inputs:{x:c,indices:f},backend:o,attrs:{axis:1,batchDims:1}});la(o,c);const w=u.slice(0,-1);w.push(a),b=f,f=Mt({inputs:{x:f},attrs:{shape:w},backend:o}),la(o,b);const x=I;return I=Mt({inputs:{x:I},attrs:{shape:w},backend:o}),la(o,x),[I,f]}};class pa{constructor(e){this.variableNames=["Image","Transforms"],this.uniforms="interpolationModeId : i32, fillModeId : i32, fillValue : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Bt(this.outputShape),this.dispatch=$t(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="transform"}getUserCode(){return"\n          fn mapCoord(outCoord : f32, len : f32) -> f32{\n            var inCoord = outCoord;\n            if(uniforms.fillModeId == 2) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  if (inCoord < sz2) {\n                    inCoord = sz2 * f32(i32(f32(-inCoord / sz2))) +\n                    inCoord;\n                  }\n                  if (inCoord < -len) {\n                    inCoord = inCoord + sz2;\n                  } else {\n                    inCoord = -inCoord - 1.0;\n                  }\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  inCoord = inCoord - sz2 * f32(i32(f32(inCoord / sz2)));\n                  if (inCoord >= len) {\n                    inCoord = sz2 - inCoord - 1.0;\n                  }\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 3) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord + len * (f32(i32(f32(-inCoord / sz))) + 1.0);\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord - len * f32(i32(f32(inCoord / sz)));\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 4) {\n              return clamp(outCoord, 0.0, len - 1.0);\n            }\n            return outCoord;\n          }\n          fn readWithFillValue(batch : i32, coordY : i32, coordX : i32,\n            channel : i32) -> f32 {\n            var outputValue : f32;\n            if (0 <= coordY && coordY < uniforms.imageShape[1] && 0 <= coordX && coordX < uniforms.imageShape[2]) {\n                outputValue = getImage(batch, coordY, coordX, channel);\n            } else {\n              outputValue = uniforms.fillValue;\n            }\n            return outputValue;\n          }\n\n          \n    \n  \n  @stage(compute) @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n      let index = getGlobalIndex();\n\n            if (index < uniforms.size) {\n              let coords = getCoordsFromIndex(index);\n              var outputValue : f32;\n              let batch = coords[0];\n              let x = coords[2];\n              let y = coords[1];\n              let channel = coords[3];\n              let xf = f32(x);\n              let yf = f32(y);\n              let a1 = getTransforms(batch, 0);\n              let a2 = getTransforms(batch, 1);\n              let a3 = getTransforms(batch, 2);\n              let b1 = getTransforms(batch, 3);\n              let b2 = getTransforms(batch, 4);\n              let b3 = getTransforms(batch, 5);\n              let c1 = getTransforms(batch, 6);\n              let c2 = getTransforms(batch, 7);\n              let projection = c1 * xf + c2 * yf + 1.0;\n              if (projection == 0.0) {\n                outputValue = uniforms.fillValue;\n              } else {\n                let inX = (a1 * xf + a2 * yf + a3) / projection;\n                let inY = (b1 * xf + b2 * yf + b3) / projection;\n                let mapX = mapCoord(inX, f32(uniforms.imageShape[2]));\n                let mapY = mapCoord(inY, f32(uniforms.imageShape[1]));\n\n                if (uniforms.interpolationModeId == 1) {\n                  let coordY = i32(round(mapY));\n                  let coordX = i32(round(mapX));\n                  outputValue = readWithFillValue(batch, coordY, coordX,\n                    channel);\n                } else {\n                  let yFloor = floor(mapY);\n                  let xFloor = floor(mapX);\n                  let yCeil = yFloor + 1.0;\n                  let xCeil = xFloor + 1.0;\n                  let valueYFloor = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yFloor), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yFloor), i32(xCeil), channel);\n                  let valueYCeil = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yCeil), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yCeil), i32(xCeil), channel);\n                  outputValue = (yCeil - mapY) * valueYFloor +\n                  (mapY - yFloor) * valueYCeil;\n                }\n              }\n              setOutputAtIndex(index, outputValue);\n            }\n          }\n        "}}const ha=[Ht,po,ho,mo,ko,vo,Co,zo,Ro,Eo,Lo,Fo,tn,Ho,jo,Jo,er,tr,or,lr,dr,pr,mr,vr,Sr,yr,zr,$r,Gr,Br,Pr,Wr,Nr,Er,Dr,Mr,Vr,Hr,Kr,jr,Qr,Jt,Mo,Zr,Jr,ei,ti,ni,oi,ii,ai,si,ui,li,di,pi,br,hi,fi,mi,To,Ii,wi,vi,Si,yi,Ci,zi,No,$i,Gi,Ai,Vt,Bi,Pi,Ei,Li,Oi,Ui,Di,Mi,Vi,Ao,na,oa,qi,Yi,ji,Qi,Zi,Ji,ea,Hi,kr,ra,aa,ca,{kernelName:nt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{image:r,transforms:i}=t,{interpolation:a,fillMode:s,fillValue:u,outputShape:l}=o,[d,c,p,h]=r.shape,[f,m]=null!=l?l:[c,p],g=new pa([d,f,m,h]),b="nearest"===a?1:2;let I;switch(s){case"constant":I=1;break;case"reflect":I=2;break;case"wrap":I=3;break;case"nearest":I=4;break;default:I=1}const w=[{type:"int32",data:[b]},{type:"int32",data:[I]},{type:"float32",data:[u]}];return n.runWebGPUProgram(g,[r,i],"float32",w)}},xo,{kernelName:ot,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:o}=e,{value:r}=t;let{axis:i}=o;i<0&&(i+=r.shape.length);const a=r,s=a.shape.length,u=r.shape[i],l=new Array(s-1);let d=0;for(let e=0;e<s;e++)e!==i&&(l[d++]=a.shape[e]);const c=[],p=new Array(s).fill(0),h=a.shape.slice();h[i]=1;const f=new Array(u);for(let e=0;e<f.length;e++){p[i]=e;const t=Go({inputs:{x:a},backend:n,attrs:{begin:p,size:h}}),o=Mt({inputs:{x:t},backend:n,attrs:{shape:l}});f[e]=o,c.push(t)}return c.forEach((e=>n.disposeData(e.dataId))),f}},bi];for(const e of ha)rt(e);class fa{constructor(e){this.device=e,this.numUsedBuffers=0,this.numFreeBuffers=0,this.freeBuffers=new Map,this.usedBuffers=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireUploadBuffer(e,t){return this.acquireBuffer(e,t,!0)}acquireBuffer(e,t,n=!1){const o=ma(e,t);if(this.freeBuffers.has(o)||this.freeBuffers.set(o,[]),this.usedBuffers.has(o)||this.usedBuffers.set(o,[]),this.numBytesUsed+=e,this.numUsedBuffers++,this.freeBuffers.get(o).length>0){this.numFreeBuffers--;const e=this.freeBuffers.get(o).shift();return this.usedBuffers.get(o).push(e),e}this.numBytesAllocated+=e;const r=this.device.createBuffer({mappedAtCreation:n,size:e,usage:t});return this.usedBuffers.get(o).push(r),r}releaseBuffer(e,t,n){if(0===this.freeBuffers.size)return;const o=ma(t,n);this.freeBuffers.has(o)||this.freeBuffers.set(o,[]),this.freeBuffers.get(o).push(e),this.numFreeBuffers++,this.numUsedBuffers--;const r=this.usedBuffers.get(o),i=r.indexOf(e);if(i<0)throw new Error("Cannot release a buffer that was never provided by this buffer manager");r.splice(i,1),this.numBytesUsed-=t}releaseUploadBuffer(e,t,n){e.mapAsync(GPUMapMode.WRITE).then((()=>{this.releaseBuffer(e,t,n)}),(e=>{}))}getNumUsedBuffers(){return this.numUsedBuffers}getNumFreeBuffers(){return this.numFreeBuffers}dispose(){this.freeBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeBuffers=new Map,this.usedBuffers=new Map,this.numUsedBuffers=0,this.numFreeBuffers=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function ma(e,t){return`${e}_${t}`}class ga{constructor(e){this.device=e,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures=new Map,this.usedTextures=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireTexture(e,t,n,o){const r=e*t*Ia(n),i=ba(e,t,n,o);if(this.freeTextures.has(i)||this.freeTextures.set(i,[]),this.usedTextures.has(i)||this.usedTextures.set(i,[]),this.numBytesUsed+=r,this.numUsedTextures++,this.freeTextures.get(i).length>0){this.numFreeTextures--;const e=this.freeTextures.get(i).shift();return this.usedTextures.get(i).push(e),e}this.numBytesAllocated+=r;const a=this.device.createTexture({size:[e,t],format:n,usage:o});return this.usedTextures.get(i).push(a),a}releaseTexture(e,t,n,o,r){if(0===this.freeTextures.size)return;const i=ba(t,n,o,r);this.freeTextures.has(i)||this.freeTextures.set(i,[]),this.freeTextures.get(i).push(e),this.numFreeTextures++,this.numUsedTextures--;const a=this.usedTextures.get(i),s=a.indexOf(e);if(s<0)throw new Error("Cannot release a texture that was never provided by this texture manager");a.splice(s,1);const u=t*n*Ia(o);this.numBytesUsed-=u}getNumUsedTextures(){return this.numUsedTextures}getNumFreeTextures(){return this.numFreeTextures}dispose(){this.freeTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeTextures=new Map,this.usedTextures=new Map,this.numUsedTextures=0,this.numFreeTextures=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function ba(e,t,n,o){return`${e}_${t}_${n}_${o}`}function Ia(e){if("rgba8unorm"===e)return 16;throw new Error(`${e} is not supported!`)}const wa=(e,t,n,o,r,i=!1)=>{const a=vt(o,{dtype:r.dtype,shape:r.shape},t,i),s=e.createShaderModule({code:a,label:t.constructor.name});return e.createComputePipeline({layout:n,compute:{module:s,entryPoint:"main"},label:t.constructor.name})};function xa(e,t,n=[],o="",r=""){return e.shaderKey+"_"+(e.workGroupSize?e.workGroupSize.join(","):"")+t.map((e=>e.length)).join(",")+n.join(",")+e.variableNames.join(",")+o+r}const ka=t().getNumber("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD"),va=(e,t)=>{const o=e.limits.maxComputeWorkgroupsPerDimension,r=t.dispatchLayout,i=t.dispatch;if(i.every((e=>e<=o)))return i;n.assert(i[0]>o&&void 0===r.y&&void 0===r.z,(()=>"Dispatch size exceeds WebGPU limits in Y or Z dimension."));let a=Math.ceil(Math.sqrt(i[0]));return a>o?(a=Math.ceil(Math.cbrt(i[0])),n.assert(a<=o,(()=>"Total dispatch size exceeds WebGPU maximum.")),[a,a,a]):[a,a,1]};class Sa extends it{constructor(e,n=!1){if(super(),this.commandQueueOwnedIds=new WeakSet,this.tensorDisposalQueue=[],this.uniformDisposalQueue=[],this.stagingDisposalQueue=[],this.textureDisposalQueue=[],this.disposed=!1,this.uploadWaitMs=0,this.downloadWaitMs=0,this.dispatchNumberInEncoder=0,this.fromPixelTextureLayout=null,this.fromPixelImportTextureLayout=null,!Nt())throw new Error("WebGPU is not supported on this device");this.layoutCache={},this.pipelineCache={},this.device=e,this.queue=e.queue,this.currentCommandEncoder=null,this.currentComputePass=null,this.supportTimeQuery=n,this.bufferManager=new fa(this.device),this.textureManager=new ga(this.device),this.tensorMap=new at(this,st()),this.supportTimeQuery&&(this.querySet=this.device.createQuerySet({type:"timestamp",count:2})),t().getBool("WEBGPU_USE_PROFILE_TOOL")&&(this.dummyCanvas=document.createElement("canvas"),this.dummyCanvas.width=1,this.dummyCanvas.height=1,this.dummyContext=this.dummyCanvas.getContext("webgpu"),this.dummyContext.configure({device:e,format:"bgra8unorm"}),document.body.appendChild(this.dummyCanvas))}nextDataId(){return Sa.nextDataId++}floatPrecision(){return 32}defaultGpuBufferUsage(){return GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST}flushDisposalQueue(){this.tensorDisposalQueue.forEach((e=>{this.maybeReleaseBuffer(e),this.tensorMap.delete(e)})),this.uniformDisposalQueue.forEach((e=>this.bufferManager.releaseBuffer(e.buffer,e.byteSize,e.usage))),this.stagingDisposalQueue.forEach((e=>this.bufferManager.releaseUploadBuffer(e.buffer,e.byteSize,e.usage))),this.textureDisposalQueue.forEach((e=>this.textureManager.releaseTexture(e.texture,e.width,e.height,e.format,e.usage))),this.tensorDisposalQueue=[],this.uniformDisposalQueue=[],this.stagingDisposalQueue=[],this.textureDisposalQueue=[]}disposeData(e,t=!1){if(this.tensorMap.has(e)){const n=this.tensorMap.get(e);if(n.refCount--,!t&&n.refCount>0)return!1;if(this.commandQueueOwnedIds.has(e))return this.tensorDisposalQueue.push(e),!1;this.maybeReleaseBuffer(e);const{complexTensorInfos:o}=this.tensorMap.get(e);null!=o&&(this.disposeData(o.real.dataId,!0),this.disposeData(o.imag.dataId,!0)),this.tensorMap.delete(e)}return!0}memory(){return{numBytesInGPU:this.bufferManager.numBytesUsed,numBytesAllocatedInGPU:this.bufferManager.numBytesAllocated,unreliable:!1}}getBufferManager(){return this.bufferManager}getTextureManager(){return this.textureManager}acquireBuffer(e,t=this.defaultGpuBufferUsage()){return this.bufferManager.acquireBuffer(e,t)}maybeReleaseBuffer(e){const t=this.tensorMap.get(e);null!=t&&null!=t.bufferInfo.buffer&&(this.bufferManager.releaseBuffer(t.bufferInfo.buffer,t.bufferInfo.byteSize,t.bufferInfo.usage),t.bufferInfo.buffer=null)}refCount(e){if(this.tensorMap.has(e)){return this.tensorMap.get(e).refCount}return 0}incRef(e){this.tensorMap.get(e).refCount++}decRef(e){if(this.tensorMap.has(e)){this.tensorMap.get(e).refCount--}}write(e,t,o){if("complex64"===o&&null!=e)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const r={id:this.nextDataId()},i=n.sizeFromShape(t)*Tt(o);return this.tensorMap.set(r,{dtype:o,shape:t,values:e,bufferInfo:{byteSize:i,usage:this.defaultGpuBufferUsage()},refCount:1}),r}move(e,t,o,r,i){if("complex64"===r)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const a=n.sizeFromShape(o)*Tt(r);this.tensorMap.set(e,{dtype:r,shape:o,values:t,bufferInfo:{byteSize:a,usage:this.defaultGpuBufferUsage()},refCount:i})}submitQueue(){this.ensureComputePassEnded(),this.queue.submit([this.currentCommandEncoder.finish()]),this.currentCommandEncoder=null,this.dispatchNumberInEncoder=0,this.commandQueueOwnedIds=new WeakSet,this.flushDisposalQueue()}getBuffer(e){return this.uploadToGPU(e),this.tensorMap.get(e).bufferInfo.buffer}ensureCommandEncoderReady(){this.currentCommandEncoder||(this.currentCommandEncoder=this.device.createCommandEncoder())}ensureComputePassEnded(){this.currentComputePass&&(this.currentComputePass.end(),this.currentComputePass=null)}getComputePass(){return this.currentComputePass||(this.currentComputePass=this.currentCommandEncoder.beginComputePass()),this.currentComputePass}async getBufferData(e,o){const r=this.acquireBuffer(o,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,r,0,o),this.submitQueue(),await r.mapAsync(GPUMapMode.READ);const i=r.getMappedRange().slice(0);return r.unmap(),null!=r&&this.bufferManager.releaseBuffer(r,o,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ),t().getBool("WEBGPU_USE_PROFILE_TOOL")&&(n.assert(void 0!==this.dummyContext,(()=>"Fail to get context for profiling tool")),this.dummyContext.getCurrentTexture()),i}convertAndCacheOnCPU(e,t){const n=this.tensorMap.get(e);return this.maybeReleaseBuffer(e),n.values=t,n.values}readSync(e){const t=this.tensorMap.get(e),{values:n}=t;if(null==n)throw new Error("WebGPU readSync is only available for CPU-resident tensors.");return n}async read(e){if(!this.tensorMap.has(e))throw new Error(`Tensor ${e} was not registered!`);const t=this.tensorMap.get(e),{values:n}=t;if(null!=n)return this.convertAndCacheOnCPU(e,n);let r;if("complex64"===t.dtype){const e=await Promise.all([this.read(t.complexTensorInfos.real.dataId),this.read(t.complexTensorInfos.imag.dataId)]),n=e[0],i=e[1];r=o.mergeRealAndImagArrays(n,i)}else{r=Pt(null!=t.values?t.values:await this.getBufferData(t.bufferInfo.buffer,t.bufferInfo.byteSize),t.dtype)}return this.convertAndCacheOnCPU(e,r),r}readToGPU(e,t={}){const o=this.tensorMap.get(e),{values:r,dtype:i,shape:a,bufferInfo:s}=o;if("complex64"===i)throw new Error("Does not support reading buffer for complex64 dtype.");if(null==s.buffer)throw null!=r?new Error("Data is not on GPU but on CPU."):new Error("There is no data on GPU or CPU.");const u=n.sizeFromShape(a)*Tt(i);null!=t.customBufSize&&n.assert(t.customBufSize>=u,(()=>`customBufSize should be equal or larger than the source tensor size ${u} bytes.`));const l=null!=t.customBufSize?t.customBufSize:u,d=this.acquireBuffer(l);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(s.buffer,0,d,0,u),this.submitQueue();const c=this.makeTensorInfo(a,i),p=st().makeTensorFromTensorInfo(c),h=this.tensorMap.get(c.dataId);return h.bufferInfo.buffer=d,h.bufferInfo.byteSize=l,{tensorRef:p,buffer:d,bufSize:l}}bufferSync(e){const t=this.readSync(e.dataId);if("string"===e.dtype)try{const o=t.map((e=>n.decodeString(e)));return d(e.shape,e.dtype,o)}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8")}return d(e.shape,e.dtype,t)}async time(e){const t=this.activeTimers,o=[];let r=!1;null==this.programTimersStack?(this.programTimersStack=o,r=!0):this.activeTimers.push(o),this.activeTimers=o,e();const i=n.flatten(this.activeTimers.map((e=>e.query))).filter((e=>null!=e)),a=n.flatten(this.activeTimers.map((e=>e.name))).filter((e=>null!=e));this.activeTimers=t,r&&(this.programTimersStack=null);const s={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},u=await Promise.all(i);return s.kernelMs=n.sum(u),s.getExtraProfileInfo=()=>u.map(((e,t)=>({name:a[t],ms:e}))).map((e=>`${e.name}: ${e.ms}`)).join(", "),this.uploadWaitMs=0,this.downloadWaitMs=0,s}getAndSavePipeline(e,t){return e in this.pipelineCache||(this.pipelineCache[e]=t()),this.pipelineCache[e]}makeTensorInfo(e,t,o){let r;if("string"===t&&null!=o&&o.length>0&&n.isString(o[0])){const i=o.map((e=>n.encodeString(e)));r=this.write(i,e,t)}else r=this.write(o,e,t);return{dataId:r,shape:e,dtype:t}}tensorToBinding(e){if(!e)return null;const t=this.tensorMap.get(e.dataId);return{offset:0,size:t.bufferInfo.byteSize,buffer:t.bufferInfo.buffer}}async getQueryTime(e){return this.supportTimeQuery?this.getTimeFromQuerySet(e):0}uploadToGPU(e){const t=this.tensorMap.get(e);if(null==t.bufferInfo.buffer&&(t.bufferInfo.buffer=this.acquireBuffer(t.bufferInfo.byteSize),t.values)){const e=this.bufferManager.acquireUploadBuffer(t.bufferInfo.byteSize,GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC),n=e.getMappedRange();"int32"===t.dtype||"bool"===t.dtype?new Int32Array(n).set(t.values):new Float32Array(n).set(t.values),e.unmap(),this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,t.bufferInfo.buffer,0,t.bufferInfo.byteSize);const o={byteSize:t.bufferInfo.byteSize,usage:GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC,buffer:e};this.stagingDisposalQueue.push(o)}}makeUniforms(e){let t=0,o=0;const r=[];e.forEach((e=>{let i;switch(0===e.data.length&&(e.data=[1]),e.data.length){case 1:i=4;break;case 2:i=8;break;case 3:case 4:case 5:case 6:i=16;break;default:n.assert(!1,(()=>`Unsupported ${e.data.length}D shape`))}5!==o&&6!==o||(i=16),t=Math.ceil(t/i)*i,o=e.data.length,r.push(t),t+=4*e.data.length}));const i=new ArrayBuffer(t);e.forEach(((e,t)=>{const n=r[t];"int32"===e.type?new Int32Array(i,n,e.data.length).set(e.data):"uint32"===e.type?new Uint32Array(i,n,e.data.length).set(e.data):new Float32Array(i,n,e.data.length).set(e.data)}));const a=this.acquireBuffer(t,GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM);this.queue.writeBuffer(a,0,i,0,t);const s={byteSize:t,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM,buffer:a};return this.uniformDisposalQueue.push(s),{offset:0,size:t,buffer:a}}createLayout(e){const t=[];t.push({binding:0,visibility:GPUShaderStage.COMPUTE,buffer:{type:"storage"}});for(let n=0;n<e;n++)t.push({binding:n+1,visibility:GPUShaderStage.COMPUTE,buffer:{type:"read-only-storage"}});t.push({binding:e+1,visibility:GPUShaderStage.COMPUTE,buffer:{type:"uniform"}});const n=this.device.createBindGroupLayout({entries:t});return{bindGroupLayout:n,pipelineLayout:this.device.createPipelineLayout({bindGroupLayouts:[n]})}}getCachedOrCreateLayout(e){return e in this.layoutCache||(this.layoutCache[e]=this.createLayout(e)),this.layoutCache[e]}runWebGPUProgram(e,r,i,a,s){if(!s){if(s=this.makeTensorInfo(e.outputShape,i),0===n.sizeFromShape(s.shape)){return this.tensorMap.get(s.dataId).values=n.getTypedArrayFromDType(s.dtype,0),s}this.uploadToGPU(s.dataId)}e.dispatch=va(this.device,e);let u=[{type:"float32",data:[NaN]}];const l=r.concat(s).map((e=>e.shape)),d="int32";l.map((e=>{u.push({type:d,data:e})}));const c=n.computeStrides(s.shape);if(u.push({type:d,data:c}),e.size){const t=n.sizeFromShape(e.outputShape);u.push({type:d,data:[e.isVec4?t/4:t]})}a&&(u=[...u,...a]);const p=this.makeUniforms(u),h=r.map(((t,n)=>{if("complex64"===t.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");return this.uploadToGPU(t.dataId),{dtype:this.tensorMap.get(t.dataId).dtype,shape:t.shape,name:e.variableNames[n]}})),f=h.map((e=>e.dtype)).concat(s.dtype),m=h.map((e=>o.getBroadcastDims(e.shape,s.shape))),g=h.map((e=>n.arraysEqual(e.shape,s.shape))).join("_"),b=m.map((e=>e.join("_"))).join(";"),I=xa(e,l,f,b,g),{bindGroupLayout:w,pipelineLayout:x}=this.getCachedOrCreateLayout(e.variableNames.length),k=this.getAndSavePipeline(I,(()=>wa(this.device,e,x,h,s))),v=null!=this.activeTimers,S=((e,t,n,o,r)=>{const i=[o,...n];return r&&i.push(r),e.createBindGroup({layout:t,entries:i.map(((e,t)=>({binding:t,resource:e})))})})(this.device,w,r.map((e=>this.tensorToBinding(e))),this.tensorToBinding(s),p);this.ensureCommandEncoderReady();const y=this.getComputePass();return v&&this.supportTimeQuery&&y.writeTimestamp(this.querySet,0),y.setPipeline(k),y.setBindGroup(0,S),y.dispatch(e.dispatch[0],e.dispatch[1],e.dispatch[2]),v&&this.supportTimeQuery&&y.writeTimestamp(this.querySet,1),this.dispatchNumberInEncoder++,r.forEach((e=>{this.commandQueueOwnedIds.add(e.dataId)})),this.commandQueueOwnedIds.add(s.dataId),t().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchNumberInEncoder&&this.submitQueue(),v&&this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime(this.querySet)}),s}getFromPixelTextureLayout(e){return e?(null===this.fromPixelImportTextureLayout&&(this.fromPixelImportTextureLayout=this.createFromPixelTextureLayout(!0)),this.fromPixelImportTextureLayout):(null===this.fromPixelTextureLayout&&(this.fromPixelTextureLayout=this.createFromPixelTextureLayout(!1)),this.fromPixelTextureLayout)}createFromPixelTextureLayout(e){const t=[];t.push({binding:0,visibility:GPUShaderStage.COMPUTE,buffer:{type:"storage"}}),e?t.push({binding:1,visibility:GPUShaderStage.COMPUTE,externalTexture:{}}):t.push({binding:1,visibility:GPUShaderStage.COMPUTE,texture:{}}),t.push({binding:2,visibility:GPUShaderStage.COMPUTE,buffer:{}});const n=this.device.createBindGroupLayout({entries:t});return{bindGroupLayout:n,pipelineLayout:this.device.createPipelineLayout({bindGroupLayouts:[n]})}}copyExternalImageToTexture(e,t){const n=GPUTextureUsage.COPY_DST|GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.TEXTURE_BINDING,o="rgba8unorm",r=this.textureManager.acquireTexture(t[1],t[0],o,n),i=r.createView();this.queue.copyExternalImageToTexture({source:e},{texture:r},[t[1],t[0]]);const a={width:t[1],height:t[0],format:o,usage:n,texture:r};return this.textureDisposalQueue.push(a),i}runFromPixelsProgram(e,o,r,i,a){e.dispatch=va(this.device,e);const s=this.makeTensorInfo(o,"int32");if(0===n.sizeFromShape(s.shape)){return this.tensorMap.get(s.dataId).values=n.getTypedArrayFromDType(s.dtype,0),s}this.uploadToGPU(s.dataId);const u=xa(e,[s.shape]),l=this.getFromPixelTextureLayout(i),d=this.getAndSavePipeline(u,(()=>wa(this.device,e,l.pipelineLayout,[],s,!0)));let c;if(i){const e={source:a};c=this.device.importExternalTexture(e)}else c=this.copyExternalImageToTexture(a,s.shape);const p=this.tensorToBinding(s),h=this.makeUniforms(r),f=this.device.createBindGroup({layout:l.bindGroupLayout,entries:[{binding:0,resource:{buffer:p.buffer}},{binding:1,resource:c},{binding:2,resource:{buffer:h.buffer}}]});this.ensureCommandEncoderReady();const m=this.getComputePass(),g=null!=this.activeTimers;return g&&this.supportTimeQuery&&m.writeTimestamp(this.querySet,0),m.setPipeline(d),m.setBindGroup(0,f),m.dispatch(e.dispatch[0],e.dispatch[1],e.dispatch[2]),g&&this.supportTimeQuery&&m.writeTimestamp(this.querySet,1),this.commandQueueOwnedIds.add(s.dataId),this.dispatchNumberInEncoder++,t().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchNumberInEncoder&&this.submitQueue(),g&&this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime(this.querySet)}),s}async getTimeFromQuerySet(e){const t=this.acquireBuffer(16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),n=this.acquireBuffer(16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.resolveQuerySet(e,0,2,t,0),this.currentCommandEncoder.copyBufferToBuffer(t,0,n,0,16),this.submitQueue(),await n.mapAsync(GPUMapMode.READ);const o=new BigUint64Array(n.getMappedRange()),r=Number(o[1]-o[0]);return n.unmap(),this.bufferManager.releaseBuffer(n,16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST),this.bufferManager.releaseBuffer(t,16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),r/1e6}shouldExecuteOnCPU(e,o=ka){return t().getBool("WEBGPU_CPU_FORWARD")&&e.every((e=>null==this.tensorMap.get(e.dataId).bufferInfo.buffer&&n.sizeFromShape(e.shape)<o))}numDataIds(){return this.tensorMap.numDataIds()-this.tensorDisposalQueue.length}dispose(){this.disposed||(this.bufferManager.dispose(),this.textureManager.dispose(),this.disposed=!0)}}Sa.nextDataId=0;var ya={__proto__:null,webgpu_util:Et,WebGPUBackend:Sa};Nt()&&ut("webgpu",(async()=>{t().set("CHECK_COMPUTATION_FOR_ERRORS",!1);const e={powerPreference:t().get("WEBGPU_USE_LOW_POWER_GPU")?"low-power":"high-performance"},n=await navigator.gpu.requestAdapter(e),o=n.limits,r={},i=n.features.has("timestamp-query");r.requiredLimits={maxComputeWorkgroupStorageSize:o.maxComputeWorkgroupStorageSize,maxComputeWorkgroupsPerDimension:o.maxComputeWorkgroupsPerDimension},i?r.requiredFeatures=["timestamp-query"]:console.warn("This device doesn't support timestamp-query extension. Start Chrome browser with flag --disable-dawn-features=disallow_unsafe_apis then try again. Or zero will shown for the kernel time when profiling mode isenabled. Using performance.now is not workable for webgpu sinceit doesn't support synchronously to read data from GPU.");const a=await n.requestDevice(r);return new Sa(a,i)}),3);export{ya as webgpu};
//# sourceMappingURL=tf-backend-webgpu.fesm.min.js.map
